//
// Copyright (c) 1997, 2011, Oracle and/or its affiliates. All rights reserved.
// DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
//
// This code is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License version 2 only, as
// published by the Free Software Foundation.
//
// This code is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// version 2 for more details (a copy is included in the LICENSE file that
// accompanied this code).
//
// You should have received a copy of the GNU General Public License version
// 2 along with this work; if not, write to the Free Software Foundation,
// Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
//
// Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
// or visit www.oracle.com if you need additional information or have any
// questions.
//
//

// Machine Generated File.  Do Not Edit!

#include "precompiled.hpp"
#include "adfiles/adGlobals_x86_32.hpp"
#include "adfiles/ad_x86_32.hpp"
#include "memory/allocation.inline.hpp"
#include "asm/assembler.hpp"
#include "code/vmreg.hpp"
#include "gc_interface/collectedHeap.inline.hpp"
#include "oops/compiledICHolderOop.hpp"
#include "oops/markOop.hpp"
#include "oops/methodOop.hpp"
#include "oops/oop.inline.hpp"
#include "oops/oop.inline2.hpp"
#include "opto/cfgnode.hpp"
#include "opto/locknode.hpp"
#include "opto/opcodes.hpp"
#include "opto/regalloc.hpp"
#include "opto/regmask.hpp"
#include "opto/runtime.hpp"
#include "runtime/biasedLocking.hpp"
#include "runtime/sharedRuntime.hpp"
#include "runtime/stubRoutines.hpp"
#include "utilities/growableArray.hpp"
#include "assembler_x86.inline.hpp"
#include "nativeInst_x86.hpp"
#include "vmreg_x86.inline.hpp"

//SourceForm

#line 243 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

#define   RELOC_IMM32    Assembler::imm_operand
#define   RELOC_DISP32   Assembler::disp32_operand

#define __ _masm.

// How to find the high register of a Long pair, given the low register
#define   HIGH_FROM_LOW(x) ((x)+2)

// These masks are used to provide 128-bit aligned bitmasks to the XMM
// instructions, to allow sign-masking or sign-bit flipping.  They allow
// fast versions of NegF/NegD and AbsF/AbsD.

// Note: 'double' and 'long long' have 32-bits alignment on x86.
static jlong* double_quadword(jlong *adr, jlong lo, jlong hi) {
  // Use the expression (adr)&(~0xF) to provide 128-bits aligned address
  // of 128-bits operands for SSE instructions.
  jlong *operand = (jlong*)(((uintptr_t)adr)&((uintptr_t)(~0xF)));
  // Store the value to a 128-bits operand.
  operand[0] = lo;
  operand[1] = hi;
  return operand;
}

// Buffer for 128-bits masks used by SSE instructions.
static jlong fp_signmask_pool[(4+1)*2]; // 4*128bits(data) + 128bits(alignment)

// Static initialization during VM startup.
static jlong *float_signmask_pool  = double_quadword(&fp_signmask_pool[1*2], CONST64(0x7FFFFFFF7FFFFFFF), CONST64(0x7FFFFFFF7FFFFFFF));
static jlong *double_signmask_pool = double_quadword(&fp_signmask_pool[2*2], CONST64(0x7FFFFFFFFFFFFFFF), CONST64(0x7FFFFFFFFFFFFFFF));
static jlong *float_signflip_pool  = double_quadword(&fp_signmask_pool[3*2], CONST64(0x8000000080000000), CONST64(0x8000000080000000));
static jlong *double_signflip_pool = double_quadword(&fp_signmask_pool[4*2], CONST64(0x8000000000000000), CONST64(0x8000000000000000));

// Offset hacking within calls.
static int pre_call_FPU_size() {
  if (Compile::current()->in_24_bit_fp_mode())
    return 6; // fldcw
  return 0;
}

static int preserve_SP_size() {
  return LP64_ONLY(1 +) 2;  // [rex,] op, rm(reg/reg)
}

// !!!!! Special hack to get all type of calls to specify the byte offset
//       from the start of the call to the point where the return address
//       will point.
int MachCallStaticJavaNode::ret_addr_offset() {
  int offset = 5 + pre_call_FPU_size();  // 5 bytes from start of call to where return address points
  if (_method_handle_invoke)
    offset += preserve_SP_size();
  return offset;
}

int MachCallDynamicJavaNode::ret_addr_offset() {
  return 10 + pre_call_FPU_size();  // 10 bytes from start of call to where return address points
}

static int sizeof_FFree_Float_Stack_All = -1;

int MachCallRuntimeNode::ret_addr_offset() {
  assert(sizeof_FFree_Float_Stack_All != -1, "must have been emitted already");
  return sizeof_FFree_Float_Stack_All + 5 + pre_call_FPU_size();
}

// Indicate if the safepoint node needs the polling page as an input.
// Since x86 does have absolute addressing, it doesn't.
bool SafePointNode::needs_polling_address_input() {
  return false;
}

//
// Compute padding required for nodes which need alignment
//

// The address of the call instruction needs to be 4-byte aligned to
// ensure that it does not span a cache line so that it can be patched.
int CallStaticJavaDirectNode::compute_padding(int current_offset) const {
  current_offset += pre_call_FPU_size();  // skip fldcw, if any
  current_offset += 1;      // skip call opcode byte
  return round_to(current_offset, alignment_required()) - current_offset;
}

// The address of the call instruction needs to be 4-byte aligned to
// ensure that it does not span a cache line so that it can be patched.
int CallStaticJavaHandleNode::compute_padding(int current_offset) const {
  current_offset += pre_call_FPU_size();  // skip fldcw, if any
  current_offset += preserve_SP_size();   // skip mov rbp, rsp
  current_offset += 1;      // skip call opcode byte
  return round_to(current_offset, alignment_required()) - current_offset;
}

// The address of the call instruction needs to be 4-byte aligned to
// ensure that it does not span a cache line so that it can be patched.
int CallDynamicJavaDirectNode::compute_padding(int current_offset) const {
  current_offset += pre_call_FPU_size();  // skip fldcw, if any
  current_offset += 5;      // skip MOV instruction
  current_offset += 1;      // skip call opcode byte
  return round_to(current_offset, alignment_required()) - current_offset;
}

#ifndef PRODUCT
void MachBreakpointNode::format( PhaseRegAlloc *, outputStream* st ) const {
  st->print("INT3");
}
#endif

// EMIT_RM()
void emit_rm(CodeBuffer &cbuf, int f1, int f2, int f3) {
  unsigned char c = (unsigned char)((f1 << 6) | (f2 << 3) | f3);
  cbuf.insts()->emit_int8(c);
}

// EMIT_CC()
void emit_cc(CodeBuffer &cbuf, int f1, int f2) {
  unsigned char c = (unsigned char)( f1 | f2 );
  cbuf.insts()->emit_int8(c);
}

// EMIT_OPCODE()
void emit_opcode(CodeBuffer &cbuf, int code) {
  cbuf.insts()->emit_int8((unsigned char) code);
}

// EMIT_OPCODE() w/ relocation information
void emit_opcode(CodeBuffer &cbuf, int code, relocInfo::relocType reloc, int offset = 0) {
  cbuf.relocate(cbuf.insts_mark() + offset, reloc);
  emit_opcode(cbuf, code);
}

// EMIT_D8()
void emit_d8(CodeBuffer &cbuf, int d8) {
  cbuf.insts()->emit_int8((unsigned char) d8);
}

// EMIT_D16()
void emit_d16(CodeBuffer &cbuf, int d16) {
  cbuf.insts()->emit_int16(d16);
}

// EMIT_D32()
void emit_d32(CodeBuffer &cbuf, int d32) {
  cbuf.insts()->emit_int32(d32);
}

// emit 32 bit value and construct relocation entry from relocInfo::relocType
void emit_d32_reloc(CodeBuffer &cbuf, int d32, relocInfo::relocType reloc,
        int format) {
  cbuf.relocate(cbuf.insts_mark(), reloc, format);
  cbuf.insts()->emit_int32(d32);
}

// emit 32 bit value and construct relocation entry from RelocationHolder
void emit_d32_reloc(CodeBuffer &cbuf, int d32, RelocationHolder const& rspec,
        int format) {
#ifdef ASSERT
  if (rspec.reloc()->type() == relocInfo::oop_type && d32 != 0 && d32 != (int)Universe::non_oop_word()) {
    assert(oop(d32)->is_oop() && (ScavengeRootsInCode || !oop(d32)->is_scavengable()), "cannot embed scavengable oops in code");
  }
#endif
  cbuf.relocate(cbuf.insts_mark(), rspec, format);
  cbuf.insts()->emit_int32(d32);
}

// Access stack slot for load or store
void store_to_stackslot(CodeBuffer &cbuf, int opcode, int rm_field, int disp) {
  emit_opcode( cbuf, opcode );               // (e.g., FILD   [ESP+src])
  if( -128 <= disp && disp <= 127 ) {
    emit_rm( cbuf, 0x01, rm_field, ESP_enc );  // R/M byte
    emit_rm( cbuf, 0x00, ESP_enc, ESP_enc);    // SIB byte
    emit_d8 (cbuf, disp);     // Displacement  // R/M byte
  } else {
    emit_rm( cbuf, 0x02, rm_field, ESP_enc );  // R/M byte
    emit_rm( cbuf, 0x00, ESP_enc, ESP_enc);    // SIB byte
    emit_d32(cbuf, disp);     // Displacement  // R/M byte
  }
}

   // eRegI ereg, memory mem) %{    // emit_reg_mem
void encode_RegMem( CodeBuffer &cbuf, int reg_encoding, int base, int index, int scale, int displace, bool displace_is_oop ) {
  // There is no index & no scale, use form without SIB byte
  if ((index == 0x4) &&
      (scale == 0) && (base != ESP_enc)) {
    // If no displacement, mode is 0x0; unless base is [EBP]
    if ( (displace == 0) && (base != EBP_enc) ) {
      emit_rm(cbuf, 0x0, reg_encoding, base);
    }
    else {                    // If 8-bit displacement, mode 0x1
      if ((displace >= -128) && (displace <= 127)
          && !(displace_is_oop) ) {
        emit_rm(cbuf, 0x1, reg_encoding, base);
        emit_d8(cbuf, displace);
      }
      else {                  // If 32-bit displacement
        if (base == -1) { // Special flag for absolute address
          emit_rm(cbuf, 0x0, reg_encoding, 0x5);
          // (manual lies; no SIB needed here)
          if ( displace_is_oop ) {
            emit_d32_reloc(cbuf, displace, relocInfo::oop_type, 1);
          } else {
            emit_d32      (cbuf, displace);
          }
        }
        else {                // Normal base + offset
          emit_rm(cbuf, 0x2, reg_encoding, base);
          if ( displace_is_oop ) {
            emit_d32_reloc(cbuf, displace, relocInfo::oop_type, 1);
          } else {
            emit_d32      (cbuf, displace);
          }
        }
      }
    }
  }
  else {                      // Else, encode with the SIB byte
    // If no displacement, mode is 0x0; unless base is [EBP]
    if (displace == 0 && (base != EBP_enc)) {  // If no displacement
      emit_rm(cbuf, 0x0, reg_encoding, 0x4);
      emit_rm(cbuf, scale, index, base);
    }
    else {                    // If 8-bit displacement, mode 0x1
      if ((displace >= -128) && (displace <= 127)
          && !(displace_is_oop) ) {
        emit_rm(cbuf, 0x1, reg_encoding, 0x4);
        emit_rm(cbuf, scale, index, base);
        emit_d8(cbuf, displace);
      }
      else {                  // If 32-bit displacement
        if (base == 0x04 ) {
          emit_rm(cbuf, 0x2, reg_encoding, 0x4);
          emit_rm(cbuf, scale, index, 0x04);
        } else {
          emit_rm(cbuf, 0x2, reg_encoding, 0x4);
          emit_rm(cbuf, scale, index, base);
        }
        if ( displace_is_oop ) {
          emit_d32_reloc(cbuf, displace, relocInfo::oop_type, 1);
        } else {
          emit_d32      (cbuf, displace);
        }
      }
    }
  }
}


void encode_Copy( CodeBuffer &cbuf, int dst_encoding, int src_encoding ) {
  if( dst_encoding == src_encoding ) {
    // reg-reg copy, use an empty encoding
  } else {
    emit_opcode( cbuf, 0x8B );
    emit_rm(cbuf, 0x3, dst_encoding, src_encoding );
  }
}

void encode_CopyXD( CodeBuffer &cbuf, int dst_encoding, int src_encoding ) {
  if( dst_encoding == src_encoding ) {
    // reg-reg copy, use an empty encoding
  } else {
    MacroAssembler _masm(&cbuf);

    __ movdqa(as_XMMRegister(dst_encoding), as_XMMRegister(src_encoding));
  }
}


//=============================================================================
const bool Matcher::constant_table_absolute_addressing = true;
const RegMask& MachConstantBaseNode::_out_RegMask = RegMask::Empty;

void MachConstantBaseNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  // Empty encoding
}

uint MachConstantBaseNode::size(PhaseRegAlloc* ra_) const {
  return 0;
}

#ifndef PRODUCT
void MachConstantBaseNode::format(PhaseRegAlloc* ra_, outputStream* st) const {
  st->print("# MachConstantBaseNode (empty encoding)");
}
#endif


//=============================================================================
#ifndef PRODUCT
void MachPrologNode::format( PhaseRegAlloc *ra_, outputStream* st ) const {
  Compile* C = ra_->C;
  if( C->in_24_bit_fp_mode() ) {
    st->print("FLDCW  24 bit fpu control word");
    st->print_cr(""); st->print("\t");
  }

  int framesize = C->frame_slots() << LogBytesPerInt;
  assert((framesize & (StackAlignmentInBytes-1)) == 0, "frame size not aligned");
  // Remove two words for return addr and rbp,
  framesize -= 2*wordSize;

  // Calls to C2R adapters often do not accept exceptional returns.
  // We require that their callers must bang for them.  But be careful, because
  // some VM calls (such as call site linkage) can use several kilobytes of
  // stack.  But the stack safety zone should account for that.
  // See bugs 4446381, 4468289, 4497237.
  if (C->need_stack_bang(framesize)) {
    st->print_cr("# stack bang"); st->print("\t");
  }
  st->print_cr("PUSHL  EBP"); st->print("\t");

  if( VerifyStackAtCalls ) { // Majik cookie to verify stack depth
    st->print("PUSH   0xBADB100D\t# Majik cookie for stack depth check");
    st->print_cr(""); st->print("\t");
    framesize -= wordSize;
  }

  if ((C->in_24_bit_fp_mode() || VerifyStackAtCalls ) && framesize < 128 ) {
    if (framesize) {
      st->print("SUB    ESP,%d\t# Create frame",framesize);
    }
  } else {
    st->print("SUB    ESP,%d\t# Create frame",framesize);
  }
}
#endif


void MachPrologNode::emit(CodeBuffer &cbuf, PhaseRegAlloc *ra_) const {
  Compile* C = ra_->C;

  if (UseSSE >= 2 && VerifyFPU) {
    MacroAssembler masm(&cbuf);
    masm.verify_FPU(0, "FPU stack must be clean on entry");
  }

  // WARNING: Initial instruction MUST be 5 bytes or longer so that
  // NativeJump::patch_verified_entry will be able to patch out the entry
  // code safely. The fldcw is ok at 6 bytes, the push to verify stack
  // depth is ok at 5 bytes, the frame allocation can be either 3 or
  // 6 bytes. So if we don't do the fldcw or the push then we must
  // use the 6 byte frame allocation even if we have no frame. :-(
  // If method sets FPU control word do it now
  if( C->in_24_bit_fp_mode() ) {
    MacroAssembler masm(&cbuf);
    masm.fldcw(ExternalAddress(StubRoutines::addr_fpu_cntrl_wrd_24()));
  }

  int framesize = C->frame_slots() << LogBytesPerInt;
  assert((framesize & (StackAlignmentInBytes-1)) == 0, "frame size not aligned");
  // Remove two words for return addr and rbp,
  framesize -= 2*wordSize;

  // Calls to C2R adapters often do not accept exceptional returns.
  // We require that their callers must bang for them.  But be careful, because
  // some VM calls (such as call site linkage) can use several kilobytes of
  // stack.  But the stack safety zone should account for that.
  // See bugs 4446381, 4468289, 4497237.
  if (C->need_stack_bang(framesize)) {
    MacroAssembler masm(&cbuf);
    masm.generate_stack_overflow_check(framesize);
  }

  // We always push rbp, so that on return to interpreter rbp, will be
  // restored correctly and we can correct the stack.
  emit_opcode(cbuf, 0x50 | EBP_enc);

  if( VerifyStackAtCalls ) { // Majik cookie to verify stack depth
    emit_opcode(cbuf, 0x68); // push 0xbadb100d
    emit_d32(cbuf, 0xbadb100d);
    framesize -= wordSize;
  }

  if ((C->in_24_bit_fp_mode() || VerifyStackAtCalls ) && framesize < 128 ) {
    if (framesize) {
      emit_opcode(cbuf, 0x83);   // sub  SP,#framesize
      emit_rm(cbuf, 0x3, 0x05, ESP_enc);
      emit_d8(cbuf, framesize);
    }
  } else {
    emit_opcode(cbuf, 0x81);   // sub  SP,#framesize
    emit_rm(cbuf, 0x3, 0x05, ESP_enc);
    emit_d32(cbuf, framesize);
  }
  C->set_frame_complete(cbuf.insts_size());

#ifdef ASSERT
  if (VerifyStackAtCalls) {
    Label L;
    MacroAssembler masm(&cbuf);
    masm.push(rax);
    masm.mov(rax, rsp);
    masm.andptr(rax, StackAlignmentInBytes-1);
    masm.cmpptr(rax, StackAlignmentInBytes-wordSize);
    masm.pop(rax);
    masm.jcc(Assembler::equal, L);
    masm.stop("Stack is not properly aligned!");
    masm.bind(L);
  }
#endif

}

uint MachPrologNode::size(PhaseRegAlloc *ra_) const {
  return MachNode::size(ra_); // too many variables; just compute it the hard way
}

int MachPrologNode::reloc() const {
  return 0; // a large enough number
}

//=============================================================================
#ifndef PRODUCT
void MachEpilogNode::format( PhaseRegAlloc *ra_, outputStream* st ) const {
  Compile *C = ra_->C;
  int framesize = C->frame_slots() << LogBytesPerInt;
  assert((framesize & (StackAlignmentInBytes-1)) == 0, "frame size not aligned");
  // Remove two words for return addr and rbp,
  framesize -= 2*wordSize;

  if( C->in_24_bit_fp_mode() ) {
    st->print("FLDCW  standard control word");
    st->cr(); st->print("\t");
  }
  if( framesize ) {
    st->print("ADD    ESP,%d\t# Destroy frame",framesize);
    st->cr(); st->print("\t");
  }
  st->print_cr("POPL   EBP"); st->print("\t");
  if( do_polling() && C->is_method_compilation() ) {
    st->print("TEST   PollPage,EAX\t! Poll Safepoint");
    st->cr(); st->print("\t");
  }
}
#endif

void MachEpilogNode::emit(CodeBuffer &cbuf, PhaseRegAlloc *ra_) const {
  Compile *C = ra_->C;

  // If method set FPU control word, restore to standard control word
  if( C->in_24_bit_fp_mode() ) {
    MacroAssembler masm(&cbuf);
    masm.fldcw(ExternalAddress(StubRoutines::addr_fpu_cntrl_wrd_std()));
  }

  int framesize = C->frame_slots() << LogBytesPerInt;
  assert((framesize & (StackAlignmentInBytes-1)) == 0, "frame size not aligned");
  // Remove two words for return addr and rbp,
  framesize -= 2*wordSize;

  // Note that VerifyStackAtCalls' Majik cookie does not change the frame size popped here

  if( framesize >= 128 ) {
    emit_opcode(cbuf, 0x81); // add  SP, #framesize
    emit_rm(cbuf, 0x3, 0x00, ESP_enc);
    emit_d32(cbuf, framesize);
  }
  else if( framesize ) {
    emit_opcode(cbuf, 0x83); // add  SP, #framesize
    emit_rm(cbuf, 0x3, 0x00, ESP_enc);
    emit_d8(cbuf, framesize);
  }

  emit_opcode(cbuf, 0x58 | EBP_enc);

  if( do_polling() && C->is_method_compilation() ) {
    cbuf.relocate(cbuf.insts_end(), relocInfo::poll_return_type, 0);
    emit_opcode(cbuf,0x85);
    emit_rm(cbuf, 0x0, EAX_enc, 0x5); // EAX
    emit_d32(cbuf, (intptr_t)os::get_polling_page());
  }
}

uint MachEpilogNode::size(PhaseRegAlloc *ra_) const {
  Compile *C = ra_->C;
  // If method set FPU control word, restore to standard control word
  int size = C->in_24_bit_fp_mode() ? 6 : 0;
  if( do_polling() && C->is_method_compilation() ) size += 6;

  int framesize = C->frame_slots() << LogBytesPerInt;
  assert((framesize & (StackAlignmentInBytes-1)) == 0, "frame size not aligned");
  // Remove two words for return addr and rbp,
  framesize -= 2*wordSize;

  size++; // popl rbp,

  if( framesize >= 128 ) {
    size += 6;
  } else {
    size += framesize ? 3 : 0;
  }
  return size;
}

int MachEpilogNode::reloc() const {
  return 0; // a large enough number
}

const Pipeline * MachEpilogNode::pipeline() const {
  return MachNode::pipeline_class();
}

int MachEpilogNode::safepoint_offset() const { return 0; }

//=============================================================================

enum RC { rc_bad, rc_int, rc_float, rc_xmm, rc_stack };
static enum RC rc_class( OptoReg::Name reg ) {

  if( !OptoReg::is_valid(reg)  ) return rc_bad;
  if (OptoReg::is_stack(reg)) return rc_stack;

  VMReg r = OptoReg::as_VMReg(reg);
  if (r->is_Register()) return rc_int;
  if (r->is_FloatRegister()) {
    assert(UseSSE < 2, "shouldn't be used in SSE2+ mode");
    return rc_float;
  }
  assert(r->is_XMMRegister(), "must be");
  return rc_xmm;
}

static int impl_helper( CodeBuffer *cbuf, bool do_size, bool is_load, int offset, int reg,
                        int opcode, const char *op_str, int size, outputStream* st ) {
  if( cbuf ) {
    emit_opcode  (*cbuf, opcode );
    encode_RegMem(*cbuf, Matcher::_regEncode[reg], ESP_enc, 0x4, 0, offset, false);
#ifndef PRODUCT
  } else if( !do_size ) {
    if( size != 0 ) st->print("\n\t");
    if( opcode == 0x8B || opcode == 0x89 ) { // MOV
      if( is_load ) st->print("%s   %s,[ESP + #%d]",op_str,Matcher::regName[reg],offset);
      else          st->print("%s   [ESP + #%d],%s",op_str,offset,Matcher::regName[reg]);
    } else { // FLD, FST, PUSH, POP
      st->print("%s [ESP + #%d]",op_str,offset);
    }
#endif
  }
  int offset_size = (offset == 0) ? 0 : ((offset <= 127) ? 1 : 4);
  return size+3+offset_size;
}

// Helper for XMM registers.  Extra opcode bits, limited syntax.
static int impl_x_helper( CodeBuffer *cbuf, bool do_size, bool is_load,
                         int offset, int reg_lo, int reg_hi, int size, outputStream* st ) {
  if( cbuf ) {
    if( reg_lo+1 == reg_hi ) { // double move?
      if( is_load && !UseXmmLoadAndClearUpper )
        emit_opcode(*cbuf, 0x66 ); // use 'movlpd' for load
      else
        emit_opcode(*cbuf, 0xF2 ); // use 'movsd' otherwise
    } else {
      emit_opcode(*cbuf, 0xF3 );
    }
    emit_opcode(*cbuf, 0x0F );
    if( reg_lo+1 == reg_hi && is_load && !UseXmmLoadAndClearUpper )
      emit_opcode(*cbuf, 0x12 );   // use 'movlpd' for load
    else
      emit_opcode(*cbuf, is_load ? 0x10 : 0x11 );
    encode_RegMem(*cbuf, Matcher::_regEncode[reg_lo], ESP_enc, 0x4, 0, offset, false);
#ifndef PRODUCT
  } else if( !do_size ) {
    if( size != 0 ) st->print("\n\t");
    if( reg_lo+1 == reg_hi ) { // double move?
      if( is_load ) st->print("%s %s,[ESP + #%d]",
                               UseXmmLoadAndClearUpper ? "MOVSD " : "MOVLPD",
                               Matcher::regName[reg_lo], offset);
      else          st->print("MOVSD  [ESP + #%d],%s",
                               offset, Matcher::regName[reg_lo]);
    } else {
      if( is_load ) st->print("MOVSS  %s,[ESP + #%d]",
                               Matcher::regName[reg_lo], offset);
      else          st->print("MOVSS  [ESP + #%d],%s",
                               offset, Matcher::regName[reg_lo]);
    }
#endif
  }
  int offset_size = (offset == 0) ? 0 : ((offset <= 127) ? 1 : 4);
  return size+5+offset_size;
}


static int impl_movx_helper( CodeBuffer *cbuf, bool do_size, int src_lo, int dst_lo,
                            int src_hi, int dst_hi, int size, outputStream* st ) {
  if( UseXmmRegToRegMoveAll ) {//Use movaps,movapd to move between xmm registers
    if( cbuf ) {
      if( (src_lo+1 == src_hi && dst_lo+1 == dst_hi) ) {
        emit_opcode(*cbuf, 0x66 );
      }
      emit_opcode(*cbuf, 0x0F );
      emit_opcode(*cbuf, 0x28 );
      emit_rm    (*cbuf, 0x3, Matcher::_regEncode[dst_lo], Matcher::_regEncode[src_lo] );
#ifndef PRODUCT
    } else if( !do_size ) {
      if( size != 0 ) st->print("\n\t");
      if( src_lo+1 == src_hi && dst_lo+1 == dst_hi ) { // double move?
        st->print("MOVAPD %s,%s",Matcher::regName[dst_lo],Matcher::regName[src_lo]);
      } else {
        st->print("MOVAPS %s,%s",Matcher::regName[dst_lo],Matcher::regName[src_lo]);
      }
#endif
    }
    return size + ((src_lo+1 == src_hi && dst_lo+1 == dst_hi) ? 4 : 3);
  } else {
    if( cbuf ) {
      emit_opcode(*cbuf, (src_lo+1 == src_hi && dst_lo+1 == dst_hi) ? 0xF2 : 0xF3 );
      emit_opcode(*cbuf, 0x0F );
      emit_opcode(*cbuf, 0x10 );
      emit_rm    (*cbuf, 0x3, Matcher::_regEncode[dst_lo], Matcher::_regEncode[src_lo] );
#ifndef PRODUCT
    } else if( !do_size ) {
      if( size != 0 ) st->print("\n\t");
      if( src_lo+1 == src_hi && dst_lo+1 == dst_hi ) { // double move?
        st->print("MOVSD  %s,%s",Matcher::regName[dst_lo],Matcher::regName[src_lo]);
      } else {
        st->print("MOVSS  %s,%s",Matcher::regName[dst_lo],Matcher::regName[src_lo]);
      }
#endif
    }
    return size+4;
  }
}

static int impl_movgpr2x_helper( CodeBuffer *cbuf, bool do_size, int src_lo, int dst_lo,
                            int src_hi, int dst_hi, int size, outputStream* st ) {
  // 32-bit
  if (cbuf) {
    emit_opcode(*cbuf, 0x66);
    emit_opcode(*cbuf, 0x0F);
    emit_opcode(*cbuf, 0x6E);
    emit_rm(*cbuf, 0x3, Matcher::_regEncode[dst_lo] & 7, Matcher::_regEncode[src_lo] & 7);
#ifndef PRODUCT
  } else if (!do_size) {
    st->print("movdl   %s, %s\t# spill", Matcher::regName[dst_lo], Matcher::regName[src_lo]);
#endif
  }
  return 4;
}


static int impl_movx2gpr_helper( CodeBuffer *cbuf, bool do_size, int src_lo, int dst_lo,
                                 int src_hi, int dst_hi, int size, outputStream* st ) {
  // 32-bit
  if (cbuf) {
    emit_opcode(*cbuf, 0x66);
    emit_opcode(*cbuf, 0x0F);
    emit_opcode(*cbuf, 0x7E);
    emit_rm(*cbuf, 0x3, Matcher::_regEncode[src_lo] & 7, Matcher::_regEncode[dst_lo] & 7);
#ifndef PRODUCT
  } else if (!do_size) {
    st->print("movdl   %s, %s\t# spill", Matcher::regName[dst_lo], Matcher::regName[src_lo]);
#endif
  }
  return 4;
}

static int impl_mov_helper( CodeBuffer *cbuf, bool do_size, int src, int dst, int size, outputStream* st ) {
  if( cbuf ) {
    emit_opcode(*cbuf, 0x8B );
    emit_rm    (*cbuf, 0x3, Matcher::_regEncode[dst], Matcher::_regEncode[src] );
#ifndef PRODUCT
  } else if( !do_size ) {
    if( size != 0 ) st->print("\n\t");
    st->print("MOV    %s,%s",Matcher::regName[dst],Matcher::regName[src]);
#endif
  }
  return size+2;
}

static int impl_fp_store_helper( CodeBuffer *cbuf, bool do_size, int src_lo, int src_hi, int dst_lo, int dst_hi,
                                 int offset, int size, outputStream* st ) {
  if( src_lo != FPR1L_num ) {      // Move value to top of FP stack, if not already there
    if( cbuf ) {
      emit_opcode( *cbuf, 0xD9 );  // FLD (i.e., push it)
      emit_d8( *cbuf, 0xC0-1+Matcher::_regEncode[src_lo] );
#ifndef PRODUCT
    } else if( !do_size ) {
      if( size != 0 ) st->print("\n\t");
      st->print("FLD    %s",Matcher::regName[src_lo]);
#endif
    }
    size += 2;
  }

  int st_op = (src_lo != FPR1L_num) ? EBX_num /*store & pop*/ : EDX_num /*store no pop*/;
  const char *op_str;
  int op;
  if( src_lo+1 == src_hi && dst_lo+1 == dst_hi ) { // double store?
    op_str = (src_lo != FPR1L_num) ? "FSTP_D" : "FST_D ";
    op = 0xDD;
  } else {                   // 32-bit store
    op_str = (src_lo != FPR1L_num) ? "FSTP_S" : "FST_S ";
    op = 0xD9;
    assert( !OptoReg::is_valid(src_hi) && !OptoReg::is_valid(dst_hi), "no non-adjacent float-stores" );
  }

  return impl_helper(cbuf,do_size,false,offset,st_op,op,op_str,size, st);
}

uint MachSpillCopyNode::implementation( CodeBuffer *cbuf, PhaseRegAlloc *ra_, bool do_size, outputStream* st ) const {
  // Get registers to move
  OptoReg::Name src_second = ra_->get_reg_second(in(1));
  OptoReg::Name src_first = ra_->get_reg_first(in(1));
  OptoReg::Name dst_second = ra_->get_reg_second(this );
  OptoReg::Name dst_first = ra_->get_reg_first(this );

  enum RC src_second_rc = rc_class(src_second);
  enum RC src_first_rc = rc_class(src_first);
  enum RC dst_second_rc = rc_class(dst_second);
  enum RC dst_first_rc = rc_class(dst_first);

  assert( OptoReg::is_valid(src_first) && OptoReg::is_valid(dst_first), "must move at least 1 register" );

  // Generate spill code!
  int size = 0;

  if( src_first == dst_first && src_second == dst_second )
    return size;            // Self copy, no move

  // --------------------------------------
  // Check for mem-mem move.  push/pop to move.
  if( src_first_rc == rc_stack && dst_first_rc == rc_stack ) {
    if( src_second == dst_first ) { // overlapping stack copy ranges
      assert( src_second_rc == rc_stack && dst_second_rc == rc_stack, "we only expect a stk-stk copy here" );
      size = impl_helper(cbuf,do_size,true ,ra_->reg2offset(src_second),ESI_num,0xFF,"PUSH  ",size, st);
      size = impl_helper(cbuf,do_size,false,ra_->reg2offset(dst_second),EAX_num,0x8F,"POP   ",size, st);
      src_second_rc = dst_second_rc = rc_bad;  // flag as already moved the second bits
    }
    // move low bits
    size = impl_helper(cbuf,do_size,true ,ra_->reg2offset(src_first),ESI_num,0xFF,"PUSH  ",size, st);
    size = impl_helper(cbuf,do_size,false,ra_->reg2offset(dst_first),EAX_num,0x8F,"POP   ",size, st);
    if( src_second_rc == rc_stack && dst_second_rc == rc_stack ) { // mov second bits
      size = impl_helper(cbuf,do_size,true ,ra_->reg2offset(src_second),ESI_num,0xFF,"PUSH  ",size, st);
      size = impl_helper(cbuf,do_size,false,ra_->reg2offset(dst_second),EAX_num,0x8F,"POP   ",size, st);
    }
    return size;
  }

  // --------------------------------------
  // Check for integer reg-reg copy
  if( src_first_rc == rc_int && dst_first_rc == rc_int )
    size = impl_mov_helper(cbuf,do_size,src_first,dst_first,size, st);

  // Check for integer store
  if( src_first_rc == rc_int && dst_first_rc == rc_stack )
    size = impl_helper(cbuf,do_size,false,ra_->reg2offset(dst_first),src_first,0x89,"MOV ",size, st);

  // Check for integer load
  if( dst_first_rc == rc_int && src_first_rc == rc_stack )
    size = impl_helper(cbuf,do_size,true ,ra_->reg2offset(src_first),dst_first,0x8B,"MOV ",size, st);

  // Check for integer reg-xmm reg copy
  if( src_first_rc == rc_int && dst_first_rc == rc_xmm ) {
    assert( (src_second_rc == rc_bad && dst_second_rc == rc_bad),
            "no 64 bit integer-float reg moves" );
    return impl_movgpr2x_helper(cbuf,do_size,src_first,dst_first,src_second, dst_second, size, st);
  }
  // --------------------------------------
  // Check for float reg-reg copy
  if( src_first_rc == rc_float && dst_first_rc == rc_float ) {
    assert( (src_second_rc == rc_bad && dst_second_rc == rc_bad) ||
            (src_first+1 == src_second && dst_first+1 == dst_second), "no non-adjacent float-moves" );
    if( cbuf ) {

      // Note the mucking with the register encode to compensate for the 0/1
      // indexing issue mentioned in a comment in the reg_def sections
      // for FPR registers many lines above here.

      if( src_first != FPR1L_num ) {
        emit_opcode  (*cbuf, 0xD9 );           // FLD    ST(i)
        emit_d8      (*cbuf, 0xC0+Matcher::_regEncode[src_first]-1 );
        emit_opcode  (*cbuf, 0xDD );           // FSTP   ST(i)
        emit_d8      (*cbuf, 0xD8+Matcher::_regEncode[dst_first] );
     } else {
        emit_opcode  (*cbuf, 0xDD );           // FST    ST(i)
        emit_d8      (*cbuf, 0xD0+Matcher::_regEncode[dst_first]-1 );
     }
#ifndef PRODUCT
    } else if( !do_size ) {
      if( size != 0 ) st->print("\n\t");
      if( src_first != FPR1L_num ) st->print("FLD    %s\n\tFSTP   %s",Matcher::regName[src_first],Matcher::regName[dst_first]);
      else                      st->print(             "FST    %s",                            Matcher::regName[dst_first]);
#endif
    }
    return size + ((src_first != FPR1L_num) ? 2+2 : 2);
  }

  // Check for float store
  if( src_first_rc == rc_float && dst_first_rc == rc_stack ) {
    return impl_fp_store_helper(cbuf,do_size,src_first,src_second,dst_first,dst_second,ra_->reg2offset(dst_first),size, st);
  }

  // Check for float load
  if( dst_first_rc == rc_float && src_first_rc == rc_stack ) {
    int offset = ra_->reg2offset(src_first);
    const char *op_str;
    int op;
    if( src_first+1 == src_second && dst_first+1 == dst_second ) { // double load?
      op_str = "FLD_D";
      op = 0xDD;
    } else {                   // 32-bit load
      op_str = "FLD_S";
      op = 0xD9;
      assert( src_second_rc == rc_bad && dst_second_rc == rc_bad, "no non-adjacent float-loads" );
    }
    if( cbuf ) {
      emit_opcode  (*cbuf, op );
      encode_RegMem(*cbuf, 0x0, ESP_enc, 0x4, 0, offset, false);
      emit_opcode  (*cbuf, 0xDD );           // FSTP   ST(i)
      emit_d8      (*cbuf, 0xD8+Matcher::_regEncode[dst_first] );
#ifndef PRODUCT
    } else if( !do_size ) {
      if( size != 0 ) st->print("\n\t");
      st->print("%s  ST,[ESP + #%d]\n\tFSTP   %s",op_str, offset,Matcher::regName[dst_first]);
#endif
    }
    int offset_size = (offset == 0) ? 0 : ((offset <= 127) ? 1 : 4);
    return size + 3+offset_size+2;
  }

  // Check for xmm reg-reg copy
  if( src_first_rc == rc_xmm && dst_first_rc == rc_xmm ) {
    assert( (src_second_rc == rc_bad && dst_second_rc == rc_bad) ||
            (src_first+1 == src_second && dst_first+1 == dst_second),
            "no non-adjacent float-moves" );
    return impl_movx_helper(cbuf,do_size,src_first,dst_first,src_second, dst_second, size, st);
  }

  // Check for xmm reg-integer reg copy
  if( src_first_rc == rc_xmm && dst_first_rc == rc_int ) {
    assert( (src_second_rc == rc_bad && dst_second_rc == rc_bad),
            "no 64 bit float-integer reg moves" );
    return impl_movx2gpr_helper(cbuf,do_size,src_first,dst_first,src_second, dst_second, size, st);
  }

  // Check for xmm store
  if( src_first_rc == rc_xmm && dst_first_rc == rc_stack ) {
    return impl_x_helper(cbuf,do_size,false,ra_->reg2offset(dst_first),src_first, src_second, size, st);
  }

  // Check for float xmm load
  if( dst_first_rc == rc_xmm && src_first_rc == rc_stack ) {
    return impl_x_helper(cbuf,do_size,true ,ra_->reg2offset(src_first),dst_first, dst_second, size, st);
  }

  // Copy from float reg to xmm reg
  if( dst_first_rc == rc_xmm && src_first_rc == rc_float ) {
    // copy to the top of stack from floating point reg
    // and use LEA to preserve flags
    if( cbuf ) {
      emit_opcode(*cbuf,0x8D);  // LEA  ESP,[ESP-8]
      emit_rm(*cbuf, 0x1, ESP_enc, 0x04);
      emit_rm(*cbuf, 0x0, 0x04, ESP_enc);
      emit_d8(*cbuf,0xF8);
#ifndef PRODUCT
    } else if( !do_size ) {
      if( size != 0 ) st->print("\n\t");
      st->print("LEA    ESP,[ESP-8]");
#endif
    }
    size += 4;

    size = impl_fp_store_helper(cbuf,do_size,src_first,src_second,dst_first,dst_second,0,size, st);

    // Copy from the temp memory to the xmm reg.
    size = impl_x_helper(cbuf,do_size,true ,0,dst_first, dst_second, size, st);

    if( cbuf ) {
      emit_opcode(*cbuf,0x8D);  // LEA  ESP,[ESP+8]
      emit_rm(*cbuf, 0x1, ESP_enc, 0x04);
      emit_rm(*cbuf, 0x0, 0x04, ESP_enc);
      emit_d8(*cbuf,0x08);
#ifndef PRODUCT
    } else if( !do_size ) {
      if( size != 0 ) st->print("\n\t");
      st->print("LEA    ESP,[ESP+8]");
#endif
    }
    size += 4;
    return size;
  }

  assert( size > 0, "missed a case" );

  // --------------------------------------------------------------------
  // Check for second bits still needing moving.
  if( src_second == dst_second )
    return size;               // Self copy; no move
  assert( src_second_rc != rc_bad && dst_second_rc != rc_bad, "src_second & dst_second cannot be Bad" );

  // Check for second word int-int move
  if( src_second_rc == rc_int && dst_second_rc == rc_int )
    return impl_mov_helper(cbuf,do_size,src_second,dst_second,size, st);

  // Check for second word integer store
  if( src_second_rc == rc_int && dst_second_rc == rc_stack )
    return impl_helper(cbuf,do_size,false,ra_->reg2offset(dst_second),src_second,0x89,"MOV ",size, st);

  // Check for second word integer load
  if( dst_second_rc == rc_int && src_second_rc == rc_stack )
    return impl_helper(cbuf,do_size,true ,ra_->reg2offset(src_second),dst_second,0x8B,"MOV ",size, st);


  Unimplemented();
}

#ifndef PRODUCT
void MachSpillCopyNode::format( PhaseRegAlloc *ra_, outputStream* st ) const {
  implementation( NULL, ra_, false, st );
}
#endif

void MachSpillCopyNode::emit(CodeBuffer &cbuf, PhaseRegAlloc *ra_) const {
  implementation( &cbuf, ra_, false, NULL );
}

uint MachSpillCopyNode::size(PhaseRegAlloc *ra_) const {
  return implementation( NULL, ra_, true, NULL );
}

//=============================================================================
#ifndef PRODUCT
void MachNopNode::format( PhaseRegAlloc *, outputStream* st ) const {
  st->print("NOP \t# %d bytes pad for loops and calls", _count);
}
#endif

void MachNopNode::emit(CodeBuffer &cbuf, PhaseRegAlloc * ) const {
  MacroAssembler _masm(&cbuf);
  __ nop(_count);
}

uint MachNopNode::size(PhaseRegAlloc *) const {
  return _count;
}


//=============================================================================
#ifndef PRODUCT
void BoxLockNode::format( PhaseRegAlloc *ra_, outputStream* st ) const {
  int offset = ra_->reg2offset(in_RegMask(0).find_first_elem());
  int reg = ra_->get_reg_first(this);
  st->print("LEA    %s,[ESP + #%d]",Matcher::regName[reg],offset);
}
#endif

void BoxLockNode::emit(CodeBuffer &cbuf, PhaseRegAlloc *ra_) const {
  int offset = ra_->reg2offset(in_RegMask(0).find_first_elem());
  int reg = ra_->get_encode(this);
  if( offset >= 128 ) {
    emit_opcode(cbuf, 0x8D);      // LEA  reg,[SP+offset]
    emit_rm(cbuf, 0x2, reg, 0x04);
    emit_rm(cbuf, 0x0, 0x04, ESP_enc);
    emit_d32(cbuf, offset);
  }
  else {
    emit_opcode(cbuf, 0x8D);      // LEA  reg,[SP+offset]
    emit_rm(cbuf, 0x1, reg, 0x04);
    emit_rm(cbuf, 0x0, 0x04, ESP_enc);
    emit_d8(cbuf, offset);
  }
}

uint BoxLockNode::size(PhaseRegAlloc *ra_) const {
  int offset = ra_->reg2offset(in_RegMask(0).find_first_elem());
  if( offset >= 128 ) {
    return 7;
  }
  else {
    return 4;
  }
}

//=============================================================================

// emit call stub, compiled java to interpreter
void emit_java_to_interp(CodeBuffer &cbuf ) {
  // Stub is fixed up when the corresponding call is converted from calling
  // compiled code to calling interpreted code.
  // mov rbx,0
  // jmp -1

  address mark = cbuf.insts_mark();  // get mark within main instrs section

  // Note that the code buffer's insts_mark is always relative to insts.
  // That's why we must use the macroassembler to generate a stub.
  MacroAssembler _masm(&cbuf);

  address base =
  __ start_a_stub(Compile::MAX_stubs_size);
  if (base == NULL)  return;  // CodeBuffer::expand failed
  // static stub relocation stores the instruction address of the call
  __ relocate(static_stub_Relocation::spec(mark), RELOC_IMM32);
  // static stub relocation also tags the methodOop in the code-stream.
  __ movoop(rbx, (jobject)NULL);  // method is zapped till fixup time
  // This is recognized as unresolved by relocs/nativeInst/ic code
  __ jump(RuntimeAddress(__ pc()));

  __ end_a_stub();
  // Update current stubs pointer and restore insts_end.
}
// size of call stub, compiled java to interpretor
uint size_java_to_interp() {
  return 10;  // movl; jmp
}
// relocation entries for call stub, compiled java to interpretor
uint reloc_java_to_interp() {
  return 4;  // 3 in emit_java_to_interp + 1 in Java_Static_Call
}

//=============================================================================
#ifndef PRODUCT
void MachUEPNode::format( PhaseRegAlloc *ra_, outputStream* st ) const {
  st->print_cr(  "CMP    EAX,[ECX+4]\t# Inline cache check");
  st->print_cr("\tJNE    SharedRuntime::handle_ic_miss_stub");
  st->print_cr("\tNOP");
  st->print_cr("\tNOP");
  if( !OptoBreakpoint )
    st->print_cr("\tNOP");
}
#endif

void MachUEPNode::emit(CodeBuffer &cbuf, PhaseRegAlloc *ra_) const {
  MacroAssembler masm(&cbuf);
#ifdef ASSERT
  uint insts_size = cbuf.insts_size();
#endif
  masm.cmpptr(rax, Address(rcx, oopDesc::klass_offset_in_bytes()));
  masm.jump_cc(Assembler::notEqual,
               RuntimeAddress(SharedRuntime::get_ic_miss_stub()));
  /* WARNING these NOPs are critical so that verified entry point is properly
     aligned for patching by NativeJump::patch_verified_entry() */
  int nops_cnt = 2;
  if( !OptoBreakpoint ) // Leave space for int3
     nops_cnt += 1;
  masm.nop(nops_cnt);

  assert(cbuf.insts_size() - insts_size == size(ra_), "checking code size of inline cache node");
}

uint MachUEPNode::size(PhaseRegAlloc *ra_) const {
  return OptoBreakpoint ? 11 : 12;
}


//=============================================================================
uint size_exception_handler() {
  // NativeCall instruction size is the same as NativeJump.
  // exception handler starts out as jump and can be patched to
  // a call be deoptimization.  (4932387)
  // Note that this value is also credited (in output.cpp) to
  // the size of the code section.
  return NativeJump::instruction_size;
}

// Emit exception handler code.  Stuff framesize into a register
// and call a VM stub routine.
int emit_exception_handler(CodeBuffer& cbuf) {

  // Note that the code buffer's insts_mark is always relative to insts.
  // That's why we must use the macroassembler to generate a handler.
  MacroAssembler _masm(&cbuf);
  address base =
  __ start_a_stub(size_exception_handler());
  if (base == NULL)  return 0;  // CodeBuffer::expand failed
  int offset = __ offset();
  __ jump(RuntimeAddress(OptoRuntime::exception_blob()->entry_point()));
  assert(__ offset() - offset <= (int) size_exception_handler(), "overflow");
  __ end_a_stub();
  return offset;
}

uint size_deopt_handler() {
  // NativeCall instruction size is the same as NativeJump.
  // exception handler starts out as jump and can be patched to
  // a call be deoptimization.  (4932387)
  // Note that this value is also credited (in output.cpp) to
  // the size of the code section.
  return 5 + NativeJump::instruction_size; // pushl(); jmp;
}

// Emit deopt handler code.
int emit_deopt_handler(CodeBuffer& cbuf) {

  // Note that the code buffer's insts_mark is always relative to insts.
  // That's why we must use the macroassembler to generate a handler.
  MacroAssembler _masm(&cbuf);
  address base =
  __ start_a_stub(size_exception_handler());
  if (base == NULL)  return 0;  // CodeBuffer::expand failed
  int offset = __ offset();
  InternalAddress here(__ pc());
  __ pushptr(here.addr());

  __ jump(RuntimeAddress(SharedRuntime::deopt_blob()->unpack()));
  assert(__ offset() - offset <= (int) size_deopt_handler(), "overflow");
  __ end_a_stub();
  return offset;
}


const bool Matcher::match_rule_supported(int opcode) {
  if (!has_match_rule(opcode))
    return false;

  return true;  // Per default match rules are supported.
}

int Matcher::regnum_to_fpu_offset(int regnum) {
  return regnum - 32; // The FP registers are in the second chunk
}

// This is UltraSparc specific, true just means we have fast l2f conversion
const bool Matcher::convL2FSupported(void) {
  return true;
}

// Vector width in bytes
const uint Matcher::vector_width_in_bytes(void) {
  return UseSSE >= 2 ? 8 : 0;
}

// Vector ideal reg
const uint Matcher::vector_ideal_reg(void) {
  return Op_RegD;
}

// Is this branch offset short enough that a short branch can be used?
//
// NOTE: If the platform does not provide any short branch variants, then
//       this method should return false for offset 0.
bool Matcher::is_short_branch_offset(int rule, int offset) {
  // the short version of jmpConUCF2 contains multiple branches,
  // making the reach slightly less
  if (rule == jmpConUCF2_rule)
    return (-126 <= offset && offset <= 125);
  return (-128 <= offset && offset <= 127);
}

const bool Matcher::isSimpleConstant64(jlong value) {
  // Will one (StoreL ConL) be cheaper than two (StoreI ConI)?.
  return false;
}

// The ecx parameter to rep stos for the ClearArray node is in dwords.
const bool Matcher::init_array_count_is_in_bytes = false;

// Threshold size for cleararray.
const int Matcher::init_array_short_size = 8 * BytesPerLong;

// Should the Matcher clone shifts on addressing modes, expecting them to
// be subsumed into complex addressing expressions or compute them into
// registers?  True for Intel but false for most RISCs
const bool Matcher::clone_shift_expressions = true;

// Do we need to mask the count passed to shift instructions or does
// the cpu only look at the lower 5/6 bits anyway?
const bool Matcher::need_masked_shift_count = false;

bool Matcher::narrow_oop_use_complex_address() {
  ShouldNotCallThis();
  return true;
}


// Is it better to copy float constants, or load them directly from memory?
// Intel can load a float constant from a direct address, requiring no
// extra registers.  Most RISCs will have to materialize an address into a
// register first, so they would do better to copy the constant from stack.
const bool Matcher::rematerialize_float_constants = true;

// If CPU can load and store mis-aligned doubles directly then no fixup is
// needed.  Else we split the double into 2 integer pieces and move it
// piece-by-piece.  Only happens when passing doubles into C code as the
// Java calling convention forces doubles to be aligned.
const bool Matcher::misaligned_doubles_ok = true;


void Matcher::pd_implicit_null_fixup(MachNode *node, uint idx) {
  // Get the memory operand from the node
  uint numopnds = node->num_opnds();        // Virtual call for number of operands
  uint skipped  = node->oper_input_base();  // Sum of leaves skipped so far
  assert( idx >= skipped, "idx too low in pd_implicit_null_fixup" );
  uint opcnt     = 1;                 // First operand
  uint num_edges = node->_opnds[1]->num_edges(); // leaves for first operand
  while( idx >= skipped+num_edges ) {
    skipped += num_edges;
    opcnt++;                          // Bump operand count
    assert( opcnt < numopnds, "Accessing non-existent operand" );
    num_edges = node->_opnds[opcnt]->num_edges(); // leaves for next operand
  }

  MachOper *memory = node->_opnds[opcnt];
  MachOper *new_memory = NULL;
  switch (memory->opcode()) {
  case DIRECT:
  case INDOFFSET32X:
    // No transformation necessary.
    return;
  case INDIRECT:
    new_memory = new (C) indirect_win95_safeOper( );
    break;
  case INDOFFSET8:
    new_memory = new (C) indOffset8_win95_safeOper(memory->disp(NULL, NULL, 0));
    break;
  case INDOFFSET32:
    new_memory = new (C) indOffset32_win95_safeOper(memory->disp(NULL, NULL, 0));
    break;
  case INDINDEXOFFSET:
    new_memory = new (C) indIndexOffset_win95_safeOper(memory->disp(NULL, NULL, 0));
    break;
  case INDINDEXSCALE:
    new_memory = new (C) indIndexScale_win95_safeOper(memory->scale());
    break;
  case INDINDEXSCALEOFFSET:
    new_memory = new (C) indIndexScaleOffset_win95_safeOper(memory->scale(), memory->disp(NULL, NULL, 0));
    break;
  case LOAD_LONG_INDIRECT:
  case LOAD_LONG_INDOFFSET32:
    // Does not use EBP as address register, use { EDX, EBX, EDI, ESI}
    return;
  default:
    assert(false, "unexpected memory operand in pd_implicit_null_fixup()");
    return;
  }
  node->_opnds[opcnt] = new_memory;
}

// Advertise here if the CPU requires explicit rounding operations
// to implement the UseStrictFP mode.
const bool Matcher::strict_fp_requires_explicit_rounding = true;

// Are floats conerted to double when stored to stack during deoptimization?
// On x32 it is stored with convertion only when FPU is used for floats.
bool Matcher::float_in_double() { return (UseSSE == 0); }

// Do ints take an entire long register or just half?
const bool Matcher::int_in_long = false;

// Return whether or not this register is ever used as an argument.  This
// function is used on startup to build the trampoline stubs in generateOptoStub.
// Registers not mentioned will be killed by the VM call in the trampoline, and
// arguments in those registers not be available to the callee.
bool Matcher::can_be_java_arg( int reg ) {
  if(  reg == ECX_num   || reg == EDX_num   ) return true;
  if( (reg == XMM0a_num || reg == XMM1a_num) && UseSSE>=1 ) return true;
  if( (reg == XMM0b_num || reg == XMM1b_num) && UseSSE>=2 ) return true;
  return false;
}

bool Matcher::is_spillable_arg( int reg ) {
  return can_be_java_arg(reg);
}

bool Matcher::use_asm_for_ldiv_by_con( jlong divisor ) {
  // Use hardware integer DIV instruction when
  // it is faster than a code which use multiply.
  // Only when constant divisor fits into 32 bit
  // (min_jint is excluded to get only correct
  // positive 32 bit values from negative).
  return VM_Version::has_fast_idiv() &&
         (divisor == (int)divisor && divisor != min_jint);
}

// Register for DIVI projection of divmodI
RegMask Matcher::divI_proj_mask() {
  return EAX_REG_mask;
}

// Register for MODI projection of divmodI
RegMask Matcher::modI_proj_mask() {
  return EDX_REG_mask;
}

// Register for DIVL projection of divmodL
RegMask Matcher::divL_proj_mask() {
  ShouldNotReachHere();
  return RegMask();
}

// Register for MODL projection of divmodL
RegMask Matcher::modL_proj_mask() {
  ShouldNotReachHere();
  return RegMask();
}

const RegMask Matcher::method_handle_invoke_SP_save_mask() {
  return EBP_REG_mask;
}

// Returns true if the high 32 bits of the value is known to be zero.
bool is_operand_hi32_zero(Node* n) {
  int opc = n->Opcode();
  if (opc == Op_LoadUI2L) {
    return true;
  }
  if (opc == Op_AndL) {
    Node* o2 = n->in(2);
    if (o2->is_Con() && (o2->get_long() & 0xFFFFFFFF00000000LL) == 0LL) {
      return true;
    }
  }
  if (opc == Op_ConL && (n->get_long() & 0xFFFFFFFF00000000LL) == 0LL) {
    return true;
  }
  return false;
}


#line 1364 "../generated/adfiles/ad_x86_32.cpp"


//SourceForm

#line 141 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/os_cpu/linux_x86/vm/linux_x86_32.ad"


// emit an interrupt that is caught by the debugger
void emit_break(CodeBuffer &cbuf) {

  // Debugger doesn't really catch this but best we can do so far QQQ
  MacroAssembler* masm = new MacroAssembler(&cbuf);
  masm->call(RuntimeAddress(CAST_FROM_FN_PTR(address, os::breakpoint)));
}

void MachBreakpointNode::emit(CodeBuffer &cbuf, PhaseRegAlloc *ra_) const {
  emit_break(cbuf);
}


uint MachBreakpointNode::size(PhaseRegAlloc *ra_) const {
  return 5;
}


#line 1390 "../generated/adfiles/ad_x86_32.cpp"


#ifndef PRODUCT
void Compile::adlc_verification() {

  // Following assertions generated from definition section
}
#endif

// Map from machine-independent register number to register_save_policy
const        char register_save_policy[] = {
  'C',
  'C',
  'N',
  'C',
  'C',
  'C',
  'C',
  'N',
  'C',
  'C',
  'C',
  'C',
  'C',
  'C',
  'C',
  'C',
  'C',
  'C',
  'C',
  'C',
  'C',
  'C',
  'C',
  'C',
  'C',
  'C',
  'C',
  'C',
  'C',
  'C',
  'C',
  'C',
  'C',
  'C',
  'C',
  'C',
  'C',
  'C',
  'C',
  'C',
  'C' // no trailing comma
};

// Map from machine-independent register number to c_reg_save_policy
const        char c_reg_save_policy[] = {
  'C',
  'E',
  'E',
  'E',
  'C',
  'C',
  'E',
  'N',
  'C',
  'C',
  'C',
  'C',
  'C',
  'C',
  'C',
  'C',
  'C',
  'C',
  'C',
  'C',
  'C',
  'C',
  'C',
  'C',
  'C',
  'C',
  'C',
  'C',
  'C',
  'C',
  'C',
  'C',
  'C',
  'C',
  'C',
  'C',
  'C',
  'C',
  'C',
  'C',
  'C' // no trailing comma
};

// Map from machine-independent register number to register_save_type
const        int register_save_type[] = {
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  0 // no trailing comma
};


const        int   reduceOp[] = {
  0, // 0
  0, // 1
  0, // 2
  0, // 3
  0, // 4
  0, // 5
  0, // 6
  0, // 7
  immI_rule, // 8
  immI0_rule, // 9
  immI1_rule, // 10
  immI_M1_rule, // 11
  immI2_rule, // 12
  immI8_rule, // 13
  immI16_rule, // 14
  immI_32_rule, // 15
  immI_1_31_rule, // 16
  immI_32_63_rule, // 17
  immI_1_rule, // 18
  immI_2_rule, // 19
  immI_3_rule, // 20
  immP_rule, // 21
  immP0_rule, // 22
  immL_rule, // 23
  immL0_rule, // 24
  immL_M1_rule, // 25
  immL_127_rule, // 26
  immL_32bits_rule, // 27
  immL32_rule, // 28
  immD0_rule, // 29
  immD1_rule, // 30
  immD_rule, // 31
  immXD_rule, // 32
  immXD0_rule, // 33
  immF0_rule, // 34
  immF1_rule, // 35
  immF_rule, // 36
  immXF_rule, // 37
  immXF0_rule, // 38
  immI_16_rule, // 39
  immI_24_rule, // 40
  immI_255_rule, // 41
  immI_65535_rule, // 42
  eRegI_rule, // 43
  xRegI_rule, // 44
  eAXRegI_rule, // 45
  eBXRegI_rule, // 46
  eCXRegI_rule, // 47
  eDXRegI_rule, // 48
  eDIRegI_rule, // 49
  naxRegI_rule, // 50
  nadxRegI_rule, // 51
  ncxRegI_rule, // 52
  eSIRegI_rule, // 53
  anyRegP_rule, // 54
  eRegP_rule, // 55
  eRegP_no_EBP_rule, // 56
  naxRegP_rule, // 57
  nabxRegP_rule, // 58
  pRegP_rule, // 59
  eAXRegP_rule, // 60
  eBXRegP_rule, // 61
  eCXRegP_rule, // 62
  eSIRegP_rule, // 63
  eDIRegP_rule, // 64
  eBPRegP_rule, // 65
  eRegL_rule, // 66
  eADXRegL_rule, // 67
  eBCXRegL_rule, // 68
  eADXRegL_low_only_rule, // 69
  eFlagsReg_rule, // 70
  eFlagsRegU_rule, // 71
  eFlagsRegUCF_rule, // 72
  flagsReg_long_LTGE_rule, // 73
  flagsReg_long_EQNE_rule, // 74
  flagsReg_long_LEGT_rule, // 75
  regD_rule, // 76
  regDPR1_rule, // 77
  regDPR2_rule, // 78
  regnotDPR1_rule, // 79
  regXD_rule, // 80
  regXD6_rule, // 81
  regXD7_rule, // 82
  regF_rule, // 83
  regFPR1_rule, // 84
  regX_rule, // 85
  direct_rule, // 86
  indirect_rule, // 87
  indOffset8_rule, // 88
  indOffset32_rule, // 89
  indOffset32X_rule, // 90
  indIndexOffset_rule, // 91
  indIndex_rule, // 92
  indIndexScale_rule, // 93
  indIndexScaleOffset_rule, // 94
  load_long_RegP_rule, // 95
  load_long_indirect_rule, // 96
  load_long_indOffset32_rule, // 97
  stackSlotP_rule, // 98
  stackSlotI_rule, // 99
  stackSlotF_rule, // 100
  stackSlotD_rule, // 101
  stackSlotL_rule, // 102
  indirect_win95_safe_rule, // 103
  indOffset8_win95_safe_rule, // 104
  indOffset32_win95_safe_rule, // 105
  indIndexOffset_win95_safe_rule, // 106
  indIndexScale_win95_safe_rule, // 107
  indIndexScaleOffset_win95_safe_rule, // 108
  cmpOp_rule, // 109
  cmpOpU_rule, // 110
  cmpOpUCF_rule, // 111
  cmpOpUCF2_rule, // 112
  cmpOp_fcmov_rule, // 113
  cmpOp_commute_rule, // 114
  // last operand
  load_long_memory_rule, // 115
  memory_rule, // 116
  long_memory_rule, // 117
  // last operand class
  _AddP_eRegP_eRegI_rule, // 118
  _LShiftI_eRegI_immI2_rule, // 119
  _AddP_eRegP__LShiftI_eRegI_immI2_rule, // 120
  _AddP_eRegP_no_EBP_eRegI_rule, // 121
  _AddP_eRegP_no_EBP__LShiftI_eRegI_immI2_rule, // 122
  _LoadI_memory__rule, // 123
  _LoadL_memory__rule, // 124
  _LoadB_memory__rule, // 125
  _LoadUB_memory__rule, // 126
  _AndI__LoadUB_memory__immI8_rule, // 127
  _LoadS_memory__rule, // 128
  _LShiftI__LoadS_memory__immI_24_rule, // 129
  _LoadUS_memory__rule, // 130
  _LShiftI__LoadUS_memory__immI_24_rule, // 131
  _AndI__LoadUS_memory__immI_255_rule, // 132
  _AndI__LoadUS_memory__immI16_rule, // 133
  _LShiftI__LoadI_memory__immI_24_rule, // 134
  _LShiftI__LoadI_memory__immI_16_rule, // 135
  _AndI__LoadI_memory__immI_255_rule, // 136
  _AndI__LoadI_memory__immI_65535_rule, // 137
  _AndI__LoadI_memory__immI_rule, // 138
  _ConvL2I_eRegL__rule, // 139
  _RoundDouble_regDPR1__rule, // 140
  _RoundFloat_regFPR1__rule, // 141
  _ConvD2F_regDPR1__rule, // 142
  _Binary_cmpOp_eFlagsReg_rule, // 143
  _Binary_eRegI_eRegI_rule, // 144
  _Binary_cmpOpU_eFlagsRegU_rule, // 145
  _Binary_cmpOpUCF_eFlagsRegUCF_rule, // 146
  _Binary_eRegI__LoadI_memory__rule, // 147
  _Binary_eRegP_eRegP_rule, // 148
  _Binary_cmpOp_fcmov_eFlagsRegU_rule, // 149
  _Binary_regDPR1_regD_rule, // 150
  _Binary_regFPR1_regF_rule, // 151
  _Binary_regD_regD_rule, // 152
  _Binary_regF_regF_rule, // 153
  _Binary_regX_regX_rule, // 154
  _Binary_regXD_regXD_rule, // 155
  _Binary_eRegL_eRegL_rule, // 156
  _AddI__LoadI_memory__eRegI_rule, // 157
  _AddI_eRegI__LoadI_memory__rule, // 158
  _AddI__LoadI_memory__immI_rule, // 159
  _AddI__LoadI_memory__immI1_rule, // 160
  _AddI__LoadI_memory__immI_M1_rule, // 161
  _Binary_eAXRegP_eRegP_rule, // 162
  _Binary_eAXRegI_eRegI_rule, // 163
  _Binary_eADXRegL_eBCXRegL_rule, // 164
  _Binary_eAXRegP_eCXRegP_rule, // 165
  _Binary_eAXRegI_eCXRegI_rule, // 166
  _SubI__LoadI_memory__eRegI_rule, // 167
  _SubI_immI0_eRegI_rule, // 168
  _ConvI2L_nadxRegI__rule, // 169
  _MulL__ConvI2L_nadxRegI__eADXRegL_low_only_rule, // 170
  _RShiftL__MulL__ConvI2L_nadxRegI__eADXRegL_low_only_immI_32_rule, // 171
  _MulL_eADXRegL_low_only__ConvI2L_nadxRegI__rule, // 172
  _RShiftL__MulL_eADXRegL_low_only__ConvI2L_nadxRegI__immI_32_rule, // 173
  _RShiftL__MulL__ConvI2L_nadxRegI__eADXRegL_low_only_immI_32_63_rule, // 174
  _RShiftL__MulL_eADXRegL_low_only__ConvI2L_nadxRegI__immI_32_63_rule, // 175
  _ConvI2L_eAXRegI__rule, // 176
  _AndL__ConvI2L_eAXRegI__immL_32bits_rule, // 177
  _AndL__ConvI2L_nadxRegI__immL_32bits_rule, // 178
  _RShiftI__LoadI_memory__immI1_rule, // 179
  _RShiftI__LoadI_memory__immI8_rule, // 180
  _LShiftI_xRegI_immI_24_rule, // 181
  _LShiftI_xRegI_immI_16_rule, // 182
  _AndI__LoadI_memory__eRegI_rule, // 183
  _AndI_eRegI__LoadI_memory__rule, // 184
  _CastP2X_eRegP__rule, // 185
  _OrI__LoadI_memory__eRegI_rule, // 186
  _OrI_eRegI__LoadI_memory__rule, // 187
  _OrI__LoadI_memory__immI_rule, // 188
  _LShiftI_eRegI_immI1_rule, // 189
  _URShiftI_eRegI_immI_M1_rule, // 190
  _LShiftI_eRegI_immI8_rule, // 191
  _URShiftI_eRegI_immI8_rule, // 192
  _LShiftI_ncxRegI_eCXRegI_rule, // 193
  _SubI_immI0_eCXRegI_rule, // 194
  _URShiftI_ncxRegI__SubI_immI0_eCXRegI_rule, // 195
  _SubI_immI_32_eCXRegI_rule, // 196
  _URShiftI_ncxRegI__SubI_immI_32_eCXRegI_rule, // 197
  _URShiftI_eRegI_immI1_rule, // 198
  _LShiftI_eRegI_immI_M1_rule, // 199
  _URShiftI_ncxRegI_eCXRegI_rule, // 200
  _LShiftI_ncxRegI__SubI_immI0_eCXRegI_rule, // 201
  _LShiftI_ncxRegI__SubI_immI_32_eCXRegI_rule, // 202
  _XorI__LoadI_memory__eRegI_rule, // 203
  _XorI_eRegI__LoadI_memory__rule, // 204
  _XorI__LoadI_memory__immI_rule, // 205
  _CmpLTMask_ncxRegI_ncxRegI_rule, // 206
  _AndI__CmpLTMask_ncxRegI_ncxRegI_ncxRegI_rule, // 207
  _SubI_ncxRegI_ncxRegI_rule, // 208
  _AndI_ncxRegI__CmpLTMask_ncxRegI_ncxRegI_rule, // 209
  _LoadL_load_long_memory__rule, // 210
  _LoadD_memory__rule, // 211
  _SubD_regD_regD_rule, // 212
  _AddD_regD_regD_rule, // 213
  _AddD__LoadD_memory__regD_rule, // 214
  _RoundDouble__AddD__LoadD_memory__regD__rule, // 215
  _AddD_regD__LoadD_memory__rule, // 216
  _RoundDouble__AddD_regD__LoadD_memory___rule, // 217
  _AddD_regD_immD_rule, // 218
  _MulD_regD_regD_rule, // 219
  _DivD_regD_regD_rule, // 220
  _LoadF_memory__rule, // 221
  _ConvF2D_regX__rule, // 222
  _SqrtD__ConvF2D_regX___rule, // 223
  _ConvF2D__LoadF_memory___rule, // 224
  _SqrtD__ConvF2D__LoadF_memory____rule, // 225
  _MulF__LoadF_memory__regF_rule, // 226
  _MulF_regF__LoadF_memory__rule, // 227
  _MulF_regF_regF_rule, // 228
  _SubF_regF_regF_rule, // 229
  _ConvI2L_eRegI__rule, // 230
  _Binary_eDIRegP_eCXRegI_rule, // 231
  _Binary_eSIRegP_eDXRegI_rule, // 232
  _Binary_eDIRegP_eSIRegP_rule, // 233
  _Binary_eDIRegP_eDXRegI_rule, // 234
  _Binary_eSIRegP_immI_rule, // 235
  _Binary_eSIRegP_eAXRegI_rule, // 236
  _AndI_eRegI_immI_rule, // 237
  _AndI_eRegI_memory_rule, // 238
  _LoadP_memory__rule, // 239
  _Binary_nadxRegI_eAXRegI_rule, // 240
  _PartialSubtypeCheck_eSIRegP_eAXRegP_rule, // 241
  _Binary_cmpOp_flagsReg_long_LTGE_rule, // 242
  _Binary_eRegL__LoadL_load_long_memory__rule, // 243
  _Binary_cmpOp_flagsReg_long_EQNE_rule, // 244
  _Binary_cmpOp_commute_flagsReg_long_LEGT_rule, // 245
  // last internally defined operand
  stackSlotI_rule, // 246
  stackSlotP_rule, // 247
  stackSlotL_rule, // 248
  eRegP_rule, // 249
  eRegP_rule, // 250
  eRegP_rule, // 251
  eRegP_rule, // 252
  eRegP_rule, // 253
  eRegI_rule, // 254
  eRegI_rule, // 255
  eRegP_rule, // 256
  eRegL_rule, // 257
  eRegL_rule, // 258
  regF_rule, // 259
  regF_rule, // 260
  regF_rule, // 261
  regX_rule, // 262
  regX_rule, // 263
  regD_rule, // 264
  regD_rule, // 265
  regD_rule, // 266
  regXD_rule, // 267
  regXD_rule, // 268
  eRegI_rule, // 269
  eRegL_rule, // 270
  eRegP_rule, // 271
  regF_rule, // 272
  regD_rule, // 273
  eADXRegL_low_only_rule, // 274
  eRegI_rule, // 275
  eRegI_rule, // 276
  Universe_rule, // 277
  eAXRegP_rule, // 278
  eRegI_rule, // 279
  eRegP_rule, // 280
  eRegP_rule, // 281
  eRegI_rule, // 282
  eFlagsReg_rule, // 283
  eFlagsReg_rule, // 284
  eFlagsReg_rule, // 285
  0, // 286
  0, // 287
  eFlagsRegU_rule, // 288
  eFlagsRegUCF_rule, // 289
  eFlagsRegU_rule, // 290
  eFlagsRegU_rule, // 291
  eFlagsRegUCF_rule, // 292
  eFlagsRegU_rule, // 293
  eFlagsRegUCF_rule, // 294
  regDPR1_rule, // 295
  regXD_rule, // 296
  regDPR1_rule, // 297
  regXD_rule, // 298
  eFlagsRegU_rule, // 299
  eFlagsRegUCF_rule, // 300
  eFlagsRegU_rule, // 301
  eFlagsRegU_rule, // 302
  eFlagsRegUCF_rule, // 303
  eFlagsRegU_rule, // 304
  eFlagsRegUCF_rule, // 305
  regFPR1_rule, // 306
  regX_rule, // 307
  regFPR1_rule, // 308
  regX_rule, // 309
  eRegI_rule, // 310
  eRegI_rule, // 311
  regF_rule, // 312
  regX_rule, // 313
  regX_rule, // 314
  eRegL_rule, // 315
  regD_rule, // 316
  regXD_rule, // 317
  regXD_rule, // 318
  eFlagsReg_rule, // 319
  eFlagsReg_rule, // 320
  eFlagsReg_rule, // 321
  eFlagsReg_rule, // 322
  eFlagsReg_rule, // 323
  eFlagsReg_rule, // 324
  eFlagsRegU_rule, // 325
  eFlagsRegU_rule, // 326
  eFlagsRegU_rule, // 327
  eFlagsRegU_rule, // 328
  eFlagsRegU_rule, // 329
  eFlagsRegU_rule, // 330
  eFlagsRegU_rule, // 331
  eFlagsRegU_rule, // 332
  eFlagsReg_rule, // 333
  eFlagsReg_rule, // 334
  eFlagsReg_rule, // 335
  flagsReg_long_LTGE_rule, // 336
  flagsReg_long_LTGE_rule, // 337
  flagsReg_long_EQNE_rule, // 338
  flagsReg_long_EQNE_rule, // 339
  flagsReg_long_LEGT_rule, // 340
  flagsReg_long_LEGT_rule, // 341
  eFlagsReg_rule, // 342
  eFlagsReg_rule, // 343
  Universe_rule, // 344
  eRegI_rule, // 345
  eRegL_rule, // 346
  eRegI_rule, // 347
  eRegI_rule, // 348
  eRegI_rule, // 349
  eRegI_rule, // 350
  eRegI_rule, // 351
  eRegI_rule, // 352
  eRegI_rule, // 353
  eRegI_rule, // 354
  eRegI_rule, // 355
  eRegI_rule, // 356
  xRegI_rule, // 357
  eRegL_rule, // 358
  xRegI_rule, // 359
  eRegL_rule, // 360
  eRegL_rule, // 361
  eRegI_rule, // 362
  eRegI_rule, // 363
  eRegL_rule, // 364
  eRegI_rule, // 365
  eRegI_rule, // 366
  eRegL_rule, // 367
  eRegL_rule, // 368
  eRegL_rule, // 369
  eRegI_rule, // 370
  eRegI_rule, // 371
  eRegI_rule, // 372
  eRegI_rule, // 373
  eRegI_rule, // 374
  eRegL_rule, // 375
  eRegL_rule, // 376
  eRegL_rule, // 377
  eRegL_rule, // 378
  eRegL_rule, // 379
  eRegL_rule, // 380
  stackSlotL_rule, // 381
  stackSlotL_rule, // 382
  eRegL_rule, // 383
  eRegI_rule, // 384
  eRegP_rule, // 385
  eRegP_rule, // 386
  regD_rule, // 387
  regXD_rule, // 388
  regXD_rule, // 389
  regX_rule, // 390
  regF_rule, // 391
  regXD_rule, // 392
  regXD_rule, // 393
  regXD_rule, // 394
  regXD_rule, // 395
  regXD_rule, // 396
  Universe_rule, // 397
  Universe_rule, // 398
  Universe_rule, // 399
  Universe_rule, // 400
  Universe_rule, // 401
  Universe_rule, // 402
  Universe_rule, // 403
  Universe_rule, // 404
  Universe_rule, // 405
  Universe_rule, // 406
  Universe_rule, // 407
  Universe_rule, // 408
  Universe_rule, // 409
  Universe_rule, // 410
  Universe_rule, // 411
  Universe_rule, // 412
  Universe_rule, // 413
  Universe_rule, // 414
  Universe_rule, // 415
  Universe_rule, // 416
  Universe_rule, // 417
  Universe_rule, // 418
  Universe_rule, // 419
  Universe_rule, // 420
  Universe_rule, // 421
  Universe_rule, // 422
  Universe_rule, // 423
  Universe_rule, // 424
  Universe_rule, // 425
  Universe_rule, // 426
  Universe_rule, // 427
  Universe_rule, // 428
  Universe_rule, // 429
  Universe_rule, // 430
  Universe_rule, // 431
  Universe_rule, // 432
  Universe_rule, // 433
  Universe_rule, // 434
  Universe_rule, // 435
  Universe_rule, // 436
  Universe_rule, // 437
  Universe_rule, // 438
  eRegI_rule, // 439
  eRegI_rule, // 440
  eRegI_rule, // 441
  eRegI_rule, // 442
  eRegI_rule, // 443
  eRegI_rule, // 444
  eRegP_rule, // 445
  eRegP_rule, // 446
  eRegP_rule, // 447
  eRegP_rule, // 448
  regDPR1_rule, // 449
  regFPR1_rule, // 450
  regD_rule, // 451
  regF_rule, // 452
  regX_rule, // 453
  regXD_rule, // 454
  regX_rule, // 455
  regX_rule, // 456
  regXD_rule, // 457
  regXD_rule, // 458
  eRegL_rule, // 459
  eRegL_rule, // 460
  eRegL_rule, // 461
  eRegI_rule, // 462
  eRegI_rule, // 463
  eRegI_rule, // 464
  eRegI_rule, // 465
  eRegP_rule, // 466
  eRegI_rule, // 467
  eRegP_rule, // 468
  eRegP_rule, // 469
  eRegI_rule, // 470
  eRegI_rule, // 471
  Universe_rule, // 472
  Universe_rule, // 473
  Universe_rule, // 474
  Universe_rule, // 475
  Universe_rule, // 476
  eRegP_rule, // 477
  stackSlotL_rule, // 478
  stackSlotL_rule, // 479
  eRegL_rule, // 480
  eRegI_rule, // 481
  eRegI_rule, // 482
  eRegI_rule, // 483
  eRegI_rule, // 484
  eRegI_rule, // 485
  eRegI_rule, // 486
  Universe_rule, // 487
  eRegP_rule, // 488
  eRegI_rule, // 489
  eRegI_rule, // 490
  eRegI_rule, // 491
  eDXRegI_rule, // 492
  eDXRegI_rule, // 493
  eDXRegI_rule, // 494
  eDXRegI_rule, // 495
  eRegI_rule, // 496
  eRegI_rule, // 497
  eRegI_rule, // 498
  eADXRegL_rule, // 499
  eADXRegL_rule, // 500
  eADXRegL_rule, // 501
  eADXRegL_rule, // 502
  eADXRegL_rule, // 503
  eADXRegL_rule, // 504
  eADXRegL_rule, // 505
  eADXRegL_rule, // 506
  eADXRegL_rule, // 507
  eAXRegI_rule, // 508
  eADXRegL_rule, // 509
  Universe_rule, // 510
  eDXRegI_rule, // 511
  eADXRegL_rule, // 512
  eADXRegL_rule, // 513
  eADXRegL_rule, // 514
  eRegI_rule, // 515
  eRegI_rule, // 516
  eRegI_rule, // 517
  eRegI_rule, // 518
  Universe_rule, // 519
  eRegI_rule, // 520
  Universe_rule, // 521
  eRegI_rule, // 522
  eRegI_rule, // 523
  eRegI_rule, // 524
  eRegI_rule, // 525
  eRegI_rule, // 526
  eRegI_rule, // 527
  eRegI_rule, // 528
  eRegI_rule, // 529
  eRegI_rule, // 530
  eRegI_rule, // 531
  Universe_rule, // 532
  Universe_rule, // 533
  Universe_rule, // 534
  eRegI_rule, // 535
  eRegI_rule, // 536
  eRegI_rule, // 537
  eRegI_rule, // 538
  eRegI_rule, // 539
  eRegI_rule, // 540
  Universe_rule, // 541
  Universe_rule, // 542
  Universe_rule, // 543
  0, // 544
  0, // 545
  0, // 546
  eRegI_rule, // 547
  eRegI_rule, // 548
  eRegI_rule, // 549
  eRegI_rule, // 550
  ncxRegI_rule, // 551
  ncxRegI_rule, // 552
  ncxRegI_rule, // 553
  ncxRegI_rule, // 554
  0, // 555
  0, // 556
  0, // 557
  eRegI_rule, // 558
  eRegI_rule, // 559
  eRegI_rule, // 560
  eRegI_rule, // 561
  ncxRegI_rule, // 562
  ncxRegI_rule, // 563
  ncxRegI_rule, // 564
  ncxRegI_rule, // 565
  eRegI_rule, // 566
  eRegI_rule, // 567
  eRegI_rule, // 568
  eRegI_rule, // 569
  eRegI_rule, // 570
  Universe_rule, // 571
  Universe_rule, // 572
  Universe_rule, // 573
  0, // 574
  eRegI_rule, // 575
  0, // 576
  eRegI_rule, // 577
  eCXRegI_rule, // 578
  eRegI_rule, // 579
  ncxRegI_rule, // 580
  ncxRegI_rule, // 581
  ncxRegI_rule, // 582
  ncxRegI_rule, // 583
  eRegL_rule, // 584
  eRegL_rule, // 585
  eRegL_rule, // 586
  eRegL_rule, // 587
  eRegL_rule, // 588
  eRegL_rule, // 589
  eRegL_rule, // 590
  eRegL_rule, // 591
  eRegL_rule, // 592
  eRegL_rule, // 593
  eRegL_rule, // 594
  eRegL_rule, // 595
  eRegL_rule, // 596
  eRegL_rule, // 597
  eRegL_rule, // 598
  eRegL_rule, // 599
  eRegL_rule, // 600
  eRegL_rule, // 601
  eRegL_rule, // 602
  eRegL_rule, // 603
  eRegL_rule, // 604
  eRegL_rule, // 605
  eRegL_rule, // 606
  eRegL_rule, // 607
  eRegL_rule, // 608
  eRegL_rule, // 609
  eRegL_rule, // 610
  eRegL_rule, // 611
  eRegL_rule, // 612
  eRegL_rule, // 613
  eRegL_rule, // 614
  eRegL_rule, // 615
  eRegL_rule, // 616
  eRegI_rule, // 617
  eRegI_rule, // 618
  eRegI_rule, // 619
  eRegI_rule, // 620
  regD_rule, // 621
  stackSlotD_rule, // 622
  regD_rule, // 623
  regD_rule, // 624
  stackSlotD_rule, // 625
  regD_rule, // 626
  regD_rule, // 627
  Universe_rule, // 628
  Universe_rule, // 629
  regD_rule, // 630
  regD_rule, // 631
  stackSlotD_rule, // 632
  regXD_rule, // 633
  regXD_rule, // 634
  regXD_rule, // 635
  regXD_rule, // 636
  regXD_rule, // 637
  regXD_rule, // 638
  regXD_rule, // 639
  regXD_rule, // 640
  regXD_rule, // 641
  regXD_rule, // 642
  regXD_rule, // 643
  regXD_rule, // 644
  regXD_rule, // 645
  regXD_rule, // 646
  regD_rule, // 647
  regDPR1_rule, // 648
  regD_rule, // 649
  regD_rule, // 650
  regD_rule, // 651
  regD_rule, // 652
  regD_rule, // 653
  regD_rule, // 654
  regD_rule, // 655
  regD_rule, // 656
  regD_rule, // 657
  regDPR1_rule, // 658
  stackSlotD_rule, // 659
  regD_rule, // 660
  regXD_rule, // 661
  regDPR1_rule, // 662
  regXD_rule, // 663
  regDPR1_rule, // 664
  regXD_rule, // 665
  regDPR1_rule, // 666
  regXD_rule, // 667
  regD_rule, // 668
  regXD_rule, // 669
  regD_rule, // 670
  regDPR1_rule, // 671
  regXD_rule, // 672
  regDPR1_rule, // 673
  regXD_rule, // 674
  regDPR1_rule, // 675
  regXD_rule, // 676
  regDPR1_rule, // 677
  regXD_rule, // 678
  eRegI_rule, // 679
  eRegI_rule, // 680
  eRegI_rule, // 681
  eRegI_rule, // 682
  stackSlotF_rule, // 683
  regF_rule, // 684
  stackSlotF_rule, // 685
  regF_rule, // 686
  regX_rule, // 687
  regX_rule, // 688
  regX_rule, // 689
  regX_rule, // 690
  regX_rule, // 691
  regX_rule, // 692
  regX_rule, // 693
  regX_rule, // 694
  regX_rule, // 695
  regX_rule, // 696
  regX_rule, // 697
  regX_rule, // 698
  regX_rule, // 699
  regX_rule, // 700
  regX_rule, // 701
  regX_rule, // 702
  regXD_rule, // 703
  regXD_rule, // 704
  stackSlotF_rule, // 705
  stackSlotF_rule, // 706
  regF_rule, // 707
  regF_rule, // 708
  stackSlotF_rule, // 709
  stackSlotF_rule, // 710
  stackSlotF_rule, // 711
  stackSlotF_rule, // 712
  stackSlotF_rule, // 713
  regF_rule, // 714
  stackSlotF_rule, // 715
  regF_rule, // 716
  stackSlotF_rule, // 717
  stackSlotF_rule, // 718
  regF_rule, // 719
  regF_rule, // 720
  stackSlotF_rule, // 721
  stackSlotF_rule, // 722
  regF_rule, // 723
  regF_rule, // 724
  regF_rule, // 725
  regF_rule, // 726
  regF_rule, // 727
  regF_rule, // 728
  regF_rule, // 729
  regF_rule, // 730
  regF_rule, // 731
  regF_rule, // 732
  stackSlotF_rule, // 733
  regF_rule, // 734
  stackSlotF_rule, // 735
  regF_rule, // 736
  regX_rule, // 737
  stackSlotF_rule, // 738
  stackSlotD_rule, // 739
  stackSlotF_rule, // 740
  regX_rule, // 741
  regX_rule, // 742
  regD_rule, // 743
  stackSlotD_rule, // 744
  regD_rule, // 745
  regXD_rule, // 746
  eAXRegI_rule, // 747
  eAXRegI_rule, // 748
  eADXRegL_rule, // 749
  eADXRegL_rule, // 750
  eAXRegI_rule, // 751
  eAXRegI_rule, // 752
  eADXRegL_rule, // 753
  eADXRegL_rule, // 754
  regD_rule, // 755
  regXD_rule, // 756
  regXD_rule, // 757
  regXD_rule, // 758
  regD_rule, // 759
  regF_rule, // 760
  stackSlotF_rule, // 761
  stackSlotF_rule, // 762
  regF_rule, // 763
  regF_rule, // 764
  regX_rule, // 765
  regX_rule, // 766
  eRegL_rule, // 767
  eRegL_rule, // 768
  eRegL_rule, // 769
  stackSlotD_rule, // 770
  regXD_rule, // 771
  regX_rule, // 772
  stackSlotF_rule, // 773
  eRegI_rule, // 774
  stackSlotI_rule, // 775
  stackSlotI_rule, // 776
  stackSlotF_rule, // 777
  stackSlotL_rule, // 778
  stackSlotL_rule, // 779
  eRegL_rule, // 780
  stackSlotD_rule, // 781
  regXD_rule, // 782
  regXD_rule, // 783
  regXD_rule, // 784
  regXD_rule, // 785
  regXD_rule, // 786
  regXD_rule, // 787
  regXD_rule, // 788
  regXD_rule, // 789
  regXD_rule, // 790
  regXD_rule, // 791
  regXD_rule, // 792
  regXD_rule, // 793
  regXD_rule, // 794
  regXD_rule, // 795
  regXD_rule, // 796
  regXD_rule, // 797
  Universe_rule, // 798
  eAXRegI_rule, // 799
  eAXRegI_rule, // 800
  eBXRegI_rule, // 801
  eBXRegI_rule, // 802
  eAXRegI_rule, // 803
  eRegI_rule, // 804
  eRegI_rule, // 805
  eAXRegI_rule, // 806
  Universe_rule, // 807
  Universe_rule, // 808
  Universe_rule, // 809
  Universe_rule, // 810
  Universe_rule, // 811
  Universe_rule, // 812
  Universe_rule, // 813
  Universe_rule, // 814
  Universe_rule, // 815
  eDIRegP_rule, // 816
  Universe_rule, // 817
  Universe_rule, // 818
  Universe_rule, // 819
  Universe_rule, // 820
  Universe_rule, // 821
  Universe_rule, // 822
  Universe_rule, // 823
  Universe_rule, // 824
  eSIRegI_rule, // 825
  Universe_rule, // 826
  eRegL_rule, // 827
  eRegL_rule, // 828
  eRegI_rule, // 829
  eRegI_rule, // 830
  eRegP_rule, // 831
  regD_rule, // 832
  regXD_rule, // 833
  regF_rule, // 834
  regX_rule, // 835
  Universe_rule, // 836
  eRegL_rule, // 837
  eRegL_rule, // 838
  eRegI_rule, // 839
  eRegI_rule, // 840
  eRegP_rule, // 841
  regD_rule, // 842
  regXD_rule, // 843
  regF_rule, // 844
  regX_rule, // 845
  Universe_rule, // 846
  eRegL_rule, // 847
  eRegL_rule, // 848
  eRegI_rule, // 849
  eRegI_rule, // 850
  eRegP_rule, // 851
  regD_rule, // 852
  regXD_rule, // 853
  regF_rule, // 854
  regX_rule, // 855
  Universe_rule, // 856
  Universe_rule, // 857
  Universe_rule, // 858
  Universe_rule, // 859
  Universe_rule, // 860
  Universe_rule, // 861
  Universe_rule, // 862
  Universe_rule, // 863
  Universe_rule, // 864
  eAXRegP_rule, // 865
  Universe_rule, // 866
  eRegP_rule, // 867
  eRegP_rule, // 868
  Universe_rule, // 869
  // last instruction
  0 // no trailing comma
};

const        int   leftOp[] = {
  0, // 0
  0, // 1
  0, // 2
  0, // 3
  0, // 4
  0, // 5
  0, // 6
  0, // 7
  0, // 8
  0, // 9
  0, // 10
  0, // 11
  0, // 12
  0, // 13
  0, // 14
  0, // 15
  0, // 16
  0, // 17
  0, // 18
  0, // 19
  0, // 20
  0, // 21
  0, // 22
  0, // 23
  0, // 24
  0, // 25
  0, // 26
  0, // 27
  0, // 28
  0, // 29
  0, // 30
  0, // 31
  0, // 32
  0, // 33
  0, // 34
  0, // 35
  0, // 36
  0, // 37
  0, // 38
  0, // 39
  0, // 40
  0, // 41
  0, // 42
  0, // 43
  0, // 44
  0, // 45
  0, // 46
  0, // 47
  0, // 48
  0, // 49
  0, // 50
  0, // 51
  0, // 52
  0, // 53
  0, // 54
  0, // 55
  0, // 56
  0, // 57
  0, // 58
  0, // 59
  0, // 60
  0, // 61
  0, // 62
  0, // 63
  0, // 64
  0, // 65
  0, // 66
  0, // 67
  0, // 68
  0, // 69
  0, // 70
  0, // 71
  0, // 72
  0, // 73
  0, // 74
  0, // 75
  0, // 76
  0, // 77
  0, // 78
  0, // 79
  0, // 80
  0, // 81
  0, // 82
  0, // 83
  0, // 84
  0, // 85
  0, // 86
  0, // 87
  eRegP_rule, // 88
  eRegP_rule, // 89
  immP_rule, // 90
  _AddP_eRegP_eRegI_rule, // 91
  eRegP_rule, // 92
  eRegP_rule, // 93
  _AddP_eRegP__LShiftI_eRegI_immI2_rule, // 94
  0, // 95
  0, // 96
  load_long_RegP_rule, // 97
  0, // 98
  0, // 99
  0, // 100
  0, // 101
  0, // 102
  0, // 103
  eRegP_no_EBP_rule, // 104
  eRegP_no_EBP_rule, // 105
  _AddP_eRegP_no_EBP_eRegI_rule, // 106
  eRegP_no_EBP_rule, // 107
  _AddP_eRegP_no_EBP__LShiftI_eRegI_immI2_rule, // 108
  0, // 109
  0, // 110
  0, // 111
  0, // 112
  0, // 113
  0, // 114
  // last operand
  0, // 115
  0, // 116
  0, // 117
  // last operand class
  eRegP_rule, // 118
  eRegI_rule, // 119
  eRegP_rule, // 120
  eRegP_no_EBP_rule, // 121
  eRegP_no_EBP_rule, // 122
  memory_rule, // 123
  memory_rule, // 124
  memory_rule, // 125
  memory_rule, // 126
  _LoadUB_memory__rule, // 127
  memory_rule, // 128
  _LoadS_memory__rule, // 129
  memory_rule, // 130
  _LoadUS_memory__rule, // 131
  _LoadUS_memory__rule, // 132
  _LoadUS_memory__rule, // 133
  _LoadI_memory__rule, // 134
  _LoadI_memory__rule, // 135
  _LoadI_memory__rule, // 136
  _LoadI_memory__rule, // 137
  _LoadI_memory__rule, // 138
  eRegL_rule, // 139
  regDPR1_rule, // 140
  regFPR1_rule, // 141
  regDPR1_rule, // 142
  cmpOp_rule, // 143
  eRegI_rule, // 144
  cmpOpU_rule, // 145
  cmpOpUCF_rule, // 146
  eRegI_rule, // 147
  eRegP_rule, // 148
  cmpOp_fcmov_rule, // 149
  regDPR1_rule, // 150
  regFPR1_rule, // 151
  regD_rule, // 152
  regF_rule, // 153
  regX_rule, // 154
  regXD_rule, // 155
  eRegL_rule, // 156
  _LoadI_memory__rule, // 157
  eRegI_rule, // 158
  _LoadI_memory__rule, // 159
  _LoadI_memory__rule, // 160
  _LoadI_memory__rule, // 161
  eAXRegP_rule, // 162
  eAXRegI_rule, // 163
  eADXRegL_rule, // 164
  eAXRegP_rule, // 165
  eAXRegI_rule, // 166
  _LoadI_memory__rule, // 167
  immI0_rule, // 168
  nadxRegI_rule, // 169
  _ConvI2L_nadxRegI__rule, // 170
  _MulL__ConvI2L_nadxRegI__eADXRegL_low_only_rule, // 171
  eADXRegL_low_only_rule, // 172
  _MulL_eADXRegL_low_only__ConvI2L_nadxRegI__rule, // 173
  _MulL__ConvI2L_nadxRegI__eADXRegL_low_only_rule, // 174
  _MulL_eADXRegL_low_only__ConvI2L_nadxRegI__rule, // 175
  eAXRegI_rule, // 176
  _ConvI2L_eAXRegI__rule, // 177
  _ConvI2L_nadxRegI__rule, // 178
  _LoadI_memory__rule, // 179
  _LoadI_memory__rule, // 180
  xRegI_rule, // 181
  xRegI_rule, // 182
  _LoadI_memory__rule, // 183
  eRegI_rule, // 184
  eRegP_rule, // 185
  _LoadI_memory__rule, // 186
  eRegI_rule, // 187
  _LoadI_memory__rule, // 188
  eRegI_rule, // 189
  eRegI_rule, // 190
  eRegI_rule, // 191
  eRegI_rule, // 192
  ncxRegI_rule, // 193
  immI0_rule, // 194
  ncxRegI_rule, // 195
  immI_32_rule, // 196
  ncxRegI_rule, // 197
  eRegI_rule, // 198
  eRegI_rule, // 199
  ncxRegI_rule, // 200
  ncxRegI_rule, // 201
  ncxRegI_rule, // 202
  _LoadI_memory__rule, // 203
  eRegI_rule, // 204
  _LoadI_memory__rule, // 205
  ncxRegI_rule, // 206
  _CmpLTMask_ncxRegI_ncxRegI_rule, // 207
  ncxRegI_rule, // 208
  ncxRegI_rule, // 209
  load_long_memory_rule, // 210
  memory_rule, // 211
  regD_rule, // 212
  regD_rule, // 213
  _LoadD_memory__rule, // 214
  _AddD__LoadD_memory__regD_rule, // 215
  regD_rule, // 216
  _AddD_regD__LoadD_memory__rule, // 217
  regD_rule, // 218
  regD_rule, // 219
  regD_rule, // 220
  memory_rule, // 221
  regX_rule, // 222
  _ConvF2D_regX__rule, // 223
  _LoadF_memory__rule, // 224
  _ConvF2D__LoadF_memory___rule, // 225
  _LoadF_memory__rule, // 226
  regF_rule, // 227
  regF_rule, // 228
  regF_rule, // 229
  eRegI_rule, // 230
  eDIRegP_rule, // 231
  eSIRegP_rule, // 232
  eDIRegP_rule, // 233
  eDIRegP_rule, // 234
  eSIRegP_rule, // 235
  eSIRegP_rule, // 236
  eRegI_rule, // 237
  eRegI_rule, // 238
  memory_rule, // 239
  nadxRegI_rule, // 240
  eSIRegP_rule, // 241
  cmpOp_rule, // 242
  eRegL_rule, // 243
  cmpOp_rule, // 244
  cmpOp_commute_rule, // 245
  // last internally defined operand
  eRegI_rule, // 246
  eRegP_rule, // 247
  eRegL_rule, // 248
  indOffset8_rule, // 249
  indOffset32_rule, // 250
  indIndexOffset_rule, // 251
  indIndexScale_rule, // 252
  indIndexScaleOffset_rule, // 253
  immI_rule, // 254
  immI0_rule, // 255
  immP_rule, // 256
  immL_rule, // 257
  immL0_rule, // 258
  immF_rule, // 259
  immF0_rule, // 260
  immF1_rule, // 261
  immXF_rule, // 262
  immXF0_rule, // 263
  immD_rule, // 264
  immD0_rule, // 265
  immD1_rule, // 266
  immXD_rule, // 267
  immXD0_rule, // 268
  stackSlotI_rule, // 269
  stackSlotL_rule, // 270
  stackSlotP_rule, // 271
  stackSlotF_rule, // 272
  stackSlotD_rule, // 273
  immL32_rule, // 274
  eRegI_rule, // 275
  _LoadI_memory__rule, // 276
  0, // 277
  eAXRegI_rule, // 278
  eRegP_rule, // 279
  eRegP_rule, // 280
  eRegP_rule, // 281
  eRegI_rule, // 282
  memory_rule, // 283
  memory_rule, // 284
  memory_rule, // 285
  0, // 286
  0, // 287
  regD_rule, // 288
  regD_rule, // 289
  regD_rule, // 290
  regXD_rule, // 291
  regXD_rule, // 292
  regXD_rule, // 293
  regXD_rule, // 294
  regDPR1_rule, // 295
  regXD_rule, // 296
  regDPR1_rule, // 297
  regXD_rule, // 298
  regF_rule, // 299
  regF_rule, // 300
  regF_rule, // 301
  regX_rule, // 302
  regX_rule, // 303
  regX_rule, // 304
  regX_rule, // 305
  regFPR1_rule, // 306
  regX_rule, // 307
  regFPR1_rule, // 308
  regX_rule, // 309
  stackSlotF_rule, // 310
  regX_rule, // 311
  stackSlotI_rule, // 312
  stackSlotI_rule, // 313
  eRegI_rule, // 314
  stackSlotD_rule, // 315
  stackSlotL_rule, // 316
  stackSlotL_rule, // 317
  stackSlotL_rule, // 318
  eRegI_rule, // 319
  eRegI_rule, // 320
  eRegI_rule, // 321
  eRegI_rule, // 322
  _AndI_eRegI_immI_rule, // 323
  _AndI_eRegI_memory_rule, // 324
  eRegI_rule, // 325
  eRegI_rule, // 326
  eRegI_rule, // 327
  eRegI_rule, // 328
  eRegP_rule, // 329
  eRegP_rule, // 330
  eRegP_rule, // 331
  eRegP_rule, // 332
  eRegP_rule, // 333
  _LoadP_memory__rule, // 334
  _PartialSubtypeCheck_eSIRegP_eAXRegP_rule, // 335
  eRegL_rule, // 336
  eRegL_rule, // 337
  eRegL_rule, // 338
  eRegL_rule, // 339
  eRegL_rule, // 340
  eRegL_rule, // 341
  eRegP_rule, // 342
  eRegP_rule, // 343
  0, // 344
  eRegI_rule, // 345
  eRegL_rule, // 346
  eRegI_rule, // 347
  eRegI_rule, // 348
  eRegI_rule, // 349
  eRegI_rule, // 350
  eRegL_rule, // 351
  eRegL_rule, // 352
  eRegI_rule, // 353
  eRegL_rule, // 354
  eRegL_rule, // 355
  _LoadL_memory__rule, // 356
  memory_rule, // 357
  _LoadB_memory__rule, // 358
  memory_rule, // 359
  _LoadUB_memory__rule, // 360
  _AndI__LoadUB_memory__immI8_rule, // 361
  memory_rule, // 362
  _LShiftI__LoadS_memory__immI_24_rule, // 363
  _LoadS_memory__rule, // 364
  memory_rule, // 365
  _LShiftI__LoadUS_memory__immI_24_rule, // 366
  _LoadUS_memory__rule, // 367
  _AndI__LoadUS_memory__immI_255_rule, // 368
  _AndI__LoadUS_memory__immI16_rule, // 369
  memory_rule, // 370
  _LShiftI__LoadI_memory__immI_24_rule, // 371
  _LoadI_memory__rule, // 372
  _LShiftI__LoadI_memory__immI_16_rule, // 373
  _LoadI_memory__rule, // 374
  _LoadI_memory__rule, // 375
  _AndI__LoadI_memory__immI_255_rule, // 376
  _AndI__LoadI_memory__immI_65535_rule, // 377
  _AndI__LoadI_memory__immI_rule, // 378
  memory_rule, // 379
  load_long_memory_rule, // 380
  memory_rule, // 381
  memory_rule, // 382
  memory_rule, // 383
  memory_rule, // 384
  memory_rule, // 385
  memory_rule, // 386
  memory_rule, // 387
  memory_rule, // 388
  memory_rule, // 389
  memory_rule, // 390
  memory_rule, // 391
  memory_rule, // 392
  memory_rule, // 393
  memory_rule, // 394
  memory_rule, // 395
  memory_rule, // 396
  memory_rule, // 397
  memory_rule, // 398
  memory_rule, // 399
  memory_rule, // 400
  memory_rule, // 401
  memory_rule, // 402
  memory_rule, // 403
  memory_rule, // 404
  memory_rule, // 405
  memory_rule, // 406
  memory_rule, // 407
  memory_rule, // 408
  memory_rule, // 409
  long_memory_rule, // 410
  memory_rule, // 411
  memory_rule, // 412
  memory_rule, // 413
  memory_rule, // 414
  memory_rule, // 415
  memory_rule, // 416
  memory_rule, // 417
  memory_rule, // 418
  memory_rule, // 419
  memory_rule, // 420
  memory_rule, // 421
  memory_rule, // 422
  memory_rule, // 423
  memory_rule, // 424
  memory_rule, // 425
  memory_rule, // 426
  memory_rule, // 427
  memory_rule, // 428
  memory_rule, // 429
  memory_rule, // 430
  memory_rule, // 431
  memory_rule, // 432
  memory_rule, // 433
  0, // 434
  0, // 435
  0, // 436
  0, // 437
  0, // 438
  _Binary_cmpOp_eFlagsReg_rule, // 439
  _Binary_cmpOpU_eFlagsRegU_rule, // 440
  _Binary_cmpOpUCF_eFlagsRegUCF_rule, // 441
  _Binary_cmpOp_eFlagsReg_rule, // 442
  _Binary_cmpOpU_eFlagsRegU_rule, // 443
  _Binary_cmpOpUCF_eFlagsRegUCF_rule, // 444
  _Binary_cmpOp_eFlagsReg_rule, // 445
  _Binary_cmpOp_eFlagsReg_rule, // 446
  _Binary_cmpOpU_eFlagsRegU_rule, // 447
  _Binary_cmpOpUCF_eFlagsRegUCF_rule, // 448
  _Binary_cmpOp_fcmov_eFlagsRegU_rule, // 449
  _Binary_cmpOp_fcmov_eFlagsRegU_rule, // 450
  _Binary_cmpOp_eFlagsReg_rule, // 451
  _Binary_cmpOp_eFlagsReg_rule, // 452
  _Binary_cmpOp_eFlagsReg_rule, // 453
  _Binary_cmpOp_eFlagsReg_rule, // 454
  _Binary_cmpOpU_eFlagsRegU_rule, // 455
  _Binary_cmpOpUCF_eFlagsRegUCF_rule, // 456
  _Binary_cmpOpU_eFlagsRegU_rule, // 457
  _Binary_cmpOpUCF_eFlagsRegUCF_rule, // 458
  _Binary_cmpOp_eFlagsReg_rule, // 459
  _Binary_cmpOpU_eFlagsRegU_rule, // 460
  _Binary_cmpOpUCF_eFlagsRegUCF_rule, // 461
  eRegI_rule, // 462
  eRegI_rule, // 463
  eRegI_rule, // 464
  eRegI_rule, // 465
  eRegP_rule, // 466
  eRegI_rule, // 467
  eRegP_rule, // 468
  eRegP_rule, // 469
  eRegI_rule, // 470
  _LoadI_memory__rule, // 471
  memory_rule, // 472
  memory_rule, // 473
  memory_rule, // 474
  memory_rule, // 475
  memory_rule, // 476
  memory_rule, // 477
  load_long_memory_rule, // 478
  load_long_memory_rule, // 479
  load_long_memory_rule, // 480
  eSIRegP_rule, // 481
  pRegP_rule, // 482
  pRegP_rule, // 483
  eRegI_rule, // 484
  eRegI_rule, // 485
  eRegI_rule, // 486
  memory_rule, // 487
  eRegP_rule, // 488
  immI0_rule, // 489
  eRegI_rule, // 490
  eRegI_rule, // 491
  _RShiftL__MulL__ConvI2L_nadxRegI__eADXRegL_low_only_immI_32_rule, // 492
  _RShiftL__MulL_eADXRegL_low_only__ConvI2L_nadxRegI__immI_32_rule, // 493
  _RShiftL__MulL__ConvI2L_nadxRegI__eADXRegL_low_only_immI_32_63_rule, // 494
  _RShiftL__MulL_eADXRegL_low_only__ConvI2L_nadxRegI__immI_32_63_rule, // 495
  _LoadI_memory__rule, // 496
  eRegI_rule, // 497
  _LoadI_memory__rule, // 498
  _ConvI2L_eAXRegI__rule, // 499
  _ConvI2L_nadxRegI__rule, // 500
  _AndL__ConvI2L_eAXRegI__immL_32bits_rule, // 501
  _AndL__ConvI2L_nadxRegI__immL_32bits_rule, // 502
  eADXRegL_rule, // 503
  eADXRegL_rule, // 504
  eADXRegL_rule, // 505
  eADXRegL_rule, // 506
  eADXRegL_rule, // 507
  eAXRegI_rule, // 508
  eRegL_rule, // 509
  eAXRegI_rule, // 510
  eAXRegI_rule, // 511
  eRegL_rule, // 512
  eADXRegL_rule, // 513
  eADXRegL_rule, // 514
  eRegI_rule, // 515
  eRegI_rule, // 516
  eRegI_rule, // 517
  eRegI_rule, // 518
  memory_rule, // 519
  eRegI_rule, // 520
  memory_rule, // 521
  eRegI_rule, // 522
  eRegI_rule, // 523
  eRegI_rule, // 524
  _LShiftI_xRegI_immI_24_rule, // 525
  _LShiftI_xRegI_immI_16_rule, // 526
  eRegI_rule, // 527
  eRegI_rule, // 528
  eRegI_rule, // 529
  eRegI_rule, // 530
  _LoadI_memory__rule, // 531
  memory_rule, // 532
  memory_rule, // 533
  memory_rule, // 534
  eRegI_rule, // 535
  eRegI_rule, // 536
  _CastP2X_eRegP__rule, // 537
  eRegI_rule, // 538
  eRegI_rule, // 539
  _LoadI_memory__rule, // 540
  memory_rule, // 541
  memory_rule, // 542
  memory_rule, // 543
  0, // 544
  0, // 545
  0, // 546
  _LShiftI_eRegI_immI1_rule, // 547
  _URShiftI_eRegI_immI_M1_rule, // 548
  _LShiftI_eRegI_immI8_rule, // 549
  _URShiftI_eRegI_immI8_rule, // 550
  _LShiftI_ncxRegI_eCXRegI_rule, // 551
  _URShiftI_ncxRegI__SubI_immI0_eCXRegI_rule, // 552
  _LShiftI_ncxRegI_eCXRegI_rule, // 553
  _URShiftI_ncxRegI__SubI_immI_32_eCXRegI_rule, // 554
  0, // 555
  0, // 556
  0, // 557
  _URShiftI_eRegI_immI1_rule, // 558
  _LShiftI_eRegI_immI_M1_rule, // 559
  _URShiftI_eRegI_immI8_rule, // 560
  _LShiftI_eRegI_immI8_rule, // 561
  _URShiftI_ncxRegI_eCXRegI_rule, // 562
  _LShiftI_ncxRegI__SubI_immI0_eCXRegI_rule, // 563
  _URShiftI_ncxRegI_eCXRegI_rule, // 564
  _LShiftI_ncxRegI__SubI_immI_32_eCXRegI_rule, // 565
  eRegI_rule, // 566
  eRegI_rule, // 567
  eRegI_rule, // 568
  eRegI_rule, // 569
  _LoadI_memory__rule, // 570
  memory_rule, // 571
  memory_rule, // 572
  memory_rule, // 573
  0, // 574
  eRegI_rule, // 575
  0, // 576
  eRegP_rule, // 577
  ncxRegI_rule, // 578
  eRegI_rule, // 579
  _AndI__CmpLTMask_ncxRegI_ncxRegI_ncxRegI_rule, // 580
  _SubI_ncxRegI_ncxRegI_rule, // 581
  _AndI_ncxRegI__CmpLTMask_ncxRegI_ncxRegI_rule, // 582
  _SubI_ncxRegI_ncxRegI_rule, // 583
  eRegL_rule, // 584
  eRegL_rule, // 585
  eRegL_rule, // 586
  _LoadL_load_long_memory__rule, // 587
  eRegL_rule, // 588
  eRegL_rule, // 589
  eRegL_rule, // 590
  immL0_rule, // 591
  eRegL_rule, // 592
  eRegL_rule, // 593
  eRegL_rule, // 594
  _LoadL_load_long_memory__rule, // 595
  eRegL_rule, // 596
  eRegL_rule, // 597
  eRegL_rule, // 598
  _LoadL_load_long_memory__rule, // 599
  eRegL_rule, // 600
  eRegL_rule, // 601
  eRegL_rule, // 602
  eRegL_rule, // 603
  _LoadL_load_long_memory__rule, // 604
  eRegL_rule, // 605
  eRegL_rule, // 606
  eRegL_rule, // 607
  eRegL_rule, // 608
  eRegL_rule, // 609
  eRegL_rule, // 610
  eRegL_rule, // 611
  eRegL_rule, // 612
  eRegL_rule, // 613
  eRegL_rule, // 614
  eRegL_rule, // 615
  eRegL_rule, // 616
  regD_rule, // 617
  regD_rule, // 618
  regXD_rule, // 619
  regXD_rule, // 620
  regD_rule, // 621
  _SubD_regD_regD_rule, // 622
  regD_rule, // 623
  regD_rule, // 624
  _AddD_regD_regD_rule, // 625
  regD_rule, // 626
  _LoadD_memory__rule, // 627
  memory_rule, // 628
  memory_rule, // 629
  regD_rule, // 630
  regD_rule, // 631
  _AddD_regD_immD_rule, // 632
  regXD_rule, // 633
  regXD_rule, // 634
  regXD_rule, // 635
  _LoadD_memory__rule, // 636
  regXD_rule, // 637
  regXD_rule, // 638
  regXD_rule, // 639
  regXD_rule, // 640
  regXD_rule, // 641
  regXD_rule, // 642
  _LoadD_memory__rule, // 643
  regXD_rule, // 644
  regXD_rule, // 645
  regXD_rule, // 646
  regD_rule, // 647
  regDPR1_rule, // 648
  regD_rule, // 649
  regD_rule, // 650
  _LoadD_memory__rule, // 651
  regD_rule, // 652
  _LoadD_memory__rule, // 653
  _MulD_regD_regD_rule, // 654
  regD_rule, // 655
  _MulD_regD_regD_rule, // 656
  regD_rule, // 657
  regDPR1_rule, // 658
  _DivD_regD_regD_rule, // 659
  regD_rule, // 660
  regXD_rule, // 661
  regDPR1_rule, // 662
  regXD_rule, // 663
  regDPR1_rule, // 664
  regXD_rule, // 665
  regDPR1_rule, // 666
  regXD_rule, // 667
  regD_rule, // 668
  regXD_rule, // 669
  regD_rule, // 670
  regD_rule, // 671
  regXD_rule, // 672
  regDPR1_rule, // 673
  regXD_rule, // 674
  regDPR1_rule, // 675
  regXD_rule, // 676
  regDPR1_rule, // 677
  regXD_rule, // 678
  regF_rule, // 679
  regF_rule, // 680
  regX_rule, // 681
  regX_rule, // 682
  regF_rule, // 683
  regF_rule, // 684
  regF_rule, // 685
  regF_rule, // 686
  regX_rule, // 687
  regX_rule, // 688
  regX_rule, // 689
  _LoadF_memory__rule, // 690
  regX_rule, // 691
  regX_rule, // 692
  regX_rule, // 693
  regX_rule, // 694
  regX_rule, // 695
  regX_rule, // 696
  _LoadF_memory__rule, // 697
  regX_rule, // 698
  regX_rule, // 699
  regX_rule, // 700
  _SqrtD__ConvF2D_regX___rule, // 701
  _SqrtD__ConvF2D__LoadF_memory____rule, // 702
  regXD_rule, // 703
  _LoadD_memory__rule, // 704
  regF_rule, // 705
  _LoadF_memory__rule, // 706
  regF_rule, // 707
  _LoadF_memory__rule, // 708
  memory_rule, // 709
  memory_rule, // 710
  _LoadF_memory__rule, // 711
  memory_rule, // 712
  regF_rule, // 713
  regF_rule, // 714
  regF_rule, // 715
  regF_rule, // 716
  regF_rule, // 717
  _LoadF_memory__rule, // 718
  regF_rule, // 719
  _LoadF_memory__rule, // 720
  memory_rule, // 721
  regF_rule, // 722
  regF_rule, // 723
  _LoadF_memory__rule, // 724
  regF_rule, // 725
  _MulF__LoadF_memory__regF_rule, // 726
  regF_rule, // 727
  _MulF_regF__LoadF_memory__rule, // 728
  regF_rule, // 729
  _MulF_regF_regF_rule, // 730
  regF_rule, // 731
  _SubF_regF_regF_rule, // 732
  regF_rule, // 733
  regF_rule, // 734
  regF_rule, // 735
  regF_rule, // 736
  regX_rule, // 737
  regF_rule, // 738
  regD_rule, // 739
  regD_rule, // 740
  regD_rule, // 741
  regXD_rule, // 742
  regF_rule, // 743
  regF_rule, // 744
  regX_rule, // 745
  regX_rule, // 746
  regD_rule, // 747
  regXD_rule, // 748
  regD_rule, // 749
  regXD_rule, // 750
  regF_rule, // 751
  regX_rule, // 752
  regF_rule, // 753
  regX_rule, // 754
  stackSlotI_rule, // 755
  eRegI_rule, // 756
  _LoadI_memory__rule, // 757
  eRegI_rule, // 758
  _LoadI_memory__rule, // 759
  stackSlotI_rule, // 760
  stackSlotI_rule, // 761
  _LoadI_memory__rule, // 762
  stackSlotI_rule, // 763
  _LoadI_memory__rule, // 764
  eRegI_rule, // 765
  eRegI_rule, // 766
  eRegI_rule, // 767
  _ConvI2L_eRegI__rule, // 768
  eRegL_rule, // 769
  eRegL_rule, // 770
  eRegL_rule, // 771
  eRegL_rule, // 772
  eRegL_rule, // 773
  eRegL_rule, // 774
  regF_rule, // 775
  regX_rule, // 776
  eRegI_rule, // 777
  regD_rule, // 778
  regXD_rule, // 779
  regXD_rule, // 780
  eRegL_rule, // 781
  eRegL_rule, // 782
  regXD_rule, // 783
  eRegI_rule, // 784
  immI0_rule, // 785
  regXD_rule, // 786
  eRegI_rule, // 787
  immI0_rule, // 788
  regXD_rule, // 789
  eRegI_rule, // 790
  immI0_rule, // 791
  regXD_rule, // 792
  eRegI_rule, // 793
  immI0_rule, // 794
  regXD_rule, // 795
  regX_rule, // 796
  immXF0_rule, // 797
  eCXRegI_rule, // 798
  _Binary_eDIRegP_eCXRegI_rule, // 799
  _Binary_eDIRegP_eSIRegP_rule, // 800
  _Binary_eDIRegP_eDXRegI_rule, // 801
  _Binary_eDIRegP_eDXRegI_rule, // 802
  eDIRegP_rule, // 803
  eRegI_rule, // 804
  eRegI_rule, // 805
  _Binary_nadxRegI_eAXRegI_rule, // 806
  eRegI_rule, // 807
  0, // 808
  cmpOp_rule, // 809
  cmpOp_rule, // 810
  cmpOpU_rule, // 811
  cmpOpUCF_rule, // 812
  cmpOpU_rule, // 813
  cmpOpUCF_rule, // 814
  cmpOpUCF2_rule, // 815
  eSIRegP_rule, // 816
  0, // 817
  cmpOp_rule, // 818
  cmpOp_rule, // 819
  cmpOpU_rule, // 820
  cmpOpUCF_rule, // 821
  cmpOpU_rule, // 822
  cmpOpUCF_rule, // 823
  cmpOpUCF2_rule, // 824
  eRegL_rule, // 825
  cmpOp_rule, // 826
  _Binary_cmpOp_flagsReg_long_LTGE_rule, // 827
  _Binary_cmpOp_flagsReg_long_LTGE_rule, // 828
  _Binary_cmpOp_flagsReg_long_LTGE_rule, // 829
  _Binary_cmpOp_flagsReg_long_LTGE_rule, // 830
  _Binary_cmpOp_flagsReg_long_LTGE_rule, // 831
  _Binary_cmpOp_flagsReg_long_LTGE_rule, // 832
  _Binary_cmpOp_flagsReg_long_LTGE_rule, // 833
  _Binary_cmpOp_flagsReg_long_LTGE_rule, // 834
  _Binary_cmpOp_flagsReg_long_LTGE_rule, // 835
  cmpOp_rule, // 836
  _Binary_cmpOp_flagsReg_long_EQNE_rule, // 837
  _Binary_cmpOp_flagsReg_long_EQNE_rule, // 838
  _Binary_cmpOp_flagsReg_long_EQNE_rule, // 839
  _Binary_cmpOp_flagsReg_long_EQNE_rule, // 840
  _Binary_cmpOp_flagsReg_long_EQNE_rule, // 841
  _Binary_cmpOp_flagsReg_long_EQNE_rule, // 842
  _Binary_cmpOp_flagsReg_long_EQNE_rule, // 843
  _Binary_cmpOp_flagsReg_long_EQNE_rule, // 844
  _Binary_cmpOp_flagsReg_long_EQNE_rule, // 845
  cmpOp_commute_rule, // 846
  _Binary_cmpOp_commute_flagsReg_long_LEGT_rule, // 847
  _Binary_cmpOp_commute_flagsReg_long_LEGT_rule, // 848
  _Binary_cmpOp_commute_flagsReg_long_LEGT_rule, // 849
  _Binary_cmpOp_commute_flagsReg_long_LEGT_rule, // 850
  _Binary_cmpOp_commute_flagsReg_long_LEGT_rule, // 851
  _Binary_cmpOp_commute_flagsReg_long_LEGT_rule, // 852
  _Binary_cmpOp_commute_flagsReg_long_LEGT_rule, // 853
  _Binary_cmpOp_commute_flagsReg_long_LEGT_rule, // 854
  _Binary_cmpOp_commute_flagsReg_long_LEGT_rule, // 855
  0, // 856
  0, // 857
  0, // 858
  0, // 859
  0, // 860
  0, // 861
  0, // 862
  eRegP_no_EBP_rule, // 863
  eRegP_no_EBP_rule, // 864
  0, // 865
  0, // 866
  0, // 867
  0, // 868
  0, // 869
  // last instruction
  0 // no trailing comma
};

const        int   rightOp[] = {
  0, // 0
  0, // 1
  0, // 2
  0, // 3
  0, // 4
  0, // 5
  0, // 6
  0, // 7
  0, // 8
  0, // 9
  0, // 10
  0, // 11
  0, // 12
  0, // 13
  0, // 14
  0, // 15
  0, // 16
  0, // 17
  0, // 18
  0, // 19
  0, // 20
  0, // 21
  0, // 22
  0, // 23
  0, // 24
  0, // 25
  0, // 26
  0, // 27
  0, // 28
  0, // 29
  0, // 30
  0, // 31
  0, // 32
  0, // 33
  0, // 34
  0, // 35
  0, // 36
  0, // 37
  0, // 38
  0, // 39
  0, // 40
  0, // 41
  0, // 42
  0, // 43
  0, // 44
  0, // 45
  0, // 46
  0, // 47
  0, // 48
  0, // 49
  0, // 50
  0, // 51
  0, // 52
  0, // 53
  0, // 54
  0, // 55
  0, // 56
  0, // 57
  0, // 58
  0, // 59
  0, // 60
  0, // 61
  0, // 62
  0, // 63
  0, // 64
  0, // 65
  0, // 66
  0, // 67
  0, // 68
  0, // 69
  0, // 70
  0, // 71
  0, // 72
  0, // 73
  0, // 74
  0, // 75
  0, // 76
  0, // 77
  0, // 78
  0, // 79
  0, // 80
  0, // 81
  0, // 82
  0, // 83
  0, // 84
  0, // 85
  0, // 86
  0, // 87
  immI8_rule, // 88
  immI_rule, // 89
  eRegI_rule, // 90
  immI_rule, // 91
  eRegI_rule, // 92
  _LShiftI_eRegI_immI2_rule, // 93
  immI_rule, // 94
  0, // 95
  0, // 96
  immI_rule, // 97
  0, // 98
  0, // 99
  0, // 100
  0, // 101
  0, // 102
  0, // 103
  immI8_rule, // 104
  immI_rule, // 105
  immI_rule, // 106
  _LShiftI_eRegI_immI2_rule, // 107
  immI_rule, // 108
  0, // 109
  0, // 110
  0, // 111
  0, // 112
  0, // 113
  0, // 114
  // last operand
  0, // 115
  0, // 116
  0, // 117
  // last operand class
  eRegI_rule, // 118
  immI2_rule, // 119
  _LShiftI_eRegI_immI2_rule, // 120
  eRegI_rule, // 121
  _LShiftI_eRegI_immI2_rule, // 122
  0, // 123
  0, // 124
  0, // 125
  0, // 126
  immI8_rule, // 127
  0, // 128
  immI_24_rule, // 129
  0, // 130
  immI_24_rule, // 131
  immI_255_rule, // 132
  immI16_rule, // 133
  immI_24_rule, // 134
  immI_16_rule, // 135
  immI_255_rule, // 136
  immI_65535_rule, // 137
  immI_rule, // 138
  0, // 139
  0, // 140
  0, // 141
  0, // 142
  eFlagsReg_rule, // 143
  eRegI_rule, // 144
  eFlagsRegU_rule, // 145
  eFlagsRegUCF_rule, // 146
  _LoadI_memory__rule, // 147
  eRegP_rule, // 148
  eFlagsRegU_rule, // 149
  regD_rule, // 150
  regF_rule, // 151
  regD_rule, // 152
  regF_rule, // 153
  regX_rule, // 154
  regXD_rule, // 155
  eRegL_rule, // 156
  eRegI_rule, // 157
  _LoadI_memory__rule, // 158
  immI_rule, // 159
  immI1_rule, // 160
  immI_M1_rule, // 161
  eRegP_rule, // 162
  eRegI_rule, // 163
  eBCXRegL_rule, // 164
  eCXRegP_rule, // 165
  eCXRegI_rule, // 166
  eRegI_rule, // 167
  eRegI_rule, // 168
  0, // 169
  eADXRegL_low_only_rule, // 170
  immI_32_rule, // 171
  _ConvI2L_nadxRegI__rule, // 172
  immI_32_rule, // 173
  immI_32_63_rule, // 174
  immI_32_63_rule, // 175
  0, // 176
  immL_32bits_rule, // 177
  immL_32bits_rule, // 178
  immI1_rule, // 179
  immI8_rule, // 180
  immI_24_rule, // 181
  immI_16_rule, // 182
  eRegI_rule, // 183
  _LoadI_memory__rule, // 184
  0, // 185
  eRegI_rule, // 186
  _LoadI_memory__rule, // 187
  immI_rule, // 188
  immI1_rule, // 189
  immI_M1_rule, // 190
  immI8_rule, // 191
  immI8_rule, // 192
  eCXRegI_rule, // 193
  eCXRegI_rule, // 194
  _SubI_immI0_eCXRegI_rule, // 195
  eCXRegI_rule, // 196
  _SubI_immI_32_eCXRegI_rule, // 197
  immI1_rule, // 198
  immI_M1_rule, // 199
  eCXRegI_rule, // 200
  _SubI_immI0_eCXRegI_rule, // 201
  _SubI_immI_32_eCXRegI_rule, // 202
  eRegI_rule, // 203
  _LoadI_memory__rule, // 204
  immI_rule, // 205
  ncxRegI_rule, // 206
  ncxRegI_rule, // 207
  ncxRegI_rule, // 208
  _CmpLTMask_ncxRegI_ncxRegI_rule, // 209
  0, // 210
  0, // 211
  regD_rule, // 212
  regD_rule, // 213
  regD_rule, // 214
  0, // 215
  _LoadD_memory__rule, // 216
  0, // 217
  immD_rule, // 218
  regD_rule, // 219
  regD_rule, // 220
  0, // 221
  0, // 222
  0, // 223
  0, // 224
  0, // 225
  regF_rule, // 226
  _LoadF_memory__rule, // 227
  regF_rule, // 228
  regF_rule, // 229
  0, // 230
  eCXRegI_rule, // 231
  eDXRegI_rule, // 232
  eSIRegP_rule, // 233
  eDXRegI_rule, // 234
  immI_rule, // 235
  eAXRegI_rule, // 236
  immI_rule, // 237
  memory_rule, // 238
  0, // 239
  eAXRegI_rule, // 240
  eAXRegP_rule, // 241
  flagsReg_long_LTGE_rule, // 242
  _LoadL_load_long_memory__rule, // 243
  flagsReg_long_EQNE_rule, // 244
  flagsReg_long_LEGT_rule, // 245
  // last internally defined operand
  0, // 246
  0, // 247
  0, // 248
  0, // 249
  0, // 250
  0, // 251
  0, // 252
  0, // 253
  0, // 254
  0, // 255
  0, // 256
  0, // 257
  0, // 258
  0, // 259
  0, // 260
  0, // 261
  0, // 262
  0, // 263
  0, // 264
  0, // 265
  0, // 266
  0, // 267
  0, // 268
  0, // 269
  0, // 270
  0, // 271
  0, // 272
  0, // 273
  0, // 274
  0, // 275
  0, // 276
  0, // 277
  0, // 278
  0, // 279
  0, // 280
  0, // 281
  0, // 282
  _Binary_eAXRegP_eRegP_rule, // 283
  _Binary_eAXRegI_eRegI_rule, // 284
  _Binary_eADXRegL_eBCXRegL_rule, // 285
  0, // 286
  0, // 287
  regD_rule, // 288
  regD_rule, // 289
  regD_rule, // 290
  regXD_rule, // 291
  regXD_rule, // 292
  _LoadD_memory__rule, // 293
  _LoadD_memory__rule, // 294
  0, // 295
  0, // 296
  0, // 297
  0, // 298
  regF_rule, // 299
  regF_rule, // 300
  regF_rule, // 301
  regX_rule, // 302
  regX_rule, // 303
  _LoadF_memory__rule, // 304
  _LoadF_memory__rule, // 305
  0, // 306
  0, // 307
  0, // 308
  0, // 309
  0, // 310
  0, // 311
  0, // 312
  0, // 313
  0, // 314
  0, // 315
  0, // 316
  0, // 317
  0, // 318
  eRegI_rule, // 319
  immI_rule, // 320
  _LoadI_memory__rule, // 321
  immI0_rule, // 322
  immI0_rule, // 323
  immI0_rule, // 324
  eRegI_rule, // 325
  immI_rule, // 326
  _LoadI_memory__rule, // 327
  immI0_rule, // 328
  eRegP_rule, // 329
  immP_rule, // 330
  _LoadP_memory__rule, // 331
  _LoadP_memory__rule, // 332
  immP0_rule, // 333
  immI0_rule, // 334
  immP0_rule, // 335
  immL0_rule, // 336
  eRegL_rule, // 337
  immL0_rule, // 338
  eRegL_rule, // 339
  immL0_rule, // 340
  eRegL_rule, // 341
  eRegP_rule, // 342
  eAXRegP_rule, // 343
  0, // 344
  0, // 345
  0, // 346
  0, // 347
  0, // 348
  0, // 349
  0, // 350
  0, // 351
  0, // 352
  0, // 353
  0, // 354
  0, // 355
  0, // 356
  0, // 357
  0, // 358
  0, // 359
  0, // 360
  0, // 361
  0, // 362
  immI_24_rule, // 363
  0, // 364
  0, // 365
  immI_24_rule, // 366
  0, // 367
  0, // 368
  0, // 369
  0, // 370
  immI_24_rule, // 371
  immI_255_rule, // 372
  immI_16_rule, // 373
  immI_65535_rule, // 374
  0, // 375
  0, // 376
  0, // 377
  0, // 378
  0, // 379
  0, // 380
  0, // 381
  0, // 382
  0, // 383
  0, // 384
  0, // 385
  0, // 386
  0, // 387
  0, // 388
  0, // 389
  0, // 390
  0, // 391
  0, // 392
  0, // 393
  0, // 394
  0, // 395
  0, // 396
  0, // 397
  0, // 398
  0, // 399
  0, // 400
  0, // 401
  0, // 402
  0, // 403
  0, // 404
  0, // 405
  0, // 406
  xRegI_rule, // 407
  eRegI_rule, // 408
  eRegI_rule, // 409
  eRegL_rule, // 410
  _ConvL2I_eRegL__rule, // 411
  stackSlotL_rule, // 412
  stackSlotL_rule, // 413
  eRegL_rule, // 414
  anyRegP_rule, // 415
  immI_rule, // 416
  immI16_rule, // 417
  immP_rule, // 418
  immI8_rule, // 419
  regXD_rule, // 420
  regXD_rule, // 421
  regXD_rule, // 422
  immI8_rule, // 423
  regDPR1_rule, // 424
  _RoundDouble_regDPR1__rule, // 425
  regXD_rule, // 426
  regX_rule, // 427
  regXD_rule, // 428
  regFPR1_rule, // 429
  _RoundFloat_regFPR1__rule, // 430
  _ConvD2F_regDPR1__rule, // 431
  immF_rule, // 432
  immXF_rule, // 433
  0, // 434
  0, // 435
  0, // 436
  0, // 437
  0, // 438
  _Binary_eRegI_eRegI_rule, // 439
  _Binary_eRegI_eRegI_rule, // 440
  _Binary_eRegI_eRegI_rule, // 441
  _Binary_eRegI__LoadI_memory__rule, // 442
  _Binary_eRegI__LoadI_memory__rule, // 443
  _Binary_eRegI__LoadI_memory__rule, // 444
  _Binary_eRegP_eRegP_rule, // 445
  _Binary_eRegP_eRegP_rule, // 446
  _Binary_eRegP_eRegP_rule, // 447
  _Binary_eRegP_eRegP_rule, // 448
  _Binary_regDPR1_regD_rule, // 449
  _Binary_regFPR1_regF_rule, // 450
  _Binary_regD_regD_rule, // 451
  _Binary_regF_regF_rule, // 452
  _Binary_regX_regX_rule, // 453
  _Binary_regXD_regXD_rule, // 454
  _Binary_regX_regX_rule, // 455
  _Binary_regX_regX_rule, // 456
  _Binary_regXD_regXD_rule, // 457
  _Binary_regXD_regXD_rule, // 458
  _Binary_eRegL_eRegL_rule, // 459
  _Binary_eRegL_eRegL_rule, // 460
  _Binary_eRegL_eRegL_rule, // 461
  eRegI_rule, // 462
  immI_rule, // 463
  immI1_rule, // 464
  immI_rule, // 465
  immI_rule, // 466
  immI_M1_rule, // 467
  eRegI_rule, // 468
  immI_rule, // 469
  _LoadI_memory__rule, // 470
  eRegI_rule, // 471
  _AddI__LoadI_memory__eRegI_rule, // 472
  _AddI_eRegI__LoadI_memory__rule, // 473
  _AddI__LoadI_memory__immI_rule, // 474
  _AddI__LoadI_memory__immI1_rule, // 475
  _AddI__LoadI_memory__immI_M1_rule, // 476
  0, // 477
  0, // 478
  0, // 479
  0, // 480
  _Binary_eADXRegL_eBCXRegL_rule, // 481
  _Binary_eAXRegP_eCXRegP_rule, // 482
  _Binary_eAXRegI_eCXRegI_rule, // 483
  eRegI_rule, // 484
  immI_rule, // 485
  _LoadI_memory__rule, // 486
  _SubI__LoadI_memory__eRegI_rule, // 487
  _SubI_immI0_eRegI_rule, // 488
  eRegI_rule, // 489
  eRegI_rule, // 490
  immI_rule, // 491
  0, // 492
  0, // 493
  0, // 494
  0, // 495
  immI_rule, // 496
  _LoadI_memory__rule, // 497
  eRegI_rule, // 498
  _ConvI2L_nadxRegI__rule, // 499
  _ConvI2L_eAXRegI__rule, // 500
  _AndL__ConvI2L_nadxRegI__immL_32bits_rule, // 501
  _AndL__ConvI2L_eAXRegI__immL_32bits_rule, // 502
  eRegL_rule, // 503
  eRegL_rule, // 504
  eRegL_rule, // 505
  eRegL_rule, // 506
  immL_127_rule, // 507
  eCXRegI_rule, // 508
  eRegL_rule, // 509
  eCXRegI_rule, // 510
  eCXRegI_rule, // 511
  eRegL_rule, // 512
  immL32_rule, // 513
  immL32_rule, // 514
  immI1_rule, // 515
  immI8_rule, // 516
  eCXRegI_rule, // 517
  immI1_rule, // 518
  _RShiftI__LoadI_memory__immI1_rule, // 519
  immI8_rule, // 520
  _RShiftI__LoadI_memory__immI8_rule, // 521
  eCXRegI_rule, // 522
  immI1_rule, // 523
  immI8_rule, // 524
  immI_24_rule, // 525
  immI_16_rule, // 526
  eCXRegI_rule, // 527
  eRegI_rule, // 528
  immI_rule, // 529
  _LoadI_memory__rule, // 530
  eRegI_rule, // 531
  _AndI__LoadI_memory__eRegI_rule, // 532
  _AndI_eRegI__LoadI_memory__rule, // 533
  _AndI__LoadI_memory__immI_rule, // 534
  eRegI_rule, // 535
  _CastP2X_eRegP__rule, // 536
  eRegI_rule, // 537
  immI_rule, // 538
  _LoadI_memory__rule, // 539
  eRegI_rule, // 540
  _OrI__LoadI_memory__eRegI_rule, // 541
  _OrI_eRegI__LoadI_memory__rule, // 542
  _OrI__LoadI_memory__immI_rule, // 543
  0, // 544
  0, // 545
  0, // 546
  _URShiftI_eRegI_immI_M1_rule, // 547
  _LShiftI_eRegI_immI1_rule, // 548
  _URShiftI_eRegI_immI8_rule, // 549
  _LShiftI_eRegI_immI8_rule, // 550
  _URShiftI_ncxRegI__SubI_immI0_eCXRegI_rule, // 551
  _LShiftI_ncxRegI_eCXRegI_rule, // 552
  _URShiftI_ncxRegI__SubI_immI_32_eCXRegI_rule, // 553
  _LShiftI_ncxRegI_eCXRegI_rule, // 554
  0, // 555
  0, // 556
  0, // 557
  _LShiftI_eRegI_immI_M1_rule, // 558
  _URShiftI_eRegI_immI1_rule, // 559
  _LShiftI_eRegI_immI8_rule, // 560
  _URShiftI_eRegI_immI8_rule, // 561
  _LShiftI_ncxRegI__SubI_immI0_eCXRegI_rule, // 562
  _URShiftI_ncxRegI_eCXRegI_rule, // 563
  _LShiftI_ncxRegI__SubI_immI_32_eCXRegI_rule, // 564
  _URShiftI_ncxRegI_eCXRegI_rule, // 565
  eRegI_rule, // 566
  immI_M1_rule, // 567
  immI_rule, // 568
  _LoadI_memory__rule, // 569
  eRegI_rule, // 570
  _XorI__LoadI_memory__eRegI_rule, // 571
  _XorI_eRegI__LoadI_memory__rule, // 572
  _XorI__LoadI_memory__immI_rule, // 573
  0, // 574
  0, // 575
  0, // 576
  0, // 577
  ncxRegI_rule, // 578
  immI0_rule, // 579
  _SubI_ncxRegI_ncxRegI_rule, // 580
  _AndI__CmpLTMask_ncxRegI_ncxRegI_ncxRegI_rule, // 581
  _SubI_ncxRegI_ncxRegI_rule, // 582
  _AndI_ncxRegI__CmpLTMask_ncxRegI_ncxRegI_rule, // 583
  eRegL_rule, // 584
  immL_rule, // 585
  _LoadL_load_long_memory__rule, // 586
  eRegL_rule, // 587
  eRegL_rule, // 588
  immL_rule, // 589
  _LoadL_load_long_memory__rule, // 590
  eRegL_rule, // 591
  eRegL_rule, // 592
  immL_rule, // 593
  _LoadL_load_long_memory__rule, // 594
  eRegL_rule, // 595
  eRegL_rule, // 596
  immL_rule, // 597
  _LoadL_load_long_memory__rule, // 598
  eRegL_rule, // 599
  eRegL_rule, // 600
  immL_M1_rule, // 601
  immL_rule, // 602
  _LoadL_load_long_memory__rule, // 603
  eRegL_rule, // 604
  immI_1_rule, // 605
  immI_2_rule, // 606
  immI_3_rule, // 607
  immI_1_31_rule, // 608
  immI_32_63_rule, // 609
  eCXRegI_rule, // 610
  immI_1_31_rule, // 611
  immI_32_63_rule, // 612
  eCXRegI_rule, // 613
  immI_1_31_rule, // 614
  immI_32_63_rule, // 615
  eCXRegI_rule, // 616
  immD0_rule, // 617
  regD_rule, // 618
  regXD_rule, // 619
  _LoadD_memory__rule, // 620
  regD_rule, // 621
  0, // 622
  _LoadD_memory__rule, // 623
  regD_rule, // 624
  0, // 625
  _LoadD_memory__rule, // 626
  regD_rule, // 627
  _RoundDouble__AddD__LoadD_memory__regD__rule, // 628
  _RoundDouble__AddD_regD__LoadD_memory___rule, // 629
  immD1_rule, // 630
  immD_rule, // 631
  0, // 632
  regXD_rule, // 633
  immXD_rule, // 634
  _LoadD_memory__rule, // 635
  regXD_rule, // 636
  regXD_rule, // 637
  immXD_rule, // 638
  _LoadD_memory__rule, // 639
  regXD_rule, // 640
  immXD_rule, // 641
  _LoadD_memory__rule, // 642
  regXD_rule, // 643
  regXD_rule, // 644
  immXD_rule, // 645
  _LoadD_memory__rule, // 646
  regD_rule, // 647
  regnotDPR1_rule, // 648
  immD_rule, // 649
  _LoadD_memory__rule, // 650
  regD_rule, // 651
  _LoadD_memory__rule, // 652
  regD_rule, // 653
  regD_rule, // 654
  _MulD_regD_regD_rule, // 655
  regD_rule, // 656
  regD_rule, // 657
  regnotDPR1_rule, // 658
  0, // 659
  regD_rule, // 660
  regXD_rule, // 661
  0, // 662
  0, // 663
  0, // 664
  0, // 665
  0, // 666
  0, // 667
  regD_rule, // 668
  regXD_rule, // 669
  0, // 670
  regDPR1_rule, // 671
  regXD_rule, // 672
  0, // 673
  0, // 674
  0, // 675
  0, // 676
  0, // 677
  0, // 678
  immF0_rule, // 679
  regF_rule, // 680
  regX_rule, // 681
  _LoadF_memory__rule, // 682
  regF_rule, // 683
  regF_rule, // 684
  regF_rule, // 685
  regF_rule, // 686
  regX_rule, // 687
  immXF_rule, // 688
  _LoadF_memory__rule, // 689
  regX_rule, // 690
  regX_rule, // 691
  immXF_rule, // 692
  _LoadF_memory__rule, // 693
  regX_rule, // 694
  immXF_rule, // 695
  _LoadF_memory__rule, // 696
  regX_rule, // 697
  regX_rule, // 698
  immXF_rule, // 699
  _LoadF_memory__rule, // 700
  0, // 701
  0, // 702
  0, // 703
  0, // 704
  _LoadF_memory__rule, // 705
  regF_rule, // 706
  _LoadF_memory__rule, // 707
  regF_rule, // 708
  regF_rule, // 709
  _LoadF_memory__rule, // 710
  memory_rule, // 711
  memory_rule, // 712
  immF_rule, // 713
  immF_rule, // 714
  regF_rule, // 715
  regF_rule, // 716
  _LoadF_memory__rule, // 717
  regF_rule, // 718
  _LoadF_memory__rule, // 719
  regF_rule, // 720
  memory_rule, // 721
  immF_rule, // 722
  immF_rule, // 723
  regF_rule, // 724
  _LoadF_memory__rule, // 725
  regF_rule, // 726
  _MulF__LoadF_memory__regF_rule, // 727
  regF_rule, // 728
  _MulF_regF__LoadF_memory__rule, // 729
  regF_rule, // 730
  _MulF_regF_regF_rule, // 731
  regF_rule, // 732
  regF_rule, // 733
  regF_rule, // 734
  regF_rule, // 735
  regF_rule, // 736
  regX_rule, // 737
  0, // 738
  0, // 739
  0, // 740
  0, // 741
  0, // 742
  0, // 743
  0, // 744
  0, // 745
  0, // 746
  0, // 747
  0, // 748
  0, // 749
  0, // 750
  0, // 751
  0, // 752
  0, // 753
  0, // 754
  0, // 755
  0, // 756
  0, // 757
  0, // 758
  0, // 759
  0, // 760
  0, // 761
  0, // 762
  0, // 763
  0, // 764
  0, // 765
  0, // 766
  0, // 767
  immL_32bits_rule, // 768
  immL_32bits_rule, // 769
  0, // 770
  0, // 771
  0, // 772
  0, // 773
  0, // 774
  0, // 775
  0, // 776
  0, // 777
  0, // 778
  0, // 779
  0, // 780
  0, // 781
  0, // 782
  0, // 783
  0, // 784
  0, // 785
  0, // 786
  0, // 787
  0, // 788
  0, // 789
  0, // 790
  0, // 791
  0, // 792
  0, // 793
  0, // 794
  0, // 795
  0, // 796
  0, // 797
  eDIRegP_rule, // 798
  _Binary_eSIRegP_eDXRegI_rule, // 799
  eCXRegI_rule, // 800
  _Binary_eSIRegP_immI_rule, // 801
  _Binary_eSIRegP_eAXRegI_rule, // 802
  eSIRegP_rule, // 803
  eRegI_rule, // 804
  eRegI_rule, // 805
  immI_rule, // 806
  0, // 807
  0, // 808
  eFlagsReg_rule, // 809
  eFlagsReg_rule, // 810
  eFlagsRegU_rule, // 811
  eFlagsRegUCF_rule, // 812
  eFlagsRegU_rule, // 813
  eFlagsRegUCF_rule, // 814
  eFlagsRegUCF_rule, // 815
  eAXRegP_rule, // 816
  0, // 817
  eFlagsReg_rule, // 818
  eFlagsReg_rule, // 819
  eFlagsRegU_rule, // 820
  eFlagsRegUCF_rule, // 821
  eFlagsRegU_rule, // 822
  eFlagsRegUCF_rule, // 823
  eFlagsRegUCF_rule, // 824
  eRegL_rule, // 825
  flagsReg_long_LTGE_rule, // 826
  _Binary_eRegL_eRegL_rule, // 827
  _Binary_eRegL__LoadL_load_long_memory__rule, // 828
  _Binary_eRegI_eRegI_rule, // 829
  _Binary_eRegI__LoadI_memory__rule, // 830
  _Binary_eRegP_eRegP_rule, // 831
  _Binary_regD_regD_rule, // 832
  _Binary_regXD_regXD_rule, // 833
  _Binary_regF_regF_rule, // 834
  _Binary_regX_regX_rule, // 835
  flagsReg_long_EQNE_rule, // 836
  _Binary_eRegL_eRegL_rule, // 837
  _Binary_eRegL__LoadL_load_long_memory__rule, // 838
  _Binary_eRegI_eRegI_rule, // 839
  _Binary_eRegI__LoadI_memory__rule, // 840
  _Binary_eRegP_eRegP_rule, // 841
  _Binary_regD_regD_rule, // 842
  _Binary_regXD_regXD_rule, // 843
  _Binary_regF_regF_rule, // 844
  _Binary_regX_regX_rule, // 845
  flagsReg_long_LEGT_rule, // 846
  _Binary_eRegL_eRegL_rule, // 847
  _Binary_eRegL__LoadL_load_long_memory__rule, // 848
  _Binary_eRegI_eRegI_rule, // 849
  _Binary_eRegI__LoadI_memory__rule, // 850
  _Binary_eRegP_eRegP_rule, // 851
  _Binary_regD_regD_rule, // 852
  _Binary_regXD_regXD_rule, // 853
  _Binary_regF_regF_rule, // 854
  _Binary_regX_regX_rule, // 855
  0, // 856
  0, // 857
  0, // 858
  0, // 859
  0, // 860
  0, // 861
  0, // 862
  eBXRegP_rule, // 863
  eAXRegP_rule, // 864
  0, // 865
  0, // 866
  0, // 867
  0, // 868
  0, // 869
  // last instruction
  0 // no trailing comma
};

const char        *ruleName[] = {
  "UNIVERSE", // 0
  "LABEL", // 1
  "SREGI", // 2
  "SREGP", // 3
  "SREGF", // 4
  "SREGD", // 5
  "SREGL", // 6
  "METHOD", // 7
  "IMMI", // 8
  "IMMI0", // 9
  "IMMI1", // 10
  "IMMI_M1", // 11
  "IMMI2", // 12
  "IMMI8", // 13
  "IMMI16", // 14
  "IMMI_32", // 15
  "IMMI_1_31", // 16
  "IMMI_32_63", // 17
  "IMMI_1", // 18
  "IMMI_2", // 19
  "IMMI_3", // 20
  "IMMP", // 21
  "IMMP0", // 22
  "IMML", // 23
  "IMML0", // 24
  "IMML_M1", // 25
  "IMML_127", // 26
  "IMML_32BITS", // 27
  "IMML32", // 28
  "IMMD0", // 29
  "IMMD1", // 30
  "IMMD", // 31
  "IMMXD", // 32
  "IMMXD0", // 33
  "IMMF0", // 34
  "IMMF1", // 35
  "IMMF", // 36
  "IMMXF", // 37
  "IMMXF0", // 38
  "IMMI_16", // 39
  "IMMI_24", // 40
  "IMMI_255", // 41
  "IMMI_65535", // 42
  "EREGI", // 43
  "XREGI", // 44
  "EAXREGI", // 45
  "EBXREGI", // 46
  "ECXREGI", // 47
  "EDXREGI", // 48
  "EDIREGI", // 49
  "NAXREGI", // 50
  "NADXREGI", // 51
  "NCXREGI", // 52
  "ESIREGI", // 53
  "ANYREGP", // 54
  "EREGP", // 55
  "EREGP_NO_EBP", // 56
  "NAXREGP", // 57
  "NABXREGP", // 58
  "PREGP", // 59
  "EAXREGP", // 60
  "EBXREGP", // 61
  "ECXREGP", // 62
  "ESIREGP", // 63
  "EDIREGP", // 64
  "EBPREGP", // 65
  "EREGL", // 66
  "EADXREGL", // 67
  "EBCXREGL", // 68
  "EADXREGL_LOW_ONLY", // 69
  "EFLAGSREG", // 70
  "EFLAGSREGU", // 71
  "EFLAGSREGUCF", // 72
  "FLAGSREG_LONG_LTGE", // 73
  "FLAGSREG_LONG_EQNE", // 74
  "FLAGSREG_LONG_LEGT", // 75
  "REGD", // 76
  "REGDPR1", // 77
  "REGDPR2", // 78
  "REGNOTDPR1", // 79
  "REGXD", // 80
  "REGXD6", // 81
  "REGXD7", // 82
  "REGF", // 83
  "REGFPR1", // 84
  "REGX", // 85
  "DIRECT", // 86
  "INDIRECT", // 87
  "INDOFFSET8", // 88
  "INDOFFSET32", // 89
  "INDOFFSET32X", // 90
  "INDINDEXOFFSET", // 91
  "INDINDEX", // 92
  "INDINDEXSCALE", // 93
  "INDINDEXSCALEOFFSET", // 94
  "LOAD_LONG_REGP", // 95
  "LOAD_LONG_INDIRECT", // 96
  "LOAD_LONG_INDOFFSET32", // 97
  "STACKSLOTP", // 98
  "STACKSLOTI", // 99
  "STACKSLOTF", // 100
  "STACKSLOTD", // 101
  "STACKSLOTL", // 102
  "INDIRECT_WIN95_SAFE", // 103
  "INDOFFSET8_WIN95_SAFE", // 104
  "INDOFFSET32_WIN95_SAFE", // 105
  "INDINDEXOFFSET_WIN95_SAFE", // 106
  "INDINDEXSCALE_WIN95_SAFE", // 107
  "INDINDEXSCALEOFFSET_WIN95_SAFE", // 108
  "CMPOP", // 109
  "CMPOPU", // 110
  "CMPOPUCF", // 111
  "CMPOPUCF2", // 112
  "CMPOP_FCMOV", // 113
  "CMPOP_COMMUTE", // 114
  // last operand
  "LOAD_LONG_MEMORY", // 115
  "MEMORY", // 116
  "LONG_MEMORY", // 117
  // last operand class
  "_AddP_eRegP_eRegI", // 118
  "_LShiftI_eRegI_immI2", // 119
  "_AddP_eRegP__LShiftI_eRegI_immI2", // 120
  "_AddP_eRegP_no_EBP_eRegI", // 121
  "_AddP_eRegP_no_EBP__LShiftI_eRegI_immI2", // 122
  "_LoadI_memory_", // 123
  "_LoadL_memory_", // 124
  "_LoadB_memory_", // 125
  "_LoadUB_memory_", // 126
  "_AndI__LoadUB_memory__immI8", // 127
  "_LoadS_memory_", // 128
  "_LShiftI__LoadS_memory__immI_24", // 129
  "_LoadUS_memory_", // 130
  "_LShiftI__LoadUS_memory__immI_24", // 131
  "_AndI__LoadUS_memory__immI_255", // 132
  "_AndI__LoadUS_memory__immI16", // 133
  "_LShiftI__LoadI_memory__immI_24", // 134
  "_LShiftI__LoadI_memory__immI_16", // 135
  "_AndI__LoadI_memory__immI_255", // 136
  "_AndI__LoadI_memory__immI_65535", // 137
  "_AndI__LoadI_memory__immI", // 138
  "_ConvL2I_eRegL_", // 139
  "_RoundDouble_regDPR1_", // 140
  "_RoundFloat_regFPR1_", // 141
  "_ConvD2F_regDPR1_", // 142
  "_Binary_cmpOp_eFlagsReg", // 143
  "_Binary_eRegI_eRegI", // 144
  "_Binary_cmpOpU_eFlagsRegU", // 145
  "_Binary_cmpOpUCF_eFlagsRegUCF", // 146
  "_Binary_eRegI__LoadI_memory_", // 147
  "_Binary_eRegP_eRegP", // 148
  "_Binary_cmpOp_fcmov_eFlagsRegU", // 149
  "_Binary_regDPR1_regD", // 150
  "_Binary_regFPR1_regF", // 151
  "_Binary_regD_regD", // 152
  "_Binary_regF_regF", // 153
  "_Binary_regX_regX", // 154
  "_Binary_regXD_regXD", // 155
  "_Binary_eRegL_eRegL", // 156
  "_AddI__LoadI_memory__eRegI", // 157
  "_AddI_eRegI__LoadI_memory_", // 158
  "_AddI__LoadI_memory__immI", // 159
  "_AddI__LoadI_memory__immI1", // 160
  "_AddI__LoadI_memory__immI_M1", // 161
  "_Binary_eAXRegP_eRegP", // 162
  "_Binary_eAXRegI_eRegI", // 163
  "_Binary_eADXRegL_eBCXRegL", // 164
  "_Binary_eAXRegP_eCXRegP", // 165
  "_Binary_eAXRegI_eCXRegI", // 166
  "_SubI__LoadI_memory__eRegI", // 167
  "_SubI_immI0_eRegI", // 168
  "_ConvI2L_nadxRegI_", // 169
  "_MulL__ConvI2L_nadxRegI__eADXRegL_low_only", // 170
  "_RShiftL__MulL__ConvI2L_nadxRegI__eADXRegL_low_only_immI_32", // 171
  "_MulL_eADXRegL_low_only__ConvI2L_nadxRegI_", // 172
  "_RShiftL__MulL_eADXRegL_low_only__ConvI2L_nadxRegI__immI_32", // 173
  "_RShiftL__MulL__ConvI2L_nadxRegI__eADXRegL_low_only_immI_32_63", // 174
  "_RShiftL__MulL_eADXRegL_low_only__ConvI2L_nadxRegI__immI_32_63", // 175
  "_ConvI2L_eAXRegI_", // 176
  "_AndL__ConvI2L_eAXRegI__immL_32bits", // 177
  "_AndL__ConvI2L_nadxRegI__immL_32bits", // 178
  "_RShiftI__LoadI_memory__immI1", // 179
  "_RShiftI__LoadI_memory__immI8", // 180
  "_LShiftI_xRegI_immI_24", // 181
  "_LShiftI_xRegI_immI_16", // 182
  "_AndI__LoadI_memory__eRegI", // 183
  "_AndI_eRegI__LoadI_memory_", // 184
  "_CastP2X_eRegP_", // 185
  "_OrI__LoadI_memory__eRegI", // 186
  "_OrI_eRegI__LoadI_memory_", // 187
  "_OrI__LoadI_memory__immI", // 188
  "_LShiftI_eRegI_immI1", // 189
  "_URShiftI_eRegI_immI_M1", // 190
  "_LShiftI_eRegI_immI8", // 191
  "_URShiftI_eRegI_immI8", // 192
  "_LShiftI_ncxRegI_eCXRegI", // 193
  "_SubI_immI0_eCXRegI", // 194
  "_URShiftI_ncxRegI__SubI_immI0_eCXRegI", // 195
  "_SubI_immI_32_eCXRegI", // 196
  "_URShiftI_ncxRegI__SubI_immI_32_eCXRegI", // 197
  "_URShiftI_eRegI_immI1", // 198
  "_LShiftI_eRegI_immI_M1", // 199
  "_URShiftI_ncxRegI_eCXRegI", // 200
  "_LShiftI_ncxRegI__SubI_immI0_eCXRegI", // 201
  "_LShiftI_ncxRegI__SubI_immI_32_eCXRegI", // 202
  "_XorI__LoadI_memory__eRegI", // 203
  "_XorI_eRegI__LoadI_memory_", // 204
  "_XorI__LoadI_memory__immI", // 205
  "_CmpLTMask_ncxRegI_ncxRegI", // 206
  "_AndI__CmpLTMask_ncxRegI_ncxRegI_ncxRegI", // 207
  "_SubI_ncxRegI_ncxRegI", // 208
  "_AndI_ncxRegI__CmpLTMask_ncxRegI_ncxRegI", // 209
  "_LoadL_load_long_memory_", // 210
  "_LoadD_memory_", // 211
  "_SubD_regD_regD", // 212
  "_AddD_regD_regD", // 213
  "_AddD__LoadD_memory__regD", // 214
  "_RoundDouble__AddD__LoadD_memory__regD_", // 215
  "_AddD_regD__LoadD_memory_", // 216
  "_RoundDouble__AddD_regD__LoadD_memory__", // 217
  "_AddD_regD_immD", // 218
  "_MulD_regD_regD", // 219
  "_DivD_regD_regD", // 220
  "_LoadF_memory_", // 221
  "_ConvF2D_regX_", // 222
  "_SqrtD__ConvF2D_regX__", // 223
  "_ConvF2D__LoadF_memory__", // 224
  "_SqrtD__ConvF2D__LoadF_memory___", // 225
  "_MulF__LoadF_memory__regF", // 226
  "_MulF_regF__LoadF_memory_", // 227
  "_MulF_regF_regF", // 228
  "_SubF_regF_regF", // 229
  "_ConvI2L_eRegI_", // 230
  "_Binary_eDIRegP_eCXRegI", // 231
  "_Binary_eSIRegP_eDXRegI", // 232
  "_Binary_eDIRegP_eSIRegP", // 233
  "_Binary_eDIRegP_eDXRegI", // 234
  "_Binary_eSIRegP_immI", // 235
  "_Binary_eSIRegP_eAXRegI", // 236
  "_AndI_eRegI_immI", // 237
  "_AndI_eRegI_memory", // 238
  "_LoadP_memory_", // 239
  "_Binary_nadxRegI_eAXRegI", // 240
  "_PartialSubtypeCheck_eSIRegP_eAXRegP", // 241
  "_Binary_cmpOp_flagsReg_long_LTGE", // 242
  "_Binary_eRegL__LoadL_load_long_memory_", // 243
  "_Binary_cmpOp_flagsReg_long_EQNE", // 244
  "_Binary_cmpOp_commute_flagsReg_long_LEGT", // 245
  // last internally defined operand
  "storeSSI", // 246
  "storeSSP", // 247
  "storeSSL", // 248
  "leaP8", // 249
  "leaP32", // 250
  "leaPIdxOff", // 251
  "leaPIdxScale", // 252
  "leaPIdxScaleOff", // 253
  "loadConI", // 254
  "loadConI0", // 255
  "loadConP", // 256
  "loadConL", // 257
  "loadConL0", // 258
  "loadConF", // 259
  "loadConF0", // 260
  "loadConF1", // 261
  "loadConX", // 262
  "loadConX0", // 263
  "loadConD", // 264
  "loadConD0", // 265
  "loadConD1", // 266
  "loadConXD", // 267
  "loadConXD0", // 268
  "loadSSI", // 269
  "loadSSL", // 270
  "loadSSP", // 271
  "loadSSF", // 272
  "loadSSD", // 273
  "loadConL_low_only", // 274
  "popCountI", // 275
  "popCountI_mem", // 276
  "membar_volatile", // 277
  "castX2P", // 278
  "castP2X", // 279
  "checkCastPP", // 280
  "castPP", // 281
  "castII", // 282
  "storePConditional", // 283
  "storeIConditional", // 284
  "storeLConditional", // 285
  "movI_nocopy", // 286
  "movP_nocopy", // 287
  "cmpD_cc_P6", // 288
  "cmpD_cc_P6CF", // 289
  "cmpD_cc", // 290
  "cmpXD_cc", // 291
  "cmpXD_ccCF", // 292
  "cmpXD_ccmem", // 293
  "cmpXD_ccmemCF", // 294
  "absD_reg", // 295
  "absXD_reg", // 296
  "negD_reg", // 297
  "negXD_reg", // 298
  "cmpF_cc_P6", // 299
  "cmpF_cc_P6CF", // 300
  "cmpF_cc", // 301
  "cmpX_cc", // 302
  "cmpX_ccCF", // 303
  "cmpX_ccmem", // 304
  "cmpX_ccmemCF", // 305
  "absF_reg", // 306
  "absX_reg", // 307
  "negF_reg", // 308
  "negX_reg", // 309
  "MoveF2I_stack_reg", // 310
  "MoveF2I_reg_reg_sse", // 311
  "MoveI2F_stack_reg", // 312
  "MoveI2F_stack_reg_sse", // 313
  "MoveI2F_reg_reg_sse", // 314
  "MoveD2L_stack_reg", // 315
  "MoveL2D_stack_reg", // 316
  "MoveL2D_stack_reg_sse", // 317
  "MoveL2D_stack_reg_sse_partial", // 318
  "compI_eReg", // 319
  "compI_eReg_imm", // 320
  "compI_eReg_mem", // 321
  "testI_reg", // 322
  "testI_reg_imm", // 323
  "testI_reg_mem", // 324
  "compU_eReg", // 325
  "compU_eReg_imm", // 326
  "compU_eReg_mem", // 327
  "testU_reg", // 328
  "compP_eReg", // 329
  "compP_eReg_imm", // 330
  "compP_eReg_mem", // 331
  "compP_mem_eReg", // 332
  "testP_reg", // 333
  "testP_Reg_mem", // 334
  "partialSubtypeCheck_vs_Zero", // 335
  "cmpL_zero_flags_LTGE", // 336
  "cmpL_reg_flags_LTGE", // 337
  "cmpL_zero_flags_EQNE", // 338
  "cmpL_reg_flags_EQNE", // 339
  "cmpL_zero_flags_LEGT", // 340
  "cmpL_reg_flags_LEGT", // 341
  "cmpFastLock", // 342
  "cmpFastUnlock", // 343
  "safePoint_poll", // 344
  "bytes_reverse_int", // 345
  "bytes_reverse_long", // 346
  "bytes_reverse_unsigned_short", // 347
  "bytes_reverse_short", // 348
  "countLeadingZerosI", // 349
  "countLeadingZerosI_bsr", // 350
  "countLeadingZerosL", // 351
  "countLeadingZerosL_bsr", // 352
  "countTrailingZerosI", // 353
  "countTrailingZerosL", // 354
  "popCountL", // 355
  "popCountL_mem", // 356
  "loadB", // 357
  "loadB2L", // 358
  "loadUB", // 359
  "loadUB2L", // 360
  "loadUB2L_immI8", // 361
  "loadS", // 362
  "loadS2B", // 363
  "loadS2L", // 364
  "loadUS", // 365
  "loadUS2B", // 366
  "loadUS2L", // 367
  "loadUS2L_immI_255", // 368
  "loadUS2L_immI16", // 369
  "loadI", // 370
  "loadI2B", // 371
  "loadI2UB", // 372
  "loadI2S", // 373
  "loadI2US", // 374
  "loadI2L", // 375
  "loadI2L_immI_255", // 376
  "loadI2L_immI_65535", // 377
  "loadI2L_immI", // 378
  "loadUI2L", // 379
  "loadL", // 380
  "loadL_volatile", // 381
  "loadLX_volatile", // 382
  "loadLX_reg_volatile", // 383
  "loadRange", // 384
  "loadP", // 385
  "loadKlass", // 386
  "loadD", // 387
  "loadXD", // 388
  "loadXD_partial", // 389
  "loadX", // 390
  "loadF", // 391
  "loadA8B", // 392
  "loadA4S", // 393
  "loadA4C", // 394
  "load2IU", // 395
  "loadA2F", // 396
  "prefetchr0", // 397
  "prefetchr", // 398
  "prefetchrNTA", // 399
  "prefetchrT0", // 400
  "prefetchrT2", // 401
  "prefetchw0", // 402
  "prefetchw", // 403
  "prefetchwNTA", // 404
  "prefetchwT0", // 405
  "prefetchwT2", // 406
  "storeB", // 407
  "storeC", // 408
  "storeI", // 409
  "storeL", // 410
  "storeL2I", // 411
  "storeL_volatile", // 412
  "storeLX_volatile", // 413
  "storeLX_reg_volatile", // 414
  "storeP", // 415
  "storeImmI", // 416
  "storeImmI16", // 417
  "storeImmP", // 418
  "storeImmB", // 419
  "storeA8B", // 420
  "storeA4C", // 421
  "storeA2I", // 422
  "storeImmCM", // 423
  "storeD", // 424
  "storeD_rounded", // 425
  "storeXD", // 426
  "storeX", // 427
  "storeA2F", // 428
  "storeF", // 429
  "storeF_rounded", // 430
  "storeF_Drounded", // 431
  "storeF_imm", // 432
  "storeX_imm", // 433
  "membar_acquire", // 434
  "membar_acquire_lock", // 435
  "membar_release", // 436
  "membar_release_lock", // 437
  "unnecessary_membar_volatile", // 438
  "cmovI_reg", // 439
  "cmovI_regU", // 440
  "cmovI_regUCF", // 441
  "cmovI_mem", // 442
  "cmovI_memU", // 443
  "cmovI_memUCF", // 444
  "cmovP_reg", // 445
  "cmovP_reg_nonP6", // 446
  "cmovP_regU", // 447
  "cmovP_regUCF", // 448
  "fcmovD_regU", // 449
  "fcmovF_regU", // 450
  "fcmovD_regS", // 451
  "fcmovF_regS", // 452
  "fcmovX_regS", // 453
  "fcmovXD_regS", // 454
  "fcmovX_regU", // 455
  "fcmovX_regUCF", // 456
  "fcmovXD_regU", // 457
  "fcmovXD_regUCF", // 458
  "cmovL_reg", // 459
  "cmovL_regU", // 460
  "cmovL_regUCF", // 461
  "addI_eReg", // 462
  "addI_eReg_imm", // 463
  "incI_eReg", // 464
  "leaI_eReg_immI", // 465
  "leaP_eReg_immI", // 466
  "decI_eReg", // 467
  "addP_eReg", // 468
  "addP_eReg_imm", // 469
  "addI_eReg_mem", // 470
  "addI_eReg_mem_0", // 471
  "addI_mem_eReg", // 472
  "addI_mem_eReg_0", // 473
  "addI_mem_imm", // 474
  "incI_mem", // 475
  "decI_mem", // 476
  "loadPLocked", // 477
  "loadLLocked", // 478
  "loadLX_Locked", // 479
  "loadLX_reg_Locked", // 480
  "compareAndSwapL", // 481
  "compareAndSwapP", // 482
  "compareAndSwapI", // 483
  "subI_eReg", // 484
  "subI_eReg_imm", // 485
  "subI_eReg_mem", // 486
  "subI_mem_eReg", // 487
  "subP_eReg", // 488
  "negI_eReg", // 489
  "mulI_eReg", // 490
  "mulI_eReg_imm", // 491
  "mulI_imm_high", // 492
  "mulI_imm_high_0", // 493
  "mulI_imm_RShift_high", // 494
  "mulI_imm_RShift_high_0", // 495
  "mulI_mem_imm", // 496
  "mulI", // 497
  "mulI_0", // 498
  "mulI2L", // 499
  "mulI2L_0", // 500
  "mulIS_eReg", // 501
  "mulIS_eReg_0", // 502
  "mulL_eReg", // 503
  "mulL_eReg_lhi0", // 504
  "mulL_eReg_rhi0", // 505
  "mulL_eReg_hi0", // 506
  "mulL_eReg_con", // 507
  "divI_eReg", // 508
  "divL_eReg", // 509
  "divModI_eReg_divmod", // 510
  "modI_eReg", // 511
  "modL_eReg", // 512
  "divL_eReg_imm32", // 513
  "modL_eReg_imm32", // 514
  "shlI_eReg_1", // 515
  "salI_eReg_imm", // 516
  "salI_eReg_CL", // 517
  "sarI_eReg_1", // 518
  "sarI_mem_1", // 519
  "sarI_eReg_imm", // 520
  "sarI_mem_imm", // 521
  "sarI_eReg_CL", // 522
  "shrI_eReg_1", // 523
  "shrI_eReg_imm", // 524
  "i2b", // 525
  "i2s", // 526
  "shrI_eReg_CL", // 527
  "andI_eReg", // 528
  "andI_eReg_imm", // 529
  "andI_eReg_mem", // 530
  "andI_eReg_mem_0", // 531
  "andI_mem_eReg", // 532
  "andI_mem_eReg_0", // 533
  "andI_mem_imm", // 534
  "orI_eReg", // 535
  "orI_eReg_castP2X", // 536
  "orI_eReg_castP2X_0", // 537
  "orI_eReg_imm", // 538
  "orI_eReg_mem", // 539
  "orI_eReg_mem_0", // 540
  "orI_mem_eReg", // 541
  "orI_mem_eReg_0", // 542
  "orI_mem_imm", // 543
  "rolI_eReg_imm1", // 544
  "rolI_eReg_imm8", // 545
  "rolI_eReg_CL", // 546
  "rolI_eReg_i1", // 547
  "rolI_eReg_i1_0", // 548
  "rolI_eReg_i8", // 549
  "rolI_eReg_i8_0", // 550
  "rolI_eReg_Var_C0", // 551
  "rolI_eReg_Var_C0_0", // 552
  "rolI_eReg_Var_C32", // 553
  "rolI_eReg_Var_C32_0", // 554
  "rorI_eReg_imm1", // 555
  "rorI_eReg_imm8", // 556
  "rorI_eReg_CL", // 557
  "rorI_eReg_i1", // 558
  "rorI_eReg_i1_0", // 559
  "rorI_eReg_i8", // 560
  "rorI_eReg_i8_0", // 561
  "rorI_eReg_Var_C0", // 562
  "rorI_eReg_Var_C0_0", // 563
  "rorI_eReg_Var_C32", // 564
  "rorI_eReg_Var_C32_0", // 565
  "xorI_eReg", // 566
  "xorI_eReg_im1", // 567
  "xorI_eReg_imm", // 568
  "xorI_eReg_mem", // 569
  "xorI_eReg_mem_0", // 570
  "xorI_mem_eReg", // 571
  "xorI_mem_eReg_0", // 572
  "xorI_mem_imm", // 573
  "ci2b", // 574
  "convI2B", // 575
  "cp2b", // 576
  "convP2B", // 577
  "cmpLTMask", // 578
  "cmpLTMask0", // 579
  "cadd_cmpLTMask", // 580
  "cadd_cmpLTMask_1", // 581
  "cadd_cmpLTMask_0", // 582
  "cadd_cmpLTMask_2", // 583
  "addL_eReg", // 584
  "addL_eReg_imm", // 585
  "addL_eReg_mem", // 586
  "addL_eReg_mem_0", // 587
  "subL_eReg", // 588
  "subL_eReg_imm", // 589
  "subL_eReg_mem", // 590
  "negL_eReg", // 591
  "andL_eReg", // 592
  "andL_eReg_imm", // 593
  "andL_eReg_mem", // 594
  "andL_eReg_mem_0", // 595
  "orl_eReg", // 596
  "orl_eReg_imm", // 597
  "orl_eReg_mem", // 598
  "orl_eReg_mem_0", // 599
  "xorl_eReg", // 600
  "xorl_eReg_im1", // 601
  "xorl_eReg_imm", // 602
  "xorl_eReg_mem", // 603
  "xorl_eReg_mem_0", // 604
  "shlL_eReg_1", // 605
  "shlL_eReg_2", // 606
  "shlL_eReg_3", // 607
  "shlL_eReg_1_31", // 608
  "shlL_eReg_32_63", // 609
  "salL_eReg_CL", // 610
  "shrL_eReg_1_31", // 611
  "shrL_eReg_32_63", // 612
  "shrL_eReg_CL", // 613
  "sarL_eReg_1_31", // 614
  "sarL_eReg_32_63", // 615
  "sarL_eReg_CL", // 616
  "cmpD_0", // 617
  "cmpD_reg", // 618
  "cmpXD_reg", // 619
  "cmpXD_regmem", // 620
  "subD_reg", // 621
  "subD_reg_round", // 622
  "subD_reg_mem", // 623
  "addD_reg", // 624
  "addD_reg_round", // 625
  "addD_reg_mem", // 626
  "addD_reg_mem_0", // 627
  "addD_mem_reg", // 628
  "addD_mem_reg_0", // 629
  "addD_reg_imm1", // 630
  "addD_reg_imm", // 631
  "addD_reg_imm_round", // 632
  "addXD_reg", // 633
  "addXD_imm", // 634
  "addXD_mem", // 635
  "addXD_mem_0", // 636
  "subXD_reg", // 637
  "subXD_imm", // 638
  "subXD_mem", // 639
  "mulXD_reg", // 640
  "mulXD_imm", // 641
  "mulXD_mem", // 642
  "mulXD_mem_0", // 643
  "divXD_reg", // 644
  "divXD_imm", // 645
  "divXD_mem", // 646
  "mulD_reg", // 647
  "strictfp_mulD_reg", // 648
  "mulD_reg_imm", // 649
  "mulD_reg_mem", // 650
  "mulD_reg_mem_0", // 651
  "mulD_reg_mem_cisc", // 652
  "mulD_reg_mem_cisc_0", // 653
  "addD_mulD_reg", // 654
  "addD_mulD_reg_0", // 655
  "subD_mulD_reg", // 656
  "divD_reg", // 657
  "strictfp_divD_reg", // 658
  "divD_reg_round", // 659
  "modD_reg", // 660
  "modXD_reg", // 661
  "sinD_reg", // 662
  "sinXD_reg", // 663
  "cosD_reg", // 664
  "cosXD_reg", // 665
  "tanD_reg", // 666
  "tanXD_reg", // 667
  "atanD_reg", // 668
  "atanXD_reg", // 669
  "sqrtD_reg", // 670
  "powD_reg", // 671
  "powXD_reg", // 672
  "expD_reg", // 673
  "expXD_reg", // 674
  "log10D_reg", // 675
  "log10XD_reg", // 676
  "logD_reg", // 677
  "logXD_reg", // 678
  "cmpF_0", // 679
  "cmpF_reg", // 680
  "cmpX_reg", // 681
  "cmpX_regmem", // 682
  "subF24_reg", // 683
  "subF_reg", // 684
  "addF24_reg", // 685
  "addF_reg", // 686
  "addX_reg", // 687
  "addX_imm", // 688
  "addX_mem", // 689
  "addX_mem_0", // 690
  "subX_reg", // 691
  "subX_imm", // 692
  "subX_mem", // 693
  "mulX_reg", // 694
  "mulX_imm", // 695
  "mulX_mem", // 696
  "mulX_mem_0", // 697
  "divX_reg", // 698
  "divX_imm", // 699
  "divX_mem", // 700
  "sqrtX_reg", // 701
  "sqrtX_mem", // 702
  "sqrtXD_reg", // 703
  "sqrtXD_mem", // 704
  "addF24_reg_mem", // 705
  "addF24_reg_mem_0", // 706
  "addF_reg_mem", // 707
  "addF_reg_mem_0", // 708
  "addF24_mem_reg", // 709
  "addF24_mem_cisc", // 710
  "addF24_mem_cisc_0", // 711
  "addF24_mem_mem", // 712
  "addF24_reg_imm", // 713
  "addF_reg_imm", // 714
  "mulF24_reg", // 715
  "mulF_reg", // 716
  "mulF24_reg_mem", // 717
  "mulF24_reg_mem_0", // 718
  "mulF_reg_mem", // 719
  "mulF_reg_mem_0", // 720
  "mulF24_mem_mem", // 721
  "mulF24_reg_imm", // 722
  "mulF_reg_imm", // 723
  "mulF_reg_load1", // 724
  "mulF_reg_load1_0", // 725
  "addF_mulF_reg_load1", // 726
  "addF_mulF_reg_load1_1", // 727
  "addF_mulF_reg_load1_0", // 728
  "addF_mulF_reg_load1_2", // 729
  "addF_mulF_reg", // 730
  "addF_mulF_reg_0", // 731
  "subF_divF_reg", // 732
  "divF24_reg", // 733
  "divF_reg", // 734
  "modF24_reg", // 735
  "modF_reg", // 736
  "modX_reg", // 737
  "roundFloat_mem_reg", // 738
  "roundDouble_mem_reg", // 739
  "convD2F_reg", // 740
  "convD2X_reg", // 741
  "convXD2X_reg", // 742
  "convF2D_reg_reg", // 743
  "convF2D_reg", // 744
  "convX2D_reg", // 745
  "convX2XD_reg", // 746
  "convD2I_reg_reg", // 747
  "convXD2I_reg_reg", // 748
  "convD2L_reg_reg", // 749
  "convXD2L_reg_reg", // 750
  "convF2I_reg_reg", // 751
  "convX2I_reg", // 752
  "convF2L_reg_reg", // 753
  "convX2L_reg_reg", // 754
  "convI2D_reg", // 755
  "convI2XD_reg", // 756
  "convI2XD_mem", // 757
  "convXI2XD_reg", // 758
  "convI2D_mem", // 759
  "conv24I2F_reg", // 760
  "convI2F_SSF", // 761
  "convI2F_SSF_mem", // 762
  "convI2F_reg", // 763
  "convI2F_mem", // 764
  "convI2X_reg", // 765
  "convXI2X_reg", // 766
  "convI2L_reg", // 767
  "convI2L_reg_zex", // 768
  "zerox_long", // 769
  "convL2D_reg", // 770
  "convL2XD_reg", // 771
  "convL2X_reg", // 772
  "convL2F_reg", // 773
  "convL2I_reg", // 774
  "MoveF2I_reg_stack", // 775
  "MoveF2I_reg_stack_sse", // 776
  "MoveI2F_reg_stack", // 777
  "MoveD2L_reg_stack", // 778
  "MoveD2L_reg_stack_sse", // 779
  "MoveD2L_reg_reg_sse", // 780
  "MoveL2D_reg_stack", // 781
  "MoveL2D_reg_reg_sse", // 782
  "Repl8B_reg", // 783
  "Repl8B_eRegI", // 784
  "Repl8B_immI0", // 785
  "Repl4S_reg", // 786
  "Repl4S_eRegI", // 787
  "Repl4S_immI0", // 788
  "Repl4C_reg", // 789
  "Repl4C_eRegI", // 790
  "Repl4C_immI0", // 791
  "Repl2I_reg", // 792
  "Repl2I_eRegI", // 793
  "Repl2I_immI0", // 794
  "Repl2F_reg", // 795
  "Repl2F_regX", // 796
  "Repl2F_immXF0", // 797
  "rep_stos", // 798
  "string_compare", // 799
  "string_equals", // 800
  "string_indexof_con", // 801
  "string_indexof", // 802
  "array_equals", // 803
  "minI_eReg", // 804
  "maxI_eReg", // 805
  "loopLimit_eReg", // 806
  "jumpXtnd", // 807
  "jmpDir", // 808
  "jmpCon", // 809
  "jmpLoopEnd", // 810
  "jmpLoopEndU", // 811
  "jmpLoopEndUCF", // 812
  "jmpConU", // 813
  "jmpConUCF", // 814
  "jmpConUCF2", // 815
  "partialSubtypeCheck", // 816
  "jmpDir_short", // 817
  "jmpCon_short", // 818
  "jmpLoopEnd_short", // 819
  "jmpLoopEndU_short", // 820
  "jmpLoopEndUCF_short", // 821
  "jmpConU_short", // 822
  "jmpConUCF_short", // 823
  "jmpConUCF2_short", // 824
  "cmpL3_reg_reg", // 825
  "cmpL_LTGE", // 826
  "cmovLL_reg_LTGE", // 827
  "cmovLL_mem_LTGE", // 828
  "cmovII_reg_LTGE", // 829
  "cmovII_mem_LTGE", // 830
  "cmovPP_reg_LTGE", // 831
  "cmovDD_reg_LTGE", // 832
  "cmovXDD_reg_LTGE", // 833
  "cmovFF_reg_LTGE", // 834
  "cmovXX_reg_LTGE", // 835
  "cmpL_EQNE", // 836
  "cmovLL_reg_EQNE", // 837
  "cmovLL_mem_EQNE", // 838
  "cmovII_reg_EQNE", // 839
  "cmovII_mem_EQNE", // 840
  "cmovPP_reg_EQNE", // 841
  "cmovDD_reg_EQNE", // 842
  "cmovXDD_reg_EQNE", // 843
  "cmovFF_reg_EQNE", // 844
  "cmovXX_reg_EQNE", // 845
  "cmpL_LEGT", // 846
  "cmovLL_reg_LEGT", // 847
  "cmovLL_mem_LEGT", // 848
  "cmovII_reg_LEGT", // 849
  "cmovII_mem_LEGT", // 850
  "cmovPP_reg_LEGT", // 851
  "cmovDD_reg_LEGT", // 852
  "cmovXDD_reg_LEGT", // 853
  "cmovFF_reg_LEGT", // 854
  "cmovXX_reg_LEGT", // 855
  "CallStaticJavaDirect", // 856
  "CallStaticJavaHandle", // 857
  "CallDynamicJavaDirect", // 858
  "CallRuntimeDirect", // 859
  "CallLeafDirect", // 860
  "CallLeafNoFPDirect", // 861
  "Ret", // 862
  "TailCalljmpInd", // 863
  "tailjmpInd", // 864
  "CreateException", // 865
  "RethrowException", // 866
  "tlsLoadP", // 867
  "TLS", // 868
  "ShouldNotReachHere", // 869
  // last instruction
  "no trailing comma"
};

const        bool  swallowed[] = {
  false, // 0
  false, // 1
  false, // 2
  false, // 3
  false, // 4
  false, // 5
  false, // 6
  false, // 7
  true, // 8
  true, // 9
  true, // 10
  true, // 11
  true, // 12
  true, // 13
  true, // 14
  true, // 15
  true, // 16
  true, // 17
  true, // 18
  true, // 19
  true, // 20
  true, // 21
  true, // 22
  true, // 23
  true, // 24
  true, // 25
  true, // 26
  true, // 27
  true, // 28
  true, // 29
  true, // 30
  true, // 31
  true, // 32
  true, // 33
  true, // 34
  true, // 35
  true, // 36
  true, // 37
  true, // 38
  true, // 39
  true, // 40
  true, // 41
  true, // 42
  false, // 43
  false, // 44
  false, // 45
  false, // 46
  false, // 47
  false, // 48
  false, // 49
  false, // 50
  false, // 51
  false, // 52
  false, // 53
  false, // 54
  false, // 55
  false, // 56
  false, // 57
  false, // 58
  false, // 59
  false, // 60
  false, // 61
  false, // 62
  false, // 63
  false, // 64
  false, // 65
  false, // 66
  false, // 67
  false, // 68
  false, // 69
  false, // 70
  false, // 71
  false, // 72
  false, // 73
  false, // 74
  false, // 75
  false, // 76
  false, // 77
  false, // 78
  false, // 79
  false, // 80
  false, // 81
  false, // 82
  false, // 83
  false, // 84
  false, // 85
  true, // 86
  false, // 87
  false, // 88
  false, // 89
  false, // 90
  false, // 91
  false, // 92
  false, // 93
  false, // 94
  false, // 95
  false, // 96
  false, // 97
  false, // 98
  false, // 99
  false, // 100
  false, // 101
  false, // 102
  false, // 103
  false, // 104
  false, // 105
  false, // 106
  false, // 107
  false, // 108
  true, // 109
  true, // 110
  true, // 111
  true, // 112
  true, // 113
  true, // 114
  // last operand
  false, // 115
  false, // 116
  false, // 117
  // last operand class
  false, // 118
  false, // 119
  false, // 120
  false, // 121
  false, // 122
  false, // 123
  false, // 124
  false, // 125
  false, // 126
  false, // 127
  false, // 128
  false, // 129
  false, // 130
  false, // 131
  false, // 132
  false, // 133
  false, // 134
  false, // 135
  false, // 136
  false, // 137
  false, // 138
  false, // 139
  false, // 140
  false, // 141
  false, // 142
  false, // 143
  false, // 144
  false, // 145
  false, // 146
  false, // 147
  false, // 148
  false, // 149
  false, // 150
  false, // 151
  false, // 152
  false, // 153
  false, // 154
  false, // 155
  false, // 156
  false, // 157
  false, // 158
  false, // 159
  false, // 160
  false, // 161
  false, // 162
  false, // 163
  false, // 164
  false, // 165
  false, // 166
  false, // 167
  false, // 168
  false, // 169
  false, // 170
  false, // 171
  false, // 172
  false, // 173
  false, // 174
  false, // 175
  false, // 176
  false, // 177
  false, // 178
  false, // 179
  false, // 180
  false, // 181
  false, // 182
  false, // 183
  false, // 184
  false, // 185
  false, // 186
  false, // 187
  false, // 188
  false, // 189
  false, // 190
  false, // 191
  false, // 192
  false, // 193
  false, // 194
  false, // 195
  false, // 196
  false, // 197
  false, // 198
  false, // 199
  false, // 200
  false, // 201
  false, // 202
  false, // 203
  false, // 204
  false, // 205
  false, // 206
  false, // 207
  false, // 208
  false, // 209
  false, // 210
  false, // 211
  false, // 212
  false, // 213
  false, // 214
  false, // 215
  false, // 216
  false, // 217
  false, // 218
  false, // 219
  false, // 220
  false, // 221
  false, // 222
  false, // 223
  false, // 224
  false, // 225
  false, // 226
  false, // 227
  false, // 228
  false, // 229
  false, // 230
  false, // 231
  false, // 232
  false, // 233
  false, // 234
  false, // 235
  false, // 236
  false, // 237
  false, // 238
  false, // 239
  false, // 240
  false, // 241
  false, // 242
  false, // 243
  false, // 244
  false, // 245
  // last internally defined operand
  false, // 246
  false, // 247
  false, // 248
  false, // 249
  false, // 250
  false, // 251
  false, // 252
  false, // 253
  false, // 254
  false, // 255
  false, // 256
  false, // 257
  false, // 258
  false, // 259
  false, // 260
  false, // 261
  false, // 262
  false, // 263
  false, // 264
  false, // 265
  false, // 266
  false, // 267
  false, // 268
  false, // 269
  false, // 270
  false, // 271
  false, // 272
  false, // 273
  false, // 274
  false, // 275
  false, // 276
  false, // 277
  false, // 278
  false, // 279
  false, // 280
  false, // 281
  false, // 282
  false, // 283
  false, // 284
  false, // 285
  false, // 286
  false, // 287
  false, // 288
  false, // 289
  false, // 290
  false, // 291
  false, // 292
  false, // 293
  false, // 294
  false, // 295
  false, // 296
  false, // 297
  false, // 298
  false, // 299
  false, // 300
  false, // 301
  false, // 302
  false, // 303
  false, // 304
  false, // 305
  false, // 306
  false, // 307
  false, // 308
  false, // 309
  false, // 310
  false, // 311
  false, // 312
  false, // 313
  false, // 314
  false, // 315
  false, // 316
  false, // 317
  false, // 318
  false, // 319
  false, // 320
  false, // 321
  false, // 322
  false, // 323
  false, // 324
  false, // 325
  false, // 326
  false, // 327
  false, // 328
  false, // 329
  false, // 330
  false, // 331
  false, // 332
  false, // 333
  false, // 334
  false, // 335
  false, // 336
  false, // 337
  false, // 338
  false, // 339
  false, // 340
  false, // 341
  false, // 342
  false, // 343
  false, // 344
  false, // 345
  false, // 346
  false, // 347
  false, // 348
  false, // 349
  false, // 350
  false, // 351
  false, // 352
  false, // 353
  false, // 354
  false, // 355
  false, // 356
  false, // 357
  false, // 358
  false, // 359
  false, // 360
  false, // 361
  false, // 362
  false, // 363
  false, // 364
  false, // 365
  false, // 366
  false, // 367
  false, // 368
  false, // 369
  false, // 370
  false, // 371
  false, // 372
  false, // 373
  false, // 374
  false, // 375
  false, // 376
  false, // 377
  false, // 378
  false, // 379
  false, // 380
  false, // 381
  false, // 382
  false, // 383
  false, // 384
  false, // 385
  false, // 386
  false, // 387
  false, // 388
  false, // 389
  false, // 390
  false, // 391
  false, // 392
  false, // 393
  false, // 394
  false, // 395
  false, // 396
  false, // 397
  false, // 398
  false, // 399
  false, // 400
  false, // 401
  false, // 402
  false, // 403
  false, // 404
  false, // 405
  false, // 406
  false, // 407
  false, // 408
  false, // 409
  false, // 410
  false, // 411
  false, // 412
  false, // 413
  false, // 414
  false, // 415
  false, // 416
  false, // 417
  false, // 418
  false, // 419
  false, // 420
  false, // 421
  false, // 422
  false, // 423
  false, // 424
  false, // 425
  false, // 426
  false, // 427
  false, // 428
  false, // 429
  false, // 430
  false, // 431
  false, // 432
  false, // 433
  false, // 434
  false, // 435
  false, // 436
  false, // 437
  false, // 438
  false, // 439
  false, // 440
  false, // 441
  false, // 442
  false, // 443
  false, // 444
  false, // 445
  false, // 446
  false, // 447
  false, // 448
  false, // 449
  false, // 450
  false, // 451
  false, // 452
  false, // 453
  false, // 454
  false, // 455
  false, // 456
  false, // 457
  false, // 458
  false, // 459
  false, // 460
  false, // 461
  false, // 462
  false, // 463
  false, // 464
  false, // 465
  false, // 466
  false, // 467
  false, // 468
  false, // 469
  false, // 470
  false, // 471
  false, // 472
  false, // 473
  false, // 474
  false, // 475
  false, // 476
  false, // 477
  false, // 478
  false, // 479
  false, // 480
  false, // 481
  false, // 482
  false, // 483
  false, // 484
  false, // 485
  false, // 486
  false, // 487
  false, // 488
  false, // 489
  false, // 490
  false, // 491
  false, // 492
  false, // 493
  false, // 494
  false, // 495
  false, // 496
  false, // 497
  false, // 498
  false, // 499
  false, // 500
  false, // 501
  false, // 502
  false, // 503
  false, // 504
  false, // 505
  false, // 506
  false, // 507
  false, // 508
  false, // 509
  false, // 510
  false, // 511
  false, // 512
  false, // 513
  false, // 514
  false, // 515
  false, // 516
  false, // 517
  false, // 518
  false, // 519
  false, // 520
  false, // 521
  false, // 522
  false, // 523
  false, // 524
  false, // 525
  false, // 526
  false, // 527
  false, // 528
  false, // 529
  false, // 530
  false, // 531
  false, // 532
  false, // 533
  false, // 534
  false, // 535
  false, // 536
  false, // 537
  false, // 538
  false, // 539
  false, // 540
  false, // 541
  false, // 542
  false, // 543
  false, // 544
  false, // 545
  false, // 546
  false, // 547
  false, // 548
  false, // 549
  false, // 550
  false, // 551
  false, // 552
  false, // 553
  false, // 554
  false, // 555
  false, // 556
  false, // 557
  false, // 558
  false, // 559
  false, // 560
  false, // 561
  false, // 562
  false, // 563
  false, // 564
  false, // 565
  false, // 566
  false, // 567
  false, // 568
  false, // 569
  false, // 570
  false, // 571
  false, // 572
  false, // 573
  false, // 574
  false, // 575
  false, // 576
  false, // 577
  false, // 578
  false, // 579
  false, // 580
  false, // 581
  false, // 582
  false, // 583
  false, // 584
  false, // 585
  false, // 586
  false, // 587
  false, // 588
  false, // 589
  false, // 590
  false, // 591
  false, // 592
  false, // 593
  false, // 594
  false, // 595
  false, // 596
  false, // 597
  false, // 598
  false, // 599
  false, // 600
  false, // 601
  false, // 602
  false, // 603
  false, // 604
  false, // 605
  false, // 606
  false, // 607
  false, // 608
  false, // 609
  false, // 610
  false, // 611
  false, // 612
  false, // 613
  false, // 614
  false, // 615
  false, // 616
  false, // 617
  false, // 618
  false, // 619
  false, // 620
  false, // 621
  false, // 622
  false, // 623
  false, // 624
  false, // 625
  false, // 626
  false, // 627
  false, // 628
  false, // 629
  false, // 630
  false, // 631
  false, // 632
  false, // 633
  false, // 634
  false, // 635
  false, // 636
  false, // 637
  false, // 638
  false, // 639
  false, // 640
  false, // 641
  false, // 642
  false, // 643
  false, // 644
  false, // 645
  false, // 646
  false, // 647
  false, // 648
  false, // 649
  false, // 650
  false, // 651
  false, // 652
  false, // 653
  false, // 654
  false, // 655
  false, // 656
  false, // 657
  false, // 658
  false, // 659
  false, // 660
  false, // 661
  false, // 662
  false, // 663
  false, // 664
  false, // 665
  false, // 666
  false, // 667
  false, // 668
  false, // 669
  false, // 670
  false, // 671
  false, // 672
  false, // 673
  false, // 674
  false, // 675
  false, // 676
  false, // 677
  false, // 678
  false, // 679
  false, // 680
  false, // 681
  false, // 682
  false, // 683
  false, // 684
  false, // 685
  false, // 686
  false, // 687
  false, // 688
  false, // 689
  false, // 690
  false, // 691
  false, // 692
  false, // 693
  false, // 694
  false, // 695
  false, // 696
  false, // 697
  false, // 698
  false, // 699
  false, // 700
  false, // 701
  false, // 702
  false, // 703
  false, // 704
  false, // 705
  false, // 706
  false, // 707
  false, // 708
  false, // 709
  false, // 710
  false, // 711
  false, // 712
  false, // 713
  false, // 714
  false, // 715
  false, // 716
  false, // 717
  false, // 718
  false, // 719
  false, // 720
  false, // 721
  false, // 722
  false, // 723
  false, // 724
  false, // 725
  false, // 726
  false, // 727
  false, // 728
  false, // 729
  false, // 730
  false, // 731
  false, // 732
  false, // 733
  false, // 734
  false, // 735
  false, // 736
  false, // 737
  false, // 738
  false, // 739
  false, // 740
  false, // 741
  false, // 742
  false, // 743
  false, // 744
  false, // 745
  false, // 746
  false, // 747
  false, // 748
  false, // 749
  false, // 750
  false, // 751
  false, // 752
  false, // 753
  false, // 754
  false, // 755
  false, // 756
  false, // 757
  false, // 758
  false, // 759
  false, // 760
  false, // 761
  false, // 762
  false, // 763
  false, // 764
  false, // 765
  false, // 766
  false, // 767
  false, // 768
  false, // 769
  false, // 770
  false, // 771
  false, // 772
  false, // 773
  false, // 774
  false, // 775
  false, // 776
  false, // 777
  false, // 778
  false, // 779
  false, // 780
  false, // 781
  false, // 782
  false, // 783
  false, // 784
  false, // 785
  false, // 786
  false, // 787
  false, // 788
  false, // 789
  false, // 790
  false, // 791
  false, // 792
  false, // 793
  false, // 794
  false, // 795
  false, // 796
  false, // 797
  false, // 798
  false, // 799
  false, // 800
  false, // 801
  false, // 802
  false, // 803
  false, // 804
  false, // 805
  false, // 806
  false, // 807
  false, // 808
  false, // 809
  false, // 810
  false, // 811
  false, // 812
  false, // 813
  false, // 814
  false, // 815
  false, // 816
  false, // 817
  false, // 818
  false, // 819
  false, // 820
  false, // 821
  false, // 822
  false, // 823
  false, // 824
  false, // 825
  false, // 826
  false, // 827
  false, // 828
  false, // 829
  false, // 830
  false, // 831
  false, // 832
  false, // 833
  false, // 834
  false, // 835
  false, // 836
  false, // 837
  false, // 838
  false, // 839
  false, // 840
  false, // 841
  false, // 842
  false, // 843
  false, // 844
  false, // 845
  false, // 846
  false, // 847
  false, // 848
  false, // 849
  false, // 850
  false, // 851
  false, // 852
  false, // 853
  false, // 854
  false, // 855
  false, // 856
  false, // 857
  false, // 858
  false, // 859
  false, // 860
  false, // 861
  false, // 862
  false, // 863
  false, // 864
  false, // 865
  false, // 866
  false, // 867
  false, // 868
  false, // 869
  // last instruction
  false // no trailing comma
};

// Mapping from machine-independent opcode to boolean
const        char must_clone[] = {
  0, // Node: 0
  0, // Set: 1
  0, // RegN: 2
  0, // RegI: 3
  0, // RegP: 4
  0, // RegF: 5
  0, // RegD: 6
  0, // RegL: 7
  0, // RegFlags: 8
  0, // _last_machine_leaf: 9
  0, // AbsD: 10
  0, // AbsF: 11
  0, // AbsI: 12
  0, // AddD: 13
  0, // AddF: 14
  0, // AddI: 15
  0, // AddL: 16
  0, // AddP: 17
  0, // Allocate: 18
  0, // AllocateArray: 19
  0, // AndI: 20
  0, // AndL: 21
  0, // AryEq: 22
  0, // AtanD: 23
  1, // Binary: 24
  1, // Bool: 25
  0, // BoxLock: 26
  0, // ReverseBytesI: 27
  0, // ReverseBytesL: 28
  0, // ReverseBytesUS: 29
  0, // ReverseBytesS: 30
  0, // CProj: 31
  0, // CallDynamicJava: 32
  0, // CallJava: 33
  0, // CallLeaf: 34
  0, // CallLeafNoFP: 35
  0, // CallRuntime: 36
  0, // CallStaticJava: 37
  0, // CastII: 38
  0, // CastX2P: 39
  0, // CastP2X: 40
  0, // CastPP: 41
  0, // Catch: 42
  0, // CatchProj: 43
  0, // CheckCastPP: 44
  0, // ClearArray: 45
  0, // ConstraintCast: 46
  0, // CMoveD: 47
  0, // CMoveF: 48
  0, // CMoveI: 49
  0, // CMoveL: 50
  0, // CMoveP: 51
  0, // CMoveN: 52
  1, // CmpN: 53
  1, // CmpD: 54
  0, // CmpD3: 55
  1, // CmpF: 56
  0, // CmpF3: 57
  1, // CmpI: 58
  1, // CmpL: 59
  0, // CmpL3: 60
  0, // CmpLTMask: 61
  1, // CmpP: 62
  1, // CmpU: 63
  0, // CompareAndSwapI: 64
  0, // CompareAndSwapL: 65
  0, // CompareAndSwapP: 66
  0, // CompareAndSwapN: 67
  0, // Con: 68
  0, // ConN: 69
  0, // ConD: 70
  0, // ConF: 71
  0, // ConI: 72
  0, // ConL: 73
  0, // ConP: 74
  0, // Conv2B: 75
  0, // ConvD2F: 76
  0, // ConvD2I: 77
  0, // ConvD2L: 78
  0, // ConvF2D: 79
  0, // ConvF2I: 80
  0, // ConvF2L: 81
  0, // ConvI2D: 82
  0, // ConvI2F: 83
  0, // ConvI2L: 84
  0, // ConvL2D: 85
  0, // ConvL2F: 86
  0, // ConvL2I: 87
  0, // CosD: 88
  0, // CountedLoop: 89
  0, // CountedLoopEnd: 90
  0, // CountLeadingZerosI: 91
  0, // CountLeadingZerosL: 92
  0, // CountTrailingZerosI: 93
  0, // CountTrailingZerosL: 94
  0, // CreateEx: 95
  0, // DecodeN: 96
  0, // DivD: 97
  0, // DivF: 98
  0, // DivI: 99
  0, // DivL: 100
  0, // DivMod: 101
  0, // DivModI: 102
  0, // DivModL: 103
  0, // EncodeP: 104
  0, // ExpD: 105
  1, // FastLock: 106
  1, // FastUnlock: 107
  0, // Goto: 108
  0, // Halt: 109
  0, // If: 110
  0, // IfFalse: 111
  0, // IfTrue: 112
  0, // Initialize: 113
  0, // JProj: 114
  0, // Jump: 115
  0, // JumpProj: 116
  0, // LShiftI: 117
  0, // LShiftL: 118
  0, // LoadB: 119
  0, // LoadUB: 120
  0, // LoadUS: 121
  0, // LoadD: 122
  0, // LoadD_unaligned: 123
  0, // LoadF: 124
  0, // LoadI: 125
  0, // LoadUI2L: 126
  0, // LoadKlass: 127
  0, // LoadNKlass: 128
  0, // LoadL: 129
  0, // LoadL_unaligned: 130
  0, // LoadPLocked: 131
  0, // LoadLLocked: 132
  0, // LoadP: 133
  0, // LoadN: 134
  0, // LoadRange: 135
  0, // LoadS: 136
  0, // Lock: 137
  0, // LogD: 138
  0, // Log10D: 139
  0, // Loop: 140
  0, // LoopLimit: 141
  0, // Mach: 142
  0, // MachProj: 143
  0, // MaxI: 144
  0, // MemBarAcquire: 145
  0, // MemBarCPUOrder: 146
  0, // MemBarRelease: 147
  0, // MemBarVolatile: 148
  0, // MergeMem: 149
  0, // MinI: 150
  0, // ModD: 151
  0, // ModF: 152
  0, // ModI: 153
  0, // ModL: 154
  0, // MoveI2F: 155
  0, // MoveF2I: 156
  0, // MoveL2D: 157
  0, // MoveD2L: 158
  0, // MulD: 159
  0, // MulF: 160
  0, // MulHiL: 161
  0, // MulI: 162
  0, // MulL: 163
  0, // Multi: 164
  0, // NegD: 165
  0, // NegF: 166
  0, // NeverBranch: 167
  0, // Opaque1: 168
  0, // Opaque2: 169
  0, // OrI: 170
  0, // OrL: 171
  0, // PCTable: 172
  0, // Parm: 173
  0, // PartialSubtypeCheck: 174
  0, // Phi: 175
  0, // PopCountI: 176
  0, // PopCountL: 177
  0, // PowD: 178
  0, // PrefetchRead: 179
  0, // PrefetchWrite: 180
  0, // Proj: 181
  0, // RShiftI: 182
  0, // RShiftL: 183
  0, // Region: 184
  0, // Rethrow: 185
  0, // Return: 186
  0, // Root: 187
  0, // RoundDouble: 188
  0, // RoundFloat: 189
  0, // SafePoint: 190
  0, // SafePointScalarObject: 191
  0, // SCMemProj: 192
  0, // SinD: 193
  0, // SqrtD: 194
  0, // Start: 195
  0, // StartOSR: 196
  0, // StoreB: 197
  0, // StoreC: 198
  0, // StoreCM: 199
  0, // StorePConditional: 200
  0, // StoreIConditional: 201
  0, // StoreLConditional: 202
  0, // StoreD: 203
  0, // StoreF: 204
  0, // StoreI: 205
  0, // StoreL: 206
  0, // StoreP: 207
  0, // StoreN: 208
  0, // StrComp: 209
  0, // StrEquals: 210
  0, // StrIndexOf: 211
  0, // SubD: 212
  0, // SubF: 213
  0, // SubI: 214
  0, // SubL: 215
  0, // TailCall: 216
  0, // TailJump: 217
  0, // TanD: 218
  0, // ThreadLocal: 219
  0, // Unlock: 220
  0, // URShiftI: 221
  0, // URShiftL: 222
  0, // XorI: 223
  0, // XorL: 224
  0, // Vector: 225
  0, // AddVB: 226
  0, // AddVC: 227
  0, // AddVS: 228
  0, // AddVI: 229
  0, // AddVL: 230
  0, // AddVF: 231
  0, // AddVD: 232
  0, // SubVB: 233
  0, // SubVC: 234
  0, // SubVS: 235
  0, // SubVI: 236
  0, // SubVL: 237
  0, // SubVF: 238
  0, // SubVD: 239
  0, // MulVF: 240
  0, // MulVD: 241
  0, // DivVF: 242
  0, // DivVD: 243
  0, // LShiftVB: 244
  0, // LShiftVC: 245
  0, // LShiftVS: 246
  0, // LShiftVI: 247
  0, // URShiftVB: 248
  0, // URShiftVC: 249
  0, // URShiftVS: 250
  0, // URShiftVI: 251
  0, // AndV: 252
  0, // OrV: 253
  0, // XorV: 254
  0, // VectorLoad: 255
  0, // Load16B: 256
  0, // Load8B: 257
  0, // Load4B: 258
  0, // Load8C: 259
  0, // Load4C: 260
  0, // Load2C: 261
  0, // Load8S: 262
  0, // Load4S: 263
  0, // Load2S: 264
  0, // Load4I: 265
  0, // Load2I: 266
  0, // Load2L: 267
  0, // Load4F: 268
  0, // Load2F: 269
  0, // Load2D: 270
  0, // VectorStore: 271
  0, // Store16B: 272
  0, // Store8B: 273
  0, // Store4B: 274
  0, // Store8C: 275
  0, // Store4C: 276
  0, // Store2C: 277
  0, // Store4I: 278
  0, // Store2I: 279
  0, // Store2L: 280
  0, // Store4F: 281
  0, // Store2F: 282
  0, // Store2D: 283
  0, // Pack: 284
  0, // PackB: 285
  0, // PackS: 286
  0, // PackC: 287
  0, // PackI: 288
  0, // PackL: 289
  0, // PackF: 290
  0, // PackD: 291
  0, // Pack2x1B: 292
  0, // Pack2x2B: 293
  0, // Replicate16B: 294
  0, // Replicate8B: 295
  0, // Replicate4B: 296
  0, // Replicate8S: 297
  0, // Replicate4S: 298
  0, // Replicate2S: 299
  0, // Replicate8C: 300
  0, // Replicate4C: 301
  0, // Replicate2C: 302
  0, // Replicate4I: 303
  0, // Replicate2I: 304
  0, // Replicate2L: 305
  0, // Replicate4F: 306
  0, // Replicate2F: 307
  0, // Replicate2D: 308
  0, // Extract: 309
  0, // ExtractB: 310
  0, // ExtractS: 311
  0, // ExtractC: 312
  0, // ExtractI: 313
  0, // ExtractL: 314
  0, // ExtractF: 315
  0 // no trailing comma // ExtractD: 316
};
//  The following instructions can cisc-spill
//  popCountI can cisc-spill operand 1 to popCountI_mem
//  popCountL can cisc-spill operand 1 to popCountL_mem
//  cmovI_reg can cisc-spill operand 4 to cmovI_mem
//  cmovI_regU can cisc-spill operand 4 to cmovI_memU
//  cmovI_regUCF can cisc-spill operand 4 to cmovI_memUCF
//  addI_eReg can cisc-spill operand 2 to addI_eReg_mem
//  subI_eReg can cisc-spill operand 2 to subI_eReg_mem
//  mulI_eReg can cisc-spill operand 2 to mulI
//  mulI_eReg_imm can cisc-spill operand 1 to mulI_mem_imm
//  i2b can cisc-spill operand 1 to loadI2B
//  i2s can cisc-spill operand 1 to loadI2S
//  andI_eReg can cisc-spill operand 2 to andI_eReg_mem
//  orI_eReg can cisc-spill operand 2 to orI_eReg_mem
//  xorI_eReg can cisc-spill operand 2 to xorI_eReg_mem
//  addL_eReg can cisc-spill operand 2 to addL_eReg_mem
//  subL_eReg can cisc-spill operand 2 to subL_eReg_mem
//  andL_eReg can cisc-spill operand 2 to andL_eReg_mem
//  orl_eReg can cisc-spill operand 2 to orl_eReg_mem
//  xorl_eReg can cisc-spill operand 2 to xorl_eReg_mem
//  cmpXD_cc can cisc-spill operand 2 to cmpXD_ccmem
//  cmpXD_ccCF can cisc-spill operand 2 to cmpXD_ccmemCF
//  cmpXD_reg can cisc-spill operand 2 to cmpXD_regmem
//  subD_reg can cisc-spill operand 2 to subD_reg_mem
//  addD_reg can cisc-spill operand 2 to addD_reg_mem
//  addXD_reg can cisc-spill operand 2 to addXD_mem
//  subXD_reg can cisc-spill operand 2 to subXD_mem
//  mulXD_reg can cisc-spill operand 2 to mulXD_mem
//  divXD_reg can cisc-spill operand 2 to divXD_mem
//  mulD_reg can cisc-spill operand 2 to mulD_reg_mem
//  cmpX_cc can cisc-spill operand 2 to cmpX_ccmem
//  cmpX_ccCF can cisc-spill operand 2 to cmpX_ccmemCF
//  cmpX_reg can cisc-spill operand 2 to cmpX_regmem
//  addF24_reg can cisc-spill operand 2 to addF24_reg_mem
//  addF_reg can cisc-spill operand 2 to addF_reg_mem
//  addX_reg can cisc-spill operand 2 to addX_mem
//  subX_reg can cisc-spill operand 2 to subX_mem
//  mulX_reg can cisc-spill operand 2 to mulX_mem
//  divX_reg can cisc-spill operand 2 to divX_mem
//  sqrtX_reg can cisc-spill operand 1 to sqrtX_mem
//  sqrtXD_reg can cisc-spill operand 1 to sqrtXD_mem
//  addF24_reg_mem can cisc-spill operand 1 to addF24_mem_cisc
//  addF24_reg_mem_0 can cisc-spill operand 2 to addF24_mem_cisc_0
//  addF24_mem_reg can cisc-spill operand 2 to addF24_mem_cisc
//  mulF24_reg can cisc-spill operand 2 to mulF24_reg_mem
//  mulF_reg can cisc-spill operand 2 to mulF_reg_mem
//  addF_mulF_reg can cisc-spill operand 1 to addF_mulF_reg_load1
//  addF_mulF_reg_0 can cisc-spill operand 2 to addF_mulF_reg_load1_1
//  convI2L_reg can cisc-spill operand 1 to loadI2L
//  compI_eReg can cisc-spill operand 2 to compI_eReg_mem
//  compU_eReg can cisc-spill operand 2 to compU_eReg_mem
//  compP_eReg can cisc-spill operand 2 to compP_eReg_mem
//  cmovLL_reg_LTGE can cisc-spill operand 4 to cmovLL_mem_LTGE
//  cmovII_reg_LTGE can cisc-spill operand 4 to cmovII_mem_LTGE
//  cmovLL_reg_EQNE can cisc-spill operand 4 to cmovLL_mem_EQNE
//  cmovII_reg_EQNE can cisc-spill operand 4 to cmovII_mem_EQNE
//  cmovLL_reg_LEGT can cisc-spill operand 4 to cmovLL_mem_LEGT
//  cmovII_reg_LEGT can cisc-spill operand 4 to cmovII_mem_LEGT



// An array of character pointers to machine register names.
const char *Matcher::regName[REG_COUNT] = {
  "ECX",
  "EBX",
  "EBP",
  "EDI",
  "EAX",
  "EDX",
  "ESI",
  "ESP",
  "FPR0L",
  "FPR0H",
  "FPR1L",
  "FPR1H",
  "FPR2L",
  "FPR2H",
  "FPR3L",
  "FPR3H",
  "FPR4L",
  "FPR4H",
  "FPR5L",
  "FPR5H",
  "FPR6L",
  "FPR6H",
  "FPR7L",
  "FPR7H",
  "XMM0a",
  "XMM0b",
  "XMM1a",
  "XMM1b",
  "XMM2a",
  "XMM2b",
  "XMM3a",
  "XMM3b",
  "XMM4a",
  "XMM4b",
  "XMM5a",
  "XMM5b",
  "XMM6a",
  "XMM6b",
  "XMM7a",
  "XMM7b",
  "EFLAGS" // no trailing comma
};

// An array of character pointers to machine register names.
const VMReg OptoReg::opto2vm[REG_COUNT] = {
	rcx->as_VMReg(),
	rbx->as_VMReg(),
	rbp->as_VMReg(),
	rdi->as_VMReg(),
	rax->as_VMReg(),
	rdx->as_VMReg(),
	rsi->as_VMReg(),
	rsp->as_VMReg(),
	VMRegImpl::Bad(),
	VMRegImpl::Bad(),
	as_FloatRegister(0)->as_VMReg(),
	as_FloatRegister(0)->as_VMReg()->next(),
	as_FloatRegister(1)->as_VMReg(),
	as_FloatRegister(1)->as_VMReg()->next(),
	as_FloatRegister(2)->as_VMReg(),
	as_FloatRegister(2)->as_VMReg()->next(),
	as_FloatRegister(3)->as_VMReg(),
	as_FloatRegister(3)->as_VMReg()->next(),
	as_FloatRegister(4)->as_VMReg(),
	as_FloatRegister(4)->as_VMReg()->next(),
	as_FloatRegister(5)->as_VMReg(),
	as_FloatRegister(5)->as_VMReg()->next(),
	as_FloatRegister(6)->as_VMReg(),
	as_FloatRegister(6)->as_VMReg()->next(),
	xmm0->as_VMReg(),
	xmm0->as_VMReg()->next(),
	xmm1->as_VMReg(),
	xmm1->as_VMReg()->next(),
	xmm2->as_VMReg(),
	xmm2->as_VMReg()->next(),
	xmm3->as_VMReg(),
	xmm3->as_VMReg()->next(),
	xmm4->as_VMReg(),
	xmm4->as_VMReg()->next(),
	xmm5->as_VMReg(),
	xmm5->as_VMReg()->next(),
	xmm6->as_VMReg(),
	xmm6->as_VMReg()->next(),
	xmm7->as_VMReg(),
	xmm7->as_VMReg()->next(),
	VMRegImpl::Bad() // no trailing comma
	};

 OptoReg::Name OptoReg::vm2opto[ConcreteRegisterImpl::number_of_registers];

// An array of the machine register encode values
const unsigned char Matcher::_regEncode[REG_COUNT] = {
  (unsigned char)'\x1',  // ECX
  (unsigned char)'\x3',  // EBX
  (unsigned char)'\x5',  // EBP
  (unsigned char)'\x7',  // EDI
  (unsigned char)'\x0',  // EAX
  (unsigned char)'\x2',  // EDX
  (unsigned char)'\x6',  // ESI
  (unsigned char)'\x4',  // ESP
  (unsigned char)'\x0',  // FPR0L
  (unsigned char)'\x0',  // FPR0H
  (unsigned char)'\x1',  // FPR1L
  (unsigned char)'\x1',  // FPR1H
  (unsigned char)'\x2',  // FPR2L
  (unsigned char)'\x2',  // FPR2H
  (unsigned char)'\x3',  // FPR3L
  (unsigned char)'\x3',  // FPR3H
  (unsigned char)'\x4',  // FPR4L
  (unsigned char)'\x4',  // FPR4H
  (unsigned char)'\x5',  // FPR5L
  (unsigned char)'\x5',  // FPR5H
  (unsigned char)'\x6',  // FPR6L
  (unsigned char)'\x6',  // FPR6H
  (unsigned char)'\x7',  // FPR7L
  (unsigned char)'\x7',  // FPR7H
  (unsigned char)'\x0',  // XMM0a
  (unsigned char)'\x0',  // XMM0b
  (unsigned char)'\x1',  // XMM1a
  (unsigned char)'\x1',  // XMM1b
  (unsigned char)'\x2',  // XMM2a
  (unsigned char)'\x2',  // XMM2b
  (unsigned char)'\x3',  // XMM3a
  (unsigned char)'\x3',  // XMM3b
  (unsigned char)'\x4',  // XMM4a
  (unsigned char)'\x4',  // XMM4b
  (unsigned char)'\x5',  // XMM5a
  (unsigned char)'\x5',  // XMM5b
  (unsigned char)'\x6',  // XMM6a
  (unsigned char)'\x6',  // XMM6b
  (unsigned char)'\x7',  // XMM7a
  (unsigned char)'\x7',  // XMM7b
  (unsigned char)'\x8' // no trailing comma  // EFLAGS
};


//------------------Define classes derived from MachOper---------------------
MachOper  *labelOper::clone(Compile* C) const {
  return  new (C) labelOper(_label, _block_num);
}
uint labelOper::opcode() const { return LABEL; }

const RegMask *sRegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *sRegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *sRegFOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *sRegDOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *sRegLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

MachOper  *methodOper::clone(Compile* C) const {
  return  new (C) methodOper(_method);
}
uint methodOper::opcode() const { return METHOD; }

const RegMask *eRegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &E_REG_mask;
}

const RegMask *xRegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &X_REG_mask;
}

const RegMask *eAXRegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &EAX_REG_mask;
}

const RegMask *eBXRegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &EBX_REG_mask;
}

const RegMask *eCXRegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &ECX_REG_mask;
}

const RegMask *eDXRegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &EDX_REG_mask;
}

const RegMask *eDIRegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &EDI_REG_mask;
}

const RegMask *naxRegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &NAX_REG_mask;
}

const RegMask *nadxRegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &NADX_REG_mask;
}

const RegMask *ncxRegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &NCX_REG_mask;
}

const RegMask *eSIRegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &ESI_REG_mask;
}

const RegMask *anyRegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &ANY_REG_mask;
}

const RegMask *eRegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &E_REG_mask;
}

const RegMask *eRegP_no_EBPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &E_REG_NO_RBP_mask;
}

const RegMask *naxRegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &NAX_REG_mask;
}

const RegMask *nabxRegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &NABX_REG_mask;
}

const RegMask *pRegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &P_REG_mask;
}

const RegMask *eAXRegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &EAX_REG_mask;
}

const RegMask *eBXRegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &EBX_REG_mask;
}

const RegMask *eCXRegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &ECX_REG_mask;
}

const RegMask *eSIRegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &ESI_REG_mask;
}

const RegMask *eDIRegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &EDI_REG_mask;
}

const RegMask *eBPRegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &EBP_REG_mask;
}

const RegMask *eRegLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &LONG_REG_mask;
}

const RegMask *eADXRegLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &EADX_REG_mask;
}

const RegMask *eBCXRegLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &EBCX_REG_mask;
}

const RegMask *eADXRegL_low_onlyOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &EADX_REG_mask;
}

const RegMask *eFlagsRegOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_FLAGS_mask;
}

const RegMask *eFlagsRegUOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_FLAGS_mask;
}

const RegMask *eFlagsRegUCFOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_FLAGS_mask;
}

const RegMask *flagsReg_long_LTGEOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_FLAGS_mask;
}

const RegMask *flagsReg_long_EQNEOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_FLAGS_mask;
}

const RegMask *flagsReg_long_LEGTOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_FLAGS_mask;
}

const RegMask *regDOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &DBL_REG_mask;
}

const RegMask *regDPR1Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &DBL_REG0_mask;
}

const RegMask *regDPR2Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &DBL_REG1_mask;
}

const RegMask *regnotDPR1Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &DBL_NOTREG0_mask;
}

const RegMask *regXDOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &XDB_REG_mask;
}

const RegMask *regXD6Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &XDB_REG6_mask;
}

const RegMask *regXD7Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &XDB_REG7_mask;
}

const RegMask *regFOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &FLT_REG_mask;
}

const RegMask *regFPR1Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &FLT_REG0_mask;
}

const RegMask *regXOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &XMM_REG_mask;
}

const RegMask *indirectOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &E_REG_mask;
}

const RegMask *indOffset8Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &E_REG_mask;
}

const RegMask *indOffset32Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &E_REG_mask;
}

const RegMask *indOffset32XOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &E_REG_mask;
}

const RegMask *indIndexOffsetOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  return &E_REG_mask;
}

const RegMask *indIndexOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  return &E_REG_mask;
}

const RegMask *indIndexScaleOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  return &E_REG_mask;
}

const RegMask *indIndexScaleOffsetOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  return &E_REG_mask;
}

const RegMask *load_long_RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &ESI_REG_mask;
}

const RegMask *load_long_indirectOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &ESI_REG_mask;
}

const RegMask *load_long_indOffset32Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &ESI_REG_mask;
}

const RegMask *stackSlotPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *stackSlotIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *stackSlotFOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *stackSlotDOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *stackSlotLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *indirect_win95_safeOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &E_REG_mask;
}

const RegMask *indOffset8_win95_safeOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &E_REG_NO_RBP_mask;
}

const RegMask *indOffset32_win95_safeOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &E_REG_NO_RBP_mask;
}

const RegMask *indIndexOffset_win95_safeOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  switch (index) {
  case 0: return &E_REG_NO_RBP_mask;
  case 1: return &E_REG_mask;
  }
  ShouldNotReachHere();
  return NULL;
}

const RegMask *indIndexScale_win95_safeOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  switch (index) {
  case 0: return &E_REG_NO_RBP_mask;
  case 1: return &E_REG_mask;
  }
  ShouldNotReachHere();
  return NULL;
}

const RegMask *indIndexScaleOffset_win95_safeOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  switch (index) {
  case 0: return &E_REG_NO_RBP_mask;
  case 1: return &E_REG_mask;
  }
  ShouldNotReachHere();
  return NULL;
}

//------------------Define members for classes derived from MachNode----------

void popCountINode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_E_REG_mask;
}

// Build CISC version of this instruction
MachNode *popCountINode::cisc_version( int offset, Compile* C ) {
  popCountI_memNode *node = new (C) popCountI_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void popCountLNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_LONG_REG_mask;
}

// Build CISC version of this instruction
MachNode *popCountLNode::cisc_version( int offset, Compile* C ) {
  popCountL_memNode *node = new (C) popCountL_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void cmovI_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_E_REG_mask;
}

// Build CISC version of this instruction
MachNode *cmovI_regNode::cisc_version( int offset, Compile* C ) {
  cmovI_memNode *node = new (C) cmovI_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void cmovI_regUNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_E_REG_mask;
}

// Build CISC version of this instruction
MachNode *cmovI_regUNode::cisc_version( int offset, Compile* C ) {
  cmovI_memUNode *node = new (C) cmovI_memUNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void cmovI_regUCFNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_E_REG_mask;
}

// Build CISC version of this instruction
MachNode *cmovI_regUCFNode::cisc_version( int offset, Compile* C ) {
  cmovI_memUCFNode *node = new (C) cmovI_memUCFNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void addI_eRegNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_E_REG_mask;
}

// Build CISC version of this instruction
MachNode *addI_eRegNode::cisc_version( int offset, Compile* C ) {
  addI_eReg_memNode *node = new (C) addI_eReg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void subI_eRegNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_E_REG_mask;
}

// Build CISC version of this instruction
MachNode *subI_eRegNode::cisc_version( int offset, Compile* C ) {
  subI_eReg_memNode *node = new (C) subI_eReg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void mulI_eRegNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_E_REG_mask;
}

// Build CISC version of this instruction
MachNode *mulI_eRegNode::cisc_version( int offset, Compile* C ) {
  mulINode *node = new (C) mulINode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void mulI_eReg_immNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_E_REG_mask;
}

// Build CISC version of this instruction
MachNode *mulI_eReg_immNode::cisc_version( int offset, Compile* C ) {
  mulI_mem_immNode *node = new (C) mulI_mem_immNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void i2bNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_X_REG_mask;
}

// Build CISC version of this instruction
MachNode *i2bNode::cisc_version( int offset, Compile* C ) {
  loadI2BNode *node = new (C) loadI2BNode();
  node->_num_opnds = 3;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void i2sNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_X_REG_mask;
}

// Build CISC version of this instruction
MachNode *i2sNode::cisc_version( int offset, Compile* C ) {
  loadI2SNode *node = new (C) loadI2SNode();
  node->_num_opnds = 3;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void andI_eRegNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_E_REG_mask;
}

// Build CISC version of this instruction
MachNode *andI_eRegNode::cisc_version( int offset, Compile* C ) {
  andI_eReg_memNode *node = new (C) andI_eReg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void orI_eRegNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_E_REG_mask;
}

// Build CISC version of this instruction
MachNode *orI_eRegNode::cisc_version( int offset, Compile* C ) {
  orI_eReg_memNode *node = new (C) orI_eReg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void xorI_eRegNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_E_REG_mask;
}

// Build CISC version of this instruction
MachNode *xorI_eRegNode::cisc_version( int offset, Compile* C ) {
  xorI_eReg_memNode *node = new (C) xorI_eReg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void addL_eRegNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_LONG_REG_mask;
}

// Build CISC version of this instruction
MachNode *addL_eRegNode::cisc_version( int offset, Compile* C ) {
  addL_eReg_memNode *node = new (C) addL_eReg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void subL_eRegNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_LONG_REG_mask;
}

// Build CISC version of this instruction
MachNode *subL_eRegNode::cisc_version( int offset, Compile* C ) {
  subL_eReg_memNode *node = new (C) subL_eReg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void andL_eRegNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_LONG_REG_mask;
}

// Build CISC version of this instruction
MachNode *andL_eRegNode::cisc_version( int offset, Compile* C ) {
  andL_eReg_memNode *node = new (C) andL_eReg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void orl_eRegNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_LONG_REG_mask;
}

// Build CISC version of this instruction
MachNode *orl_eRegNode::cisc_version( int offset, Compile* C ) {
  orl_eReg_memNode *node = new (C) orl_eReg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void xorl_eRegNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_LONG_REG_mask;
}

// Build CISC version of this instruction
MachNode *xorl_eRegNode::cisc_version( int offset, Compile* C ) {
  xorl_eReg_memNode *node = new (C) xorl_eReg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void cmpXD_ccNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_XDB_REG_mask;
}

// Build CISC version of this instruction
MachNode *cmpXD_ccNode::cisc_version( int offset, Compile* C ) {
  cmpXD_ccmemNode *node = new (C) cmpXD_ccmemNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void cmpXD_ccCFNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_XDB_REG_mask;
}

// Build CISC version of this instruction
MachNode *cmpXD_ccCFNode::cisc_version( int offset, Compile* C ) {
  cmpXD_ccmemCFNode *node = new (C) cmpXD_ccmemCFNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void cmpXD_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_XDB_REG_mask;
}

// Build CISC version of this instruction
MachNode *cmpXD_regNode::cisc_version( int offset, Compile* C ) {
  cmpXD_regmemNode *node = new (C) cmpXD_regmemNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void subD_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_DBL_REG_mask;
}

// Build CISC version of this instruction
MachNode *subD_regNode::cisc_version( int offset, Compile* C ) {
  subD_reg_memNode *node = new (C) subD_reg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void addD_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_DBL_REG_mask;
}

// Build CISC version of this instruction
MachNode *addD_regNode::cisc_version( int offset, Compile* C ) {
  addD_reg_memNode *node = new (C) addD_reg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void addXD_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_XDB_REG_mask;
}

// Build CISC version of this instruction
MachNode *addXD_regNode::cisc_version( int offset, Compile* C ) {
  addXD_memNode *node = new (C) addXD_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void subXD_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_XDB_REG_mask;
}

// Build CISC version of this instruction
MachNode *subXD_regNode::cisc_version( int offset, Compile* C ) {
  subXD_memNode *node = new (C) subXD_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void mulXD_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_XDB_REG_mask;
}

// Build CISC version of this instruction
MachNode *mulXD_regNode::cisc_version( int offset, Compile* C ) {
  mulXD_memNode *node = new (C) mulXD_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void divXD_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_XDB_REG_mask;
}

// Build CISC version of this instruction
MachNode *divXD_regNode::cisc_version( int offset, Compile* C ) {
  divXD_memNode *node = new (C) divXD_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void mulD_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_DBL_REG_mask;
}

// Build CISC version of this instruction
MachNode *mulD_regNode::cisc_version( int offset, Compile* C ) {
  mulD_reg_memNode *node = new (C) mulD_reg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void cmpX_ccNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_XMM_REG_mask;
}

// Build CISC version of this instruction
MachNode *cmpX_ccNode::cisc_version( int offset, Compile* C ) {
  cmpX_ccmemNode *node = new (C) cmpX_ccmemNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void cmpX_ccCFNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_XMM_REG_mask;
}

// Build CISC version of this instruction
MachNode *cmpX_ccCFNode::cisc_version( int offset, Compile* C ) {
  cmpX_ccmemCFNode *node = new (C) cmpX_ccmemCFNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void cmpX_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_XMM_REG_mask;
}

// Build CISC version of this instruction
MachNode *cmpX_regNode::cisc_version( int offset, Compile* C ) {
  cmpX_regmemNode *node = new (C) cmpX_regmemNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void addF24_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_FLT_REG_mask;
}

// Build CISC version of this instruction
MachNode *addF24_regNode::cisc_version( int offset, Compile* C ) {
  addF24_reg_memNode *node = new (C) addF24_reg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void addF_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_FLT_REG_mask;
}

// Build CISC version of this instruction
MachNode *addF_regNode::cisc_version( int offset, Compile* C ) {
  addF_reg_memNode *node = new (C) addF_reg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void addX_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_XMM_REG_mask;
}

// Build CISC version of this instruction
MachNode *addX_regNode::cisc_version( int offset, Compile* C ) {
  addX_memNode *node = new (C) addX_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void subX_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_XMM_REG_mask;
}

// Build CISC version of this instruction
MachNode *subX_regNode::cisc_version( int offset, Compile* C ) {
  subX_memNode *node = new (C) subX_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void mulX_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_XMM_REG_mask;
}

// Build CISC version of this instruction
MachNode *mulX_regNode::cisc_version( int offset, Compile* C ) {
  mulX_memNode *node = new (C) mulX_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void divX_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_XMM_REG_mask;
}

// Build CISC version of this instruction
MachNode *divX_regNode::cisc_version( int offset, Compile* C ) {
  divX_memNode *node = new (C) divX_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void sqrtX_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_XMM_REG_mask;
}

// Build CISC version of this instruction
MachNode *sqrtX_regNode::cisc_version( int offset, Compile* C ) {
  sqrtX_memNode *node = new (C) sqrtX_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void sqrtXD_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_XDB_REG_mask;
}

// Build CISC version of this instruction
MachNode *sqrtXD_regNode::cisc_version( int offset, Compile* C ) {
  sqrtXD_memNode *node = new (C) sqrtXD_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void addF24_reg_memNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_FLT_REG_mask;
}

// Build CISC version of this instruction
MachNode *addF24_reg_memNode::cisc_version( int offset, Compile* C ) {
  addF24_mem_ciscNode *node = new (C) addF24_mem_ciscNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void addF24_reg_mem_0Node::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_FLT_REG_mask;
}

// Build CISC version of this instruction
MachNode *addF24_reg_mem_0Node::cisc_version( int offset, Compile* C ) {
  addF24_mem_cisc_0Node *node = new (C) addF24_mem_cisc_0Node();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void addF24_mem_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_FLT_REG_mask;
}

// Build CISC version of this instruction
MachNode *addF24_mem_regNode::cisc_version( int offset, Compile* C ) {
  addF24_mem_ciscNode *node = new (C) addF24_mem_ciscNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void mulF24_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_FLT_REG_mask;
}

// Build CISC version of this instruction
MachNode *mulF24_regNode::cisc_version( int offset, Compile* C ) {
  mulF24_reg_memNode *node = new (C) mulF24_reg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void mulF_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_FLT_REG_mask;
}

// Build CISC version of this instruction
MachNode *mulF_regNode::cisc_version( int offset, Compile* C ) {
  mulF_reg_memNode *node = new (C) mulF_reg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void addF_mulF_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_FLT_REG_mask;
}

// Build CISC version of this instruction
MachNode *addF_mulF_regNode::cisc_version( int offset, Compile* C ) {
  addF_mulF_reg_load1Node *node = new (C) addF_mulF_reg_load1Node();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void addF_mulF_reg_0Node::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_FLT_REG_mask;
}

// Build CISC version of this instruction
MachNode *addF_mulF_reg_0Node::cisc_version( int offset, Compile* C ) {
  addF_mulF_reg_load1_1Node *node = new (C) addF_mulF_reg_load1_1Node();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void convI2L_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_E_REG_mask;
}

// Build CISC version of this instruction
MachNode *convI2L_regNode::cisc_version( int offset, Compile* C ) {
  loadI2LNode *node = new (C) loadI2LNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void compI_eRegNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_E_REG_mask;
}

// Build CISC version of this instruction
MachNode *compI_eRegNode::cisc_version( int offset, Compile* C ) {
  compI_eReg_memNode *node = new (C) compI_eReg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void compU_eRegNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_E_REG_mask;
}

// Build CISC version of this instruction
MachNode *compU_eRegNode::cisc_version( int offset, Compile* C ) {
  compU_eReg_memNode *node = new (C) compU_eReg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void compP_eRegNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_E_REG_mask;
}

// Build CISC version of this instruction
MachNode *compP_eRegNode::cisc_version( int offset, Compile* C ) {
  compP_eReg_memNode *node = new (C) compP_eReg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}

// Build short branch version of this instruction
MachNode *jmpDirNode::short_branch_version(Compile* C) {
  jmpDir_shortNode *node = new (C) jmpDir_shortNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  return node;
}

// Build short branch version of this instruction
MachNode *jmpConNode::short_branch_version(Compile* C) {
  jmpCon_shortNode *node = new (C) jmpCon_shortNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  return node;
}

// Build short branch version of this instruction
MachNode *jmpLoopEndNode::short_branch_version(Compile* C) {
  jmpLoopEnd_shortNode *node = new (C) jmpLoopEnd_shortNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  return node;
}

// Build short branch version of this instruction
MachNode *jmpLoopEndUNode::short_branch_version(Compile* C) {
  jmpLoopEndU_shortNode *node = new (C) jmpLoopEndU_shortNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  return node;
}

// Build short branch version of this instruction
MachNode *jmpLoopEndUCFNode::short_branch_version(Compile* C) {
  jmpLoopEndUCF_shortNode *node = new (C) jmpLoopEndUCF_shortNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  return node;
}

// Build short branch version of this instruction
MachNode *jmpConUNode::short_branch_version(Compile* C) {
  jmpConU_shortNode *node = new (C) jmpConU_shortNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  return node;
}

// Build short branch version of this instruction
MachNode *jmpConUCFNode::short_branch_version(Compile* C) {
  jmpConUCF_shortNode *node = new (C) jmpConUCF_shortNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  return node;
}

// Build short branch version of this instruction
MachNode *jmpConUCF2Node::short_branch_version(Compile* C) {
  jmpConUCF2_shortNode *node = new (C) jmpConUCF2_shortNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  return node;
}


void cmovLL_reg_LTGENode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_LONG_REG_mask;
}

// Build CISC version of this instruction
MachNode *cmovLL_reg_LTGENode::cisc_version( int offset, Compile* C ) {
  cmovLL_mem_LTGENode *node = new (C) cmovLL_mem_LTGENode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void cmovII_reg_LTGENode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_E_REG_mask;
}

// Build CISC version of this instruction
MachNode *cmovII_reg_LTGENode::cisc_version( int offset, Compile* C ) {
  cmovII_mem_LTGENode *node = new (C) cmovII_mem_LTGENode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void cmovLL_reg_EQNENode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_LONG_REG_mask;
}

// Build CISC version of this instruction
MachNode *cmovLL_reg_EQNENode::cisc_version( int offset, Compile* C ) {
  cmovLL_mem_EQNENode *node = new (C) cmovLL_mem_EQNENode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void cmovII_reg_EQNENode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_E_REG_mask;
}

// Build CISC version of this instruction
MachNode *cmovII_reg_EQNENode::cisc_version( int offset, Compile* C ) {
  cmovII_mem_EQNENode *node = new (C) cmovII_mem_EQNENode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void cmovLL_reg_LEGTNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_LONG_REG_mask;
}

// Build CISC version of this instruction
MachNode *cmovLL_reg_LEGTNode::cisc_version( int offset, Compile* C ) {
  cmovLL_mem_LEGTNode *node = new (C) cmovLL_mem_LEGTNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void cmovII_reg_LEGTNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_E_REG_mask;
}

// Build CISC version of this instruction
MachNode *cmovII_reg_LEGTNode::cisc_version( int offset, Compile* C ) {
  cmovII_mem_LEGTNode *node = new (C) cmovII_mem_LEGTNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


// Copy _idx, inputs and operands to new node
void MachNode::fill_new_machnode( MachNode* node, Compile* C) const {
  // New node must use same node index
  node->set_idx( _idx );
  // Copy machine-independent inputs
  for( uint j = 0; j < req(); j++ ) {
    node->add_req(in(j));
  }
  // Copy my operands, except for cisc position
  int nopnds = num_opnds();
  assert( node->num_opnds() == (uint)nopnds, "Must have same number of operands");
  MachOper **to = node->_opnds;
  for( int i = 0; i < nopnds; i++ ) {
    if( i != cisc_operand() ) 
      to[i] = _opnds[i]->clone(C);
  }
}

void jmpDirNode::label_set( Label& label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(1));
  oper->_label     = &label;
  oper->_block_num = block_num;
}
void jmpConNode::label_set( Label& label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  oper->_label     = &label;
  oper->_block_num = block_num;
}
void jmpLoopEndNode::label_set( Label& label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  oper->_label     = &label;
  oper->_block_num = block_num;
}
void jmpLoopEndUNode::label_set( Label& label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  oper->_label     = &label;
  oper->_block_num = block_num;
}
void jmpLoopEndUCFNode::label_set( Label& label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  oper->_label     = &label;
  oper->_block_num = block_num;
}
void jmpConUNode::label_set( Label& label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  oper->_label     = &label;
  oper->_block_num = block_num;
}
void jmpConUCFNode::label_set( Label& label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  oper->_label     = &label;
  oper->_block_num = block_num;
}
void jmpConUCF2Node::label_set( Label& label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  oper->_label     = &label;
  oper->_block_num = block_num;
}
void jmpDir_shortNode::label_set( Label& label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(1));
  oper->_label     = &label;
  oper->_block_num = block_num;
}
void jmpCon_shortNode::label_set( Label& label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  oper->_label     = &label;
  oper->_block_num = block_num;
}
void jmpLoopEnd_shortNode::label_set( Label& label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  oper->_label     = &label;
  oper->_block_num = block_num;
}
void jmpLoopEndU_shortNode::label_set( Label& label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  oper->_label     = &label;
  oper->_block_num = block_num;
}
void jmpLoopEndUCF_shortNode::label_set( Label& label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  oper->_label     = &label;
  oper->_block_num = block_num;
}
void jmpConU_shortNode::label_set( Label& label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  oper->_label     = &label;
  oper->_block_num = block_num;
}
void jmpConUCF_shortNode::label_set( Label& label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  oper->_label     = &label;
  oper->_block_num = block_num;
}
void jmpConUCF2_shortNode::label_set( Label& label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  oper->_label     = &label;
  oper->_block_num = block_num;
}
void cmpL_LTGENode::label_set( Label& label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  oper->_label     = &label;
  oper->_block_num = block_num;
}
void cmpL_EQNENode::label_set( Label& label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  oper->_label     = &label;
  oper->_block_num = block_num;
}
void cmpL_LEGTNode::label_set( Label& label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  oper->_label     = &label;
  oper->_block_num = block_num;
}
void CallStaticJavaDirectNode::method_set( intptr_t method ) {
  ((methodOper*)opnd_array(1))->_method = method;
}

void CallStaticJavaHandleNode::method_set( intptr_t method ) {
  ((methodOper*)opnd_array(1))->_method = method;
}

void CallDynamicJavaDirectNode::method_set( intptr_t method ) {
  ((methodOper*)opnd_array(1))->_method = method;
}

void CallRuntimeDirectNode::method_set( intptr_t method ) {
  ((methodOper*)opnd_array(1))->_method = method;
}

void CallLeafDirectNode::method_set( intptr_t method ) {
  ((methodOper*)opnd_array(1))->_method = method;
}

void CallLeafNoFPDirectNode::method_set( intptr_t method ) {
  ((methodOper*)opnd_array(1))->_method = method;
}

int  popCountI_memNode::reloc()   const {
  return  1;
}

int  popCountL_memNode::reloc()   const {
  return  1;
}

int  loadBNode::reloc()   const {
  return  1;
}

int  loadB2LNode::reloc()   const {
  return  1;
}

int  loadUBNode::reloc()   const {
  return  1;
}

int  loadUB2LNode::reloc()   const {
  return  1;
}

int  loadUB2L_immI8Node::reloc()   const {
  return  1;
}

int  loadSNode::reloc()   const {
  return  1;
}

int  loadS2BNode::reloc()   const {
  return  1;
}

int  loadS2LNode::reloc()   const {
  return  1;
}

int  loadUSNode::reloc()   const {
  return  1;
}

int  loadUS2BNode::reloc()   const {
  return  1;
}

int  loadUS2LNode::reloc()   const {
  return  1;
}

int  loadUS2L_immI_255Node::reloc()   const {
  return  1;
}

int  loadUS2L_immI16Node::reloc()   const {
  return  1;
}

int  loadINode::reloc()   const {
  return  1;
}

int  loadI2BNode::reloc()   const {
  return  1;
}

int  loadI2UBNode::reloc()   const {
  return  1;
}

int  loadI2SNode::reloc()   const {
  return  1;
}

int  loadI2USNode::reloc()   const {
  return  1;
}

int  loadI2LNode::reloc()   const {
  return  1;
}

int  loadI2L_immI_255Node::reloc()   const {
  return  1;
}

int  loadI2L_immI_65535Node::reloc()   const {
  return  1;
}

int  loadI2L_immINode::reloc()   const {
  return  1;
}

int  loadUI2LNode::reloc()   const {
  return  1;
}

int  loadLNode::reloc()   const {
  return  1;
}

int  loadL_volatileNode::reloc()   const {
  return  1;
}

int  loadLX_volatileNode::reloc()   const {
  return  1;
}

int  loadLX_reg_volatileNode::reloc()   const {
  return  1;
}

int  loadRangeNode::reloc()   const {
  return  1;
}

int  loadPNode::reloc()   const {
  return  1;
}

int  loadKlassNode::reloc()   const {
  return  1;
}

int  loadDNode::reloc()   const {
  return  1;
}

int  loadXDNode::reloc()   const {
  return  1;
}

int  loadXD_partialNode::reloc()   const {
  return  1;
}

int  loadXNode::reloc()   const {
  return  1;
}

int  loadFNode::reloc()   const {
  return  1;
}

int  loadA8BNode::reloc()   const {
  return  1;
}

int  loadA4SNode::reloc()   const {
  return  1;
}

int  loadA4CNode::reloc()   const {
  return  1;
}

int  load2IUNode::reloc()   const {
  return  1;
}

int  loadA2FNode::reloc()   const {
  return  1;
}

int  loadConPNode::reloc()   const {
  return  1;
}

int  loadConFNode::reloc()   const {
  return  2;
}

int  loadConF0Node::reloc()   const {
  return  2;
}

int  loadConF1Node::reloc()   const {
  return  2;
}

int  loadConXNode::reloc()   const {
  return  2;
}

int  loadConX0Node::reloc()   const {
  return  2;
}

int  loadConDNode::reloc()   const {
  return  2;
}

int  loadConD0Node::reloc()   const {
  return  2;
}

int  loadConD1Node::reloc()   const {
  return  2;
}

int  loadConXDNode::reloc()   const {
  return  2;
}

int  loadConXD0Node::reloc()   const {
  return  2;
}

int  prefetchr0Node::reloc()   const {
  return  1;
}

int  prefetchrNode::reloc()   const {
  return  1;
}

int  prefetchrNTANode::reloc()   const {
  return  1;
}

int  prefetchrT0Node::reloc()   const {
  return  1;
}

int  prefetchrT2Node::reloc()   const {
  return  1;
}

int  prefetchw0Node::reloc()   const {
  return  1;
}

int  prefetchwNode::reloc()   const {
  return  1;
}

int  prefetchwNTANode::reloc()   const {
  return  1;
}

int  prefetchwT0Node::reloc()   const {
  return  1;
}

int  prefetchwT2Node::reloc()   const {
  return  1;
}

int  storeBNode::reloc()   const {
  return  2;
}

int  storeCNode::reloc()   const {
  return  2;
}

int  storeINode::reloc()   const {
  return  2;
}

int  storeLNode::reloc()   const {
  return  2;
}

int  storeL2INode::reloc()   const {
  return  2;
}

int  storeL_volatileNode::reloc()   const {
  return  2;
}

int  storeLX_volatileNode::reloc()   const {
  return  2;
}

int  storeLX_reg_volatileNode::reloc()   const {
  return  2;
}

int  storePNode::reloc()   const {
  return  2;
}

int  storeImmINode::reloc()   const {
  return  2;
}

int  storeImmI16Node::reloc()   const {
  return  2;
}

int  storeImmPNode::reloc()   const {
  return  3;
}

int  storeImmBNode::reloc()   const {
  return  2;
}

int  storeA8BNode::reloc()   const {
  return  2;
}

int  storeA4CNode::reloc()   const {
  return  2;
}

int  storeA2INode::reloc()   const {
  return  2;
}

int  storeImmCMNode::reloc()   const {
  return  2;
}

int  storeDNode::reloc()   const {
  return  2;
}

int  storeD_roundedNode::reloc()   const {
  return  2;
}

int  storeXDNode::reloc()   const {
  return  2;
}

int  storeXNode::reloc()   const {
  return  2;
}

int  storeA2FNode::reloc()   const {
  return  2;
}

int  storeFNode::reloc()   const {
  return  2;
}

int  storeF_roundedNode::reloc()   const {
  return  2;
}

int  storeF_DroundedNode::reloc()   const {
  return  2;
}

int  storeF_immNode::reloc()   const {
  return  3;
}

int  storeX_immNode::reloc()   const {
  return  3;
}

int  cmovI_memNode::reloc()   const {
  return  1;
}

int  cmovI_memUNode::reloc()   const {
  return  1;
}

int  cmovI_memUCFNode::reloc()   const {
  return  1;
}

int  addI_eReg_memNode::reloc()   const {
  return  1;
}

int  addI_eReg_mem_0Node::reloc()   const {
  return  1;
}

int  addI_mem_eRegNode::reloc()   const {
  return  3;
}

int  addI_mem_eReg_0Node::reloc()   const {
  return  3;
}

int  addI_mem_immNode::reloc()   const {
  return  3;
}

int  incI_memNode::reloc()   const {
  return  3;
}

int  decI_memNode::reloc()   const {
  return  3;
}

int  loadPLockedNode::reloc()   const {
  return  1;
}

int  loadLLockedNode::reloc()   const {
  return  1;
}

int  loadLX_LockedNode::reloc()   const {
  return  1;
}

int  loadLX_reg_LockedNode::reloc()   const {
  return  1;
}

int  storePConditionalNode::reloc()   const {
  return  1;
}

int  storeIConditionalNode::reloc()   const {
  return  1;
}

int  storeLConditionalNode::reloc()   const {
  return  1;
}

int  subI_eReg_memNode::reloc()   const {
  return  1;
}

int  subI_mem_eRegNode::reloc()   const {
  return  3;
}

int  mulI_mem_immNode::reloc()   const {
  return  1;
}

int  mulINode::reloc()   const {
  return  1;
}

int  mulI_0Node::reloc()   const {
  return  1;
}

int  sarI_mem_1Node::reloc()   const {
  return  3;
}

int  sarI_mem_immNode::reloc()   const {
  return  3;
}

int  andI_eReg_memNode::reloc()   const {
  return  1;
}

int  andI_eReg_mem_0Node::reloc()   const {
  return  1;
}

int  andI_mem_eRegNode::reloc()   const {
  return  3;
}

int  andI_mem_eReg_0Node::reloc()   const {
  return  3;
}

int  andI_mem_immNode::reloc()   const {
  return  3;
}

int  orI_eReg_memNode::reloc()   const {
  return  1;
}

int  orI_eReg_mem_0Node::reloc()   const {
  return  1;
}

int  orI_mem_eRegNode::reloc()   const {
  return  3;
}

int  orI_mem_eReg_0Node::reloc()   const {
  return  3;
}

int  orI_mem_immNode::reloc()   const {
  return  3;
}

int  xorI_eReg_memNode::reloc()   const {
  return  1;
}

int  xorI_eReg_mem_0Node::reloc()   const {
  return  1;
}

int  xorI_mem_eRegNode::reloc()   const {
  return  3;
}

int  xorI_mem_eReg_0Node::reloc()   const {
  return  3;
}

int  xorI_mem_immNode::reloc()   const {
  return  3;
}

int  addL_eReg_memNode::reloc()   const {
  return  1;
}

int  addL_eReg_mem_0Node::reloc()   const {
  return  1;
}

int  subL_eReg_memNode::reloc()   const {
  return  1;
}

int  andL_eReg_memNode::reloc()   const {
  return  1;
}

int  andL_eReg_mem_0Node::reloc()   const {
  return  1;
}

int  orl_eReg_memNode::reloc()   const {
  return  1;
}

int  orl_eReg_mem_0Node::reloc()   const {
  return  1;
}

int  xorl_eReg_memNode::reloc()   const {
  return  1;
}

int  xorl_eReg_mem_0Node::reloc()   const {
  return  1;
}

int  cmpD_0Node::reloc()   const {
  return  1;
}

int  cmpXD_ccmemNode::reloc()   const {
  return  1;
}

int  cmpXD_ccmemCFNode::reloc()   const {
  return  1;
}

int  cmpXD_regmemNode::reloc()   const {
  return  1;
}

int  subD_reg_memNode::reloc()   const {
  return  1;
}

int  addD_reg_memNode::reloc()   const {
  return  1;
}

int  addD_reg_mem_0Node::reloc()   const {
  return  1;
}

int  addD_mem_regNode::reloc()   const {
  return  3;
}

int  addD_mem_reg_0Node::reloc()   const {
  return  3;
}

int  addD_reg_imm1Node::reloc()   const {
  return  1;
}

int  addD_reg_immNode::reloc()   const {
  return  1;
}

int  addD_reg_imm_roundNode::reloc()   const {
  return  1;
}

int  addXD_immNode::reloc()   const {
  return  1;
}

int  addXD_memNode::reloc()   const {
  return  1;
}

int  addXD_mem_0Node::reloc()   const {
  return  1;
}

int  subXD_immNode::reloc()   const {
  return  1;
}

int  subXD_memNode::reloc()   const {
  return  1;
}

int  mulXD_immNode::reloc()   const {
  return  1;
}

int  mulXD_memNode::reloc()   const {
  return  1;
}

int  mulXD_mem_0Node::reloc()   const {
  return  1;
}

int  divXD_immNode::reloc()   const {
  return  1;
}

int  divXD_memNode::reloc()   const {
  return  1;
}

int  mulD_reg_immNode::reloc()   const {
  return  1;
}

int  mulD_reg_memNode::reloc()   const {
  return  1;
}

int  mulD_reg_mem_0Node::reloc()   const {
  return  1;
}

int  mulD_reg_mem_ciscNode::reloc()   const {
  return  1;
}

int  mulD_reg_mem_cisc_0Node::reloc()   const {
  return  1;
}

int  cmpF_0Node::reloc()   const {
  return  1;
}

int  cmpX_ccmemNode::reloc()   const {
  return  1;
}

int  cmpX_ccmemCFNode::reloc()   const {
  return  1;
}

int  cmpX_regmemNode::reloc()   const {
  return  1;
}

int  addX_immNode::reloc()   const {
  return  1;
}

int  addX_memNode::reloc()   const {
  return  1;
}

int  addX_mem_0Node::reloc()   const {
  return  1;
}

int  subX_immNode::reloc()   const {
  return  1;
}

int  subX_memNode::reloc()   const {
  return  1;
}

int  mulX_immNode::reloc()   const {
  return  1;
}

int  mulX_memNode::reloc()   const {
  return  1;
}

int  mulX_mem_0Node::reloc()   const {
  return  1;
}

int  divX_immNode::reloc()   const {
  return  1;
}

int  divX_memNode::reloc()   const {
  return  1;
}

int  sqrtX_memNode::reloc()   const {
  return  1;
}

int  sqrtXD_memNode::reloc()   const {
  return  1;
}

int  addF24_reg_memNode::reloc()   const {
  return  1;
}

int  addF24_reg_mem_0Node::reloc()   const {
  return  1;
}

int  addF_reg_memNode::reloc()   const {
  return  1;
}

int  addF_reg_mem_0Node::reloc()   const {
  return  1;
}

int  addF24_mem_regNode::reloc()   const {
  return  1;
}

int  addF24_mem_ciscNode::reloc()   const {
  return  2;
}

int  addF24_mem_cisc_0Node::reloc()   const {
  return  2;
}

int  addF24_mem_memNode::reloc()   const {
  return  2;
}

int  addF24_reg_immNode::reloc()   const {
  return  1;
}

int  addF_reg_immNode::reloc()   const {
  return  1;
}

int  mulF24_reg_memNode::reloc()   const {
  return  1;
}

int  mulF24_reg_mem_0Node::reloc()   const {
  return  1;
}

int  mulF_reg_memNode::reloc()   const {
  return  1;
}

int  mulF_reg_mem_0Node::reloc()   const {
  return  1;
}

int  mulF24_mem_memNode::reloc()   const {
  return  2;
}

int  mulF24_reg_immNode::reloc()   const {
  return  1;
}

int  mulF_reg_immNode::reloc()   const {
  return  1;
}

int  mulF_reg_load1Node::reloc()   const {
  return  1;
}

int  mulF_reg_load1_0Node::reloc()   const {
  return  1;
}

int  addF_mulF_reg_load1Node::reloc()   const {
  return  1;
}

int  addF_mulF_reg_load1_1Node::reloc()   const {
  return  1;
}

int  addF_mulF_reg_load1_0Node::reloc()   const {
  return  1;
}

int  addF_mulF_reg_load1_2Node::reloc()   const {
  return  1;
}

int  convI2XD_memNode::reloc()   const {
  return  1;
}

int  convI2D_memNode::reloc()   const {
  return  1;
}

int  convI2F_SSF_memNode::reloc()   const {
  return  1;
}

int  convI2F_memNode::reloc()   const {
  return  1;
}

int  Repl2F_immXF0Node::reloc()   const {
  return  1;
}

int  compI_eReg_memNode::reloc()   const {
  return  1;
}

int  testI_reg_memNode::reloc()   const {
  return  1;
}

int  compU_eReg_memNode::reloc()   const {
  return  1;
}

int  compP_eReg_immNode::reloc()   const {
  return  1;
}

int  compP_eReg_memNode::reloc()   const {
  return  1;
}

int  compP_mem_eRegNode::reloc()   const {
  return  1;
}

int  testP_regNode::reloc()   const {
  return  1;
}

int  testP_Reg_memNode::reloc()   const {
  return  1;
}

int  partialSubtypeCheck_vs_ZeroNode::reloc()   const {
  return  1;
}

int  cmovLL_mem_LTGENode::reloc()   const {
  return  1;
}

int  cmovII_mem_LTGENode::reloc()   const {
  return  1;
}

int  cmovLL_mem_EQNENode::reloc()   const {
  return  1;
}

int  cmovII_mem_EQNENode::reloc()   const {
  return  1;
}

int  cmovLL_mem_LEGTNode::reloc()   const {
  return  1;
}

int  cmovII_mem_LEGTNode::reloc()   const {
  return  1;
}

int  CallStaticJavaDirectNode::reloc()   const {
  return  1;
}

int  CallStaticJavaHandleNode::reloc()   const {
  return  1;
}

int  CallDynamicJavaDirectNode::reloc()   const {
  return  1;
}

int  CallRuntimeDirectNode::reloc()   const {
  return  1;
}

int  CallLeafDirectNode::reloc()   const {
  return  1;
}

int  CallLeafNoFPDirectNode::reloc()   const {
  return  1;
}

int  RetNode::reloc()   const {
  return  1;
}

int  TailCalljmpIndNode::reloc()   const {
  return  1;
}

int  tailjmpIndNode::reloc()   const {
  return  1;
}

int  RethrowExceptionNode::reloc()   const {
  return  1;
}

int  safePoint_pollNode::reloc()   const {
  return  1;
}


void bytes_reverse_intNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0F /*primary()*/));
  
#line 8969 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1728 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_cc(cbuf, (0xC8 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1) );
  
#line 8977 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void bytes_reverse_longNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 1732 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int destlo = opnd_array(1)->reg(ra_,this,idx1);
    int desthi = HIGH_FROM_LOW(destlo);
    // bswap lo
    emit_opcode(cbuf, 0x0F);
    emit_cc(cbuf, 0xC8, destlo);
    // bswap hi
    emit_opcode(cbuf, 0x0F);
    emit_cc(cbuf, 0xC8, desthi);
    // xchg lo and hi
    emit_opcode(cbuf, 0x87);
    emit_rm(cbuf, 0x3, destlo, desthi);
  
#line 9001 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void bytes_reverse_unsigned_shortNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {
    MacroAssembler _masm(&cbuf);

#line 6270 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ bswapl(opnd_array(1)->as_Register(ra_,this,idx1));
    __ shrl(opnd_array(1)->as_Register(ra_,this,idx1), 16); 
  
#line 9017 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void bytes_reverse_shortNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {
    MacroAssembler _masm(&cbuf);

#line 6282 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ bswapl(opnd_array(1)->as_Register(ra_,this,idx1));
    __ sarl(opnd_array(1)->as_Register(ra_,this,idx1), 16); 
  
#line 9033 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void countLeadingZerosINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {
    MacroAssembler _masm(&cbuf);

#line 6298 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ lzcntl(opnd_array(0)->as_Register(ra_,this), opnd_array(1)->as_Register(ra_,this,idx1));
  
#line 9048 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void countLeadingZerosI_bsrNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {
    MacroAssembler _masm(&cbuf);

#line 6315 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    Register Rdst = opnd_array(0)->as_Register(ra_,this);
    Register Rsrc = opnd_array(1)->as_Register(ra_,this,idx1);
    Label skip;
    __ bsrl(Rdst, Rsrc);
    __ jccb(Assembler::notZero, skip);
    __ movl(Rdst, -1);
    __ bind(skip);
    __ negl(Rdst);
    __ addl(Rdst, BitsPerInt - 1);
  
#line 9071 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void countLeadingZerosLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {
    MacroAssembler _masm(&cbuf);

#line 6339 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    Register Rdst = opnd_array(2)->as_Register(ra_,this,idx2);
    Register Rsrc = opnd_array(1)->as_Register(ra_,this,idx1);
    Label done;
    __ lzcntl(Rdst, HIGH_FROM_LOW(Rsrc));
    __ jccb(Assembler::carryClear, done);
    __ lzcntl(Rdst, Rsrc);
    __ addl(Rdst, BitsPerInt);
    __ bind(done);
  
#line 9094 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void countLeadingZerosL_bsrNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {
    MacroAssembler _masm(&cbuf);

#line 6368 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    Register Rdst = opnd_array(2)->as_Register(ra_,this,idx2);
    Register Rsrc = opnd_array(1)->as_Register(ra_,this,idx1);
    Label msw_is_zero;
    Label not_zero;
    __ bsrl(Rdst, HIGH_FROM_LOW(Rsrc));
    __ jccb(Assembler::zero, msw_is_zero);
    __ addl(Rdst, BitsPerInt);
    __ jmpb(not_zero);
    __ bind(msw_is_zero);
    __ bsrl(Rdst, Rsrc);
    __ jccb(Assembler::notZero, not_zero);
    __ movl(Rdst, -1);
    __ bind(not_zero);
    __ negl(Rdst);
    __ addl(Rdst, BitsPerLong - 1);
  
#line 9124 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void countTrailingZerosINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {
    MacroAssembler _masm(&cbuf);

#line 6396 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    Register Rdst = opnd_array(0)->as_Register(ra_,this);
    Label done;
    __ bsfl(Rdst, opnd_array(1)->as_Register(ra_,this,idx1));
    __ jccb(Assembler::notZero, done);
    __ movl(Rdst, BitsPerInt);
    __ bind(done);
  
#line 9144 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void countTrailingZerosLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {
    MacroAssembler _masm(&cbuf);

#line 6419 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    Register Rdst = opnd_array(2)->as_Register(ra_,this,idx2);
    Register Rsrc = opnd_array(1)->as_Register(ra_,this,idx1);
    Label msw_not_zero;
    Label done;
    __ bsfl(Rdst, Rsrc);
    __ jccb(Assembler::notZero, done);
    __ bsfl(Rdst, HIGH_FROM_LOW(Rsrc));
    __ jccb(Assembler::notZero, msw_not_zero);
    __ movl(Rdst, BitsPerInt);
    __ bind(msw_not_zero);
    __ addl(Rdst, BitsPerInt);
    __ bind(done);
  
#line 9171 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void popCountINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {
    MacroAssembler _masm(&cbuf);

#line 6444 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ popcntl(opnd_array(0)->as_Register(ra_,this), opnd_array(1)->as_Register(ra_,this,idx1));
  
#line 9186 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void popCountI_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
  {
    MacroAssembler _masm(&cbuf);

#line 6455 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ popcntl(opnd_array(0)->as_Register(ra_,this), Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_is_oop()));
  
#line 9201 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void popCountLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
  {
    MacroAssembler _masm(&cbuf);

#line 6470 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ popcntl(opnd_array(2)->as_Register(ra_,this,idx2), opnd_array(1)->as_Register(ra_,this,idx1));
    __ popcntl(opnd_array(3)->as_Register(ra_,this,idx3), HIGH_FROM_LOW(opnd_array(1)->as_Register(ra_,this,idx1)));
    __ addl(opnd_array(2)->as_Register(ra_,this,idx2), opnd_array(3)->as_Register(ra_,this,idx3));
  
#line 9220 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void popCountL_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
  {
    MacroAssembler _masm(&cbuf);

#line 6487 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    //__ popcntl($dst$$Register, $mem$$Address$$first);
    //__ popcntl($tmp$$Register, $mem$$Address$$second);
    __ popcntl(opnd_array(2)->as_Register(ra_,this,idx2), Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), false));
    __ popcntl(opnd_array(3)->as_Register(ra_,this,idx3), Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1)+ 4, false));
    __ addl(opnd_array(2)->as_Register(ra_,this,idx2), opnd_array(3)->as_Register(ra_,this,idx3));
  
#line 9241 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void loadBNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
  {
    MacroAssembler _masm(&cbuf);

#line 6507 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ movsbl(opnd_array(0)->as_Register(ra_,this), Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_is_oop()));
  
#line 9256 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void loadB2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
  {
    MacroAssembler _masm(&cbuf);

#line 6524 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ movsbl(opnd_array(0)->as_Register(ra_,this), Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_is_oop()));
    __ movl(HIGH_FROM_LOW(opnd_array(0)->as_Register(ra_,this)), opnd_array(0)->as_Register(ra_,this)); // This is always a different register.
    __ sarl(HIGH_FROM_LOW(opnd_array(0)->as_Register(ra_,this)), 7); // 24+1 MSB are already signed extended.
  
#line 9273 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void loadUBNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
  {
    MacroAssembler _masm(&cbuf);

#line 6540 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ movzbl(opnd_array(0)->as_Register(ra_,this), Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_is_oop()));
  
#line 9288 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void loadUB2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
  {
    MacroAssembler _masm(&cbuf);

#line 6556 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    Register Rdst = opnd_array(0)->as_Register(ra_,this);
    __ movzbl(Rdst, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_is_oop()));
    __ xorl(HIGH_FROM_LOW(Rdst), HIGH_FROM_LOW(Rdst));
  
#line 9305 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void loadUB2L_immI8Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {
    MacroAssembler _masm(&cbuf);

#line 6573 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    Register Rdst = opnd_array(0)->as_Register(ra_,this);
    __ movzbl(Rdst, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_is_oop()));
    __ xorl(HIGH_FROM_LOW(Rdst), HIGH_FROM_LOW(Rdst));
    __ andl(Rdst, opnd_array(2)->constant());
  
#line 9324 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void loadSNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
  {
    MacroAssembler _masm(&cbuf);

#line 6589 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ movswl(opnd_array(0)->as_Register(ra_,this), Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_is_oop()));
  
#line 9339 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void loadS2BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {
    MacroAssembler _masm(&cbuf);

#line 6602 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ movsbl(opnd_array(0)->as_Register(ra_,this), Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_is_oop()));
  
#line 9355 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void loadS2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
  {
    MacroAssembler _masm(&cbuf);

#line 6618 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ movswl(opnd_array(0)->as_Register(ra_,this), Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_is_oop()));
    __ movl(HIGH_FROM_LOW(opnd_array(0)->as_Register(ra_,this)), opnd_array(0)->as_Register(ra_,this)); // This is always a different register.
    __ sarl(HIGH_FROM_LOW(opnd_array(0)->as_Register(ra_,this)), 15); // 16+1 MSB are already signed extended.
  
#line 9372 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void loadUSNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
  {
    MacroAssembler _masm(&cbuf);

#line 6634 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ movzwl(opnd_array(0)->as_Register(ra_,this), Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_is_oop()));
  
#line 9387 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void loadUS2BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {
    MacroAssembler _masm(&cbuf);

#line 6647 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ movsbl(opnd_array(0)->as_Register(ra_,this), Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_is_oop()));
  
#line 9403 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void loadUS2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
  {
    MacroAssembler _masm(&cbuf);

#line 6662 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ movzwl(opnd_array(0)->as_Register(ra_,this), Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_is_oop()));
    __ xorl(HIGH_FROM_LOW(opnd_array(0)->as_Register(ra_,this)), HIGH_FROM_LOW(opnd_array(0)->as_Register(ra_,this)));
  
#line 9419 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void loadUS2L_immI_255Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {
    MacroAssembler _masm(&cbuf);

#line 6677 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    Register Rdst = opnd_array(0)->as_Register(ra_,this);
    __ movzbl(Rdst, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_is_oop()));
    __ xorl(HIGH_FROM_LOW(Rdst), HIGH_FROM_LOW(Rdst));
  
#line 9437 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void loadUS2L_immI16Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {
    MacroAssembler _masm(&cbuf);

#line 6693 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    Register Rdst = opnd_array(0)->as_Register(ra_,this);
    __ movzwl(Rdst, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_is_oop()));
    __ xorl(HIGH_FROM_LOW(Rdst), HIGH_FROM_LOW(Rdst));
    __ andl(Rdst, opnd_array(2)->constant());
  
#line 9456 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void loadINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
  {
    MacroAssembler _masm(&cbuf);

#line 6709 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ movl(opnd_array(0)->as_Register(ra_,this), Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_is_oop()));
  
#line 9471 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void loadI2BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {
    MacroAssembler _masm(&cbuf);

#line 6722 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ movsbl(opnd_array(0)->as_Register(ra_,this), Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_is_oop()));
  
#line 9487 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void loadI2UBNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {
    MacroAssembler _masm(&cbuf);

#line 6734 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ movzbl(opnd_array(0)->as_Register(ra_,this), Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_is_oop()));
  
#line 9503 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void loadI2SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {
    MacroAssembler _masm(&cbuf);

#line 6746 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ movswl(opnd_array(0)->as_Register(ra_,this), Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_is_oop()));
  
#line 9519 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void loadI2USNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {
    MacroAssembler _masm(&cbuf);

#line 6758 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ movzwl(opnd_array(0)->as_Register(ra_,this), Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_is_oop()));
  
#line 9535 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void loadI2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
  {
    MacroAssembler _masm(&cbuf);

#line 6774 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ movl(opnd_array(0)->as_Register(ra_,this), Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_is_oop()));
    __ movl(HIGH_FROM_LOW(opnd_array(0)->as_Register(ra_,this)), opnd_array(0)->as_Register(ra_,this)); // This is always a different register.
    __ sarl(HIGH_FROM_LOW(opnd_array(0)->as_Register(ra_,this)), 31);
  
#line 9552 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void loadI2L_immI_255Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {
    MacroAssembler _masm(&cbuf);

#line 6790 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    Register Rdst = opnd_array(0)->as_Register(ra_,this);
    __ movzbl(Rdst, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_is_oop()));
    __ xorl(HIGH_FROM_LOW(Rdst), HIGH_FROM_LOW(Rdst));
  
#line 9570 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void loadI2L_immI_65535Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {
    MacroAssembler _masm(&cbuf);

#line 6805 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    Register Rdst = opnd_array(0)->as_Register(ra_,this);
    __ movzwl(Rdst, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_is_oop()));
    __ xorl(HIGH_FROM_LOW(Rdst), HIGH_FROM_LOW(Rdst));
  
#line 9588 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void loadI2L_immINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {
    MacroAssembler _masm(&cbuf);

#line 6821 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    Register Rdst = opnd_array(0)->as_Register(ra_,this);
    __ movl(Rdst, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_is_oop()));
    __ xorl(HIGH_FROM_LOW(Rdst), HIGH_FROM_LOW(Rdst));
    __ andl(Rdst, opnd_array(2)->constant());
  
#line 9607 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void loadUI2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
  {
    MacroAssembler _masm(&cbuf);

#line 6839 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ movl(opnd_array(0)->as_Register(ra_,this), Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_is_oop()));
    __ xorl(HIGH_FROM_LOW(opnd_array(0)->as_Register(ra_,this)), HIGH_FROM_LOW(opnd_array(0)->as_Register(ra_,this)));
  
#line 9623 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void loadLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
  {
    MacroAssembler _masm(&cbuf);

#line 6857 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    Address Amemlo = Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), false);
    Address Amemhi = Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1)+ 4, false);
    __ movl(opnd_array(0)->as_Register(ra_,this), Amemlo);
    __ movl(HIGH_FROM_LOW(opnd_array(0)->as_Register(ra_,this)), Amemhi);
  
#line 9641 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void loadL_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
  {

#line 4174 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf,0xDF);
    int rm_byte_opcode = 0x05;
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_is_oop);
    store_to_stackslot( cbuf, 0x0DF, 0x07, opnd_array(0)->disp(ra_,this,0) );
  
#line 9663 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void loadLX_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 4186 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    { // Atomic long load
      // UseXmmLoadAndClearUpper ? movsd $tmp,$mem : movlpd $tmp,$mem
      emit_opcode(cbuf,UseXmmLoadAndClearUpper ? 0xF2 : 0x66);
      emit_opcode(cbuf,0x0F);
      emit_opcode(cbuf,UseXmmLoadAndClearUpper ? 0x10 : 0x12);
      int base     = opnd_array(1)->base(ra_,this,idx1);
      int index    = opnd_array(1)->index(ra_,this,idx1);
      int scale    = opnd_array(1)->scale();
      int displace = opnd_array(1)->disp(ra_,this,idx1);
      bool disp_is_oop = opnd_array(1)->disp_is_oop(); // disp-as-oop when working with static globals
      encode_RegMem(cbuf, opnd_array(2)->reg(ra_,this,idx2), base, index, scale, displace, disp_is_oop);
    }
    { // MOVSD $dst,$tmp ! atomic long store
      emit_opcode(cbuf,0xF2);
      emit_opcode(cbuf,0x0F);
      emit_opcode(cbuf,0x11);
      int base     = opnd_array(0)->base(ra_,this,idx0);
      int index    = opnd_array(0)->index(ra_,this,idx0);
      int scale    = opnd_array(0)->scale();
      int displace = opnd_array(0)->disp(ra_,this,0);
      bool disp_is_oop = opnd_array(0)->disp_is_oop(); // disp-as-oop when working with static globals
      encode_RegMem(cbuf, opnd_array(2)->reg(ra_,this,idx2), base, index, scale, displace, disp_is_oop);
    }
  
#line 9700 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void loadLX_reg_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 4212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    { // Atomic long load
      // UseXmmLoadAndClearUpper ? movsd $tmp,$mem : movlpd $tmp,$mem
      emit_opcode(cbuf,UseXmmLoadAndClearUpper ? 0xF2 : 0x66);
      emit_opcode(cbuf,0x0F);
      emit_opcode(cbuf,UseXmmLoadAndClearUpper ? 0x10 : 0x12);
      int base     = opnd_array(1)->base(ra_,this,idx1);
      int index    = opnd_array(1)->index(ra_,this,idx1);
      int scale    = opnd_array(1)->scale();
      int displace = opnd_array(1)->disp(ra_,this,idx1);
      bool disp_is_oop = opnd_array(1)->disp_is_oop(); // disp-as-oop when working with static globals
      encode_RegMem(cbuf, opnd_array(2)->reg(ra_,this,idx2), base, index, scale, displace, disp_is_oop);
    }
    { // MOVD $dst.lo,$tmp
      emit_opcode(cbuf,0x66);
      emit_opcode(cbuf,0x0F);
      emit_opcode(cbuf,0x7E);
      emit_rm(cbuf, 0x3, opnd_array(2)->reg(ra_,this,idx2), opnd_array(0)->reg(ra_,this));
    }
    { // PSRLQ $tmp,32
      emit_opcode(cbuf,0x66);
      emit_opcode(cbuf,0x0F);
      emit_opcode(cbuf,0x73);
      emit_rm(cbuf, 0x3, 0x02, opnd_array(2)->reg(ra_,this,idx2));
      emit_d8(cbuf, 0x20);
    }
    { // MOVD $dst.hi,$tmp
      emit_opcode(cbuf,0x66);
      emit_opcode(cbuf,0x0F);
      emit_opcode(cbuf,0x7E);
      emit_rm(cbuf, 0x3, opnd_array(2)->reg(ra_,this,idx2), HIGH_FROM_LOW(opnd_array(0)->reg(ra_,this)));
    }
  
#line 9745 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void loadRangeNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x8B /*primary()*/));
  
#line 9759 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(0)->reg(ra_,this);
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 9773 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void loadPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x8B /*primary()*/));
  
#line 9787 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(0)->reg(ra_,this);
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 9801 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void loadKlassNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x8B /*primary()*/));
  
#line 9815 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(0)->reg(ra_,this);
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 9829 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void loadDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xDD /*primary()*/));
  
#line 9843 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2302 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_is_oop);
  
#line 9857 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2507 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xDD );           // FSTP   ST(i)
    emit_d8( cbuf, 0xD8+opnd_array(0)->reg(ra_,this) );
  
#line 9866 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void loadXDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xF2));
  
#line 9880 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0F));
  
#line 9888 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x10));
  
#line 9896 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(0)->reg(ra_,this);
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 9910 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void loadXD_partialNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x66));
  
#line 9924 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0F));
  
#line 9932 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x12));
  
#line 9940 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(0)->reg(ra_,this);
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 9954 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void loadXNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xF3));
  
#line 9968 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0F));
  
#line 9976 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x10));
  
#line 9984 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(0)->reg(ra_,this);
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 9998 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void loadFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9 /*primary()*/));
  
#line 10012 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2302 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_is_oop);
  
#line 10026 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2572 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xDD );           // FSTP   ST(i)
    emit_d8( cbuf, 0xD8+opnd_array(0)->reg(ra_,this) );
  
#line 10035 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void loadA8BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
  {

#line 3172 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    MacroAssembler _masm(&cbuf);
    __ movq(opnd_array(0)->as_XMMRegister(ra_,this), Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_is_oop()));
  
#line 10050 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void loadA4SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
  {

#line 3172 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    MacroAssembler _masm(&cbuf);
    __ movq(opnd_array(0)->as_XMMRegister(ra_,this), Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_is_oop()));
  
#line 10065 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void loadA4CNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
  {

#line 3172 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    MacroAssembler _masm(&cbuf);
    __ movq(opnd_array(0)->as_XMMRegister(ra_,this), Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_is_oop()));
  
#line 10080 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void load2IUNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
  {

#line 3172 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    MacroAssembler _masm(&cbuf);
    __ movq(opnd_array(0)->as_XMMRegister(ra_,this), Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_is_oop()));
  
#line 10095 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void loadA2FNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
  {

#line 3172 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    MacroAssembler _masm(&cbuf);
    __ movq(opnd_array(0)->as_XMMRegister(ra_,this), Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_is_oop()));
  
#line 10110 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void leaP8Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x8D /*primary()*/));
  
#line 10124 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(0)->reg(ra_,this);
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 10138 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void leaP32Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x8D /*primary()*/));
  
#line 10152 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(0)->reg(ra_,this);
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 10166 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void leaPIdxOffNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x8D /*primary()*/));
  
#line 10180 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(0)->reg(ra_,this);
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 10194 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void leaPIdxScaleNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x8D /*primary()*/));
  
#line 10208 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(0)->reg(ra_,this);
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 10222 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void leaPIdxScaleOffNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x8D /*primary()*/));
  
#line 10236 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(0)->reg(ra_,this);
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 10250 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void loadConINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 1978 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Load immediate does not have a zero or sign extended version
    // for 8-bit immediates
    emit_opcode(cbuf, 0xB8 + opnd_array(0)->reg(ra_,this));
    emit_d32(cbuf, opnd_array(1)->constant());
  
#line 10267 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void loadConI0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x33 /*primary()*/));
  
#line 10281 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2095 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(0)->reg(ra_,this), opnd_array(0)->reg(ra_,this));
  
#line 10289 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void loadConPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 1985 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Load immediate does not have a zero or sign extended version
    // for 8-bit immediates
    emit_opcode(cbuf, (0xB8 /*primary()*/) + opnd_array(0)->reg(ra_,this));
    
if ( opnd_array(1)->constant_is_oop() ) {
  emit_d32_reloc(cbuf, opnd_array(1)->constant(), relocInfo::oop_type, 0);
} else {
  emit_d32(cbuf, opnd_array(1)->constant());
};
  
#line 10311 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void loadConLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 1992 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Load immediate does not have a zero or sign extended version
    // for 8-bit immediates
    int dst_enc = opnd_array(0)->reg(ra_,this);
    int src_con = opnd_array(1)->constantL() & 0x0FFFFFFFFL;
    if (src_con == 0) {
      // xor dst, dst
      emit_opcode(cbuf, 0x33);
      emit_rm(cbuf, 0x3, dst_enc, dst_enc);
    } else {
      emit_opcode(cbuf, (0xB8 /*primary()*/) + dst_enc);
      emit_d32(cbuf, src_con);
    }
  
#line 10336 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2007 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Load immediate does not have a zero or sign extended version
    // for 8-bit immediates
    int dst_enc = opnd_array(0)->reg(ra_,this) + 2;
    int src_con = ((julong)(opnd_array(1)->constantL())) >> 32;
    if (src_con == 0) {
      // xor dst, dst
      emit_opcode(cbuf, 0x33);
      emit_rm(cbuf, 0x3, dst_enc, dst_enc);
    } else {
      emit_opcode(cbuf, (0xB8 /*primary()*/) + dst_enc);
      emit_d32(cbuf, src_con);
    }
  
#line 10355 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void loadConL0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 2099 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x33 /*primary()*/));
    emit_rm(cbuf, 0x3, opnd_array(0)->reg(ra_,this), opnd_array(0)->reg(ra_,this));
  
#line 10370 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2104 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x33 /*secondary()*/));
    emit_rm(cbuf, 0x3, HIGH_FROM_LOW(opnd_array(0)->reg(ra_,this)), HIGH_FROM_LOW(opnd_array(0)->reg(ra_,this)));
  
#line 10379 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void loadConFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {
    MacroAssembler _masm(&cbuf);

#line 7156 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ fld_s(InternalAddress(__ code()->consts()->start() + constant_offset()));
    __ fstp_d(opnd_array(0)->reg(ra_,this));
  
#line 10395 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void loadConFNode::eval_constant(Compile* C) {
  {

#line 7157 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
    _constant = C->constant_table().add(opnd_array(1));
#line 10403 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void loadConF0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {
    MacroAssembler _masm(&cbuf);

#line 7169 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ fldz();
    __ fstp_d(opnd_array(0)->reg(ra_,this));
  
#line 10419 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void loadConF1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {
    MacroAssembler _masm(&cbuf);

#line 7182 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ fld1();
    __ fstp_d(opnd_array(0)->reg(ra_,this));
  
#line 10435 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void loadConXNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {
    MacroAssembler _masm(&cbuf);

#line 7194 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ movflt(opnd_array(0)->as_XMMRegister(ra_,this), InternalAddress(__ code()->consts()->start() + constant_offset()));
  
#line 10450 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void loadConXNode::eval_constant(Compile* C) {
  {

#line 7195 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
    _constant = C->constant_table().add(opnd_array(1));
#line 10458 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void loadConX0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {
    MacroAssembler _masm(&cbuf);

#line 7205 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ xorps(opnd_array(0)->as_XMMRegister(ra_,this), opnd_array(0)->as_XMMRegister(ra_,this));
  
#line 10473 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void loadConDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {
    MacroAssembler _masm(&cbuf);

#line 7218 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ fld_d(InternalAddress(__ code()->consts()->start() + constant_offset()));
    __ fstp_d(opnd_array(0)->reg(ra_,this));
  
#line 10489 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void loadConDNode::eval_constant(Compile* C) {
  {

#line 7219 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
    _constant = C->constant_table().add(opnd_array(1));
#line 10497 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void loadConD0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {
    MacroAssembler _masm(&cbuf);

#line 7232 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ fldz();
    __ fstp_d(opnd_array(0)->reg(ra_,this));
  
#line 10513 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void loadConD1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {
    MacroAssembler _masm(&cbuf);

#line 7246 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ fld1();
    __ fstp_d(opnd_array(0)->reg(ra_,this));
  
#line 10529 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void loadConXDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {
    MacroAssembler _masm(&cbuf);

#line 7258 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ movdbl(opnd_array(0)->as_XMMRegister(ra_,this), InternalAddress(__ code()->consts()->start() + constant_offset()));
  
#line 10544 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void loadConXDNode::eval_constant(Compile* C) {
  {

#line 7259 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
    _constant = C->constant_table().add(opnd_array(1));
#line 10552 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void loadConXD0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x66));
  
#line 10566 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0F));
  
#line 10574 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x57));
  
#line 10582 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2095 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(0)->reg(ra_,this), opnd_array(0)->reg(ra_,this));
  
#line 10590 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void loadSSINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x8B /*primary()*/));
  
#line 10604 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(0)->reg(ra_,this);
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 10618 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void loadSSLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x8B /*primary()*/));
  
#line 10632 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(0)->reg(ra_,this);
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 10646 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1586 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x8B /*secondary()*/));
  
#line 10654 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2222 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = HIGH_FROM_LOW(opnd_array(0)->reg(ra_,this));  // Hi register of pair, computed from lo
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1) + 4;      // Offset is 4 further in memory
    assert( !opnd_array(1)->disp_is_oop(), "Cannot add 4 to oop" );
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, false/*disp_is_oop*/);
  
#line 10668 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void loadSSPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x8B /*primary()*/));
  
#line 10682 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(0)->reg(ra_,this);
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 10696 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void loadSSFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9 /*primary()*/));
  
#line 10710 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2292 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    assert( !opnd_array(1)->disp_is_oop(), "No oops here because no relo info allowed" );
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, false);
  
#line 10724 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2572 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xDD );           // FSTP   ST(i)
    emit_d8( cbuf, 0xD8+opnd_array(0)->reg(ra_,this) );
  
#line 10733 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void loadSSDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xDD /*primary()*/));
  
#line 10747 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2292 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    assert( !opnd_array(1)->disp_is_oop(), "No oops here because no relo info allowed" );
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, false);
  
#line 10761 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2507 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xDD );           // FSTP   ST(i)
    emit_d8( cbuf, 0xD8+opnd_array(0)->reg(ra_,this) );
  
#line 10770 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void prefetchr0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
  // User did not define which encode class to use.
}
uint  prefetchr0Node::size(PhaseRegAlloc *ra_) const {
 assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
 return (VerifyOops ? MachNode::size(ra_) : 0);
}
void prefetchrNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0F /*primary()*/));
  
#line 10795 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1586 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0d /*secondary()*/));
  
#line 10803 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2302 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_is_oop);
  
#line 10817 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void prefetchrNTANode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0F /*primary()*/));
  
#line 10831 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1586 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x18 /*secondary()*/));
  
#line 10839 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2302 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_is_oop);
  
#line 10853 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void prefetchrT0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0F /*primary()*/));
  
#line 10867 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1586 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x18 /*secondary()*/));
  
#line 10875 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2302 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x01);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_is_oop);
  
#line 10889 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void prefetchrT2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0F /*primary()*/));
  
#line 10903 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1586 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x18 /*secondary()*/));
  
#line 10911 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2302 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x03);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_is_oop);
  
#line 10925 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void prefetchw0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
  // User did not define which encode class to use.
}
uint  prefetchw0Node::size(PhaseRegAlloc *ra_) const {
 assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
 return (VerifyOops ? MachNode::size(ra_) : 0);
}
void prefetchwNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0F /*primary()*/));
  
#line 10950 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1586 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0D /*secondary()*/));
  
#line 10958 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2302 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x01);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_is_oop);
  
#line 10972 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void prefetchwNTANode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0F /*primary()*/));
  
#line 10986 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1586 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x18 /*secondary()*/));
  
#line 10994 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2302 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_is_oop);
  
#line 11008 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void prefetchwT0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0F /*primary()*/));
  
#line 11022 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1586 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x18 /*secondary()*/));
  
#line 11030 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2302 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x01);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_is_oop);
  
#line 11044 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void prefetchwT2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0F /*primary()*/));
  
#line 11058 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1586 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x18 /*secondary()*/));
  
#line 11066 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2302 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x03);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_is_oop);
  
#line 11080 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void storeBNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x88 /*primary()*/));
  
#line 11095 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(2)->reg(ra_,this,idx2);
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 11109 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void storeCNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1586 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x66 /*secondary()*/));
  
#line 11124 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x89 /*primary()*/));
  
#line 11132 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(2)->reg(ra_,this,idx2);
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 11146 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void storeINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x89 /*primary()*/));
  
#line 11161 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(2)->reg(ra_,this,idx2);
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 11175 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void storeLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x89 /*primary()*/));
  
#line 11190 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(2)->reg(ra_,this,idx2);
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 11204 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1586 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x89 /*secondary()*/));
  
#line 11212 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2222 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = HIGH_FROM_LOW(opnd_array(2)->reg(ra_,this,idx2));  // Hi register of pair, computed from lo
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1) + 4;      // Offset is 4 further in memory
    assert( !opnd_array(1)->disp_is_oop(), "Cannot add 4 to oop" );
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, false/*disp_is_oop*/);
  
#line 11226 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void storeL2INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {
    MacroAssembler _masm(&cbuf);

#line 7496 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ movl(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_is_oop()), opnd_array(2)->as_Register(ra_,this,idx2));
  
#line 11242 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void storeL_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x3B /*primary()*/));
  
#line 11257 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = (EAX_enc);
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 11271 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 4250 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    store_to_stackslot( cbuf, 0x0DF, 0x05, opnd_array(2)->disp(ra_,this,idx2) );
    cbuf.set_insts_mark();            // Mark start of FIST in case $mem has an oop
    emit_opcode(cbuf,0xDF);
    int rm_byte_opcode = 0x07;
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_is_oop);
  
#line 11288 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void storeLX_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x3B /*primary()*/));
  
#line 11304 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = (EAX_enc);
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 11318 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 4263 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    { // Atomic long load
      // UseXmmLoadAndClearUpper ? movsd $tmp,[$src] : movlpd $tmp,[$src]
      emit_opcode(cbuf,UseXmmLoadAndClearUpper ? 0xF2 : 0x66);
      emit_opcode(cbuf,0x0F);
      emit_opcode(cbuf,UseXmmLoadAndClearUpper ? 0x10 : 0x12);
      int base     = opnd_array(2)->base(ra_,this,idx2);
      int index    = opnd_array(2)->index(ra_,this,idx2);
      int scale    = opnd_array(2)->scale();
      int displace = opnd_array(2)->disp(ra_,this,idx2);
      bool disp_is_oop = opnd_array(2)->disp_is_oop(); // disp-as-oop when working with static globals
      encode_RegMem(cbuf, opnd_array(3)->reg(ra_,this,idx3), base, index, scale, displace, disp_is_oop);
    }
    cbuf.set_insts_mark();            // Mark start of MOVSD in case $mem has an oop
    { // MOVSD $mem,$tmp ! atomic long store
      emit_opcode(cbuf,0xF2);
      emit_opcode(cbuf,0x0F);
      emit_opcode(cbuf,0x11);
      int base     = opnd_array(1)->base(ra_,this,idx1);
      int index    = opnd_array(1)->index(ra_,this,idx1);
      int scale    = opnd_array(1)->scale();
      int displace = opnd_array(1)->disp(ra_,this,idx1);
      bool disp_is_oop = opnd_array(1)->disp_is_oop(); // disp-as-oop when working with static globals
      encode_RegMem(cbuf, opnd_array(3)->reg(ra_,this,idx3), base, index, scale, displace, disp_is_oop);
    }
  
#line 11349 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void storeLX_reg_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
    unsigned idx4 = idx3 + opnd_array(3)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x3B /*primary()*/));
  
#line 11366 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = (EAX_enc);
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 11380 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 4290 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    { // MOVD $tmp,$src.lo
      emit_opcode(cbuf,0x66);
      emit_opcode(cbuf,0x0F);
      emit_opcode(cbuf,0x6E);
      emit_rm(cbuf, 0x3, opnd_array(4)->reg(ra_,this,idx4), opnd_array(2)->reg(ra_,this,idx2));
    }
    { // MOVD $tmp2,$src.hi
      emit_opcode(cbuf,0x66);
      emit_opcode(cbuf,0x0F);
      emit_opcode(cbuf,0x6E);
      emit_rm(cbuf, 0x3, opnd_array(3)->reg(ra_,this,idx3), HIGH_FROM_LOW(opnd_array(2)->reg(ra_,this,idx2)));
    }
    { // PUNPCKLDQ $tmp,$tmp2
      emit_opcode(cbuf,0x66);
      emit_opcode(cbuf,0x0F);
      emit_opcode(cbuf,0x62);
      emit_rm(cbuf, 0x3, opnd_array(4)->reg(ra_,this,idx4), opnd_array(3)->reg(ra_,this,idx3));
    }
    cbuf.set_insts_mark();            // Mark start of MOVSD in case $mem has an oop
    { // MOVSD $mem,$tmp ! atomic long store
      emit_opcode(cbuf,0xF2);
      emit_opcode(cbuf,0x0F);
      emit_opcode(cbuf,0x11);
      int base     = opnd_array(1)->base(ra_,this,idx1);
      int index    = opnd_array(1)->index(ra_,this,idx1);
      int scale    = opnd_array(1)->scale();
      int displace = opnd_array(1)->disp(ra_,this,idx1);
      bool disp_is_oop = opnd_array(1)->disp_is_oop(); // disp-as-oop when working with static globals
      encode_RegMem(cbuf, opnd_array(4)->reg(ra_,this,idx4), base, index, scale, displace, disp_is_oop);
    }
  
#line 11417 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void storePNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x89 /*primary()*/));
  
#line 11432 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(2)->reg(ra_,this,idx2);
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 11446 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void storeImmINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xC7 /*primary()*/));
  
#line 11461 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2302 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_is_oop);
  
#line 11475 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2121 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Output immediate
    emit_d32(cbuf, opnd_array(2)->constant());
  
#line 11484 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void storeImmI16Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1595 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf,0x66);
  
#line 11499 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xC7 /*primary()*/));
  
#line 11507 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2302 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_is_oop);
  
#line 11521 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2140 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Output immediate
    emit_d16(cbuf, opnd_array(2)->constant());
  
#line 11530 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void storeImmPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xC7 /*primary()*/));
  
#line 11545 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2302 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_is_oop);
  
#line 11559 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2121 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Output immediate
    
if ( opnd_array(2)->constant_is_oop() ) {
  emit_d32_reloc(cbuf, opnd_array(2)->constant(), relocInfo::oop_type, 0);
} else {
  emit_d32(cbuf, opnd_array(2)->constant());
};
  
#line 11573 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void storeImmBNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xC6 /*primary()*/));
  
#line 11588 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2302 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_is_oop);
  
#line 11602 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1683 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Check for 8-bit immediate, and set sign extend bit in opcode
    if ((opnd_array(2)->constant() >= -128) && (opnd_array(2)->constant() <= 127)) {
      emit_d8(cbuf, opnd_array(2)->constant());
    }
    else {                          // If 32-bit immediate
      // Output immediate
      emit_d32(cbuf, opnd_array(2)->constant());
    }
  
#line 11617 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void storeA8BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 3177 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    MacroAssembler _masm(&cbuf);
    __ movq(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_is_oop()), opnd_array(2)->as_XMMRegister(ra_,this,idx2));
  
#line 11633 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void storeA4CNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 3177 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    MacroAssembler _masm(&cbuf);
    __ movq(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_is_oop()), opnd_array(2)->as_XMMRegister(ra_,this,idx2));
  
#line 11649 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void storeA2INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 3177 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    MacroAssembler _masm(&cbuf);
    __ movq(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_is_oop()), opnd_array(2)->as_XMMRegister(ra_,this,idx2));
  
#line 11665 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void storeImmCMNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xC6 /*primary()*/));
  
#line 11680 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2302 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_is_oop);
  
#line 11694 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1683 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Check for 8-bit immediate, and set sign extend bit in opcode
    if ((opnd_array(2)->constant() >= -128) && (opnd_array(2)->constant() <= 127)) {
      emit_d8(cbuf, opnd_array(2)->constant());
    }
    else {                          // If 32-bit immediate
      // Output immediate
      emit_d32(cbuf, opnd_array(2)->constant());
    }
  
#line 11709 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void storeDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 2346 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // If src is FPR1, we can just FST to store it.
    // Else we need to FLD it to FPR1, then FSTP to store/pop it.
    int reg_encoding = 0x2; // Just store
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop(); // disp-as-oop when working with static globals
    if( opnd_array(2)->reg(ra_,this,idx2) != FPR1L_enc ) {
      reg_encoding = 0x3;  // Store & pop
      emit_opcode( cbuf, 0xD9 ); // FLD (i.e., push it)
      emit_d8( cbuf, 0xC0-1+opnd_array(2)->reg(ra_,this,idx2) );
    }
    cbuf.set_insts_mark();       // Mark start of opcode for reloc info in mem operand
    emit_opcode(cbuf,(0xDD /*primary()*/));
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 11739 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void storeD_roundedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 2346 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // If src is FPR1, we can just FST to store it.
    // Else we need to FLD it to FPR1, then FSTP to store/pop it.
    int reg_encoding = 0x2; // Just store
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop(); // disp-as-oop when working with static globals
    if( opnd_array(2)->reg(ra_,this,idx2) != FPR1L_enc ) {
      reg_encoding = 0x3;  // Store & pop
      emit_opcode( cbuf, 0xD9 ); // FLD (i.e., push it)
      emit_d8( cbuf, 0xC0-1+opnd_array(2)->reg(ra_,this,idx2) );
    }
    cbuf.set_insts_mark();       // Mark start of opcode for reloc info in mem operand
    emit_opcode(cbuf,(0xDD /*primary()*/));
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 11769 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void storeXDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xF2));
  
#line 11784 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0F));
  
#line 11792 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x11));
  
#line 11800 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(2)->reg(ra_,this,idx2);
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 11814 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void storeXNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xF3));
  
#line 11829 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0F));
  
#line 11837 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x11));
  
#line 11845 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(2)->reg(ra_,this,idx2);
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 11859 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void storeA2FNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 3177 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    MacroAssembler _masm(&cbuf);
    __ movq(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_is_oop()), opnd_array(2)->as_XMMRegister(ra_,this,idx2));
  
#line 11875 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void storeFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 2346 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // If src is FPR1, we can just FST to store it.
    // Else we need to FLD it to FPR1, then FSTP to store/pop it.
    int reg_encoding = 0x2; // Just store
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop(); // disp-as-oop when working with static globals
    if( opnd_array(2)->reg(ra_,this,idx2) != FPR1L_enc ) {
      reg_encoding = 0x3;  // Store & pop
      emit_opcode( cbuf, 0xD9 ); // FLD (i.e., push it)
      emit_d8( cbuf, 0xC0-1+opnd_array(2)->reg(ra_,this,idx2) );
    }
    cbuf.set_insts_mark();       // Mark start of opcode for reloc info in mem operand
    emit_opcode(cbuf,(0xD9 /*primary()*/));
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 11905 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void storeF_roundedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 2346 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // If src is FPR1, we can just FST to store it.
    // Else we need to FLD it to FPR1, then FSTP to store/pop it.
    int reg_encoding = 0x2; // Just store
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop(); // disp-as-oop when working with static globals
    if( opnd_array(2)->reg(ra_,this,idx2) != FPR1L_enc ) {
      reg_encoding = 0x3;  // Store & pop
      emit_opcode( cbuf, 0xD9 ); // FLD (i.e., push it)
      emit_d8( cbuf, 0xC0-1+opnd_array(2)->reg(ra_,this,idx2) );
    }
    cbuf.set_insts_mark();       // Mark start of opcode for reloc info in mem operand
    emit_opcode(cbuf,(0xD9 /*primary()*/));
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 11935 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void storeF_DroundedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 2346 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // If src is FPR1, we can just FST to store it.
    // Else we need to FLD it to FPR1, then FSTP to store/pop it.
    int reg_encoding = 0x2; // Just store
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop(); // disp-as-oop when working with static globals
    if( opnd_array(2)->reg(ra_,this,idx2) != FPR1L_enc ) {
      reg_encoding = 0x3;  // Store & pop
      emit_opcode( cbuf, 0xD9 ); // FLD (i.e., push it)
      emit_d8( cbuf, 0xC0-1+opnd_array(2)->reg(ra_,this,idx2) );
    }
    cbuf.set_insts_mark();       // Mark start of opcode for reloc info in mem operand
    emit_opcode(cbuf,(0xD9 /*primary()*/));
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 11965 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void storeF_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xC7 /*primary()*/));
  
#line 11980 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2302 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_is_oop);
  
#line 11994 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2126 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Output Float immediate bits
    jfloat jf = opnd_array(2)->constantF();
    int    jf_as_bits = jint_cast( jf );
    emit_d32(cbuf, jf_as_bits);
  
#line 12005 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void storeX_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xC7 /*primary()*/));
  
#line 12020 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2302 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_is_oop);
  
#line 12034 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2133 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Output Float immediate bits
    jfloat jf = opnd_array(2)->constantF();
    int    jf_as_bits = jint_cast( jf );
    emit_d32(cbuf, jf_as_bits);
  
#line 12045 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void storeSSINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 2534 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    store_to_stackslot( cbuf, (0x89 /*primary()*/), opnd_array(1)->reg(ra_,this,idx1), opnd_array(0)->disp(ra_,this,0) );
  
#line 12059 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void storeSSPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 2534 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    store_to_stackslot( cbuf, (0x89 /*primary()*/), opnd_array(1)->reg(ra_,this,idx1), opnd_array(0)->disp(ra_,this,0) );
  
#line 12073 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void storeSSLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x89 /*primary()*/));
  
#line 12087 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(1)->reg(ra_,this,idx1);
    int base  = opnd_array(0)->base(ra_,this,idx0);
    int index = opnd_array(0)->index(ra_,this,idx0);
    int scale = opnd_array(0)->scale();
    int displace = opnd_array(0)->disp(ra_,this,0);
    bool disp_is_oop = opnd_array(0)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 12101 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1586 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x89 /*secondary()*/));
  
#line 12109 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2222 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1));  // Hi register of pair, computed from lo
    int base  = opnd_array(0)->base(ra_,this,idx0);
    int index = opnd_array(0)->index(ra_,this,idx0);
    int scale = opnd_array(0)->scale();
    int displace = opnd_array(0)->disp(ra_,this,0) + 4;      // Offset is 4 further in memory
    assert( !opnd_array(0)->disp_is_oop(), "Cannot add 4 to oop" );
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, false/*disp_is_oop*/);
  
#line 12123 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void membar_acquireNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  // User did not define which encode class to use.
}
uint  membar_acquireNode::size(PhaseRegAlloc *ra_) const {
 assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
 return (VerifyOops ? MachNode::size(ra_) : 0);
}
void membar_acquire_lockNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  // User did not define which encode class to use.
}
uint  membar_acquire_lockNode::size(PhaseRegAlloc *ra_) const {
 assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
 return (VerifyOops ? MachNode::size(ra_) : 0);
}
void membar_releaseNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  // User did not define which encode class to use.
}
uint  membar_releaseNode::size(PhaseRegAlloc *ra_) const {
 assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
 return (VerifyOops ? MachNode::size(ra_) : 0);
}
void membar_release_lockNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  // User did not define which encode class to use.
}
uint  membar_release_lockNode::size(PhaseRegAlloc *ra_) const {
 assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
 return (VerifyOops ? MachNode::size(ra_) : 0);
}
void membar_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {
    MacroAssembler _masm(&cbuf);

#line 7853 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ membar(Assembler::StoreLoad);
  
#line 12182 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void unnecessary_membar_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  // User did not define which encode class to use.
}
uint  unnecessary_membar_volatileNode::size(PhaseRegAlloc *ra_) const {
 assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
 return (VerifyOops ? MachNode::size(ra_) : 0);
}
void castX2PNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  // User did not define which encode class to use.
}
void castP2XNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 2082 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    encode_Copy( cbuf, opnd_array(0)->reg(ra_,this), opnd_array(1)->reg(ra_,this,idx1) );
  
#line 12214 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void cmovI_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
    unsigned idx4 = idx3 + opnd_array(3)->num_edges();
  {

#line 1765 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x0F /*primary()*/));
    emit_cc(cbuf, (0x40 /*secondary()*/), opnd_array(1)->ccode());
  
#line 12232 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2095 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(3)->reg(ra_,this,idx3), opnd_array(4)->reg(ra_,this,idx4));
  
#line 12240 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void cmovI_regUNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
    unsigned idx4 = idx3 + opnd_array(3)->num_edges();
  {

#line 1765 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x0F /*primary()*/));
    emit_cc(cbuf, (0x40 /*secondary()*/), opnd_array(1)->ccode());
  
#line 12258 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2095 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(3)->reg(ra_,this,idx3), opnd_array(4)->reg(ra_,this,idx4));
  
#line 12266 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void cmovI_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
    unsigned idx4 = idx3 + opnd_array(3)->num_edges();
  {

#line 1765 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x0F /*primary()*/));
    emit_cc(cbuf, (0x40 /*secondary()*/), opnd_array(1)->ccode());
  
#line 12284 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(3)->reg(ra_,this,idx3);
    int base  = opnd_array(4)->base(ra_,this,idx4);
    int index = opnd_array(4)->index(ra_,this,idx4);
    int scale = opnd_array(4)->scale();
    int displace = opnd_array(4)->disp(ra_,this,idx4);
    bool disp_is_oop = opnd_array(4)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 12298 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void cmovI_memUNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
    unsigned idx4 = idx3 + opnd_array(3)->num_edges();
  {

#line 1765 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x0F /*primary()*/));
    emit_cc(cbuf, (0x40 /*secondary()*/), opnd_array(1)->ccode());
  
#line 12316 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(3)->reg(ra_,this,idx3);
    int base  = opnd_array(4)->base(ra_,this,idx4);
    int index = opnd_array(4)->index(ra_,this,idx4);
    int scale = opnd_array(4)->scale();
    int displace = opnd_array(4)->disp(ra_,this,idx4);
    bool disp_is_oop = opnd_array(4)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 12330 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void cmovP_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
    unsigned idx4 = idx3 + opnd_array(3)->num_edges();
  {

#line 1765 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x0F /*primary()*/));
    emit_cc(cbuf, (0x40 /*secondary()*/), opnd_array(1)->ccode());
  
#line 12348 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2095 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(3)->reg(ra_,this,idx3), opnd_array(4)->reg(ra_,this,idx4));
  
#line 12356 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void cmovP_reg_nonP6Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
    unsigned idx4 = idx3 + opnd_array(3)->num_edges();
  {

#line 1777 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Invert sense of branch from sense of CMOV
    emit_cc( cbuf, 0x70, (opnd_array(1)->ccode()^1) );
    emit_d8( cbuf, (0x2) );
  
#line 12375 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x8b /*primary()*/));
  
#line 12383 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2095 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(3)->reg(ra_,this,idx3), opnd_array(4)->reg(ra_,this,idx4));
  
#line 12391 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void cmovP_regUNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
    unsigned idx4 = idx3 + opnd_array(3)->num_edges();
  {

#line 1765 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x0F /*primary()*/));
    emit_cc(cbuf, (0x40 /*secondary()*/), opnd_array(1)->ccode());
  
#line 12409 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2095 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(3)->reg(ra_,this,idx3), opnd_array(4)->reg(ra_,this,idx4));
  
#line 12417 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void fcmovD_regUNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
    unsigned idx4 = idx3 + opnd_array(3)->num_edges();
  {

#line 1770 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int op = 0xDA00 + opnd_array(1)->ccode() + (opnd_array(4)->reg(ra_,this,idx4)-1);
    emit_d8(cbuf, op >> 8 );
    emit_d8(cbuf, op & 255);
  
#line 12436 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void fcmovF_regUNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
    unsigned idx4 = idx3 + opnd_array(3)->num_edges();
  {

#line 1770 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int op = 0xDA00 + opnd_array(1)->ccode() + (opnd_array(4)->reg(ra_,this,idx4)-1);
    emit_d8(cbuf, op >> 8 );
    emit_d8(cbuf, op & 255);
  
#line 12455 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void fcmovD_regSNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
    unsigned idx4 = idx3 + opnd_array(3)->num_edges();
  {

#line 1777 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Invert sense of branch from sense of CMOV
    emit_cc( cbuf, 0x70, (opnd_array(1)->ccode()^1) );
    emit_d8( cbuf, (0x4) );
  
#line 12474 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2512 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );
    emit_d8( cbuf, 0xC0-1+opnd_array(4)->reg(ra_,this,idx4) );   // FLD ST(i-1)
  
#line 12483 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xdd /*primary()*/));
  
#line 12491 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1746 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x3 /*secondary()*/), opnd_array(3)->reg(ra_,this,idx3) );
  
#line 12499 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void fcmovF_regSNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
    unsigned idx4 = idx3 + opnd_array(3)->num_edges();
  {

#line 1777 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Invert sense of branch from sense of CMOV
    emit_cc( cbuf, 0x70, (opnd_array(1)->ccode()^1) );
    emit_d8( cbuf, (0x4) );
  
#line 12518 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2577 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );           // FLD    ST(i-1)
    emit_d8( cbuf, 0xC0-1+opnd_array(4)->reg(ra_,this,idx4) );
  
#line 12527 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xdd /*primary()*/));
  
#line 12535 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1746 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x3 /*secondary()*/), opnd_array(3)->reg(ra_,this,idx3) );
  
#line 12543 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void fcmovX_regSNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
    unsigned idx4 = idx3 + opnd_array(3)->num_edges();
  {
    MacroAssembler _masm(&cbuf);

#line 8078 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    Label skip;
    // Invert sense of branch from sense of CMOV
    __ jccb((Assembler::Condition)(opnd_array(1)->ccode()^1), skip);
    __ movflt(opnd_array(3)->as_XMMRegister(ra_,this,idx3), opnd_array(4)->as_XMMRegister(ra_,this,idx4));
    __ bind(skip);
  
#line 12565 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void fcmovXD_regSNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
    unsigned idx4 = idx3 + opnd_array(3)->num_edges();
  {
    MacroAssembler _masm(&cbuf);

#line 8096 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    Label skip;
    // Invert sense of branch from sense of CMOV
    __ jccb((Assembler::Condition)(opnd_array(1)->ccode()^1), skip);
    __ movdbl(opnd_array(3)->as_XMMRegister(ra_,this,idx3), opnd_array(4)->as_XMMRegister(ra_,this,idx4));
    __ bind(skip);
  
#line 12587 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void fcmovX_regUNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
    unsigned idx4 = idx3 + opnd_array(3)->num_edges();
  {
    MacroAssembler _masm(&cbuf);

#line 8114 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    Label skip;
    // Invert sense of branch from sense of CMOV
    __ jccb((Assembler::Condition)(opnd_array(1)->ccode()^1), skip);
    __ movflt(opnd_array(3)->as_XMMRegister(ra_,this,idx3), opnd_array(4)->as_XMMRegister(ra_,this,idx4));
    __ bind(skip);
  
#line 12609 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void fcmovXD_regUNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
    unsigned idx4 = idx3 + opnd_array(3)->num_edges();
  {
    MacroAssembler _masm(&cbuf);

#line 8141 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    Label skip;
    // Invert sense of branch from sense of CMOV
    __ jccb((Assembler::Condition)(opnd_array(1)->ccode()^1), skip);
    __ movdbl(opnd_array(3)->as_XMMRegister(ra_,this,idx3), opnd_array(4)->as_XMMRegister(ra_,this,idx4));
    __ bind(skip);
  
#line 12631 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void cmovL_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
    unsigned idx4 = idx3 + opnd_array(3)->num_edges();
  {

#line 1765 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x0F /*primary()*/));
    emit_cc(cbuf, (0x40 /*secondary()*/), opnd_array(1)->ccode());
  
#line 12649 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2109 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(3)->reg(ra_,this,idx3), opnd_array(4)->reg(ra_,this,idx4));
  
#line 12657 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1765 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x0F /*primary()*/));
    emit_cc(cbuf, (0x40 /*secondary()*/), opnd_array(1)->ccode());
  
#line 12666 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2113 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, HIGH_FROM_LOW(opnd_array(3)->reg(ra_,this,idx3)), HIGH_FROM_LOW(opnd_array(4)->reg(ra_,this,idx4)));
  
#line 12674 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void cmovL_regUNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
    unsigned idx4 = idx3 + opnd_array(3)->num_edges();
  {

#line 1765 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x0F /*primary()*/));
    emit_cc(cbuf, (0x40 /*secondary()*/), opnd_array(1)->ccode());
  
#line 12692 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2109 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(3)->reg(ra_,this,idx3), opnd_array(4)->reg(ra_,this,idx4));
  
#line 12700 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1765 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x0F /*primary()*/));
    emit_cc(cbuf, (0x40 /*secondary()*/), opnd_array(1)->ccode());
  
#line 12709 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2113 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, HIGH_FROM_LOW(opnd_array(3)->reg(ra_,this,idx3)), HIGH_FROM_LOW(opnd_array(4)->reg(ra_,this,idx4)));
  
#line 12717 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void addI_eRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x03 /*primary()*/));
  
#line 12732 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2095 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1), opnd_array(2)->reg(ra_,this,idx2));
  
#line 12740 "../generated/adfiles/ad_x86_32.cpp"
  }
}
uint  addI_eRegNode::size(PhaseRegAlloc *ra_) const {
 assert(VerifyOops || MachNode::size(ra_) <= 2, "bad fixed size");
 return (VerifyOops ? MachNode::size(ra_) : 2);
}
void addI_eReg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1671 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Emit primary opcode and set sign-extend bit
    // Check for 8-bit immediate, and set sign extend bit in opcode
    if ((opnd_array(2)->constant() >= -128) && (opnd_array(2)->constant() <= 127)) {
      emit_opcode(cbuf, (0x81 /*primary()*/) | 0x02);    }
    else {                          // If 32-bit immediate
      emit_opcode(cbuf, (0x81 /*primary()*/));
    }
    // Emit r/m byte with secondary opcode, after primary opcode.
    emit_rm(cbuf, 0x3, (0x00 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1));
  
#line 12767 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1683 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Check for 8-bit immediate, and set sign extend bit in opcode
    if ((opnd_array(2)->constant() >= -128) && (opnd_array(2)->constant() <= 127)) {
      emit_d8(cbuf, opnd_array(2)->constant());
    }
    else {                          // If 32-bit immediate
      // Output immediate
      emit_d32(cbuf, opnd_array(2)->constant());
    }
  
#line 12782 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void incI_eRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1655 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x40 /*primary()*/) + opnd_array(1)->reg(ra_,this,idx1));
  
#line 12797 "../generated/adfiles/ad_x86_32.cpp"
  }
}
uint  incI_eRegNode::size(PhaseRegAlloc *ra_) const {
 assert(VerifyOops || MachNode::size(ra_) <= 1, "bad fixed size");
 return (VerifyOops ? MachNode::size(ra_) : 1);
}
void leaI_eReg_immINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x8D /*primary()*/));
  
#line 12816 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2312 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(0)->reg(ra_,this);
    int base         = opnd_array(1)->reg(ra_,this,idx1);      // 0xFFFFFFFF indicates no base
    int index        = 0x04;            // 0x04 indicates no index
    int scale        = 0x00;            // 0x00 indicates no scale
    int displace     = opnd_array(2)->constant(); // 0x00 indicates no displacement
    bool disp_is_oop = false;
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 12830 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void leaP_eReg_immINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x8D /*primary()*/));
  
#line 12845 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2312 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(0)->reg(ra_,this);
    int base         = opnd_array(1)->reg(ra_,this,idx1);      // 0xFFFFFFFF indicates no base
    int index        = 0x04;            // 0x04 indicates no index
    int scale        = 0x00;            // 0x00 indicates no scale
    int displace     = opnd_array(2)->constant(); // 0x00 indicates no displacement
    bool disp_is_oop = false;
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 12859 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void decI_eRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1655 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x48 /*primary()*/) + opnd_array(1)->reg(ra_,this,idx1));
  
#line 12874 "../generated/adfiles/ad_x86_32.cpp"
  }
}
uint  decI_eRegNode::size(PhaseRegAlloc *ra_) const {
 assert(VerifyOops || MachNode::size(ra_) <= 1, "bad fixed size");
 return (VerifyOops ? MachNode::size(ra_) : 1);
}
void addP_eRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x03 /*primary()*/));
  
#line 12893 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2095 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1), opnd_array(2)->reg(ra_,this,idx2));
  
#line 12901 "../generated/adfiles/ad_x86_32.cpp"
  }
}
uint  addP_eRegNode::size(PhaseRegAlloc *ra_) const {
 assert(VerifyOops || MachNode::size(ra_) <= 2, "bad fixed size");
 return (VerifyOops ? MachNode::size(ra_) : 2);
}
void addP_eReg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1671 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Emit primary opcode and set sign-extend bit
    // Check for 8-bit immediate, and set sign extend bit in opcode
    if ((opnd_array(2)->constant() >= -128) && (opnd_array(2)->constant() <= 127)) {
      emit_opcode(cbuf, (0x81 /*primary()*/) | 0x02);    }
    else {                          // If 32-bit immediate
      emit_opcode(cbuf, (0x81 /*primary()*/));
    }
    // Emit r/m byte with secondary opcode, after primary opcode.
    emit_rm(cbuf, 0x3, (0x00 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1));
  
#line 12928 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1683 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Check for 8-bit immediate, and set sign extend bit in opcode
    if ((opnd_array(2)->constant() >= -128) && (opnd_array(2)->constant() <= 127)) {
      emit_d8(cbuf, opnd_array(2)->constant());
    }
    else {                          // If 32-bit immediate
      // Output immediate
      emit_d32(cbuf, opnd_array(2)->constant());
    }
  
#line 12943 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void addI_eReg_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x03 /*primary()*/));
  
#line 12958 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(1)->reg(ra_,this,idx1);
    int base  = opnd_array(2)->base(ra_,this,idx2);
    int index = opnd_array(2)->index(ra_,this,idx2);
    int scale = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2);
    bool disp_is_oop = opnd_array(2)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 12972 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void addI_eReg_mem_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x03 /*primary()*/));
  
#line 12987 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(2)->reg(ra_,this,idx2);
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 13001 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void addI_mem_eRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x01 /*primary()*/));
  
#line 13016 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(2)->reg(ra_,this,idx2);
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 13030 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void addI_mem_eReg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x01 /*primary()*/));
  
#line 13045 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(2)->reg(ra_,this,idx2);
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 13059 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void addI_mem_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1661 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Check for 8-bit immediate, and set sign extend bit in opcode
    if ((opnd_array(2)->constant() >= -128) && (opnd_array(2)->constant() <= 127)) {
      emit_opcode(cbuf, (0x81 /*primary()*/) | 0x02);
    }
    else {                          // If 32-bit immediate
      emit_opcode(cbuf, (0x81 /*primary()*/));
    }
  
#line 13080 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2302 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_is_oop);
  
#line 13094 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1683 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Check for 8-bit immediate, and set sign extend bit in opcode
    if ((opnd_array(2)->constant() >= -128) && (opnd_array(2)->constant() <= 127)) {
      emit_d8(cbuf, opnd_array(2)->constant());
    }
    else {                          // If 32-bit immediate
      // Output immediate
      emit_d32(cbuf, opnd_array(2)->constant());
    }
  
#line 13109 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void incI_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xFF /*primary()*/));
  
#line 13124 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2302 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_is_oop);
  
#line 13138 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void decI_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xFF /*primary()*/));
  
#line 13153 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2302 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x01);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_is_oop);
  
#line 13167 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void checkCastPPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  // User did not define which encode class to use.
}
uint  checkCastPPNode::size(PhaseRegAlloc *ra_) const {
 assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
 return (VerifyOops ? MachNode::size(ra_) : 0);
}
void castPPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  // User did not define which encode class to use.
}
void castIINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  // User did not define which encode class to use.
}
void loadPLockedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x8B /*primary()*/));
  
#line 13206 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(0)->reg(ra_,this);
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 13220 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void loadLLockedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
  {

#line 4174 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf,0xDF);
    int rm_byte_opcode = 0x05;
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_is_oop);
    store_to_stackslot( cbuf, 0x0DF, 0x07, opnd_array(0)->disp(ra_,this,0) );
  
#line 13242 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void loadLX_LockedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 4186 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    { // Atomic long load
      // UseXmmLoadAndClearUpper ? movsd $tmp,$mem : movlpd $tmp,$mem
      emit_opcode(cbuf,UseXmmLoadAndClearUpper ? 0xF2 : 0x66);
      emit_opcode(cbuf,0x0F);
      emit_opcode(cbuf,UseXmmLoadAndClearUpper ? 0x10 : 0x12);
      int base     = opnd_array(1)->base(ra_,this,idx1);
      int index    = opnd_array(1)->index(ra_,this,idx1);
      int scale    = opnd_array(1)->scale();
      int displace = opnd_array(1)->disp(ra_,this,idx1);
      bool disp_is_oop = opnd_array(1)->disp_is_oop(); // disp-as-oop when working with static globals
      encode_RegMem(cbuf, opnd_array(2)->reg(ra_,this,idx2), base, index, scale, displace, disp_is_oop);
    }
    { // MOVSD $dst,$tmp ! atomic long store
      emit_opcode(cbuf,0xF2);
      emit_opcode(cbuf,0x0F);
      emit_opcode(cbuf,0x11);
      int base     = opnd_array(0)->base(ra_,this,idx0);
      int index    = opnd_array(0)->index(ra_,this,idx0);
      int scale    = opnd_array(0)->scale();
      int displace = opnd_array(0)->disp(ra_,this,0);
      bool disp_is_oop = opnd_array(0)->disp_is_oop(); // disp-as-oop when working with static globals
      encode_RegMem(cbuf, opnd_array(2)->reg(ra_,this,idx2), base, index, scale, displace, disp_is_oop);
    }
  
#line 13279 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void loadLX_reg_LockedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 4212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    { // Atomic long load
      // UseXmmLoadAndClearUpper ? movsd $tmp,$mem : movlpd $tmp,$mem
      emit_opcode(cbuf,UseXmmLoadAndClearUpper ? 0xF2 : 0x66);
      emit_opcode(cbuf,0x0F);
      emit_opcode(cbuf,UseXmmLoadAndClearUpper ? 0x10 : 0x12);
      int base     = opnd_array(1)->base(ra_,this,idx1);
      int index    = opnd_array(1)->index(ra_,this,idx1);
      int scale    = opnd_array(1)->scale();
      int displace = opnd_array(1)->disp(ra_,this,idx1);
      bool disp_is_oop = opnd_array(1)->disp_is_oop(); // disp-as-oop when working with static globals
      encode_RegMem(cbuf, opnd_array(2)->reg(ra_,this,idx2), base, index, scale, displace, disp_is_oop);
    }
    { // MOVD $dst.lo,$tmp
      emit_opcode(cbuf,0x66);
      emit_opcode(cbuf,0x0F);
      emit_opcode(cbuf,0x7E);
      emit_rm(cbuf, 0x3, opnd_array(2)->reg(ra_,this,idx2), opnd_array(0)->reg(ra_,this));
    }
    { // PSRLQ $tmp,32
      emit_opcode(cbuf,0x66);
      emit_opcode(cbuf,0x0F);
      emit_opcode(cbuf,0x73);
      emit_rm(cbuf, 0x3, 0x02, opnd_array(2)->reg(ra_,this,idx2));
      emit_d8(cbuf, 0x20);
    }
    { // MOVD $dst.hi,$tmp
      emit_opcode(cbuf,0x66);
      emit_opcode(cbuf,0x0F);
      emit_opcode(cbuf,0x7E);
      emit_rm(cbuf, 0x3, opnd_array(2)->reg(ra_,this,idx2), HIGH_FROM_LOW(opnd_array(0)->reg(ra_,this)));
    }
  
#line 13324 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void storePConditionalNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
  {

#line 2155 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    if( os::is_MP() )
      emit_opcode(cbuf,0xF0);         // [Lock]
  
#line 13341 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0F));
  
#line 13349 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xB1));
  
#line 13357 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(3)->reg(ra_,this,idx3);
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 13371 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void storeIConditionalNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
  {

#line 2155 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    if( os::is_MP() )
      emit_opcode(cbuf,0xF0);         // [Lock]
  
#line 13388 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0F));
  
#line 13396 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xB1));
  
#line 13404 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(3)->reg(ra_,this,idx3);
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 13418 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void storeLConditionalNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
  {
    MacroAssembler _masm(&cbuf);

#line 8441 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Note: we need to swap rbx, and rcx before and after the
    //       cmpxchg8 instruction because the instruction uses
    //       rcx as the high order word of the new value to store but
    //       our register encoding uses rbx.
    __ xchgl(as_Register(EBX_enc), as_Register(ECX_enc));
    if( os::is_MP() )
      __ lock();
    __ cmpxchg8(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_is_oop()));
    __ xchgl(as_Register(EBX_enc), as_Register(ECX_enc));
  
#line 13443 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void compareAndSwapLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
  {

#line 2165 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"


    // XCHG  rbx,ecx
    emit_opcode(cbuf,0x87);
    emit_opcode(cbuf,0xD9);
    // [Lock]
    if( os::is_MP() )
      emit_opcode(cbuf,0xF0);
    // CMPXCHG8 [Eptr]
    emit_opcode(cbuf,0x0F);
    emit_opcode(cbuf,0xC7);
    emit_rm( cbuf, 0x0, 1, opnd_array(1)->reg(ra_,this,idx1) );
    // XCHG  rbx,ecx
    emit_opcode(cbuf,0x87);
    emit_opcode(cbuf,0xD9);
  
#line 13472 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2193 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int res_encoding = opnd_array(0)->reg(ra_,this);

    // MOV  res,0
    emit_opcode( cbuf, 0xB8 + res_encoding);
    emit_d32( cbuf, 0 );
    // JNE,s  fail
    emit_opcode(cbuf,0x75);
    emit_d8(cbuf, 5 );
    // MOV  res,1
    emit_opcode( cbuf, 0xB8 + res_encoding);
    emit_d32( cbuf, 1 );
    // fail:
  
#line 13491 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void compareAndSwapPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
  {

#line 2182 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // [Lock]
    if( os::is_MP() )
      emit_opcode(cbuf,0xF0);

    // CMPXCHG [Eptr]
    emit_opcode(cbuf,0x0F);
    emit_opcode(cbuf,0xB1);
    emit_rm( cbuf, 0x0, 1, opnd_array(1)->reg(ra_,this,idx1) );
  
#line 13514 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2193 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int res_encoding = opnd_array(0)->reg(ra_,this);

    // MOV  res,0
    emit_opcode( cbuf, 0xB8 + res_encoding);
    emit_d32( cbuf, 0 );
    // JNE,s  fail
    emit_opcode(cbuf,0x75);
    emit_d8(cbuf, 5 );
    // MOV  res,1
    emit_opcode( cbuf, 0xB8 + res_encoding);
    emit_d32( cbuf, 1 );
    // fail:
  
#line 13533 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void compareAndSwapINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
  {

#line 2182 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // [Lock]
    if( os::is_MP() )
      emit_opcode(cbuf,0xF0);

    // CMPXCHG [Eptr]
    emit_opcode(cbuf,0x0F);
    emit_opcode(cbuf,0xB1);
    emit_rm( cbuf, 0x0, 1, opnd_array(1)->reg(ra_,this,idx1) );
  
#line 13556 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2193 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int res_encoding = opnd_array(0)->reg(ra_,this);

    // MOV  res,0
    emit_opcode( cbuf, 0xB8 + res_encoding);
    emit_d32( cbuf, 0 );
    // JNE,s  fail
    emit_opcode(cbuf,0x75);
    emit_d8(cbuf, 5 );
    // MOV  res,1
    emit_opcode( cbuf, 0xB8 + res_encoding);
    emit_d32( cbuf, 1 );
    // fail:
  
#line 13575 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void subI_eRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x2B /*primary()*/));
  
#line 13590 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2095 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1), opnd_array(2)->reg(ra_,this,idx2));
  
#line 13598 "../generated/adfiles/ad_x86_32.cpp"
  }
}
uint  subI_eRegNode::size(PhaseRegAlloc *ra_) const {
 assert(VerifyOops || MachNode::size(ra_) <= 2, "bad fixed size");
 return (VerifyOops ? MachNode::size(ra_) : 2);
}
void subI_eReg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1671 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Emit primary opcode and set sign-extend bit
    // Check for 8-bit immediate, and set sign extend bit in opcode
    if ((opnd_array(2)->constant() >= -128) && (opnd_array(2)->constant() <= 127)) {
      emit_opcode(cbuf, (0x81 /*primary()*/) | 0x02);    }
    else {                          // If 32-bit immediate
      emit_opcode(cbuf, (0x81 /*primary()*/));
    }
    // Emit r/m byte with secondary opcode, after primary opcode.
    emit_rm(cbuf, 0x3, (0x05 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1));
  
#line 13625 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1683 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Check for 8-bit immediate, and set sign extend bit in opcode
    if ((opnd_array(2)->constant() >= -128) && (opnd_array(2)->constant() <= 127)) {
      emit_d8(cbuf, opnd_array(2)->constant());
    }
    else {                          // If 32-bit immediate
      // Output immediate
      emit_d32(cbuf, opnd_array(2)->constant());
    }
  
#line 13640 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void subI_eReg_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x2B /*primary()*/));
  
#line 13655 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(1)->reg(ra_,this,idx1);
    int base  = opnd_array(2)->base(ra_,this,idx2);
    int index = opnd_array(2)->index(ra_,this,idx2);
    int scale = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2);
    bool disp_is_oop = opnd_array(2)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 13669 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void subI_mem_eRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x29 /*primary()*/));
  
#line 13684 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(2)->reg(ra_,this,idx2);
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 13698 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void subP_eRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x2B /*primary()*/));
  
#line 13714 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2095 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1), opnd_array(3)->reg(ra_,this,idx3));
  
#line 13722 "../generated/adfiles/ad_x86_32.cpp"
  }
}
uint  subP_eRegNode::size(PhaseRegAlloc *ra_) const {
 assert(VerifyOops || MachNode::size(ra_) <= 2, "bad fixed size");
 return (VerifyOops ? MachNode::size(ra_) : 2);
}
void negI_eRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xF7 /*primary()*/));
  
#line 13741 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1746 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x03 /*secondary()*/), opnd_array(2)->reg(ra_,this,idx2) );
  
#line 13749 "../generated/adfiles/ad_x86_32.cpp"
  }
}
uint  negI_eRegNode::size(PhaseRegAlloc *ra_) const {
 assert(VerifyOops || MachNode::size(ra_) <= 2, "bad fixed size");
 return (VerifyOops ? MachNode::size(ra_) : 2);
}
void mulI_eRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1586 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0F /*secondary()*/));
  
#line 13768 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xAF /*primary()*/));
  
#line 13776 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2095 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1), opnd_array(2)->reg(ra_,this,idx2));
  
#line 13784 "../generated/adfiles/ad_x86_32.cpp"
  }
}
uint  mulI_eRegNode::size(PhaseRegAlloc *ra_) const {
 assert(VerifyOops || MachNode::size(ra_) <= 3, "bad fixed size");
 return (VerifyOops ? MachNode::size(ra_) : 3);
}
void mulI_eReg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1661 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Check for 8-bit immediate, and set sign extend bit in opcode
    if ((opnd_array(2)->constant() >= -128) && (opnd_array(2)->constant() <= 127)) {
      emit_opcode(cbuf, (0x69 /*primary()*/) | 0x02);
    }
    else {                          // If 32-bit immediate
      emit_opcode(cbuf, (0x69 /*primary()*/));
    }
  
#line 13809 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2095 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(0)->reg(ra_,this), opnd_array(1)->reg(ra_,this,idx1));
  
#line 13817 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1683 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Check for 8-bit immediate, and set sign extend bit in opcode
    if ((opnd_array(2)->constant() >= -128) && (opnd_array(2)->constant() <= 127)) {
      emit_d8(cbuf, opnd_array(2)->constant());
    }
    else {                          // If 32-bit immediate
      // Output immediate
      emit_d32(cbuf, opnd_array(2)->constant());
    }
  
#line 13832 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void loadConL_low_onlyNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 1992 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Load immediate does not have a zero or sign extended version
    // for 8-bit immediates
    int dst_enc = opnd_array(0)->reg(ra_,this);
    int src_con = opnd_array(1)->constantL() & 0x0FFFFFFFFL;
    if (src_con == 0) {
      // xor dst, dst
      emit_opcode(cbuf, 0x33);
      emit_rm(cbuf, 0x3, dst_enc, dst_enc);
    } else {
      emit_opcode(cbuf, (0xB8 /*primary()*/) + dst_enc);
      emit_d32(cbuf, src_con);
    }
  
#line 13857 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void mulI_imm_highNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
  {

#line 2994 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // IMUL   EDX:EAX,$src1
    emit_opcode( cbuf, 0xF7 );
    emit_rm( cbuf, 0x3, 0x5, opnd_array(1)->reg(ra_,this,idx1) );
    // SAR    EDX,$cnt-32
    int shift_count = ((int)opnd_array(3)->constant()) - 32;
    if (shift_count > 0) {
      emit_opcode(cbuf, 0xC1);
      emit_rm(cbuf, 0x3, 7, opnd_array(0)->reg(ra_,this) );
      emit_d8(cbuf, shift_count);
    }
  
#line 13882 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void mulI_imm_high_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
  {

#line 2994 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // IMUL   EDX:EAX,$src1
    emit_opcode( cbuf, 0xF7 );
    emit_rm( cbuf, 0x3, 0x5, opnd_array(2)->reg(ra_,this,idx2) );
    // SAR    EDX,$cnt-32
    int shift_count = ((int)opnd_array(3)->constant()) - 32;
    if (shift_count > 0) {
      emit_opcode(cbuf, 0xC1);
      emit_rm(cbuf, 0x3, 7, opnd_array(0)->reg(ra_,this) );
      emit_d8(cbuf, shift_count);
    }
  
#line 13907 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void mulI_imm_RShift_highNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
  {

#line 2994 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // IMUL   EDX:EAX,$src1
    emit_opcode( cbuf, 0xF7 );
    emit_rm( cbuf, 0x3, 0x5, opnd_array(1)->reg(ra_,this,idx1) );
    // SAR    EDX,$cnt-32
    int shift_count = ((int)opnd_array(3)->constant()) - 32;
    if (shift_count > 0) {
      emit_opcode(cbuf, 0xC1);
      emit_rm(cbuf, 0x3, 7, opnd_array(0)->reg(ra_,this) );
      emit_d8(cbuf, shift_count);
    }
  
#line 13932 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void mulI_imm_RShift_high_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
  {

#line 2994 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // IMUL   EDX:EAX,$src1
    emit_opcode( cbuf, 0xF7 );
    emit_rm( cbuf, 0x3, 0x5, opnd_array(2)->reg(ra_,this,idx2) );
    // SAR    EDX,$cnt-32
    int shift_count = ((int)opnd_array(3)->constant()) - 32;
    if (shift_count > 0) {
      emit_opcode(cbuf, 0xC1);
      emit_rm(cbuf, 0x3, 7, opnd_array(0)->reg(ra_,this) );
      emit_d8(cbuf, shift_count);
    }
  
#line 13957 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void mulI_mem_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1661 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Check for 8-bit immediate, and set sign extend bit in opcode
    if ((opnd_array(2)->constant() >= -128) && (opnd_array(2)->constant() <= 127)) {
      emit_opcode(cbuf, (0x69 /*primary()*/) | 0x02);
    }
    else {                          // If 32-bit immediate
      emit_opcode(cbuf, (0x69 /*primary()*/));
    }
  
#line 13978 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(0)->reg(ra_,this);
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 13992 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1683 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Check for 8-bit immediate, and set sign extend bit in opcode
    if ((opnd_array(2)->constant() >= -128) && (opnd_array(2)->constant() <= 127)) {
      emit_d8(cbuf, opnd_array(2)->constant());
    }
    else {                          // If 32-bit immediate
      // Output immediate
      emit_d32(cbuf, opnd_array(2)->constant());
    }
  
#line 14007 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void mulINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1586 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0F /*secondary()*/));
  
#line 14022 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xAF /*primary()*/));
  
#line 14030 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(1)->reg(ra_,this,idx1);
    int base  = opnd_array(2)->base(ra_,this,idx2);
    int index = opnd_array(2)->index(ra_,this,idx2);
    int scale = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2);
    bool disp_is_oop = opnd_array(2)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 14044 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void mulI_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1586 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0F /*secondary()*/));
  
#line 14059 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xAF /*primary()*/));
  
#line 14067 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(2)->reg(ra_,this,idx2);
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 14081 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void mulI2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 3020 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Basic idea: long = (long)int * (long)int
    // IMUL EDX:EAX, src
    emit_opcode( cbuf, 0xF7 );
    emit_rm( cbuf, 0x3, 0x5, opnd_array(2)->reg(ra_,this,idx2));
  
#line 14099 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void mulI2L_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 3020 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Basic idea: long = (long)int * (long)int
    // IMUL EDX:EAX, src
    emit_opcode( cbuf, 0xF7 );
    emit_rm( cbuf, 0x3, 0x5, opnd_array(1)->reg(ra_,this,idx1));
  
#line 14117 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void mulIS_eRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
  {

#line 3027 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Basic Idea:  long = (int & 0xffffffffL) * (int & 0xffffffffL)
    // MUL EDX:EAX, src
    emit_opcode( cbuf, 0xF7 );
    emit_rm( cbuf, 0x3, 0x4, opnd_array(3)->reg(ra_,this,idx3));
  
#line 14136 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void mulIS_eReg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
  {

#line 3027 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Basic Idea:  long = (int & 0xffffffffL) * (int & 0xffffffffL)
    // MUL EDX:EAX, src
    emit_opcode( cbuf, 0xF7 );
    emit_rm( cbuf, 0x3, 0x4, opnd_array(1)->reg(ra_,this,idx1));
  
#line 14155 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void mulL_eRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
  {

#line 3034 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Basic idea: lo(result) = lo(x_lo * y_lo)
    //             hi(result) = hi(x_lo * y_lo) + lo(x_hi * y_lo) + lo(x_lo * y_hi)
    // MOV    $tmp,$src.lo
    encode_Copy( cbuf, opnd_array(3)->reg(ra_,this,idx3), opnd_array(2)->reg(ra_,this,idx2) );
    // IMUL   $tmp,EDX
    emit_opcode( cbuf, 0x0F );
    emit_opcode( cbuf, 0xAF );
    emit_rm( cbuf, 0x3, opnd_array(3)->reg(ra_,this,idx3), HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)) );
    // MOV    EDX,$src.hi
    encode_Copy( cbuf, HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)), HIGH_FROM_LOW(opnd_array(2)->reg(ra_,this,idx2)) );
    // IMUL   EDX,EAX
    emit_opcode( cbuf, 0x0F );
    emit_opcode( cbuf, 0xAF );
    emit_rm( cbuf, 0x3, HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)), opnd_array(1)->reg(ra_,this,idx1) );
    // ADD    $tmp,EDX
    emit_opcode( cbuf, 0x03 );
    emit_rm( cbuf, 0x3, opnd_array(3)->reg(ra_,this,idx3), HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)) );
    // MUL   EDX:EAX,$src.lo
    emit_opcode( cbuf, 0xF7 );
    emit_rm( cbuf, 0x3, 0x4, opnd_array(2)->reg(ra_,this,idx2) );
    // ADD    EDX,ESI
    emit_opcode( cbuf, 0x03 );
    emit_rm( cbuf, 0x3, HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)), opnd_array(3)->reg(ra_,this,idx3) );
  
#line 14193 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void mulL_eReg_lhi0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
  {
    MacroAssembler _masm(&cbuf);

#line 8714 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ movl(opnd_array(3)->as_Register(ra_,this,idx3), HIGH_FROM_LOW(opnd_array(2)->as_Register(ra_,this,idx2)));
    __ imull(opnd_array(3)->as_Register(ra_,this,idx3), rax);
    __ mull(opnd_array(2)->as_Register(ra_,this,idx2));
    __ addl(rdx, opnd_array(3)->as_Register(ra_,this,idx3));
  
#line 14213 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void mulL_eReg_rhi0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
  {
    MacroAssembler _masm(&cbuf);

#line 8735 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ movl(opnd_array(3)->as_Register(ra_,this,idx3), opnd_array(2)->as_Register(ra_,this,idx2));
    __ imull(opnd_array(3)->as_Register(ra_,this,idx3), rdx);
    __ mull(opnd_array(2)->as_Register(ra_,this,idx2));
    __ addl(rdx, opnd_array(3)->as_Register(ra_,this,idx3));
  
#line 14233 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void mulL_eReg_hi0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {
    MacroAssembler _masm(&cbuf);

#line 8753 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ mull(opnd_array(2)->as_Register(ra_,this,idx2));
  
#line 14249 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void mulL_eReg_conNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
  {

#line 3060 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Basic idea: lo(result) = lo(src * y_lo)
    //             hi(result) = hi(src * y_lo) + lo(src * y_hi)
    // IMUL   $tmp,EDX,$src
    emit_opcode( cbuf, 0x6B );
    emit_rm( cbuf, 0x3, opnd_array(3)->reg(ra_,this,idx3), HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)) );
    emit_d8( cbuf, (int)opnd_array(2)->constantL() );
    // MOV    EDX,$src
    emit_opcode(cbuf, 0xB8 + EDX_enc);
    emit_d32( cbuf, (int)opnd_array(2)->constantL() );
    // MUL   EDX:EAX,EDX
    emit_opcode( cbuf, 0xF7 );
    emit_rm( cbuf, 0x3, 0x4, EDX_enc );
    // ADD    EDX,ESI
    emit_opcode( cbuf, 0x03 );
    emit_rm( cbuf, 0x3, EDX_enc, opnd_array(3)->reg(ra_,this,idx3) );
  
#line 14279 "../generated/adfiles/ad_x86_32.cpp"
  }
}
uint  mulL_eReg_conNode::size(PhaseRegAlloc *ra_) const {
 assert(VerifyOops || MachNode::size(ra_) <= 12, "bad fixed size");
 return (VerifyOops ? MachNode::size(ra_) : 12);
}
void divI_eRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1613 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Full implementation of Java idiv and irem; checks for
    // special case as described in JVM spec., p.243 & p.271.
    //
    //         normal case                           special case
    //
    // input : rax,: dividend                         min_int
    //         reg: divisor                          -1
    //
    // output: rax,: quotient  (= rax, idiv reg)       min_int
    //         rdx: remainder (= rax, irem reg)       0
    //
    //  Code sequnce:
    //
    //  81 F8 00 00 00 80    cmp         rax,80000000h
    //  0F 85 0B 00 00 00    jne         normal_case
    //  33 D2                xor         rdx,edx
    //  83 F9 FF             cmp         rcx,0FFh
    //  0F 84 03 00 00 00    je          done
    //                  normal_case:
    //  99                   cdq
    //  F7 F9                idiv        rax,ecx
    //                  done:
    //
    emit_opcode(cbuf,0x81); emit_d8(cbuf,0xF8);
    emit_opcode(cbuf,0x00); emit_d8(cbuf,0x00);
    emit_opcode(cbuf,0x00); emit_d8(cbuf,0x80);                     // cmp rax,80000000h
    emit_opcode(cbuf,0x0F); emit_d8(cbuf,0x85);
    emit_opcode(cbuf,0x0B); emit_d8(cbuf,0x00);
    emit_opcode(cbuf,0x00); emit_d8(cbuf,0x00);                     // jne normal_case
    emit_opcode(cbuf,0x33); emit_d8(cbuf,0xD2);                     // xor rdx,edx
    emit_opcode(cbuf,0x83); emit_d8(cbuf,0xF9); emit_d8(cbuf,0xFF); // cmp rcx,0FFh
    emit_opcode(cbuf,0x0F); emit_d8(cbuf,0x84);
    emit_opcode(cbuf,0x03); emit_d8(cbuf,0x00);
    emit_opcode(cbuf,0x00); emit_d8(cbuf,0x00);                     // je done
    // normal_case:
    emit_opcode(cbuf,0x99);                                         // cdq
    // idiv (note: must be emitted by the user of this rule)
    // normal:
  
#line 14335 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xF7 /*primary()*/));
  
#line 14343 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1746 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x7 /*secondary()*/), opnd_array(2)->reg(ra_,this,idx2) );
  
#line 14351 "../generated/adfiles/ad_x86_32.cpp"
  }
}
uint  divI_eRegNode::size(PhaseRegAlloc *ra_) const {
 assert(VerifyOops || MachNode::size(ra_) <= 26, "bad fixed size");
 return (VerifyOops ? MachNode::size(ra_) : 26);
}
void divL_eRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 3078 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // PUSH src1.hi
    emit_opcode(cbuf, HIGH_FROM_LOW(0x50+opnd_array(1)->reg(ra_,this,idx1)) );
    // PUSH src1.lo
    emit_opcode(cbuf,               0x50+opnd_array(1)->reg(ra_,this,idx1)  );
    // PUSH src2.hi
    emit_opcode(cbuf, HIGH_FROM_LOW(0x50+opnd_array(2)->reg(ra_,this,idx2)) );
    // PUSH src2.lo
    emit_opcode(cbuf,               0x50+opnd_array(2)->reg(ra_,this,idx2)  );
    // CALL directly to the runtime
    cbuf.set_insts_mark();
    emit_opcode(cbuf,0xE8);       // Call into runtime
    emit_d32_reloc(cbuf, (CAST_FROM_FN_PTR(address, SharedRuntime::ldiv) - cbuf.insts_end()) - 4, runtime_call_Relocation::spec(), RELOC_IMM32 );
    // Restore stack
    emit_opcode(cbuf, 0x83); // add  SP, #framesize
    emit_rm(cbuf, 0x3, 0x00, ESP_enc);
    emit_d8(cbuf, 4*4);
  
#line 14385 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void divModI_eReg_divmodNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1613 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Full implementation of Java idiv and irem; checks for
    // special case as described in JVM spec., p.243 & p.271.
    //
    //         normal case                           special case
    //
    // input : rax,: dividend                         min_int
    //         reg: divisor                          -1
    //
    // output: rax,: quotient  (= rax, idiv reg)       min_int
    //         rdx: remainder (= rax, irem reg)       0
    //
    //  Code sequnce:
    //
    //  81 F8 00 00 00 80    cmp         rax,80000000h
    //  0F 85 0B 00 00 00    jne         normal_case
    //  33 D2                xor         rdx,edx
    //  83 F9 FF             cmp         rcx,0FFh
    //  0F 84 03 00 00 00    je          done
    //                  normal_case:
    //  99                   cdq
    //  F7 F9                idiv        rax,ecx
    //                  done:
    //
    emit_opcode(cbuf,0x81); emit_d8(cbuf,0xF8);
    emit_opcode(cbuf,0x00); emit_d8(cbuf,0x00);
    emit_opcode(cbuf,0x00); emit_d8(cbuf,0x80);                     // cmp rax,80000000h
    emit_opcode(cbuf,0x0F); emit_d8(cbuf,0x85);
    emit_opcode(cbuf,0x0B); emit_d8(cbuf,0x00);
    emit_opcode(cbuf,0x00); emit_d8(cbuf,0x00);                     // jne normal_case
    emit_opcode(cbuf,0x33); emit_d8(cbuf,0xD2);                     // xor rdx,edx
    emit_opcode(cbuf,0x83); emit_d8(cbuf,0xF9); emit_d8(cbuf,0xFF); // cmp rcx,0FFh
    emit_opcode(cbuf,0x0F); emit_d8(cbuf,0x84);
    emit_opcode(cbuf,0x03); emit_d8(cbuf,0x00);
    emit_opcode(cbuf,0x00); emit_d8(cbuf,0x00);                     // je done
    // normal_case:
    emit_opcode(cbuf,0x99);                                         // cdq
    // idiv (note: must be emitted by the user of this rule)
    // normal:
  
#line 14437 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xF7 /*primary()*/));
  
#line 14445 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1746 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x7 /*secondary()*/), opnd_array(2)->reg(ra_,this,idx2) );
  
#line 14453 "../generated/adfiles/ad_x86_32.cpp"
  }
}
uint  divModI_eReg_divmodNode::size(PhaseRegAlloc *ra_) const {
 assert(VerifyOops || MachNode::size(ra_) <= 26, "bad fixed size");
 return (VerifyOops ? MachNode::size(ra_) : 26);
}
void modI_eRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1613 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Full implementation of Java idiv and irem; checks for
    // special case as described in JVM spec., p.243 & p.271.
    //
    //         normal case                           special case
    //
    // input : rax,: dividend                         min_int
    //         reg: divisor                          -1
    //
    // output: rax,: quotient  (= rax, idiv reg)       min_int
    //         rdx: remainder (= rax, irem reg)       0
    //
    //  Code sequnce:
    //
    //  81 F8 00 00 00 80    cmp         rax,80000000h
    //  0F 85 0B 00 00 00    jne         normal_case
    //  33 D2                xor         rdx,edx
    //  83 F9 FF             cmp         rcx,0FFh
    //  0F 84 03 00 00 00    je          done
    //                  normal_case:
    //  99                   cdq
    //  F7 F9                idiv        rax,ecx
    //                  done:
    //
    emit_opcode(cbuf,0x81); emit_d8(cbuf,0xF8);
    emit_opcode(cbuf,0x00); emit_d8(cbuf,0x00);
    emit_opcode(cbuf,0x00); emit_d8(cbuf,0x80);                     // cmp rax,80000000h
    emit_opcode(cbuf,0x0F); emit_d8(cbuf,0x85);
    emit_opcode(cbuf,0x0B); emit_d8(cbuf,0x00);
    emit_opcode(cbuf,0x00); emit_d8(cbuf,0x00);                     // jne normal_case
    emit_opcode(cbuf,0x33); emit_d8(cbuf,0xD2);                     // xor rdx,edx
    emit_opcode(cbuf,0x83); emit_d8(cbuf,0xF9); emit_d8(cbuf,0xFF); // cmp rcx,0FFh
    emit_opcode(cbuf,0x0F); emit_d8(cbuf,0x84);
    emit_opcode(cbuf,0x03); emit_d8(cbuf,0x00);
    emit_opcode(cbuf,0x00); emit_d8(cbuf,0x00);                     // je done
    // normal_case:
    emit_opcode(cbuf,0x99);                                         // cdq
    // idiv (note: must be emitted by the user of this rule)
    // normal:
  
#line 14509 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xF7 /*primary()*/));
  
#line 14517 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1746 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x7 /*secondary()*/), opnd_array(2)->reg(ra_,this,idx2) );
  
#line 14525 "../generated/adfiles/ad_x86_32.cpp"
  }
}
uint  modI_eRegNode::size(PhaseRegAlloc *ra_) const {
 assert(VerifyOops || MachNode::size(ra_) <= 26, "bad fixed size");
 return (VerifyOops ? MachNode::size(ra_) : 26);
}
void modL_eRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 3097 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // PUSH src1.hi
    emit_opcode(cbuf, HIGH_FROM_LOW(0x50+opnd_array(1)->reg(ra_,this,idx1)) );
    // PUSH src1.lo
    emit_opcode(cbuf,               0x50+opnd_array(1)->reg(ra_,this,idx1)  );
    // PUSH src2.hi
    emit_opcode(cbuf, HIGH_FROM_LOW(0x50+opnd_array(2)->reg(ra_,this,idx2)) );
    // PUSH src2.lo
    emit_opcode(cbuf,               0x50+opnd_array(2)->reg(ra_,this,idx2)  );
    // CALL directly to the runtime
    cbuf.set_insts_mark();
    emit_opcode(cbuf,0xE8);       // Call into runtime
    emit_d32_reloc(cbuf, (CAST_FROM_FN_PTR(address, SharedRuntime::lrem ) - cbuf.insts_end()) - 4, runtime_call_Relocation::spec(), RELOC_IMM32 );
    // Restore stack
    emit_opcode(cbuf, 0x83); // add  SP, #framesize
    emit_rm(cbuf, 0x3, 0x00, ESP_enc);
    emit_d8(cbuf, 4*4);
  
#line 14559 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void divL_eReg_imm32Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
    unsigned idx4 = idx3 + opnd_array(3)->num_edges();
  {
    MacroAssembler _masm(&cbuf);

#line 8884 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int con = (int)opnd_array(2)->constantL();
    assert(con != 0 && con != -1 && con != min_jint, "wrong divisor");
    int pcon = (con > 0) ? con : -con;
    Label Lfast, Lpos, Ldone;

    __ movl(opnd_array(3)->as_Register(ra_,this,idx3), pcon);
    __ xorl(opnd_array(4)->as_Register(ra_,this,idx4),opnd_array(4)->as_Register(ra_,this,idx4));
    __ cmpl(opnd_array(3)->as_Register(ra_,this,idx3), HIGH_FROM_LOW(opnd_array(1)->as_Register(ra_,this,idx1)));
    __ jccb(Assembler::above, Lfast); // result fits into 32 bit

    __ movl(opnd_array(4)->as_Register(ra_,this,idx4), opnd_array(1)->as_Register(ra_,this,idx1)); // save
    __ movl(opnd_array(1)->as_Register(ra_,this,idx1), HIGH_FROM_LOW(opnd_array(1)->as_Register(ra_,this,idx1)));
    __ movl(HIGH_FROM_LOW(opnd_array(1)->as_Register(ra_,this,idx1)),0); // preserve flags
    __ jccb(Assembler::lessEqual, Lpos); // result is positive

    // Negative dividend.
    // convert value to positive to use unsigned division
    __ lneg(opnd_array(1)->as_Register(ra_,this,idx1), opnd_array(4)->as_Register(ra_,this,idx4));
    __ divl(opnd_array(3)->as_Register(ra_,this,idx3));
    __ xchgl(opnd_array(1)->as_Register(ra_,this,idx1), opnd_array(4)->as_Register(ra_,this,idx4));
    __ divl(opnd_array(3)->as_Register(ra_,this,idx3));
    // revert result back to negative
    __ lneg(opnd_array(4)->as_Register(ra_,this,idx4), opnd_array(1)->as_Register(ra_,this,idx1));
    __ jmpb(Ldone);

    __ bind(Lpos);
    __ divl(opnd_array(3)->as_Register(ra_,this,idx3)); // Use unsigned division
    __ xchgl(opnd_array(1)->as_Register(ra_,this,idx1), opnd_array(4)->as_Register(ra_,this,idx4));
    // Fallthrow for final divide, tmp2 has 32 bit hi result

    __ bind(Lfast);
    // fast path: src is positive
    __ divl(opnd_array(3)->as_Register(ra_,this,idx3)); // Use unsigned division

    __ bind(Ldone);
    __ movl(HIGH_FROM_LOW(opnd_array(1)->as_Register(ra_,this,idx1)),opnd_array(4)->as_Register(ra_,this,idx4));
    if (con < 0) {
      __ lneg(HIGH_FROM_LOW(opnd_array(1)->as_Register(ra_,this,idx1)), opnd_array(1)->as_Register(ra_,this,idx1));
    }
  
#line 14615 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void modL_eReg_imm32Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
    unsigned idx4 = idx3 + opnd_array(3)->num_edges();
  {
    MacroAssembler _masm(&cbuf);

#line 8954 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int con = (int)opnd_array(2)->constantL();
    assert(con != 0 && con != -1 && con != min_jint, "wrong divisor");
    int pcon = (con > 0) ? con : -con;
    Label  Lfast, Lpos, Ldone;

    __ movl(opnd_array(3)->as_Register(ra_,this,idx3), pcon);
    __ cmpl(opnd_array(3)->as_Register(ra_,this,idx3), HIGH_FROM_LOW(opnd_array(1)->as_Register(ra_,this,idx1)));
    __ jccb(Assembler::above, Lfast); // src is positive and result fits into 32 bit

    __ movl(opnd_array(4)->as_Register(ra_,this,idx4), opnd_array(1)->as_Register(ra_,this,idx1)); // save
    __ movl(opnd_array(1)->as_Register(ra_,this,idx1), HIGH_FROM_LOW(opnd_array(1)->as_Register(ra_,this,idx1)));
    __ movl(HIGH_FROM_LOW(opnd_array(1)->as_Register(ra_,this,idx1)),0); // preserve flags
    __ jccb(Assembler::lessEqual, Lpos); // result is positive

    // Negative dividend.
    // convert value to positive to use unsigned division
    __ lneg(opnd_array(1)->as_Register(ra_,this,idx1), opnd_array(4)->as_Register(ra_,this,idx4));
    __ divl(opnd_array(3)->as_Register(ra_,this,idx3));
    __ movl(opnd_array(1)->as_Register(ra_,this,idx1), opnd_array(4)->as_Register(ra_,this,idx4));
    __ divl(opnd_array(3)->as_Register(ra_,this,idx3));
    // revert remainder back to negative
    __ negl(HIGH_FROM_LOW(opnd_array(1)->as_Register(ra_,this,idx1)));
    __ jmpb(Ldone);

    __ bind(Lpos);
    __ divl(opnd_array(3)->as_Register(ra_,this,idx3));
    __ movl(opnd_array(1)->as_Register(ra_,this,idx1), opnd_array(4)->as_Register(ra_,this,idx4));

    __ bind(Lfast);
    // fast path: src is positive
    __ divl(opnd_array(3)->as_Register(ra_,this,idx3));

    __ bind(Ldone);
    __ movl(opnd_array(1)->as_Register(ra_,this,idx1), HIGH_FROM_LOW(opnd_array(1)->as_Register(ra_,this,idx1)));
    __ sarl(HIGH_FROM_LOW(opnd_array(1)->as_Register(ra_,this,idx1)), 31); // result sign

  
#line 14668 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void shlI_eReg_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD1 /*primary()*/));
  
#line 14683 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1746 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x4 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1) );
  
#line 14691 "../generated/adfiles/ad_x86_32.cpp"
  }
}
uint  shlI_eReg_1Node::size(PhaseRegAlloc *ra_) const {
 assert(VerifyOops || MachNode::size(ra_) <= 2, "bad fixed size");
 return (VerifyOops ? MachNode::size(ra_) : 2);
}
void salI_eReg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1972 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0xC1 /*primary()*/));
    emit_rm(cbuf, 0x3, (0x4 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1));
    emit_d8(cbuf, opnd_array(2)->constant());
  
#line 14712 "../generated/adfiles/ad_x86_32.cpp"
  }
}
uint  salI_eReg_immNode::size(PhaseRegAlloc *ra_) const {
 assert(VerifyOops || MachNode::size(ra_) <= 3, "bad fixed size");
 return (VerifyOops ? MachNode::size(ra_) : 3);
}
void salI_eReg_CLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD3 /*primary()*/));
  
#line 14731 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1746 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x4 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1) );
  
#line 14739 "../generated/adfiles/ad_x86_32.cpp"
  }
}
uint  salI_eReg_CLNode::size(PhaseRegAlloc *ra_) const {
 assert(VerifyOops || MachNode::size(ra_) <= 2, "bad fixed size");
 return (VerifyOops ? MachNode::size(ra_) : 2);
}
void sarI_eReg_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD1 /*primary()*/));
  
#line 14758 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1746 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x7 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1) );
  
#line 14766 "../generated/adfiles/ad_x86_32.cpp"
  }
}
uint  sarI_eReg_1Node::size(PhaseRegAlloc *ra_) const {
 assert(VerifyOops || MachNode::size(ra_) <= 2, "bad fixed size");
 return (VerifyOops ? MachNode::size(ra_) : 2);
}
void sarI_mem_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD1 /*primary()*/));
  
#line 14785 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2302 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x7 /*secondary()*/);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_is_oop);
  
#line 14799 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void sarI_eReg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1972 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0xC1 /*primary()*/));
    emit_rm(cbuf, 0x3, (0x7 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1));
    emit_d8(cbuf, opnd_array(2)->constant());
  
#line 14816 "../generated/adfiles/ad_x86_32.cpp"
  }
}
uint  sarI_eReg_immNode::size(PhaseRegAlloc *ra_) const {
 assert(VerifyOops || MachNode::size(ra_) <= 3, "bad fixed size");
 return (VerifyOops ? MachNode::size(ra_) : 3);
}
void sarI_mem_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xC1 /*primary()*/));
  
#line 14835 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2302 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x7 /*secondary()*/);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_is_oop);
  
#line 14849 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1683 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Check for 8-bit immediate, and set sign extend bit in opcode
    if ((opnd_array(2)->constant() >= -128) && (opnd_array(2)->constant() <= 127)) {
      emit_d8(cbuf, opnd_array(2)->constant());
    }
    else {                          // If 32-bit immediate
      // Output immediate
      emit_d32(cbuf, opnd_array(2)->constant());
    }
  
#line 14864 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void sarI_eReg_CLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD3 /*primary()*/));
  
#line 14879 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1746 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x7 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1) );
  
#line 14887 "../generated/adfiles/ad_x86_32.cpp"
  }
}
uint  sarI_eReg_CLNode::size(PhaseRegAlloc *ra_) const {
 assert(VerifyOops || MachNode::size(ra_) <= 2, "bad fixed size");
 return (VerifyOops ? MachNode::size(ra_) : 2);
}
void shrI_eReg_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD1 /*primary()*/));
  
#line 14906 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1746 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x5 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1) );
  
#line 14914 "../generated/adfiles/ad_x86_32.cpp"
  }
}
uint  shrI_eReg_1Node::size(PhaseRegAlloc *ra_) const {
 assert(VerifyOops || MachNode::size(ra_) <= 2, "bad fixed size");
 return (VerifyOops ? MachNode::size(ra_) : 2);
}
void shrI_eReg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1972 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0xC1 /*primary()*/));
    emit_rm(cbuf, 0x3, (0x5 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1));
    emit_d8(cbuf, opnd_array(2)->constant());
  
#line 14935 "../generated/adfiles/ad_x86_32.cpp"
  }
}
uint  shrI_eReg_immNode::size(PhaseRegAlloc *ra_) const {
 assert(VerifyOops || MachNode::size(ra_) <= 3, "bad fixed size");
 return (VerifyOops ? MachNode::size(ra_) : 3);
}
void i2bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {
    MacroAssembler _masm(&cbuf);

#line 9121 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ movsbl(opnd_array(0)->as_Register(ra_,this), opnd_array(1)->as_Register(ra_,this,idx1));
  
#line 14955 "../generated/adfiles/ad_x86_32.cpp"
  }
}
uint  i2bNode::size(PhaseRegAlloc *ra_) const {
 assert(VerifyOops || MachNode::size(ra_) <= 3, "bad fixed size");
 return (VerifyOops ? MachNode::size(ra_) : 3);
}
void i2sNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {
    MacroAssembler _masm(&cbuf);

#line 9134 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ movswl(opnd_array(0)->as_Register(ra_,this), opnd_array(1)->as_Register(ra_,this,idx1));
  
#line 14975 "../generated/adfiles/ad_x86_32.cpp"
  }
}
uint  i2sNode::size(PhaseRegAlloc *ra_) const {
 assert(VerifyOops || MachNode::size(ra_) <= 3, "bad fixed size");
 return (VerifyOops ? MachNode::size(ra_) : 3);
}
void shrI_eReg_CLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD3 /*primary()*/));
  
#line 14994 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1746 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x5 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1) );
  
#line 15002 "../generated/adfiles/ad_x86_32.cpp"
  }
}
uint  shrI_eReg_CLNode::size(PhaseRegAlloc *ra_) const {
 assert(VerifyOops || MachNode::size(ra_) <= 2, "bad fixed size");
 return (VerifyOops ? MachNode::size(ra_) : 2);
}
void andI_eRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x23 /*primary()*/));
  
#line 15021 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2095 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1), opnd_array(2)->reg(ra_,this,idx2));
  
#line 15029 "../generated/adfiles/ad_x86_32.cpp"
  }
}
uint  andI_eRegNode::size(PhaseRegAlloc *ra_) const {
 assert(VerifyOops || MachNode::size(ra_) <= 2, "bad fixed size");
 return (VerifyOops ? MachNode::size(ra_) : 2);
}
void andI_eReg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1671 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Emit primary opcode and set sign-extend bit
    // Check for 8-bit immediate, and set sign extend bit in opcode
    if ((opnd_array(2)->constant() >= -128) && (opnd_array(2)->constant() <= 127)) {
      emit_opcode(cbuf, (0x81 /*primary()*/) | 0x02);    }
    else {                          // If 32-bit immediate
      emit_opcode(cbuf, (0x81 /*primary()*/));
    }
    // Emit r/m byte with secondary opcode, after primary opcode.
    emit_rm(cbuf, 0x3, (0x04 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1));
  
#line 15056 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1683 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Check for 8-bit immediate, and set sign extend bit in opcode
    if ((opnd_array(2)->constant() >= -128) && (opnd_array(2)->constant() <= 127)) {
      emit_d8(cbuf, opnd_array(2)->constant());
    }
    else {                          // If 32-bit immediate
      // Output immediate
      emit_d32(cbuf, opnd_array(2)->constant());
    }
  
#line 15071 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void andI_eReg_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x23 /*primary()*/));
  
#line 15086 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(1)->reg(ra_,this,idx1);
    int base  = opnd_array(2)->base(ra_,this,idx2);
    int index = opnd_array(2)->index(ra_,this,idx2);
    int scale = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2);
    bool disp_is_oop = opnd_array(2)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 15100 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void andI_eReg_mem_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x23 /*primary()*/));
  
#line 15115 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(2)->reg(ra_,this,idx2);
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 15129 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void andI_mem_eRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x21 /*primary()*/));
  
#line 15144 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(2)->reg(ra_,this,idx2);
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 15158 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void andI_mem_eReg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x21 /*primary()*/));
  
#line 15173 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(2)->reg(ra_,this,idx2);
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 15187 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void andI_mem_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1661 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Check for 8-bit immediate, and set sign extend bit in opcode
    if ((opnd_array(2)->constant() >= -128) && (opnd_array(2)->constant() <= 127)) {
      emit_opcode(cbuf, (0x81 /*primary()*/) | 0x02);
    }
    else {                          // If 32-bit immediate
      emit_opcode(cbuf, (0x81 /*primary()*/));
    }
  
#line 15208 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2302 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x4 /*secondary()*/);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_is_oop);
  
#line 15222 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1683 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Check for 8-bit immediate, and set sign extend bit in opcode
    if ((opnd_array(2)->constant() >= -128) && (opnd_array(2)->constant() <= 127)) {
      emit_d8(cbuf, opnd_array(2)->constant());
    }
    else {                          // If 32-bit immediate
      // Output immediate
      emit_d32(cbuf, opnd_array(2)->constant());
    }
  
#line 15237 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void orI_eRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0B /*primary()*/));
  
#line 15252 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2095 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1), opnd_array(2)->reg(ra_,this,idx2));
  
#line 15260 "../generated/adfiles/ad_x86_32.cpp"
  }
}
uint  orI_eRegNode::size(PhaseRegAlloc *ra_) const {
 assert(VerifyOops || MachNode::size(ra_) <= 2, "bad fixed size");
 return (VerifyOops ? MachNode::size(ra_) : 2);
}
void orI_eReg_castP2XNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0B /*primary()*/));
  
#line 15279 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2095 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1), opnd_array(2)->reg(ra_,this,idx2));
  
#line 15287 "../generated/adfiles/ad_x86_32.cpp"
  }
}
uint  orI_eReg_castP2XNode::size(PhaseRegAlloc *ra_) const {
 assert(VerifyOops || MachNode::size(ra_) <= 2, "bad fixed size");
 return (VerifyOops ? MachNode::size(ra_) : 2);
}
void orI_eReg_castP2X_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0B /*primary()*/));
  
#line 15306 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2095 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(2)->reg(ra_,this,idx2), opnd_array(1)->reg(ra_,this,idx1));
  
#line 15314 "../generated/adfiles/ad_x86_32.cpp"
  }
}
uint  orI_eReg_castP2X_0Node::size(PhaseRegAlloc *ra_) const {
 assert(VerifyOops || MachNode::size(ra_) <= 2, "bad fixed size");
 return (VerifyOops ? MachNode::size(ra_) : 2);
}
void orI_eReg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1671 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Emit primary opcode and set sign-extend bit
    // Check for 8-bit immediate, and set sign extend bit in opcode
    if ((opnd_array(2)->constant() >= -128) && (opnd_array(2)->constant() <= 127)) {
      emit_opcode(cbuf, (0x81 /*primary()*/) | 0x02);    }
    else {                          // If 32-bit immediate
      emit_opcode(cbuf, (0x81 /*primary()*/));
    }
    // Emit r/m byte with secondary opcode, after primary opcode.
    emit_rm(cbuf, 0x3, (0x01 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1));
  
#line 15341 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1683 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Check for 8-bit immediate, and set sign extend bit in opcode
    if ((opnd_array(2)->constant() >= -128) && (opnd_array(2)->constant() <= 127)) {
      emit_d8(cbuf, opnd_array(2)->constant());
    }
    else {                          // If 32-bit immediate
      // Output immediate
      emit_d32(cbuf, opnd_array(2)->constant());
    }
  
#line 15356 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void orI_eReg_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0B /*primary()*/));
  
#line 15371 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(1)->reg(ra_,this,idx1);
    int base  = opnd_array(2)->base(ra_,this,idx2);
    int index = opnd_array(2)->index(ra_,this,idx2);
    int scale = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2);
    bool disp_is_oop = opnd_array(2)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 15385 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void orI_eReg_mem_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0B /*primary()*/));
  
#line 15400 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(2)->reg(ra_,this,idx2);
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 15414 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void orI_mem_eRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x09 /*primary()*/));
  
#line 15429 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(2)->reg(ra_,this,idx2);
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 15443 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void orI_mem_eReg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x09 /*primary()*/));
  
#line 15458 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(2)->reg(ra_,this,idx2);
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 15472 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void orI_mem_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1661 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Check for 8-bit immediate, and set sign extend bit in opcode
    if ((opnd_array(2)->constant() >= -128) && (opnd_array(2)->constant() <= 127)) {
      emit_opcode(cbuf, (0x81 /*primary()*/) | 0x02);
    }
    else {                          // If 32-bit immediate
      emit_opcode(cbuf, (0x81 /*primary()*/));
    }
  
#line 15493 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2302 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x1 /*secondary()*/);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_is_oop);
  
#line 15507 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1683 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Check for 8-bit immediate, and set sign extend bit in opcode
    if ((opnd_array(2)->constant() >= -128) && (opnd_array(2)->constant() <= 127)) {
      emit_d8(cbuf, opnd_array(2)->constant());
    }
    else {                          // If 32-bit immediate
      // Output immediate
      emit_d32(cbuf, opnd_array(2)->constant());
    }
  
#line 15522 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void rolI_eReg_imm1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD1 /*primary()*/));
  
#line 15537 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1746 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x0 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1) );
  
#line 15545 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void rolI_eReg_imm8Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1972 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0xC1 /*primary()*/));
    emit_rm(cbuf, 0x3, (0x0 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1));
    emit_d8(cbuf, opnd_array(2)->constant());
  
#line 15562 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void rolI_eReg_CLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD3 /*primary()*/));
  
#line 15577 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1746 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x0 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1) );
  
#line 15585 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void rorI_eReg_imm1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD1 /*primary()*/));
  
#line 15600 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1746 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x1 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1) );
  
#line 15608 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void rorI_eReg_imm8Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1972 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0xC1 /*primary()*/));
    emit_rm(cbuf, 0x3, (0x1 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1));
    emit_d8(cbuf, opnd_array(2)->constant());
  
#line 15625 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void rorI_eReg_CLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD3 /*primary()*/));
  
#line 15640 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1746 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x1 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1) );
  
#line 15648 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void xorI_eRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x33 /*primary()*/));
  
#line 15663 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2095 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1), opnd_array(2)->reg(ra_,this,idx2));
  
#line 15671 "../generated/adfiles/ad_x86_32.cpp"
  }
}
uint  xorI_eRegNode::size(PhaseRegAlloc *ra_) const {
 assert(VerifyOops || MachNode::size(ra_) <= 2, "bad fixed size");
 return (VerifyOops ? MachNode::size(ra_) : 2);
}
void xorI_eReg_im1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {
    MacroAssembler _masm(&cbuf);

#line 9444 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

     __ notl(opnd_array(1)->as_Register(ra_,this,idx1));
  
#line 15691 "../generated/adfiles/ad_x86_32.cpp"
  }
}
uint  xorI_eReg_im1Node::size(PhaseRegAlloc *ra_) const {
 assert(VerifyOops || MachNode::size(ra_) <= 2, "bad fixed size");
 return (VerifyOops ? MachNode::size(ra_) : 2);
}
void xorI_eReg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1671 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Emit primary opcode and set sign-extend bit
    // Check for 8-bit immediate, and set sign extend bit in opcode
    if ((opnd_array(2)->constant() >= -128) && (opnd_array(2)->constant() <= 127)) {
      emit_opcode(cbuf, (0x81 /*primary()*/) | 0x02);    }
    else {                          // If 32-bit immediate
      emit_opcode(cbuf, (0x81 /*primary()*/));
    }
    // Emit r/m byte with secondary opcode, after primary opcode.
    emit_rm(cbuf, 0x3, (0x06 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1));
  
#line 15718 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1683 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Check for 8-bit immediate, and set sign extend bit in opcode
    if ((opnd_array(2)->constant() >= -128) && (opnd_array(2)->constant() <= 127)) {
      emit_d8(cbuf, opnd_array(2)->constant());
    }
    else {                          // If 32-bit immediate
      // Output immediate
      emit_d32(cbuf, opnd_array(2)->constant());
    }
  
#line 15733 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void xorI_eReg_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x33 /*primary()*/));
  
#line 15748 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(1)->reg(ra_,this,idx1);
    int base  = opnd_array(2)->base(ra_,this,idx2);
    int index = opnd_array(2)->index(ra_,this,idx2);
    int scale = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2);
    bool disp_is_oop = opnd_array(2)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 15762 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void xorI_eReg_mem_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x33 /*primary()*/));
  
#line 15777 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(2)->reg(ra_,this,idx2);
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 15791 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void xorI_mem_eRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x31 /*primary()*/));
  
#line 15806 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(2)->reg(ra_,this,idx2);
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 15820 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void xorI_mem_eReg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x31 /*primary()*/));
  
#line 15835 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(2)->reg(ra_,this,idx2);
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 15849 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void xorI_mem_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1661 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Check for 8-bit immediate, and set sign extend bit in opcode
    if ((opnd_array(2)->constant() >= -128) && (opnd_array(2)->constant() <= 127)) {
      emit_opcode(cbuf, (0x81 /*primary()*/) | 0x02);
    }
    else {                          // If 32-bit immediate
      emit_opcode(cbuf, (0x81 /*primary()*/));
    }
  
#line 15870 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2302 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x6 /*secondary()*/);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_is_oop);
  
#line 15884 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1683 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Check for 8-bit immediate, and set sign extend bit in opcode
    if ((opnd_array(2)->constant() >= -128) && (opnd_array(2)->constant() <= 127)) {
      emit_d8(cbuf, opnd_array(2)->constant());
    }
    else {                          // If 32-bit immediate
      // Output immediate
      emit_d32(cbuf, opnd_array(2)->constant());
    }
  
#line 15899 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void movI_nocopyNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 2082 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    encode_Copy( cbuf, opnd_array(0)->reg(ra_,this), opnd_array(1)->reg(ra_,this,idx1) );
  
#line 15913 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void ci2bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 2365 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // NEG $dst
    emit_opcode(cbuf,0xF7);
    emit_rm(cbuf, 0x3, 0x03, opnd_array(1)->reg(ra_,this,idx1) );
  
#line 15930 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1603 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf,(0x13));
    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1), opnd_array(2)->reg(ra_,this,idx2));
  
#line 15939 "../generated/adfiles/ad_x86_32.cpp"
  }
}
uint  ci2bNode::size(PhaseRegAlloc *ra_) const {
 assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
 return (VerifyOops ? MachNode::size(ra_) : 4);
}
void movP_nocopyNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 2082 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    encode_Copy( cbuf, opnd_array(0)->reg(ra_,this), opnd_array(1)->reg(ra_,this,idx1) );
  
#line 15957 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void cp2bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 2365 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // NEG $dst
    emit_opcode(cbuf,0xF7);
    emit_rm(cbuf, 0x3, 0x03, opnd_array(1)->reg(ra_,this,idx1) );
  
#line 15974 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1603 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf,(0x13));
    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1), opnd_array(2)->reg(ra_,this,idx2));
  
#line 15983 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void cmpLTMaskNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1603 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf,(0x33));
    emit_rm(cbuf, 0x3, opnd_array(0)->reg(ra_,this), opnd_array(0)->reg(ra_,this));
  
#line 15999 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1603 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf,(0x3B));
    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1), opnd_array(2)->reg(ra_,this,idx2));
  
#line 16008 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2371 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // SETLT $dst
    emit_opcode(cbuf,0x0F);
    emit_opcode(cbuf,0x9C);
    emit_rm( cbuf, 0x3, 0x4, opnd_array(0)->reg(ra_,this) );
  
#line 16019 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2365 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // NEG $dst
    emit_opcode(cbuf,0xF7);
    emit_rm(cbuf, 0x3, 0x03, opnd_array(0)->reg(ra_,this) );
  
#line 16029 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void cmpLTMask0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1972 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0xC1 /*primary()*/));
    emit_rm(cbuf, 0x3, (0x7 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1));
    emit_d8(cbuf, (0x1F));
  
#line 16046 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void cadd_cmpLTMaskNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
  {

#line 2378 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int tmpReg = ECX_enc;

    // SUB $p,$q
    emit_opcode(cbuf,0x2B);
    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1), opnd_array(2)->reg(ra_,this,idx2));
    // SBB $tmp,$tmp
    emit_opcode(cbuf,0x1B);
    emit_rm(cbuf, 0x3, tmpReg, tmpReg);
    // AND $tmp,$y
    emit_opcode(cbuf,0x23);
    emit_rm(cbuf, 0x3, tmpReg, opnd_array(3)->reg(ra_,this,idx3));
    // ADD $p,$tmp
    emit_opcode(cbuf,0x03);
    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1), tmpReg);
  
#line 16075 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void cadd_cmpLTMask_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
  {

#line 2378 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int tmpReg = ECX_enc;

    // SUB $p,$q
    emit_opcode(cbuf,0x2B);
    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1), opnd_array(2)->reg(ra_,this,idx2));
    // SBB $tmp,$tmp
    emit_opcode(cbuf,0x1B);
    emit_rm(cbuf, 0x3, tmpReg, tmpReg);
    // AND $tmp,$y
    emit_opcode(cbuf,0x23);
    emit_rm(cbuf, 0x3, tmpReg, opnd_array(3)->reg(ra_,this,idx3));
    // ADD $p,$tmp
    emit_opcode(cbuf,0x03);
    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1), tmpReg);
  
#line 16104 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void cadd_cmpLTMask_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
  {

#line 2378 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int tmpReg = ECX_enc;

    // SUB $p,$q
    emit_opcode(cbuf,0x2B);
    emit_rm(cbuf, 0x3, opnd_array(2)->reg(ra_,this,idx2), opnd_array(3)->reg(ra_,this,idx3));
    // SBB $tmp,$tmp
    emit_opcode(cbuf,0x1B);
    emit_rm(cbuf, 0x3, tmpReg, tmpReg);
    // AND $tmp,$y
    emit_opcode(cbuf,0x23);
    emit_rm(cbuf, 0x3, tmpReg, opnd_array(1)->reg(ra_,this,idx1));
    // ADD $p,$tmp
    emit_opcode(cbuf,0x03);
    emit_rm(cbuf, 0x3, opnd_array(2)->reg(ra_,this,idx2), tmpReg);
  
#line 16133 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void cadd_cmpLTMask_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
  {

#line 2378 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int tmpReg = ECX_enc;

    // SUB $p,$q
    emit_opcode(cbuf,0x2B);
    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1), opnd_array(2)->reg(ra_,this,idx2));
    // SBB $tmp,$tmp
    emit_opcode(cbuf,0x1B);
    emit_rm(cbuf, 0x3, tmpReg, tmpReg);
    // AND $tmp,$y
    emit_opcode(cbuf,0x23);
    emit_rm(cbuf, 0x3, tmpReg, opnd_array(3)->reg(ra_,this,idx3));
    // ADD $p,$tmp
    emit_opcode(cbuf,0x03);
    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1), tmpReg);
  
#line 16162 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void addL_eRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 2099 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x03 /*primary()*/));
    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1), opnd_array(2)->reg(ra_,this,idx2));
  
#line 16178 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2104 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x13 /*secondary()*/));
    emit_rm(cbuf, 0x3, HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)), HIGH_FROM_LOW(opnd_array(2)->reg(ra_,this,idx2)));
  
#line 16187 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void addL_eReg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1694 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Emit primary opcode and set sign-extend bit
    // Check for 8-bit immediate, and set sign extend bit in opcode
    int con = (int)opnd_array(2)->constantL(); // Throw away top bits
    emit_opcode(cbuf, ((con >= -128) && (con <= 127)) ? ((0x81 /*primary()*/) | 0x02) : (0x81 /*primary()*/));
    // Emit r/m byte with secondary opcode, after primary opcode.
    emit_rm(cbuf, 0x3, (0x00 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1));
    if ((con >= -128) && (con <= 127)) emit_d8 (cbuf,con);
    else                               emit_d32(cbuf,con);
  
#line 16209 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1705 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Emit primary opcode and set sign-extend bit
    // Check for 8-bit immediate, and set sign extend bit in opcode
    int con = (int)(opnd_array(2)->constantL() >> 32); // Throw away bottom bits
    emit_opcode(cbuf, ((con >= -128) && (con <= 127)) ? ((0x81 /*primary()*/) | 0x02) : (0x81 /*primary()*/));
    // Emit r/m byte with tertiary opcode, after primary opcode.
    emit_rm(cbuf, 0x3, (0x02 /*tertiary()*/), HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)));
    if ((con >= -128) && (con <= 127)) emit_d8 (cbuf,con);
    else                               emit_d32(cbuf,con);
  
#line 16224 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void addL_eReg_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x03 /*primary()*/));
  
#line 16239 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(1)->reg(ra_,this,idx1);
    int base  = opnd_array(2)->base(ra_,this,idx2);
    int index = opnd_array(2)->index(ra_,this,idx2);
    int scale = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2);
    bool disp_is_oop = opnd_array(2)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 16253 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1586 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x13 /*secondary()*/));
  
#line 16261 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2222 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1));  // Hi register of pair, computed from lo
    int base  = opnd_array(2)->base(ra_,this,idx2);
    int index = opnd_array(2)->index(ra_,this,idx2);
    int scale = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2) + 4;      // Offset is 4 further in memory
    assert( !opnd_array(2)->disp_is_oop(), "Cannot add 4 to oop" );
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, false/*disp_is_oop*/);
  
#line 16275 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void addL_eReg_mem_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x03 /*primary()*/));
  
#line 16290 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(2)->reg(ra_,this,idx2);
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 16304 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1586 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x13 /*secondary()*/));
  
#line 16312 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2222 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = HIGH_FROM_LOW(opnd_array(2)->reg(ra_,this,idx2));  // Hi register of pair, computed from lo
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1) + 4;      // Offset is 4 further in memory
    assert( !opnd_array(1)->disp_is_oop(), "Cannot add 4 to oop" );
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, false/*disp_is_oop*/);
  
#line 16326 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void subL_eRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 2099 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x2B /*primary()*/));
    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1), opnd_array(2)->reg(ra_,this,idx2));
  
#line 16342 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2104 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x1B /*secondary()*/));
    emit_rm(cbuf, 0x3, HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)), HIGH_FROM_LOW(opnd_array(2)->reg(ra_,this,idx2)));
  
#line 16351 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void subL_eReg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1694 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Emit primary opcode and set sign-extend bit
    // Check for 8-bit immediate, and set sign extend bit in opcode
    int con = (int)opnd_array(2)->constantL(); // Throw away top bits
    emit_opcode(cbuf, ((con >= -128) && (con <= 127)) ? ((0x81 /*primary()*/) | 0x02) : (0x81 /*primary()*/));
    // Emit r/m byte with secondary opcode, after primary opcode.
    emit_rm(cbuf, 0x3, (0x05 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1));
    if ((con >= -128) && (con <= 127)) emit_d8 (cbuf,con);
    else                               emit_d32(cbuf,con);
  
#line 16373 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1705 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Emit primary opcode and set sign-extend bit
    // Check for 8-bit immediate, and set sign extend bit in opcode
    int con = (int)(opnd_array(2)->constantL() >> 32); // Throw away bottom bits
    emit_opcode(cbuf, ((con >= -128) && (con <= 127)) ? ((0x81 /*primary()*/) | 0x02) : (0x81 /*primary()*/));
    // Emit r/m byte with tertiary opcode, after primary opcode.
    emit_rm(cbuf, 0x3, (0x03 /*tertiary()*/), HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)));
    if ((con >= -128) && (con <= 127)) emit_d8 (cbuf,con);
    else                               emit_d32(cbuf,con);
  
#line 16388 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void subL_eReg_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x2B /*primary()*/));
  
#line 16403 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(1)->reg(ra_,this,idx1);
    int base  = opnd_array(2)->base(ra_,this,idx2);
    int index = opnd_array(2)->index(ra_,this,idx2);
    int scale = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2);
    bool disp_is_oop = opnd_array(2)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 16417 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1586 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x1B /*secondary()*/));
  
#line 16425 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2222 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1));  // Hi register of pair, computed from lo
    int base  = opnd_array(2)->base(ra_,this,idx2);
    int index = opnd_array(2)->index(ra_,this,idx2);
    int scale = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2) + 4;      // Offset is 4 further in memory
    assert( !opnd_array(2)->disp_is_oop(), "Cannot add 4 to oop" );
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, false/*disp_is_oop*/);
  
#line 16439 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void negL_eRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 3162 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf,0xF7);    // NEG hi
    emit_rm    (cbuf,0x3, 0x3, HIGH_FROM_LOW(opnd_array(2)->reg(ra_,this,idx2)));
    emit_opcode(cbuf,0xF7);    // NEG lo
    emit_rm    (cbuf,0x3, 0x3,               opnd_array(2)->reg(ra_,this,idx2) );
    emit_opcode(cbuf,0x83);    // SBB hi,0
    emit_rm    (cbuf,0x3, 0x3, HIGH_FROM_LOW(opnd_array(2)->reg(ra_,this,idx2)));
    emit_d8    (cbuf,0 );
  
#line 16460 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void andL_eRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 2099 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x23 /*primary()*/));
    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1), opnd_array(2)->reg(ra_,this,idx2));
  
#line 16476 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2104 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x23 /*secondary()*/));
    emit_rm(cbuf, 0x3, HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)), HIGH_FROM_LOW(opnd_array(2)->reg(ra_,this,idx2)));
  
#line 16485 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void andL_eReg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1694 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Emit primary opcode and set sign-extend bit
    // Check for 8-bit immediate, and set sign extend bit in opcode
    int con = (int)opnd_array(2)->constantL(); // Throw away top bits
    emit_opcode(cbuf, ((con >= -128) && (con <= 127)) ? ((0x81 /*primary()*/) | 0x02) : (0x81 /*primary()*/));
    // Emit r/m byte with secondary opcode, after primary opcode.
    emit_rm(cbuf, 0x3, (0x04 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1));
    if ((con >= -128) && (con <= 127)) emit_d8 (cbuf,con);
    else                               emit_d32(cbuf,con);
  
#line 16507 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1705 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Emit primary opcode and set sign-extend bit
    // Check for 8-bit immediate, and set sign extend bit in opcode
    int con = (int)(opnd_array(2)->constantL() >> 32); // Throw away bottom bits
    emit_opcode(cbuf, ((con >= -128) && (con <= 127)) ? ((0x81 /*primary()*/) | 0x02) : (0x81 /*primary()*/));
    // Emit r/m byte with tertiary opcode, after primary opcode.
    emit_rm(cbuf, 0x3, (0x04 /*tertiary()*/), HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)));
    if ((con >= -128) && (con <= 127)) emit_d8 (cbuf,con);
    else                               emit_d32(cbuf,con);
  
#line 16522 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void andL_eReg_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x23 /*primary()*/));
  
#line 16537 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(1)->reg(ra_,this,idx1);
    int base  = opnd_array(2)->base(ra_,this,idx2);
    int index = opnd_array(2)->index(ra_,this,idx2);
    int scale = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2);
    bool disp_is_oop = opnd_array(2)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 16551 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1586 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x23 /*secondary()*/));
  
#line 16559 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2222 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1));  // Hi register of pair, computed from lo
    int base  = opnd_array(2)->base(ra_,this,idx2);
    int index = opnd_array(2)->index(ra_,this,idx2);
    int scale = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2) + 4;      // Offset is 4 further in memory
    assert( !opnd_array(2)->disp_is_oop(), "Cannot add 4 to oop" );
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, false/*disp_is_oop*/);
  
#line 16573 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void andL_eReg_mem_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x23 /*primary()*/));
  
#line 16588 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(2)->reg(ra_,this,idx2);
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 16602 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1586 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x23 /*secondary()*/));
  
#line 16610 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2222 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = HIGH_FROM_LOW(opnd_array(2)->reg(ra_,this,idx2));  // Hi register of pair, computed from lo
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1) + 4;      // Offset is 4 further in memory
    assert( !opnd_array(1)->disp_is_oop(), "Cannot add 4 to oop" );
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, false/*disp_is_oop*/);
  
#line 16624 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void orl_eRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 2099 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x0B /*primary()*/));
    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1), opnd_array(2)->reg(ra_,this,idx2));
  
#line 16640 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2104 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x0B /*secondary()*/));
    emit_rm(cbuf, 0x3, HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)), HIGH_FROM_LOW(opnd_array(2)->reg(ra_,this,idx2)));
  
#line 16649 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void orl_eReg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1694 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Emit primary opcode and set sign-extend bit
    // Check for 8-bit immediate, and set sign extend bit in opcode
    int con = (int)opnd_array(2)->constantL(); // Throw away top bits
    emit_opcode(cbuf, ((con >= -128) && (con <= 127)) ? ((0x81 /*primary()*/) | 0x02) : (0x81 /*primary()*/));
    // Emit r/m byte with secondary opcode, after primary opcode.
    emit_rm(cbuf, 0x3, (0x01 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1));
    if ((con >= -128) && (con <= 127)) emit_d8 (cbuf,con);
    else                               emit_d32(cbuf,con);
  
#line 16671 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1705 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Emit primary opcode and set sign-extend bit
    // Check for 8-bit immediate, and set sign extend bit in opcode
    int con = (int)(opnd_array(2)->constantL() >> 32); // Throw away bottom bits
    emit_opcode(cbuf, ((con >= -128) && (con <= 127)) ? ((0x81 /*primary()*/) | 0x02) : (0x81 /*primary()*/));
    // Emit r/m byte with tertiary opcode, after primary opcode.
    emit_rm(cbuf, 0x3, (0x01 /*tertiary()*/), HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)));
    if ((con >= -128) && (con <= 127)) emit_d8 (cbuf,con);
    else                               emit_d32(cbuf,con);
  
#line 16686 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void orl_eReg_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0B /*primary()*/));
  
#line 16701 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(1)->reg(ra_,this,idx1);
    int base  = opnd_array(2)->base(ra_,this,idx2);
    int index = opnd_array(2)->index(ra_,this,idx2);
    int scale = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2);
    bool disp_is_oop = opnd_array(2)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 16715 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1586 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0B /*secondary()*/));
  
#line 16723 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2222 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1));  // Hi register of pair, computed from lo
    int base  = opnd_array(2)->base(ra_,this,idx2);
    int index = opnd_array(2)->index(ra_,this,idx2);
    int scale = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2) + 4;      // Offset is 4 further in memory
    assert( !opnd_array(2)->disp_is_oop(), "Cannot add 4 to oop" );
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, false/*disp_is_oop*/);
  
#line 16737 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void orl_eReg_mem_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0B /*primary()*/));
  
#line 16752 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(2)->reg(ra_,this,idx2);
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 16766 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1586 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0B /*secondary()*/));
  
#line 16774 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2222 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = HIGH_FROM_LOW(opnd_array(2)->reg(ra_,this,idx2));  // Hi register of pair, computed from lo
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1) + 4;      // Offset is 4 further in memory
    assert( !opnd_array(1)->disp_is_oop(), "Cannot add 4 to oop" );
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, false/*disp_is_oop*/);
  
#line 16788 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void xorl_eRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 2099 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x33 /*primary()*/));
    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1), opnd_array(2)->reg(ra_,this,idx2));
  
#line 16804 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2104 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x33 /*secondary()*/));
    emit_rm(cbuf, 0x3, HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)), HIGH_FROM_LOW(opnd_array(2)->reg(ra_,this,idx2)));
  
#line 16813 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void xorl_eReg_im1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {
    MacroAssembler _masm(&cbuf);

#line 9772 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

     __ notl(opnd_array(1)->as_Register(ra_,this,idx1));
     __ notl(HIGH_FROM_LOW(opnd_array(1)->as_Register(ra_,this,idx1)));
  
#line 16830 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void xorl_eReg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1694 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Emit primary opcode and set sign-extend bit
    // Check for 8-bit immediate, and set sign extend bit in opcode
    int con = (int)opnd_array(2)->constantL(); // Throw away top bits
    emit_opcode(cbuf, ((con >= -128) && (con <= 127)) ? ((0x81 /*primary()*/) | 0x02) : (0x81 /*primary()*/));
    // Emit r/m byte with secondary opcode, after primary opcode.
    emit_rm(cbuf, 0x3, (0x06 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1));
    if ((con >= -128) && (con <= 127)) emit_d8 (cbuf,con);
    else                               emit_d32(cbuf,con);
  
#line 16852 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1705 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Emit primary opcode and set sign-extend bit
    // Check for 8-bit immediate, and set sign extend bit in opcode
    int con = (int)(opnd_array(2)->constantL() >> 32); // Throw away bottom bits
    emit_opcode(cbuf, ((con >= -128) && (con <= 127)) ? ((0x81 /*primary()*/) | 0x02) : (0x81 /*primary()*/));
    // Emit r/m byte with tertiary opcode, after primary opcode.
    emit_rm(cbuf, 0x3, (0x06 /*tertiary()*/), HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)));
    if ((con >= -128) && (con <= 127)) emit_d8 (cbuf,con);
    else                               emit_d32(cbuf,con);
  
#line 16867 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void xorl_eReg_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x33 /*primary()*/));
  
#line 16882 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(1)->reg(ra_,this,idx1);
    int base  = opnd_array(2)->base(ra_,this,idx2);
    int index = opnd_array(2)->index(ra_,this,idx2);
    int scale = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2);
    bool disp_is_oop = opnd_array(2)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 16896 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1586 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x33 /*secondary()*/));
  
#line 16904 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2222 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1));  // Hi register of pair, computed from lo
    int base  = opnd_array(2)->base(ra_,this,idx2);
    int index = opnd_array(2)->index(ra_,this,idx2);
    int scale = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2) + 4;      // Offset is 4 further in memory
    assert( !opnd_array(2)->disp_is_oop(), "Cannot add 4 to oop" );
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, false/*disp_is_oop*/);
  
#line 16918 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void xorl_eReg_mem_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x33 /*primary()*/));
  
#line 16933 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(2)->reg(ra_,this,idx2);
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 16947 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1586 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x33 /*secondary()*/));
  
#line 16955 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2222 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = HIGH_FROM_LOW(opnd_array(2)->reg(ra_,this,idx2));  // Hi register of pair, computed from lo
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1) + 4;      // Offset is 4 further in memory
    assert( !opnd_array(1)->disp_is_oop(), "Cannot add 4 to oop" );
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, false/*disp_is_oop*/);
  
#line 16969 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void shlL_eReg_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {
    MacroAssembler _masm(&cbuf);

#line 9810 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ addl(opnd_array(1)->as_Register(ra_,this,idx1),opnd_array(1)->as_Register(ra_,this,idx1));
    __ adcl(HIGH_FROM_LOW(opnd_array(1)->as_Register(ra_,this,idx1)),HIGH_FROM_LOW(opnd_array(1)->as_Register(ra_,this,idx1)));
  
#line 16986 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void shlL_eReg_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {
    MacroAssembler _masm(&cbuf);

#line 9827 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ addl(opnd_array(1)->as_Register(ra_,this,idx1),opnd_array(1)->as_Register(ra_,this,idx1));
    __ adcl(HIGH_FROM_LOW(opnd_array(1)->as_Register(ra_,this,idx1)),HIGH_FROM_LOW(opnd_array(1)->as_Register(ra_,this,idx1)));
    __ addl(opnd_array(1)->as_Register(ra_,this,idx1),opnd_array(1)->as_Register(ra_,this,idx1));
    __ adcl(HIGH_FROM_LOW(opnd_array(1)->as_Register(ra_,this,idx1)),HIGH_FROM_LOW(opnd_array(1)->as_Register(ra_,this,idx1)));
  
#line 17005 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void shlL_eReg_3Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {
    MacroAssembler _masm(&cbuf);

#line 9848 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ addl(opnd_array(1)->as_Register(ra_,this,idx1),opnd_array(1)->as_Register(ra_,this,idx1));
    __ adcl(HIGH_FROM_LOW(opnd_array(1)->as_Register(ra_,this,idx1)),HIGH_FROM_LOW(opnd_array(1)->as_Register(ra_,this,idx1)));
    __ addl(opnd_array(1)->as_Register(ra_,this,idx1),opnd_array(1)->as_Register(ra_,this,idx1));
    __ adcl(HIGH_FROM_LOW(opnd_array(1)->as_Register(ra_,this,idx1)),HIGH_FROM_LOW(opnd_array(1)->as_Register(ra_,this,idx1)));
    __ addl(opnd_array(1)->as_Register(ra_,this,idx1),opnd_array(1)->as_Register(ra_,this,idx1));
    __ adcl(HIGH_FROM_LOW(opnd_array(1)->as_Register(ra_,this,idx1)),HIGH_FROM_LOW(opnd_array(1)->as_Register(ra_,this,idx1)));
  
#line 17026 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void shlL_eReg_1_31Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 2232 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int r1, r2;
    if( (0xA4 /*tertiary()*/) == 0xA4 ) { r1 = opnd_array(1)->reg(ra_,this,idx1);  r2 = HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)); }
    else                    { r2 = opnd_array(1)->reg(ra_,this,idx1);  r1 = HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)); }
    emit_opcode(cbuf,0x0F);
    emit_opcode(cbuf,(0xA4 /*tertiary()*/));
    emit_rm(cbuf, 0x3, r1, r2);
    emit_d8(cbuf,opnd_array(2)->constant());
    emit_d8(cbuf,(0xC1 /*primary()*/));
    emit_rm(cbuf, 0x3, (0x4 /*secondary()*/), r1);
    emit_d8(cbuf,opnd_array(2)->constant());
  
#line 17050 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void shlL_eReg_32_63Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 2258 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int r1, r2;
    if( (0x4 /*secondary()*/) == 0x5 ) { r1 = opnd_array(1)->reg(ra_,this,idx1);  r2 = HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)); }
    else                    { r2 = opnd_array(1)->reg(ra_,this,idx1);  r1 = HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)); }

    emit_opcode( cbuf, 0x8B ); // Move r1,r2
    emit_rm(cbuf, 0x3, r1, r2);
    if( opnd_array(2)->constant() > 32 ) { // Shift, if not by zero
      emit_opcode(cbuf,(0xC1 /*primary()*/));
      emit_rm(cbuf, 0x3, (0x4 /*secondary()*/), r1);
      emit_d8(cbuf,opnd_array(2)->constant()-32);
    }
    emit_opcode(cbuf,0x33);  // XOR r2,r2
    emit_rm(cbuf, 0x3, r2, r2);
  
#line 17077 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void salL_eReg_CLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 2419 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // TEST shift,32
    emit_opcode(cbuf,0xF7);
    emit_rm(cbuf, 0x3, 0, ECX_enc);
    emit_d32(cbuf,0x20);
    // JEQ,s small
    emit_opcode(cbuf, 0x74);
    emit_d8(cbuf, 0x04);
    // MOV    $dst.hi,$dst.lo
    emit_opcode( cbuf, 0x8B );
    emit_rm(cbuf, 0x3, HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)), opnd_array(1)->reg(ra_,this,idx1) );
    // CLR    $dst.lo
    emit_opcode(cbuf, 0x33);
    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1), opnd_array(1)->reg(ra_,this,idx1));
// small:
    // SHLD   $dst.hi,$dst.lo,$shift
    emit_opcode(cbuf,0x0F);
    emit_opcode(cbuf,0xA5);
    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1), HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)));
    // SHL    $dst.lo,$shift"
    emit_opcode(cbuf,0xD3);
    emit_rm(cbuf, 0x3, 0x4, opnd_array(1)->reg(ra_,this,idx1) );
  
#line 17112 "../generated/adfiles/ad_x86_32.cpp"
  }
}
uint  salL_eReg_CLNode::size(PhaseRegAlloc *ra_) const {
 assert(VerifyOops || MachNode::size(ra_) <= 17, "bad fixed size");
 return (VerifyOops ? MachNode::size(ra_) : 17);
}
void shrL_eReg_1_31Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 2232 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int r1, r2;
    if( (0xAC /*tertiary()*/) == 0xA4 ) { r1 = opnd_array(1)->reg(ra_,this,idx1);  r2 = HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)); }
    else                    { r2 = opnd_array(1)->reg(ra_,this,idx1);  r1 = HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)); }
    emit_opcode(cbuf,0x0F);
    emit_opcode(cbuf,(0xAC /*tertiary()*/));
    emit_rm(cbuf, 0x3, r1, r2);
    emit_d8(cbuf,opnd_array(2)->constant());
    emit_d8(cbuf,(0xC1 /*primary()*/));
    emit_rm(cbuf, 0x3, (0x5 /*secondary()*/), r1);
    emit_d8(cbuf,opnd_array(2)->constant());
  
#line 17140 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void shrL_eReg_32_63Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 2258 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int r1, r2;
    if( (0x5 /*secondary()*/) == 0x5 ) { r1 = opnd_array(1)->reg(ra_,this,idx1);  r2 = HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)); }
    else                    { r2 = opnd_array(1)->reg(ra_,this,idx1);  r1 = HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)); }

    emit_opcode( cbuf, 0x8B ); // Move r1,r2
    emit_rm(cbuf, 0x3, r1, r2);
    if( opnd_array(2)->constant() > 32 ) { // Shift, if not by zero
      emit_opcode(cbuf,(0xC1 /*primary()*/));
      emit_rm(cbuf, 0x3, (0x5 /*secondary()*/), r1);
      emit_d8(cbuf,opnd_array(2)->constant()-32);
    }
    emit_opcode(cbuf,0x33);  // XOR r2,r2
    emit_rm(cbuf, 0x3, r2, r2);
  
#line 17167 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void shrL_eReg_CLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 2443 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // TEST shift,32
    emit_opcode(cbuf,0xF7);
    emit_rm(cbuf, 0x3, 0, ECX_enc);
    emit_d32(cbuf,0x20);
    // JEQ,s small
    emit_opcode(cbuf, 0x74);
    emit_d8(cbuf, 0x04);
    // MOV    $dst.lo,$dst.hi
    emit_opcode( cbuf, 0x8B );
    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1), HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)) );
    // CLR    $dst.hi
    emit_opcode(cbuf, 0x33);
    emit_rm(cbuf, 0x3, HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)), HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)));
// small:
    // SHRD   $dst.lo,$dst.hi,$shift
    emit_opcode(cbuf,0x0F);
    emit_opcode(cbuf,0xAD);
    emit_rm(cbuf, 0x3, HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)), opnd_array(1)->reg(ra_,this,idx1));
    // SHR    $dst.hi,$shift"
    emit_opcode(cbuf,0xD3);
    emit_rm(cbuf, 0x3, 0x5, HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)) );
  
#line 17202 "../generated/adfiles/ad_x86_32.cpp"
  }
}
uint  shrL_eReg_CLNode::size(PhaseRegAlloc *ra_) const {
 assert(VerifyOops || MachNode::size(ra_) <= 17, "bad fixed size");
 return (VerifyOops ? MachNode::size(ra_) : 17);
}
void sarL_eReg_1_31Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 2232 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int r1, r2;
    if( (0xAC /*tertiary()*/) == 0xA4 ) { r1 = opnd_array(1)->reg(ra_,this,idx1);  r2 = HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)); }
    else                    { r2 = opnd_array(1)->reg(ra_,this,idx1);  r1 = HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)); }
    emit_opcode(cbuf,0x0F);
    emit_opcode(cbuf,(0xAC /*tertiary()*/));
    emit_rm(cbuf, 0x3, r1, r2);
    emit_d8(cbuf,opnd_array(2)->constant());
    emit_d8(cbuf,(0xC1 /*primary()*/));
    emit_rm(cbuf, 0x3, (0x7 /*secondary()*/), r1);
    emit_d8(cbuf,opnd_array(2)->constant());
  
#line 17230 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void sarL_eReg_32_63Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 2245 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0x8B ); // Move
    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1), HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)));
    if( opnd_array(2)->constant() > 32 ) { // Shift, if not by zero
      emit_d8(cbuf,(0xC1 /*primary()*/));
      emit_rm(cbuf, 0x3, (0x7 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1));
      emit_d8(cbuf,opnd_array(2)->constant()-32);
    }
    emit_d8(cbuf,(0xC1 /*primary()*/));
    emit_rm(cbuf, 0x3, (0x7 /*secondary()*/), HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)));
    emit_d8(cbuf,31);
  
#line 17254 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void sarL_eReg_CLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 2467 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // TEST shift,32
    emit_opcode(cbuf,0xF7);
    emit_rm(cbuf, 0x3, 0, ECX_enc);
    emit_d32(cbuf,0x20);
    // JEQ,s small
    emit_opcode(cbuf, 0x74);
    emit_d8(cbuf, 0x05);
    // MOV    $dst.lo,$dst.hi
    emit_opcode( cbuf, 0x8B );
    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1), HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)) );
    // SAR    $dst.hi,31
    emit_opcode(cbuf, 0xC1);
    emit_rm(cbuf, 0x3, 7, HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)) );
    emit_d8(cbuf, 0x1F );
// small:
    // SHRD   $dst.lo,$dst.hi,$shift
    emit_opcode(cbuf,0x0F);
    emit_opcode(cbuf,0xAD);
    emit_rm(cbuf, 0x3, HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)), opnd_array(1)->reg(ra_,this,idx1));
    // SAR    $dst.hi,$shift"
    emit_opcode(cbuf,0xD3);
    emit_rm(cbuf, 0x3, 0x7, HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)) );
  
#line 17290 "../generated/adfiles/ad_x86_32.cpp"
  }
}
uint  sarL_eReg_CLNode::size(PhaseRegAlloc *ra_) const {
 assert(VerifyOops || MachNode::size(ra_) <= 18, "bad fixed size");
 return (VerifyOops ? MachNode::size(ra_) : 18);
}
void cmpD_cc_P6Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 2512 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );
    emit_d8( cbuf, 0xC0-1+opnd_array(1)->reg(ra_,this,idx1) );   // FLD ST(i-1)
  
#line 17310 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xDF /*primary()*/));
  
#line 17318 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1746 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x05 /*secondary()*/), opnd_array(2)->reg(ra_,this,idx2) );
  
#line 17326 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2872 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Fixup the integer flags in case comparison involved a NaN
    //
    // JNP exit (no unordered comparison, P-flag is set by NaN)
    emit_opcode( cbuf, 0x7B );
    emit_d8    ( cbuf, 0x03 );
    // MOV AH,1 - treat as LT case (set carry flag)
    emit_opcode( cbuf, 0xB4 );
    emit_d8    ( cbuf, 0x01 );
    // SAHF
    emit_opcode( cbuf, 0x9E);
    // NOP     // target for branch to avoid branch to branch
    emit_opcode( cbuf, 0x90);
  
#line 17345 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void cmpD_cc_P6CFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 2512 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );
    emit_d8( cbuf, 0xC0-1+opnd_array(1)->reg(ra_,this,idx1) );   // FLD ST(i-1)
  
#line 17361 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xDF /*primary()*/));
  
#line 17369 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1746 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x05 /*secondary()*/), opnd_array(2)->reg(ra_,this,idx2) );
  
#line 17377 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void cmpD_ccNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 2512 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );
    emit_d8( cbuf, 0xC0-1+opnd_array(1)->reg(ra_,this,idx1) );   // FLD ST(i-1)
  
#line 17393 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD8 /*primary()*/));
  
#line 17401 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1746 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x3 /*secondary()*/), opnd_array(2)->reg(ra_,this,idx2) );
  
#line 17409 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2849 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // fnstsw_ax
    emit_opcode( cbuf, 0xDF);
    emit_opcode( cbuf, 0xE0);
    // test ax,0x0400
    emit_opcode( cbuf, 0x66 );   // operand-size prefix for 16-bit immediate
    emit_opcode( cbuf, 0xA9 );
    emit_d16   ( cbuf, 0x0400 );
    // // // This sequence works, but stalls for 12-16 cycles on PPro
    // // test rax,0x0400
    // emit_opcode( cbuf, 0xA9 );
    // emit_d32   ( cbuf, 0x00000400 );
    //
    // jz exit (no unordered comparison)
    emit_opcode( cbuf, 0x74 );
    emit_d8    ( cbuf, 0x02 );
    // mov ah,1 - treat as LT case (set carry flag)
    emit_opcode( cbuf, 0xB4 );
    emit_d8    ( cbuf, 0x01 );
    // sahf
    emit_opcode( cbuf, 0x9E);
  
#line 17436 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void cmpD_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 2512 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );
    emit_d8( cbuf, 0xC0-1+opnd_array(1)->reg(ra_,this,idx1) );   // FLD ST(i-1)
  
#line 17452 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1586 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9 /*secondary()*/));
  
#line 17460 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xE4 /*primary()*/));
  
#line 17468 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2501 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xDD );
    emit_d8( cbuf, 0xD8 );
  
#line 17477 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2902 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // fnstsw_ax();
    emit_opcode( cbuf, 0xDF);
    emit_opcode( cbuf, 0xE0);
    // sahf
    emit_opcode( cbuf, 0x9E);
    // movl(dst, nan_result);
    emit_opcode( cbuf, 0xB8 + opnd_array(0)->reg(ra_,this));
    emit_d32( cbuf, -1 );
    // jcc(Assembler::parity, exit);
    emit_opcode( cbuf, 0x7A );
    emit_d8    ( cbuf, 0x13 );
    // movl(dst, less_result);
    emit_opcode( cbuf, 0xB8 + opnd_array(0)->reg(ra_,this));
    emit_d32( cbuf, -1 );
    // jcc(Assembler::below, exit);
    emit_opcode( cbuf, 0x72 );
    emit_d8    ( cbuf, 0x0C );
    // movl(dst, equal_result);
    emit_opcode( cbuf, 0xB8 + opnd_array(0)->reg(ra_,this));
    emit_d32( cbuf, 0 );
    // jcc(Assembler::equal, exit);
    emit_opcode( cbuf, 0x74 );
    emit_d8    ( cbuf, 0x05 );
    // movl(dst, greater_result);
    emit_opcode( cbuf, 0xB8 + opnd_array(0)->reg(ra_,this));
    emit_d32( cbuf, 1 );
  
#line 17510 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void cmpD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 2512 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );
    emit_d8( cbuf, 0xC0-1+opnd_array(1)->reg(ra_,this,idx1) );   // FLD ST(i-1)
  
#line 17526 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD8 /*primary()*/));
  
#line 17534 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1746 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x3 /*secondary()*/), opnd_array(2)->reg(ra_,this,idx2) );
  
#line 17542 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2902 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // fnstsw_ax();
    emit_opcode( cbuf, 0xDF);
    emit_opcode( cbuf, 0xE0);
    // sahf
    emit_opcode( cbuf, 0x9E);
    // movl(dst, nan_result);
    emit_opcode( cbuf, 0xB8 + opnd_array(0)->reg(ra_,this));
    emit_d32( cbuf, -1 );
    // jcc(Assembler::parity, exit);
    emit_opcode( cbuf, 0x7A );
    emit_d8    ( cbuf, 0x13 );
    // movl(dst, less_result);
    emit_opcode( cbuf, 0xB8 + opnd_array(0)->reg(ra_,this));
    emit_d32( cbuf, -1 );
    // jcc(Assembler::below, exit);
    emit_opcode( cbuf, 0x72 );
    emit_d8    ( cbuf, 0x0C );
    // movl(dst, equal_result);
    emit_opcode( cbuf, 0xB8 + opnd_array(0)->reg(ra_,this));
    emit_d32( cbuf, 0 );
    // jcc(Assembler::equal, exit);
    emit_opcode( cbuf, 0x74 );
    emit_d8    ( cbuf, 0x05 );
    // movl(dst, greater_result);
    emit_opcode( cbuf, 0xB8 + opnd_array(0)->reg(ra_,this));
    emit_d32( cbuf, 1 );
  
#line 17575 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void cmpXD_ccNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x66 /*primary()*/));
  
#line 17590 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1586 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0F /*secondary()*/));
  
#line 17598 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x2F /*tertiary()*/));
  
#line 17606 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2095 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1), opnd_array(2)->reg(ra_,this,idx2));
  
#line 17614 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2872 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Fixup the integer flags in case comparison involved a NaN
    //
    // JNP exit (no unordered comparison, P-flag is set by NaN)
    emit_opcode( cbuf, 0x7B );
    emit_d8    ( cbuf, 0x03 );
    // MOV AH,1 - treat as LT case (set carry flag)
    emit_opcode( cbuf, 0xB4 );
    emit_d8    ( cbuf, 0x01 );
    // SAHF
    emit_opcode( cbuf, 0x9E);
    // NOP     // target for branch to avoid branch to branch
    emit_opcode( cbuf, 0x90);
  
#line 17633 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void cmpXD_ccCFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x66 /*primary()*/));
  
#line 17648 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1586 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0F /*secondary()*/));
  
#line 17656 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x2F /*tertiary()*/));
  
#line 17664 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2095 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1), opnd_array(2)->reg(ra_,this,idx2));
  
#line 17672 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void cmpXD_ccmemNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x66 /*primary()*/));
  
#line 17687 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1586 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0F /*secondary()*/));
  
#line 17695 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x2F /*tertiary()*/));
  
#line 17703 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(1)->reg(ra_,this,idx1);
    int base  = opnd_array(2)->base(ra_,this,idx2);
    int index = opnd_array(2)->index(ra_,this,idx2);
    int scale = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2);
    bool disp_is_oop = opnd_array(2)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 17717 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2872 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Fixup the integer flags in case comparison involved a NaN
    //
    // JNP exit (no unordered comparison, P-flag is set by NaN)
    emit_opcode( cbuf, 0x7B );
    emit_d8    ( cbuf, 0x03 );
    // MOV AH,1 - treat as LT case (set carry flag)
    emit_opcode( cbuf, 0xB4 );
    emit_d8    ( cbuf, 0x01 );
    // SAHF
    emit_opcode( cbuf, 0x9E);
    // NOP     // target for branch to avoid branch to branch
    emit_opcode( cbuf, 0x90);
  
#line 17736 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void cmpXD_ccmemCFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x66 /*primary()*/));
  
#line 17751 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1586 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0F /*secondary()*/));
  
#line 17759 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x2F /*tertiary()*/));
  
#line 17767 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(1)->reg(ra_,this,idx1);
    int base  = opnd_array(2)->base(ra_,this,idx2);
    int index = opnd_array(2)->index(ra_,this,idx2);
    int scale = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2);
    bool disp_is_oop = opnd_array(2)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 17781 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void cmpXD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1941 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, 0x33);
    emit_rm(cbuf, 0x3, opnd_array(0)->reg(ra_,this), opnd_array(0)->reg(ra_,this));
  
#line 17797 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x66 /*primary()*/));
  
#line 17805 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1586 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0F /*secondary()*/));
  
#line 17813 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x2F /*tertiary()*/));
  
#line 17821 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2095 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1), opnd_array(2)->reg(ra_,this,idx2));
  
#line 17829 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2935 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    MacroAssembler _masm(&cbuf);
    Label nan, inc, done;

    __ jccb(Assembler::parity, nan);
    __ jccb(Assembler::equal,  done);
    __ jccb(Assembler::above,  inc);
    __ bind(nan);
    __ decrement(as_Register(opnd_array(0)->reg(ra_,this))); // NO L qqq
    __ jmpb(done);
    __ bind(inc);
    __ increment(as_Register(opnd_array(0)->reg(ra_,this))); // NO L qqq
    __ bind(done);
  
#line 17848 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void cmpXD_regmemNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x66 /*primary()*/));
  
#line 17863 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1586 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0F /*secondary()*/));
  
#line 17871 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x2F /*tertiary()*/));
  
#line 17879 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(1)->reg(ra_,this,idx1);
    int base  = opnd_array(2)->base(ra_,this,idx2);
    int index = opnd_array(2)->index(ra_,this,idx2);
    int scale = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2);
    bool disp_is_oop = opnd_array(2)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 17893 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1978 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Load immediate does not have a zero or sign extended version
    // for 8-bit immediates
    emit_opcode(cbuf, 0xB8 + opnd_array(0)->reg(ra_,this));
    emit_d32(cbuf, (0x0));
  
#line 17904 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2935 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    MacroAssembler _masm(&cbuf);
    Label nan, inc, done;

    __ jccb(Assembler::parity, nan);
    __ jccb(Assembler::equal,  done);
    __ jccb(Assembler::above,  inc);
    __ bind(nan);
    __ decrement(as_Register(opnd_array(0)->reg(ra_,this))); // NO L qqq
    __ jmpb(done);
    __ bind(inc);
    __ increment(as_Register(opnd_array(0)->reg(ra_,this))); // NO L qqq
    __ bind(done);
  
#line 17923 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void subD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 2512 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );
    emit_d8( cbuf, 0xC0-1+opnd_array(2)->reg(ra_,this,idx2) );   // FLD ST(i-1)
  
#line 17939 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xDE /*primary()*/));
  
#line 17947 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1746 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x5 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1) );
  
#line 17955 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void subD_reg_roundNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 2512 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );
    emit_d8( cbuf, 0xC0-1+opnd_array(2)->reg(ra_,this,idx2) );   // FLD ST(i-1)
  
#line 17971 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD8 /*primary()*/));
  
#line 17979 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1746 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x5 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1) );
  
#line 17987 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2568 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    store_to_stackslot( cbuf, 0xDD, 0x03, opnd_array(0)->disp(ra_,this,0) );
  
#line 17995 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void subD_reg_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xDD /*tertiary()*/));
  
#line 18010 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2302 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(2)->base(ra_,this,idx2);
    int index    = opnd_array(2)->index(ra_,this,idx2);
    int scale    = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2);
    bool disp_is_oop = opnd_array(2)->disp_is_oop(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_is_oop);
  
#line 18024 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xDE /*primary()*/));
  
#line 18032 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1746 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x5 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1) );
  
#line 18040 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void absD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 1586 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9 /*secondary()*/));
  
#line 18054 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xE1 /*primary()*/));
  
#line 18062 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void absXD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 4090 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    address signmask_address=(address)double_signmask_pool;
    // andpd:\tANDPD  $dst,[signconst]
    emit_opcode(cbuf, 0x66);
    emit_opcode(cbuf, 0x0F);
    emit_opcode(cbuf, 0x54);
    emit_rm(cbuf, 0x0, opnd_array(1)->reg(ra_,this,idx1), 0x5);
    emit_d32(cbuf, (int)signmask_address);
  
#line 18082 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void negD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 1586 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9 /*secondary()*/));
  
#line 18096 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xE0 /*primary()*/));
  
#line 18104 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void negXD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {
    MacroAssembler _masm(&cbuf);

#line 10237 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

     __ xorpd(opnd_array(1)->as_XMMRegister(ra_,this,idx1),
              ExternalAddress((address)double_signflip_pool));
  
#line 18120 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void addD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 2512 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );
    emit_d8( cbuf, 0xC0-1+opnd_array(2)->reg(ra_,this,idx2) );   // FLD ST(i-1)
  
#line 18136 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xDE /*primary()*/));
  
#line 18144 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1746 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x0 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1) );
  
#line 18152 "../generated/adfiles/ad_x86_32.cpp"
  }
}
uint  addD_regNode::size(PhaseRegAlloc *ra_) const {
 assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
 return (VerifyOops ? MachNode::size(ra_) : 4);
}
void addD_reg_roundNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 2512 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );
    emit_d8( cbuf, 0xC0-1+opnd_array(2)->reg(ra_,this,idx2) );   // FLD ST(i-1)
  
#line 18172 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD8 /*primary()*/));
  
#line 18180 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1746 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x0 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1) );
  
#line 18188 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2568 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    store_to_stackslot( cbuf, 0xDD, 0x03, opnd_array(0)->disp(ra_,this,0) );
  
#line 18196 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void addD_reg_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xDD /*tertiary()*/));
  
#line 18211 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2302 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(2)->base(ra_,this,idx2);
    int index    = opnd_array(2)->index(ra_,this,idx2);
    int scale    = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2);
    bool disp_is_oop = opnd_array(2)->disp_is_oop(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_is_oop);
  
#line 18225 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xDE /*primary()*/));
  
#line 18233 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1746 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x0 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1) );
  
#line 18241 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void addD_reg_mem_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xDD /*tertiary()*/));
  
#line 18256 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2302 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_is_oop);
  
#line 18270 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xDE /*primary()*/));
  
#line 18278 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1746 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x0 /*secondary()*/), opnd_array(2)->reg(ra_,this,idx2) );
  
#line 18286 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void addD_mem_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xDD));
  
#line 18301 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2302 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_is_oop);
  
#line 18315 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD8));
  
#line 18323 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1746 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x0 /*secondary()*/), opnd_array(2)->reg(ra_,this,idx2) );
  
#line 18331 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2208 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    cbuf.set_insts_mark();            // Mark start of opcode for reloc info in mem operand
  
#line 18339 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xDD));
  
#line 18347 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2302 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x03);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_is_oop);
  
#line 18361 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void addD_mem_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xDD));
  
#line 18376 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2302 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_is_oop);
  
#line 18390 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD8));
  
#line 18398 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1746 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x0 /*secondary()*/), opnd_array(2)->reg(ra_,this,idx2) );
  
#line 18406 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2208 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    cbuf.set_insts_mark();            // Mark start of opcode for reloc info in mem operand
  
#line 18414 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xDD));
  
#line 18422 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2302 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x03);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_is_oop);
  
#line 18436 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void addD_reg_imm1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {
    MacroAssembler _masm(&cbuf);

#line 10309 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ fld1();
    __ faddp(opnd_array(1)->reg(ra_,this,idx1));
  
#line 18453 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void addD_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {
    MacroAssembler _masm(&cbuf);

#line 10322 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ fld_d(InternalAddress(__ code()->consts()->start() + constant_offset()));
    __ faddp(opnd_array(1)->reg(ra_,this,idx1));
  
#line 18470 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void addD_reg_immNode::eval_constant(Compile* C) {
  {

#line 10323 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
    _constant = C->constant_table().add(opnd_array(2));
#line 18478 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void addD_reg_imm_roundNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {
    MacroAssembler _masm(&cbuf);

#line 10336 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ fld_d(InternalAddress(__ code()->consts()->start() + constant_offset()));
    __ fadd(opnd_array(1)->reg(ra_,this,idx1));
    __ fstp_d(Address(rsp, opnd_array(0)->disp(ra_,this,0)));
  
#line 18496 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void addD_reg_imm_roundNode::eval_constant(Compile* C) {
  {

#line 10337 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
    _constant = C->constant_table().add(opnd_array(2));
#line 18504 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void addXD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xF2));
  
#line 18519 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0F));
  
#line 18527 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x58));
  
#line 18535 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2095 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1), opnd_array(2)->reg(ra_,this,idx2));
  
#line 18543 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void addXD_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {
    MacroAssembler _masm(&cbuf);

#line 10357 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ addsd(opnd_array(1)->as_XMMRegister(ra_,this,idx1), InternalAddress(__ code()->consts()->start() + constant_offset()));
  
#line 18559 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void addXD_immNode::eval_constant(Compile* C) {
  {

#line 10358 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
    _constant = C->constant_table().add(opnd_array(2));
#line 18567 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void addXD_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xF2));
  
#line 18582 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0F));
  
#line 18590 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x58));
  
#line 18598 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(1)->reg(ra_,this,idx1);
    int base  = opnd_array(2)->base(ra_,this,idx2);
    int index = opnd_array(2)->index(ra_,this,idx2);
    int scale = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2);
    bool disp_is_oop = opnd_array(2)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 18612 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void addXD_mem_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xF2));
  
#line 18627 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0F));
  
#line 18635 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x58));
  
#line 18643 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(2)->reg(ra_,this,idx2);
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 18657 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void subXD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xF2));
  
#line 18672 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0F));
  
#line 18680 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x5C));
  
#line 18688 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2095 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1), opnd_array(2)->reg(ra_,this,idx2));
  
#line 18696 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void subXD_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {
    MacroAssembler _masm(&cbuf);

#line 10384 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ subsd(opnd_array(1)->as_XMMRegister(ra_,this,idx1), InternalAddress(__ code()->consts()->start() + constant_offset()));
  
#line 18712 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void subXD_immNode::eval_constant(Compile* C) {
  {

#line 10385 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
    _constant = C->constant_table().add(opnd_array(2));
#line 18720 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void subXD_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xF2));
  
#line 18735 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0F));
  
#line 18743 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x5C));
  
#line 18751 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(1)->reg(ra_,this,idx1);
    int base  = opnd_array(2)->base(ra_,this,idx2);
    int index = opnd_array(2)->index(ra_,this,idx2);
    int scale = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2);
    bool disp_is_oop = opnd_array(2)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 18765 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void mulXD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xF2));
  
#line 18780 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0F));
  
#line 18788 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x59));
  
#line 18796 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2095 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1), opnd_array(2)->reg(ra_,this,idx2));
  
#line 18804 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void mulXD_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {
    MacroAssembler _masm(&cbuf);

#line 10411 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ mulsd(opnd_array(1)->as_XMMRegister(ra_,this,idx1), InternalAddress(__ code()->consts()->start() + constant_offset()));
  
#line 18820 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void mulXD_immNode::eval_constant(Compile* C) {
  {

#line 10412 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
    _constant = C->constant_table().add(opnd_array(2));
#line 18828 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void mulXD_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xF2));
  
#line 18843 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0F));
  
#line 18851 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x59));
  
#line 18859 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(1)->reg(ra_,this,idx1);
    int base  = opnd_array(2)->base(ra_,this,idx2);
    int index = opnd_array(2)->index(ra_,this,idx2);
    int scale = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2);
    bool disp_is_oop = opnd_array(2)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 18873 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void mulXD_mem_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xF2));
  
#line 18888 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0F));
  
#line 18896 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x59));
  
#line 18904 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(2)->reg(ra_,this,idx2);
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 18918 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void divXD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xF2));
  
#line 18933 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0F));
  
#line 18941 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x5E));
  
#line 18949 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2095 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1), opnd_array(2)->reg(ra_,this,idx2));
  
#line 18957 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void divXD_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {
    MacroAssembler _masm(&cbuf);

#line 10439 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ divsd(opnd_array(1)->as_XMMRegister(ra_,this,idx1), InternalAddress(__ code()->consts()->start() + constant_offset()));
  
#line 18973 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void divXD_immNode::eval_constant(Compile* C) {
  {

#line 10440 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
    _constant = C->constant_table().add(opnd_array(2));
#line 18981 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void divXD_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xF2));
  
#line 18996 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0F));
  
#line 19004 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x5E));
  
#line 19012 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(1)->reg(ra_,this,idx1);
    int base  = opnd_array(2)->base(ra_,this,idx2);
    int index = opnd_array(2)->index(ra_,this,idx2);
    int scale = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2);
    bool disp_is_oop = opnd_array(2)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 19026 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void mulD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 2512 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );
    emit_d8( cbuf, 0xC0-1+opnd_array(2)->reg(ra_,this,idx2) );   // FLD ST(i-1)
  
#line 19042 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xDE /*primary()*/));
  
#line 19050 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1746 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x1 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1) );
  
#line 19058 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void strictfp_mulD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 2517 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xDB );           // FLD m80real
    emit_opcode( cbuf, 0x2D );
    emit_d32( cbuf, (int)StubRoutines::addr_fpu_subnormal_bias1() );
    emit_opcode( cbuf, 0xDE );           // FMULP ST(dst), ST0
    emit_opcode( cbuf, 0xC8+opnd_array(1)->reg(ra_,this,idx1) );
  
#line 19077 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2512 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );
    emit_d8( cbuf, 0xC0-1+opnd_array(2)->reg(ra_,this,idx2) );   // FLD ST(i-1)
  
#line 19086 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xDE /*primary()*/));
  
#line 19094 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1746 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x1 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1) );
  
#line 19102 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2525 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xDB );           // FLD m80real
    emit_opcode( cbuf, 0x2D );
    emit_d32( cbuf, (int)StubRoutines::addr_fpu_subnormal_bias2() );
    emit_opcode( cbuf, 0xDE );           // FMULP ST(dst), ST0
    emit_opcode( cbuf, 0xC8+opnd_array(1)->reg(ra_,this,idx1) );
  
#line 19114 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void mulD_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {
    MacroAssembler _masm(&cbuf);

#line 10499 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ fld_d(InternalAddress(__ code()->consts()->start() + constant_offset()));
    __ fmulp(opnd_array(1)->reg(ra_,this,idx1));
  
#line 19131 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void mulD_reg_immNode::eval_constant(Compile* C) {
  {

#line 10500 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
    _constant = C->constant_table().add(opnd_array(2));
#line 19139 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void mulD_reg_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xDD /*tertiary()*/));
  
#line 19154 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2302 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(2)->base(ra_,this,idx2);
    int index    = opnd_array(2)->index(ra_,this,idx2);
    int scale    = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2);
    bool disp_is_oop = opnd_array(2)->disp_is_oop(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_is_oop);
  
#line 19168 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xDE /*primary()*/));
  
#line 19176 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1746 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x1 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1) );
  
#line 19184 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void mulD_reg_mem_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xDD /*tertiary()*/));
  
#line 19199 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2302 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_is_oop);
  
#line 19213 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xDE /*primary()*/));
  
#line 19221 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1746 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x1 /*secondary()*/), opnd_array(2)->reg(ra_,this,idx2) );
  
#line 19229 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void mulD_reg_mem_ciscNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9 /*tertiary()*/));
  
#line 19244 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2302 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(2)->base(ra_,this,idx2);
    int index    = opnd_array(2)->index(ra_,this,idx2);
    int scale    = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2);
    bool disp_is_oop = opnd_array(2)->disp_is_oop(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_is_oop);
  
#line 19258 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2495 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0xD8 /*primary()*/));
    emit_rm(cbuf, 0x3, (0x1 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1) );
  
#line 19267 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2507 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xDD );           // FSTP   ST(i)
    emit_d8( cbuf, 0xD8+opnd_array(0)->reg(ra_,this) );
  
#line 19276 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void mulD_reg_mem_cisc_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9 /*tertiary()*/));
  
#line 19291 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2302 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_is_oop);
  
#line 19305 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2495 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0xD8 /*primary()*/));
    emit_rm(cbuf, 0x3, (0x1 /*secondary()*/), opnd_array(2)->reg(ra_,this,idx2) );
  
#line 19314 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2507 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xDD );           // FSTP   ST(i)
    emit_d8( cbuf, 0xD8+opnd_array(0)->reg(ra_,this) );
  
#line 19323 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void addD_mulD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
  {

#line 2577 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );           // FLD    ST(i-1)
    emit_d8( cbuf, 0xC0-1+opnd_array(1)->reg(ra_,this,idx1) );
  
#line 19340 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 4119 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Operand was loaded from memory into fp ST (stack top)
    // FMUL   ST,$src  /* D8 C8+i */
    emit_opcode(cbuf, 0xD8);
    emit_opcode(cbuf, 0xC8 + opnd_array(2)->reg(ra_,this,idx2));
  
#line 19351 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 4133 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // FADDP  src2,ST  /* DE C0+i */
    emit_opcode(cbuf, 0xDE);
    emit_opcode(cbuf, 0xC0 + opnd_array(3)->reg(ra_,this,idx3));
  
#line 19361 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void addD_mulD_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
  {

#line 2577 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );           // FLD    ST(i-1)
    emit_d8( cbuf, 0xC0-1+opnd_array(2)->reg(ra_,this,idx2) );
  
#line 19378 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 4119 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Operand was loaded from memory into fp ST (stack top)
    // FMUL   ST,$src  /* D8 C8+i */
    emit_opcode(cbuf, 0xD8);
    emit_opcode(cbuf, 0xC8 + opnd_array(3)->reg(ra_,this,idx3));
  
#line 19389 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 4133 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // FADDP  src2,ST  /* DE C0+i */
    emit_opcode(cbuf, 0xDE);
    emit_opcode(cbuf, 0xC0 + opnd_array(1)->reg(ra_,this,idx1));
  
#line 19399 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void subD_mulD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
  {

#line 2577 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );           // FLD    ST(i-1)
    emit_d8( cbuf, 0xC0-1+opnd_array(1)->reg(ra_,this,idx1) );
  
#line 19416 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 4119 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Operand was loaded from memory into fp ST (stack top)
    // FMUL   ST,$src  /* D8 C8+i */
    emit_opcode(cbuf, 0xD8);
    emit_opcode(cbuf, 0xC8 + opnd_array(2)->reg(ra_,this,idx2));
  
#line 19427 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xDE));
  
#line 19435 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1655 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xE0) + opnd_array(3)->reg(ra_,this,idx3));
  
#line 19443 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void divD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 2512 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );
    emit_d8( cbuf, 0xC0-1+opnd_array(2)->reg(ra_,this,idx2) );   // FLD ST(i-1)
  
#line 19459 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xDE /*primary()*/));
  
#line 19467 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1746 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x7 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1) );
  
#line 19475 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void strictfp_divD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 2517 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xDB );           // FLD m80real
    emit_opcode( cbuf, 0x2D );
    emit_d32( cbuf, (int)StubRoutines::addr_fpu_subnormal_bias1() );
    emit_opcode( cbuf, 0xDE );           // FMULP ST(dst), ST0
    emit_opcode( cbuf, 0xC8+opnd_array(1)->reg(ra_,this,idx1) );
  
#line 19494 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2512 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );
    emit_d8( cbuf, 0xC0-1+opnd_array(2)->reg(ra_,this,idx2) );   // FLD ST(i-1)
  
#line 19503 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xDE /*primary()*/));
  
#line 19511 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1746 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x7 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1) );
  
#line 19519 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2525 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xDB );           // FLD m80real
    emit_opcode( cbuf, 0x2D );
    emit_d32( cbuf, (int)StubRoutines::addr_fpu_subnormal_bias2() );
    emit_opcode( cbuf, 0xDE );           // FMULP ST(dst), ST0
    emit_opcode( cbuf, 0xC8+opnd_array(1)->reg(ra_,this,idx1) );
  
#line 19531 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void divD_reg_roundNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 2512 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );
    emit_d8( cbuf, 0xC0-1+opnd_array(1)->reg(ra_,this,idx1) );   // FLD ST(i-1)
  
#line 19547 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD8 /*primary()*/));
  
#line 19555 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1746 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x6 /*secondary()*/), opnd_array(2)->reg(ra_,this,idx2) );
  
#line 19563 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2568 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    store_to_stackslot( cbuf, 0xDD, 0x03, opnd_array(0)->disp(ra_,this,0) );
  
#line 19571 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void modD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 2626 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // load dst in FPR0
    emit_opcode( cbuf, 0xD9 );
    emit_d8( cbuf, 0xC0-1+opnd_array(1)->reg(ra_,this,idx1) );
    if (opnd_array(2)->reg(ra_,this,idx2) != FPR1L_enc) {
      // fincstp
      emit_opcode (cbuf, 0xD9);
      emit_opcode (cbuf, 0xF7);
      // swap src with FPR1:
      // FXCH FPR1 with src
      emit_opcode(cbuf, 0xD9);
      emit_d8(cbuf, 0xC8-1+opnd_array(2)->reg(ra_,this,idx2) );
      // fdecstp
      emit_opcode (cbuf, 0xD9);
      emit_opcode (cbuf, 0xF6);
    }
  
#line 19600 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2827 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // fprem must be iterative
    // :: loop
    // fprem
    emit_opcode( cbuf, 0xD9 );
    emit_opcode( cbuf, 0xF8 );
    // wait
    emit_opcode( cbuf, 0x9b );
    // fnstsw ax
    emit_opcode( cbuf, 0xDF );
    emit_opcode( cbuf, 0xE0 );
    // sahf
    emit_opcode( cbuf, 0x9E );
    // jp  ::loop
    emit_opcode( cbuf, 0x0F );
    emit_opcode( cbuf, 0x8A );
    emit_opcode( cbuf, 0xF4 );
    emit_opcode( cbuf, 0xFF );
    emit_opcode( cbuf, 0xFF );
    emit_opcode( cbuf, 0xFF );
  
#line 19626 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2798 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    if (opnd_array(2)->reg(ra_,this,idx2) != FPR1L_enc) {
      // fincstp
      emit_opcode (cbuf, 0xD9);
      emit_opcode (cbuf, 0xF7);
      // FXCH FPR1 with src
      emit_opcode(cbuf, 0xD9);
      emit_d8(cbuf, 0xC8-1+opnd_array(2)->reg(ra_,this,idx2) );
      // fdecstp
      emit_opcode (cbuf, 0xD9);
      emit_opcode (cbuf, 0xF6);
    }
    // // following asm replaced with Pop_Reg_F or Pop_Mem_F
    // // FSTP   FPR$dst$$reg
    // emit_opcode( cbuf, 0xDD );
    // emit_d8( cbuf, 0xD8+$dst$$reg );
  
#line 19648 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2507 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xDD );           // FSTP   ST(i)
    emit_d8( cbuf, 0xD8+opnd_array(1)->reg(ra_,this,idx1) );
  
#line 19657 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void modXD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 2644 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Allocate a word
    emit_opcode(cbuf,0x83);            // SUB ESP,8
    emit_opcode(cbuf,0xEC);
    emit_d8(cbuf,0x08);

    emit_opcode  (cbuf, 0xF2 );     // MOVSD [ESP], src1
    emit_opcode  (cbuf, 0x0F );
    emit_opcode  (cbuf, 0x11 );
    encode_RegMem(cbuf, opnd_array(2)->reg(ra_,this,idx2), ESP_enc, 0x4, 0, 0, false);

    emit_opcode(cbuf,0xDD );      // FLD_D [ESP]
    encode_RegMem(cbuf, 0x0, ESP_enc, 0x4, 0, 0, false);

    emit_opcode  (cbuf, 0xF2 );     // MOVSD [ESP], src0
    emit_opcode  (cbuf, 0x0F );
    emit_opcode  (cbuf, 0x11 );
    encode_RegMem(cbuf, opnd_array(1)->reg(ra_,this,idx1), ESP_enc, 0x4, 0, 0, false);

    emit_opcode(cbuf,0xDD );      // FLD_D [ESP]
    encode_RegMem(cbuf, 0x0, ESP_enc, 0x4, 0, 0, false);

  
#line 19692 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2827 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // fprem must be iterative
    // :: loop
    // fprem
    emit_opcode( cbuf, 0xD9 );
    emit_opcode( cbuf, 0xF8 );
    // wait
    emit_opcode( cbuf, 0x9b );
    // fnstsw ax
    emit_opcode( cbuf, 0xDF );
    emit_opcode( cbuf, 0xE0 );
    // sahf
    emit_opcode( cbuf, 0x9E );
    // jp  ::loop
    emit_opcode( cbuf, 0x0F );
    emit_opcode( cbuf, 0x8A );
    emit_opcode( cbuf, 0xF4 );
    emit_opcode( cbuf, 0xFF );
    emit_opcode( cbuf, 0xFF );
    emit_opcode( cbuf, 0xFF );
  
#line 19718 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2692 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    store_to_stackslot( cbuf, 0xDD, 0x03, 0 ); //FSTP [ESP]

    // UseXmmLoadAndClearUpper ? movsd dst,[esp] : movlpd dst,[esp]
    emit_opcode  (cbuf, UseXmmLoadAndClearUpper ? 0xF2 : 0x66);
    emit_opcode  (cbuf, 0x0F );
    emit_opcode  (cbuf, UseXmmLoadAndClearUpper ? 0x10 : 0x12);
    encode_RegMem(cbuf, opnd_array(0)->reg(ra_,this), ESP_enc, 0x4, 0, 0, false);

    emit_opcode(cbuf,0x83);    // ADD ESP,8
    emit_opcode(cbuf,0xC4);
    emit_d8(cbuf,0x08);
  
#line 19736 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2501 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xDD );
    emit_d8( cbuf, 0xD8 );
  
#line 19745 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void sinD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9 /*primary()*/));
  
#line 19759 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1586 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xFE /*secondary()*/));
  
#line 19767 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void sinXD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 2719 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Allocate a word
    emit_opcode(cbuf,0x83);            // SUB ESP,8
    emit_opcode(cbuf,0xEC);
    emit_d8(cbuf,0x08);

    emit_opcode  (cbuf, 0xF2 );     // MOVSD [ESP], src
    emit_opcode  (cbuf, 0x0F );
    emit_opcode  (cbuf, 0x11 );
    encode_RegMem(cbuf, opnd_array(1)->reg(ra_,this,idx1), ESP_enc, 0x4, 0, 0, false);

    emit_opcode(cbuf,0xDD );      // FLD_D [ESP]
    encode_RegMem(cbuf, 0x0, ESP_enc, 0x4, 0, 0, false);
  
#line 19792 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9 /*primary()*/));
  
#line 19800 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1586 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xFE /*secondary()*/));
  
#line 19808 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2692 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    store_to_stackslot( cbuf, 0xDD, 0x03, 0 ); //FSTP [ESP]

    // UseXmmLoadAndClearUpper ? movsd dst,[esp] : movlpd dst,[esp]
    emit_opcode  (cbuf, UseXmmLoadAndClearUpper ? 0xF2 : 0x66);
    emit_opcode  (cbuf, 0x0F );
    emit_opcode  (cbuf, UseXmmLoadAndClearUpper ? 0x10 : 0x12);
    encode_RegMem(cbuf, opnd_array(1)->reg(ra_,this,idx1), ESP_enc, 0x4, 0, 0, false);

    emit_opcode(cbuf,0x83);    // ADD ESP,8
    emit_opcode(cbuf,0xC4);
    emit_d8(cbuf,0x08);
  
#line 19826 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void cosD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9 /*primary()*/));
  
#line 19840 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1586 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xFF /*secondary()*/));
  
#line 19848 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void cosXD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 2719 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Allocate a word
    emit_opcode(cbuf,0x83);            // SUB ESP,8
    emit_opcode(cbuf,0xEC);
    emit_d8(cbuf,0x08);

    emit_opcode  (cbuf, 0xF2 );     // MOVSD [ESP], src
    emit_opcode  (cbuf, 0x0F );
    emit_opcode  (cbuf, 0x11 );
    encode_RegMem(cbuf, opnd_array(1)->reg(ra_,this,idx1), ESP_enc, 0x4, 0, 0, false);

    emit_opcode(cbuf,0xDD );      // FLD_D [ESP]
    encode_RegMem(cbuf, 0x0, ESP_enc, 0x4, 0, 0, false);
  
#line 19873 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9 /*primary()*/));
  
#line 19881 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1586 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xFF /*secondary()*/));
  
#line 19889 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2692 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    store_to_stackslot( cbuf, 0xDD, 0x03, 0 ); //FSTP [ESP]

    // UseXmmLoadAndClearUpper ? movsd dst,[esp] : movlpd dst,[esp]
    emit_opcode  (cbuf, UseXmmLoadAndClearUpper ? 0xF2 : 0x66);
    emit_opcode  (cbuf, 0x0F );
    emit_opcode  (cbuf, UseXmmLoadAndClearUpper ? 0x10 : 0x12);
    encode_RegMem(cbuf, opnd_array(1)->reg(ra_,this,idx1), ESP_enc, 0x4, 0, 0, false);

    emit_opcode(cbuf,0x83);    // ADD ESP,8
    emit_opcode(cbuf,0xC4);
    emit_d8(cbuf,0x08);
  
#line 19907 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void tanD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9));
  
#line 19921 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xF2));
  
#line 19929 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xDD));
  
#line 19937 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD8));
  
#line 19945 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void tanXD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 2719 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Allocate a word
    emit_opcode(cbuf,0x83);            // SUB ESP,8
    emit_opcode(cbuf,0xEC);
    emit_d8(cbuf,0x08);

    emit_opcode  (cbuf, 0xF2 );     // MOVSD [ESP], src
    emit_opcode  (cbuf, 0x0F );
    emit_opcode  (cbuf, 0x11 );
    encode_RegMem(cbuf, opnd_array(1)->reg(ra_,this,idx1), ESP_enc, 0x4, 0, 0, false);

    emit_opcode(cbuf,0xDD );      // FLD_D [ESP]
    encode_RegMem(cbuf, 0x0, ESP_enc, 0x4, 0, 0, false);
  
#line 19970 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9));
  
#line 19978 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xF2));
  
#line 19986 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xDD));
  
#line 19994 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD8));
  
#line 20002 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2692 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    store_to_stackslot( cbuf, 0xDD, 0x03, 0 ); //FSTP [ESP]

    // UseXmmLoadAndClearUpper ? movsd dst,[esp] : movlpd dst,[esp]
    emit_opcode  (cbuf, UseXmmLoadAndClearUpper ? 0xF2 : 0x66);
    emit_opcode  (cbuf, 0x0F );
    emit_opcode  (cbuf, UseXmmLoadAndClearUpper ? 0x10 : 0x12);
    encode_RegMem(cbuf, opnd_array(1)->reg(ra_,this,idx1), ESP_enc, 0x4, 0, 0, false);

    emit_opcode(cbuf,0x83);    // ADD ESP,8
    emit_opcode(cbuf,0xC4);
    emit_d8(cbuf,0x08);
  
#line 20020 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void atanD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 2512 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );
    emit_d8( cbuf, 0xC0-1+opnd_array(2)->reg(ra_,this,idx2) );   // FLD ST(i-1)
  
#line 20036 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9 /*primary()*/));
  
#line 20044 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1586 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xF3 /*secondary()*/));
  
#line 20052 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1746 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0xF3 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1) );
  
#line 20060 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void atanXD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 2719 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Allocate a word
    emit_opcode(cbuf,0x83);            // SUB ESP,8
    emit_opcode(cbuf,0xEC);
    emit_d8(cbuf,0x08);

    emit_opcode  (cbuf, 0xF2 );     // MOVSD [ESP], src
    emit_opcode  (cbuf, 0x0F );
    emit_opcode  (cbuf, 0x11 );
    encode_RegMem(cbuf, opnd_array(2)->reg(ra_,this,idx2), ESP_enc, 0x4, 0, 0, false);

    emit_opcode(cbuf,0xDD );      // FLD_D [ESP]
    encode_RegMem(cbuf, 0x0, ESP_enc, 0x4, 0, 0, false);
  
#line 20086 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9 /*primary()*/));
  
#line 20094 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1586 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xF3 /*secondary()*/));
  
#line 20102 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2692 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    store_to_stackslot( cbuf, 0xDD, 0x03, 0 ); //FSTP [ESP]

    // UseXmmLoadAndClearUpper ? movsd dst,[esp] : movlpd dst,[esp]
    emit_opcode  (cbuf, UseXmmLoadAndClearUpper ? 0xF2 : 0x66);
    emit_opcode  (cbuf, 0x0F );
    emit_opcode  (cbuf, UseXmmLoadAndClearUpper ? 0x10 : 0x12);
    encode_RegMem(cbuf, opnd_array(1)->reg(ra_,this,idx1), ESP_enc, 0x4, 0, 0, false);

    emit_opcode(cbuf,0x83);    // ADD ESP,8
    emit_opcode(cbuf,0xC4);
    emit_d8(cbuf,0x08);
  
#line 20120 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void sqrtD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 2512 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );
    emit_d8( cbuf, 0xC0-1+opnd_array(1)->reg(ra_,this,idx1) );   // FLD ST(i-1)
  
#line 20135 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1586 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9 /*secondary()*/));
  
#line 20143 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xFA /*primary()*/));
  
#line 20151 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2507 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xDD );           // FSTP   ST(i)
    emit_d8( cbuf, 0xD8+opnd_array(0)->reg(ra_,this) );
  
#line 20160 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void powD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 2734 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf,0x83);     // SUB ESP,8
    emit_opcode(cbuf,0xEC);
    emit_d8    (cbuf,0x08);
  
#line 20177 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2512 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );
    emit_d8( cbuf, 0xC0-1+opnd_array(1)->reg(ra_,this,idx1) );   // FLD ST(i-1)
  
#line 20186 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9));
  
#line 20194 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xF1));
  
#line 20202 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2758 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // FPR1 holds Y*ln2(X).  Compute FPR1 = 2^(Y*ln2(X))
    emit_opcode(cbuf,0xD9); emit_opcode(cbuf,0xC0);  // fdup = fld st(0)          Q       Q
    emit_opcode(cbuf,0xD9); emit_opcode(cbuf,0xFC);  // frndint               int(Q)      Q
    emit_opcode(cbuf,0xDC); emit_opcode(cbuf,0xE9);  // fsub st(1) -= st(0);  int(Q) frac(Q)
    emit_opcode(cbuf,0xDB);                          // FISTP [ESP]           frac(Q)
    emit_opcode(cbuf,0x1C);
    emit_d8(cbuf,0x24);
    emit_opcode(cbuf,0xD9); emit_opcode(cbuf,0xF0);  // f2xm1                 2^frac(Q)-1
    emit_opcode(cbuf,0xD9); emit_opcode(cbuf,0xE8);  // fld1                  1 2^frac(Q)-1
    emit_opcode(cbuf,0xDE); emit_opcode(cbuf,0xC1);  // faddp                 2^frac(Q)
    emit_opcode(cbuf,0x8B);                          // mov rax,[esp+0]=int(Q)
    encode_RegMem(cbuf, EAX_enc, ESP_enc, 0x4, 0, 0, false);
    emit_opcode(cbuf,0xC7);                          // mov rcx,0xFFFFF800 - overflow mask
    emit_rm(cbuf, 0x3, 0x0, ECX_enc);
    emit_d32(cbuf,0xFFFFF800);
    emit_opcode(cbuf,0x81);                          // add rax,1023 - the double exponent bias
    emit_rm(cbuf, 0x3, 0x0, EAX_enc);
    emit_d32(cbuf,1023);
    emit_opcode(cbuf,0x8B);                          // mov rbx,eax
    emit_rm(cbuf, 0x3, EBX_enc, EAX_enc);
    emit_opcode(cbuf,0xC1);                          // shl rax,20 - Slide to exponent position
    emit_rm(cbuf,0x3,0x4,EAX_enc);
    emit_d8(cbuf,20);
    emit_opcode(cbuf,0x85);                          // test rbx,ecx - check for overflow
    emit_rm(cbuf, 0x3, EBX_enc, ECX_enc);
    emit_opcode(cbuf,0x0F); emit_opcode(cbuf,0x45);  // CMOVne rax,ecx - overflow; stuff NAN into EAX
    emit_rm(cbuf, 0x3, EAX_enc, ECX_enc);
    emit_opcode(cbuf,0x89);                          // mov [esp+4],eax - Store as part of double word
    encode_RegMem(cbuf, EAX_enc, ESP_enc, 0x4, 0, 4, false);
    emit_opcode(cbuf,0xC7);                          // mov [esp+0],0   - [ESP] = (double)(1<<int(Q)) = 2^int(Q)
    encode_RegMem(cbuf, 0x0, ESP_enc, 0x4, 0, 0, false);
    emit_d32(cbuf,0);
    emit_opcode(cbuf,0xDC);                          // fmul dword st(0),[esp+0]; FPR1 = 2^int(Q)*2^frac(Q) = 2^Q
    encode_RegMem(cbuf, 0x1, ESP_enc, 0x4, 0, 0, false);
  
#line 20243 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2740 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf,0x83);     // ADD ESP,8
    emit_opcode(cbuf,0xC4);
    emit_d8    (cbuf,0x08);
  
#line 20253 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void powXD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 2734 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf,0x83);     // SUB ESP,8
    emit_opcode(cbuf,0xEC);
    emit_d8    (cbuf,0x08);
  
#line 20270 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2746 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode  (cbuf, 0xF2 );     // MOVSD [ESP], xmm_src
    emit_opcode  (cbuf, 0x0F );
    emit_opcode  (cbuf, 0x11 );
    encode_RegMem(cbuf, opnd_array(2)->reg(ra_,this,idx2), ESP_enc, 0x4, 0, 0, false);

    emit_opcode(cbuf,0xDD );      // FLD_D [ESP]
    encode_RegMem(cbuf, 0x0, ESP_enc, 0x4, 0, 0, false);
  
#line 20284 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2746 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode  (cbuf, 0xF2 );     // MOVSD [ESP], xmm_src
    emit_opcode  (cbuf, 0x0F );
    emit_opcode  (cbuf, 0x11 );
    encode_RegMem(cbuf, opnd_array(1)->reg(ra_,this,idx1), ESP_enc, 0x4, 0, 0, false);

    emit_opcode(cbuf,0xDD );      // FLD_D [ESP]
    encode_RegMem(cbuf, 0x0, ESP_enc, 0x4, 0, 0, false);
  
#line 20298 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9));
  
#line 20306 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xF1));
  
#line 20314 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2758 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // FPR1 holds Y*ln2(X).  Compute FPR1 = 2^(Y*ln2(X))
    emit_opcode(cbuf,0xD9); emit_opcode(cbuf,0xC0);  // fdup = fld st(0)          Q       Q
    emit_opcode(cbuf,0xD9); emit_opcode(cbuf,0xFC);  // frndint               int(Q)      Q
    emit_opcode(cbuf,0xDC); emit_opcode(cbuf,0xE9);  // fsub st(1) -= st(0);  int(Q) frac(Q)
    emit_opcode(cbuf,0xDB);                          // FISTP [ESP]           frac(Q)
    emit_opcode(cbuf,0x1C);
    emit_d8(cbuf,0x24);
    emit_opcode(cbuf,0xD9); emit_opcode(cbuf,0xF0);  // f2xm1                 2^frac(Q)-1
    emit_opcode(cbuf,0xD9); emit_opcode(cbuf,0xE8);  // fld1                  1 2^frac(Q)-1
    emit_opcode(cbuf,0xDE); emit_opcode(cbuf,0xC1);  // faddp                 2^frac(Q)
    emit_opcode(cbuf,0x8B);                          // mov rax,[esp+0]=int(Q)
    encode_RegMem(cbuf, EAX_enc, ESP_enc, 0x4, 0, 0, false);
    emit_opcode(cbuf,0xC7);                          // mov rcx,0xFFFFF800 - overflow mask
    emit_rm(cbuf, 0x3, 0x0, ECX_enc);
    emit_d32(cbuf,0xFFFFF800);
    emit_opcode(cbuf,0x81);                          // add rax,1023 - the double exponent bias
    emit_rm(cbuf, 0x3, 0x0, EAX_enc);
    emit_d32(cbuf,1023);
    emit_opcode(cbuf,0x8B);                          // mov rbx,eax
    emit_rm(cbuf, 0x3, EBX_enc, EAX_enc);
    emit_opcode(cbuf,0xC1);                          // shl rax,20 - Slide to exponent position
    emit_rm(cbuf,0x3,0x4,EAX_enc);
    emit_d8(cbuf,20);
    emit_opcode(cbuf,0x85);                          // test rbx,ecx - check for overflow
    emit_rm(cbuf, 0x3, EBX_enc, ECX_enc);
    emit_opcode(cbuf,0x0F); emit_opcode(cbuf,0x45);  // CMOVne rax,ecx - overflow; stuff NAN into EAX
    emit_rm(cbuf, 0x3, EAX_enc, ECX_enc);
    emit_opcode(cbuf,0x89);                          // mov [esp+4],eax - Store as part of double word
    encode_RegMem(cbuf, EAX_enc, ESP_enc, 0x4, 0, 4, false);
    emit_opcode(cbuf,0xC7);                          // mov [esp+0],0   - [ESP] = (double)(1<<int(Q)) = 2^int(Q)
    encode_RegMem(cbuf, 0x0, ESP_enc, 0x4, 0, 0, false);
    emit_d32(cbuf,0);
    emit_opcode(cbuf,0xDC);                          // fmul dword st(0),[esp+0]; FPR1 = 2^int(Q)*2^frac(Q) = 2^Q
    encode_RegMem(cbuf, 0x1, ESP_enc, 0x4, 0, 0, false);
  
#line 20355 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2692 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    store_to_stackslot( cbuf, 0xDD, 0x03, 0 ); //FSTP [ESP]

    // UseXmmLoadAndClearUpper ? movsd dst,[esp] : movlpd dst,[esp]
    emit_opcode  (cbuf, UseXmmLoadAndClearUpper ? 0xF2 : 0x66);
    emit_opcode  (cbuf, 0x0F );
    emit_opcode  (cbuf, UseXmmLoadAndClearUpper ? 0x10 : 0x12);
    encode_RegMem(cbuf, opnd_array(0)->reg(ra_,this), ESP_enc, 0x4, 0, 0, false);

    emit_opcode(cbuf,0x83);    // ADD ESP,8
    emit_opcode(cbuf,0xC4);
    emit_d8(cbuf,0x08);
  
#line 20373 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void expD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 2734 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf,0x83);     // SUB ESP,8
    emit_opcode(cbuf,0xEC);
    emit_d8    (cbuf,0x08);
  
#line 20389 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9));
  
#line 20397 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xEA));
  
#line 20405 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xDE));
  
#line 20413 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xC9));
  
#line 20421 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2758 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // FPR1 holds Y*ln2(X).  Compute FPR1 = 2^(Y*ln2(X))
    emit_opcode(cbuf,0xD9); emit_opcode(cbuf,0xC0);  // fdup = fld st(0)          Q       Q
    emit_opcode(cbuf,0xD9); emit_opcode(cbuf,0xFC);  // frndint               int(Q)      Q
    emit_opcode(cbuf,0xDC); emit_opcode(cbuf,0xE9);  // fsub st(1) -= st(0);  int(Q) frac(Q)
    emit_opcode(cbuf,0xDB);                          // FISTP [ESP]           frac(Q)
    emit_opcode(cbuf,0x1C);
    emit_d8(cbuf,0x24);
    emit_opcode(cbuf,0xD9); emit_opcode(cbuf,0xF0);  // f2xm1                 2^frac(Q)-1
    emit_opcode(cbuf,0xD9); emit_opcode(cbuf,0xE8);  // fld1                  1 2^frac(Q)-1
    emit_opcode(cbuf,0xDE); emit_opcode(cbuf,0xC1);  // faddp                 2^frac(Q)
    emit_opcode(cbuf,0x8B);                          // mov rax,[esp+0]=int(Q)
    encode_RegMem(cbuf, EAX_enc, ESP_enc, 0x4, 0, 0, false);
    emit_opcode(cbuf,0xC7);                          // mov rcx,0xFFFFF800 - overflow mask
    emit_rm(cbuf, 0x3, 0x0, ECX_enc);
    emit_d32(cbuf,0xFFFFF800);
    emit_opcode(cbuf,0x81);                          // add rax,1023 - the double exponent bias
    emit_rm(cbuf, 0x3, 0x0, EAX_enc);
    emit_d32(cbuf,1023);
    emit_opcode(cbuf,0x8B);                          // mov rbx,eax
    emit_rm(cbuf, 0x3, EBX_enc, EAX_enc);
    emit_opcode(cbuf,0xC1);                          // shl rax,20 - Slide to exponent position
    emit_rm(cbuf,0x3,0x4,EAX_enc);
    emit_d8(cbuf,20);
    emit_opcode(cbuf,0x85);                          // test rbx,ecx - check for overflow
    emit_rm(cbuf, 0x3, EBX_enc, ECX_enc);
    emit_opcode(cbuf,0x0F); emit_opcode(cbuf,0x45);  // CMOVne rax,ecx - overflow; stuff NAN into EAX
    emit_rm(cbuf, 0x3, EAX_enc, ECX_enc);
    emit_opcode(cbuf,0x89);                          // mov [esp+4],eax - Store as part of double word
    encode_RegMem(cbuf, EAX_enc, ESP_enc, 0x4, 0, 4, false);
    emit_opcode(cbuf,0xC7);                          // mov [esp+0],0   - [ESP] = (double)(1<<int(Q)) = 2^int(Q)
    encode_RegMem(cbuf, 0x0, ESP_enc, 0x4, 0, 0, false);
    emit_d32(cbuf,0);
    emit_opcode(cbuf,0xDC);                          // fmul dword st(0),[esp+0]; FPR1 = 2^int(Q)*2^frac(Q) = 2^Q
    encode_RegMem(cbuf, 0x1, ESP_enc, 0x4, 0, 0, false);
  
#line 20462 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2740 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf,0x83);     // ADD ESP,8
    emit_opcode(cbuf,0xC4);
    emit_d8    (cbuf,0x08);
  
#line 20472 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void expXD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 2719 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Allocate a word
    emit_opcode(cbuf,0x83);            // SUB ESP,8
    emit_opcode(cbuf,0xEC);
    emit_d8(cbuf,0x08);

    emit_opcode  (cbuf, 0xF2 );     // MOVSD [ESP], src
    emit_opcode  (cbuf, 0x0F );
    emit_opcode  (cbuf, 0x11 );
    encode_RegMem(cbuf, opnd_array(1)->reg(ra_,this,idx1), ESP_enc, 0x4, 0, 0, false);

    emit_opcode(cbuf,0xDD );      // FLD_D [ESP]
    encode_RegMem(cbuf, 0x0, ESP_enc, 0x4, 0, 0, false);
  
#line 20497 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9));
  
#line 20505 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xEA));
  
#line 20513 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xDE));
  
#line 20521 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xC9));
  
#line 20529 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2758 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // FPR1 holds Y*ln2(X).  Compute FPR1 = 2^(Y*ln2(X))
    emit_opcode(cbuf,0xD9); emit_opcode(cbuf,0xC0);  // fdup = fld st(0)          Q       Q
    emit_opcode(cbuf,0xD9); emit_opcode(cbuf,0xFC);  // frndint               int(Q)      Q
    emit_opcode(cbuf,0xDC); emit_opcode(cbuf,0xE9);  // fsub st(1) -= st(0);  int(Q) frac(Q)
    emit_opcode(cbuf,0xDB);                          // FISTP [ESP]           frac(Q)
    emit_opcode(cbuf,0x1C);
    emit_d8(cbuf,0x24);
    emit_opcode(cbuf,0xD9); emit_opcode(cbuf,0xF0);  // f2xm1                 2^frac(Q)-1
    emit_opcode(cbuf,0xD9); emit_opcode(cbuf,0xE8);  // fld1                  1 2^frac(Q)-1
    emit_opcode(cbuf,0xDE); emit_opcode(cbuf,0xC1);  // faddp                 2^frac(Q)
    emit_opcode(cbuf,0x8B);                          // mov rax,[esp+0]=int(Q)
    encode_RegMem(cbuf, EAX_enc, ESP_enc, 0x4, 0, 0, false);
    emit_opcode(cbuf,0xC7);                          // mov rcx,0xFFFFF800 - overflow mask
    emit_rm(cbuf, 0x3, 0x0, ECX_enc);
    emit_d32(cbuf,0xFFFFF800);
    emit_opcode(cbuf,0x81);                          // add rax,1023 - the double exponent bias
    emit_rm(cbuf, 0x3, 0x0, EAX_enc);
    emit_d32(cbuf,1023);
    emit_opcode(cbuf,0x8B);                          // mov rbx,eax
    emit_rm(cbuf, 0x3, EBX_enc, EAX_enc);
    emit_opcode(cbuf,0xC1);                          // shl rax,20 - Slide to exponent position
    emit_rm(cbuf,0x3,0x4,EAX_enc);
    emit_d8(cbuf,20);
    emit_opcode(cbuf,0x85);                          // test rbx,ecx - check for overflow
    emit_rm(cbuf, 0x3, EBX_enc, ECX_enc);
    emit_opcode(cbuf,0x0F); emit_opcode(cbuf,0x45);  // CMOVne rax,ecx - overflow; stuff NAN into EAX
    emit_rm(cbuf, 0x3, EAX_enc, ECX_enc);
    emit_opcode(cbuf,0x89);                          // mov [esp+4],eax - Store as part of double word
    encode_RegMem(cbuf, EAX_enc, ESP_enc, 0x4, 0, 4, false);
    emit_opcode(cbuf,0xC7);                          // mov [esp+0],0   - [ESP] = (double)(1<<int(Q)) = 2^int(Q)
    encode_RegMem(cbuf, 0x0, ESP_enc, 0x4, 0, 0, false);
    emit_d32(cbuf,0);
    emit_opcode(cbuf,0xDC);                          // fmul dword st(0),[esp+0]; FPR1 = 2^int(Q)*2^frac(Q) = 2^Q
    encode_RegMem(cbuf, 0x1, ESP_enc, 0x4, 0, 0, false);
  
#line 20570 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2692 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    store_to_stackslot( cbuf, 0xDD, 0x03, 0 ); //FSTP [ESP]

    // UseXmmLoadAndClearUpper ? movsd dst,[esp] : movlpd dst,[esp]
    emit_opcode  (cbuf, UseXmmLoadAndClearUpper ? 0xF2 : 0x66);
    emit_opcode  (cbuf, 0x0F );
    emit_opcode  (cbuf, UseXmmLoadAndClearUpper ? 0x10 : 0x12);
    encode_RegMem(cbuf, opnd_array(0)->reg(ra_,this), ESP_enc, 0x4, 0, 0, false);

    emit_opcode(cbuf,0x83);    // ADD ESP,8
    emit_opcode(cbuf,0xC4);
    emit_d8(cbuf,0x08);
  
#line 20588 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void log10D_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9));
  
#line 20602 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xEC));
  
#line 20610 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9));
  
#line 20618 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xC9));
  
#line 20626 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9));
  
#line 20634 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xF1));
  
#line 20642 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void log10XD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9));
  
#line 20656 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xEC));
  
#line 20664 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2719 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Allocate a word
    emit_opcode(cbuf,0x83);            // SUB ESP,8
    emit_opcode(cbuf,0xEC);
    emit_d8(cbuf,0x08);

    emit_opcode  (cbuf, 0xF2 );     // MOVSD [ESP], src
    emit_opcode  (cbuf, 0x0F );
    emit_opcode  (cbuf, 0x11 );
    encode_RegMem(cbuf, opnd_array(1)->reg(ra_,this,idx1), ESP_enc, 0x4, 0, 0, false);

    emit_opcode(cbuf,0xDD );      // FLD_D [ESP]
    encode_RegMem(cbuf, 0x0, ESP_enc, 0x4, 0, 0, false);
  
#line 20683 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9));
  
#line 20691 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xF1));
  
#line 20699 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2692 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    store_to_stackslot( cbuf, 0xDD, 0x03, 0 ); //FSTP [ESP]

    // UseXmmLoadAndClearUpper ? movsd dst,[esp] : movlpd dst,[esp]
    emit_opcode  (cbuf, UseXmmLoadAndClearUpper ? 0xF2 : 0x66);
    emit_opcode  (cbuf, 0x0F );
    emit_opcode  (cbuf, UseXmmLoadAndClearUpper ? 0x10 : 0x12);
    encode_RegMem(cbuf, opnd_array(0)->reg(ra_,this), ESP_enc, 0x4, 0, 0, false);

    emit_opcode(cbuf,0x83);    // ADD ESP,8
    emit_opcode(cbuf,0xC4);
    emit_d8(cbuf,0x08);
  
#line 20717 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void logD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9));
  
#line 20731 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xED));
  
#line 20739 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9));
  
#line 20747 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xC9));
  
#line 20755 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9));
  
#line 20763 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xF1));
  
#line 20771 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void logXD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9));
  
#line 20785 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xED));
  
#line 20793 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2719 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Allocate a word
    emit_opcode(cbuf,0x83);            // SUB ESP,8
    emit_opcode(cbuf,0xEC);
    emit_d8(cbuf,0x08);

    emit_opcode  (cbuf, 0xF2 );     // MOVSD [ESP], src
    emit_opcode  (cbuf, 0x0F );
    emit_opcode  (cbuf, 0x11 );
    encode_RegMem(cbuf, opnd_array(1)->reg(ra_,this,idx1), ESP_enc, 0x4, 0, 0, false);

    emit_opcode(cbuf,0xDD );      // FLD_D [ESP]
    encode_RegMem(cbuf, 0x0, ESP_enc, 0x4, 0, 0, false);
  
#line 20812 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9));
  
#line 20820 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xF1));
  
#line 20828 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2692 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    store_to_stackslot( cbuf, 0xDD, 0x03, 0 ); //FSTP [ESP]

    // UseXmmLoadAndClearUpper ? movsd dst,[esp] : movlpd dst,[esp]
    emit_opcode  (cbuf, UseXmmLoadAndClearUpper ? 0xF2 : 0x66);
    emit_opcode  (cbuf, 0x0F );
    emit_opcode  (cbuf, UseXmmLoadAndClearUpper ? 0x10 : 0x12);
    encode_RegMem(cbuf, opnd_array(0)->reg(ra_,this), ESP_enc, 0x4, 0, 0, false);

    emit_opcode(cbuf,0x83);    // ADD ESP,8
    emit_opcode(cbuf,0xC4);
    emit_d8(cbuf,0x08);
  
#line 20846 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void cmpF_cc_P6Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 2512 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );
    emit_d8( cbuf, 0xC0-1+opnd_array(1)->reg(ra_,this,idx1) );   // FLD ST(i-1)
  
#line 20862 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xDF /*primary()*/));
  
#line 20870 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1746 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x05 /*secondary()*/), opnd_array(2)->reg(ra_,this,idx2) );
  
#line 20878 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2872 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Fixup the integer flags in case comparison involved a NaN
    //
    // JNP exit (no unordered comparison, P-flag is set by NaN)
    emit_opcode( cbuf, 0x7B );
    emit_d8    ( cbuf, 0x03 );
    // MOV AH,1 - treat as LT case (set carry flag)
    emit_opcode( cbuf, 0xB4 );
    emit_d8    ( cbuf, 0x01 );
    // SAHF
    emit_opcode( cbuf, 0x9E);
    // NOP     // target for branch to avoid branch to branch
    emit_opcode( cbuf, 0x90);
  
#line 20897 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void cmpF_cc_P6CFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 2512 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );
    emit_d8( cbuf, 0xC0-1+opnd_array(1)->reg(ra_,this,idx1) );   // FLD ST(i-1)
  
#line 20913 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xDF /*primary()*/));
  
#line 20921 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1746 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x05 /*secondary()*/), opnd_array(2)->reg(ra_,this,idx2) );
  
#line 20929 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void cmpF_ccNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 2512 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );
    emit_d8( cbuf, 0xC0-1+opnd_array(1)->reg(ra_,this,idx1) );   // FLD ST(i-1)
  
#line 20945 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD8 /*primary()*/));
  
#line 20953 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1746 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x3 /*secondary()*/), opnd_array(2)->reg(ra_,this,idx2) );
  
#line 20961 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2849 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // fnstsw_ax
    emit_opcode( cbuf, 0xDF);
    emit_opcode( cbuf, 0xE0);
    // test ax,0x0400
    emit_opcode( cbuf, 0x66 );   // operand-size prefix for 16-bit immediate
    emit_opcode( cbuf, 0xA9 );
    emit_d16   ( cbuf, 0x0400 );
    // // // This sequence works, but stalls for 12-16 cycles on PPro
    // // test rax,0x0400
    // emit_opcode( cbuf, 0xA9 );
    // emit_d32   ( cbuf, 0x00000400 );
    //
    // jz exit (no unordered comparison)
    emit_opcode( cbuf, 0x74 );
    emit_d8    ( cbuf, 0x02 );
    // mov ah,1 - treat as LT case (set carry flag)
    emit_opcode( cbuf, 0xB4 );
    emit_d8    ( cbuf, 0x01 );
    // sahf
    emit_opcode( cbuf, 0x9E);
  
#line 20988 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void cmpF_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 2512 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );
    emit_d8( cbuf, 0xC0-1+opnd_array(1)->reg(ra_,this,idx1) );   // FLD ST(i-1)
  
#line 21004 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1586 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9 /*secondary()*/));
  
#line 21012 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xE4 /*primary()*/));
  
#line 21020 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2501 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xDD );
    emit_d8( cbuf, 0xD8 );
  
#line 21029 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2902 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // fnstsw_ax();
    emit_opcode( cbuf, 0xDF);
    emit_opcode( cbuf, 0xE0);
    // sahf
    emit_opcode( cbuf, 0x9E);
    // movl(dst, nan_result);
    emit_opcode( cbuf, 0xB8 + opnd_array(0)->reg(ra_,this));
    emit_d32( cbuf, -1 );
    // jcc(Assembler::parity, exit);
    emit_opcode( cbuf, 0x7A );
    emit_d8    ( cbuf, 0x13 );
    // movl(dst, less_result);
    emit_opcode( cbuf, 0xB8 + opnd_array(0)->reg(ra_,this));
    emit_d32( cbuf, -1 );
    // jcc(Assembler::below, exit);
    emit_opcode( cbuf, 0x72 );
    emit_d8    ( cbuf, 0x0C );
    // movl(dst, equal_result);
    emit_opcode( cbuf, 0xB8 + opnd_array(0)->reg(ra_,this));
    emit_d32( cbuf, 0 );
    // jcc(Assembler::equal, exit);
    emit_opcode( cbuf, 0x74 );
    emit_d8    ( cbuf, 0x05 );
    // movl(dst, greater_result);
    emit_opcode( cbuf, 0xB8 + opnd_array(0)->reg(ra_,this));
    emit_d32( cbuf, 1 );
  
#line 21062 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void cmpF_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 2512 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );
    emit_d8( cbuf, 0xC0-1+opnd_array(1)->reg(ra_,this,idx1) );   // FLD ST(i-1)
  
#line 21078 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD8 /*primary()*/));
  
#line 21086 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1746 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x3 /*secondary()*/), opnd_array(2)->reg(ra_,this,idx2) );
  
#line 21094 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2902 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // fnstsw_ax();
    emit_opcode( cbuf, 0xDF);
    emit_opcode( cbuf, 0xE0);
    // sahf
    emit_opcode( cbuf, 0x9E);
    // movl(dst, nan_result);
    emit_opcode( cbuf, 0xB8 + opnd_array(0)->reg(ra_,this));
    emit_d32( cbuf, -1 );
    // jcc(Assembler::parity, exit);
    emit_opcode( cbuf, 0x7A );
    emit_d8    ( cbuf, 0x13 );
    // movl(dst, less_result);
    emit_opcode( cbuf, 0xB8 + opnd_array(0)->reg(ra_,this));
    emit_d32( cbuf, -1 );
    // jcc(Assembler::below, exit);
    emit_opcode( cbuf, 0x72 );
    emit_d8    ( cbuf, 0x0C );
    // movl(dst, equal_result);
    emit_opcode( cbuf, 0xB8 + opnd_array(0)->reg(ra_,this));
    emit_d32( cbuf, 0 );
    // jcc(Assembler::equal, exit);
    emit_opcode( cbuf, 0x74 );
    emit_d8    ( cbuf, 0x05 );
    // movl(dst, greater_result);
    emit_opcode( cbuf, 0xB8 + opnd_array(0)->reg(ra_,this));
    emit_d32( cbuf, 1 );
  
#line 21127 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void cmpX_ccNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0F /*primary()*/));
  
#line 21142 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1586 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x2F /*secondary()*/));
  
#line 21150 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2095 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1), opnd_array(2)->reg(ra_,this,idx2));
  
#line 21158 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2872 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Fixup the integer flags in case comparison involved a NaN
    //
    // JNP exit (no unordered comparison, P-flag is set by NaN)
    emit_opcode( cbuf, 0x7B );
    emit_d8    ( cbuf, 0x03 );
    // MOV AH,1 - treat as LT case (set carry flag)
    emit_opcode( cbuf, 0xB4 );
    emit_d8    ( cbuf, 0x01 );
    // SAHF
    emit_opcode( cbuf, 0x9E);
    // NOP     // target for branch to avoid branch to branch
    emit_opcode( cbuf, 0x90);
  
#line 21177 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void cmpX_ccCFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0F /*primary()*/));
  
#line 21192 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1586 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x2F /*secondary()*/));
  
#line 21200 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2095 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1), opnd_array(2)->reg(ra_,this,idx2));
  
#line 21208 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void cmpX_ccmemNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0F /*primary()*/));
  
#line 21223 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1586 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x2F /*secondary()*/));
  
#line 21231 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(1)->reg(ra_,this,idx1);
    int base  = opnd_array(2)->base(ra_,this,idx2);
    int index = opnd_array(2)->index(ra_,this,idx2);
    int scale = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2);
    bool disp_is_oop = opnd_array(2)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 21245 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2872 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Fixup the integer flags in case comparison involved a NaN
    //
    // JNP exit (no unordered comparison, P-flag is set by NaN)
    emit_opcode( cbuf, 0x7B );
    emit_d8    ( cbuf, 0x03 );
    // MOV AH,1 - treat as LT case (set carry flag)
    emit_opcode( cbuf, 0xB4 );
    emit_d8    ( cbuf, 0x01 );
    // SAHF
    emit_opcode( cbuf, 0x9E);
    // NOP     // target for branch to avoid branch to branch
    emit_opcode( cbuf, 0x90);
  
#line 21264 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void cmpX_ccmemCFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0F /*primary()*/));
  
#line 21279 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1586 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x2F /*secondary()*/));
  
#line 21287 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(1)->reg(ra_,this,idx1);
    int base  = opnd_array(2)->base(ra_,this,idx2);
    int index = opnd_array(2)->index(ra_,this,idx2);
    int scale = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2);
    bool disp_is_oop = opnd_array(2)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 21301 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void cmpX_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1941 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, 0x33);
    emit_rm(cbuf, 0x3, opnd_array(0)->reg(ra_,this), opnd_array(0)->reg(ra_,this));
  
#line 21317 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0F /*primary()*/));
  
#line 21325 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1586 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x2F /*secondary()*/));
  
#line 21333 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2095 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1), opnd_array(2)->reg(ra_,this,idx2));
  
#line 21341 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2935 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    MacroAssembler _masm(&cbuf);
    Label nan, inc, done;

    __ jccb(Assembler::parity, nan);
    __ jccb(Assembler::equal,  done);
    __ jccb(Assembler::above,  inc);
    __ bind(nan);
    __ decrement(as_Register(opnd_array(0)->reg(ra_,this))); // NO L qqq
    __ jmpb(done);
    __ bind(inc);
    __ increment(as_Register(opnd_array(0)->reg(ra_,this))); // NO L qqq
    __ bind(done);
  
#line 21360 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void cmpX_regmemNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0F /*primary()*/));
  
#line 21375 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1586 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x2F /*secondary()*/));
  
#line 21383 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(1)->reg(ra_,this,idx1);
    int base  = opnd_array(2)->base(ra_,this,idx2);
    int index = opnd_array(2)->index(ra_,this,idx2);
    int scale = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2);
    bool disp_is_oop = opnd_array(2)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 21397 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1978 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Load immediate does not have a zero or sign extended version
    // for 8-bit immediates
    emit_opcode(cbuf, 0xB8 + opnd_array(0)->reg(ra_,this));
    emit_d32(cbuf, (0x0));
  
#line 21408 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2935 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    MacroAssembler _masm(&cbuf);
    Label nan, inc, done;

    __ jccb(Assembler::parity, nan);
    __ jccb(Assembler::equal,  done);
    __ jccb(Assembler::above,  inc);
    __ bind(nan);
    __ decrement(as_Register(opnd_array(0)->reg(ra_,this))); // NO L qqq
    __ jmpb(done);
    __ bind(inc);
    __ increment(as_Register(opnd_array(0)->reg(ra_,this))); // NO L qqq
    __ bind(done);
  
#line 21427 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void subF24_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 2577 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );           // FLD    ST(i-1)
    emit_d8( cbuf, 0xC0-1+opnd_array(1)->reg(ra_,this,idx1) );
  
#line 21443 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2495 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0xD8 /*primary()*/));
    emit_rm(cbuf, 0x3, (0x4 /*secondary()*/), opnd_array(2)->reg(ra_,this,idx2) );
  
#line 21452 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2562 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    store_to_stackslot( cbuf, 0xD9, 0x03, opnd_array(0)->disp(ra_,this,0) );
  
#line 21460 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void subF_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 2577 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );           // FLD    ST(i-1)
    emit_d8( cbuf, 0xC0-1+opnd_array(2)->reg(ra_,this,idx2) );
  
#line 21476 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xDE /*primary()*/));
  
#line 21484 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1746 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x5 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1) );
  
#line 21492 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void addF24_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 2577 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );           // FLD    ST(i-1)
    emit_d8( cbuf, 0xC0-1+opnd_array(2)->reg(ra_,this,idx2) );
  
#line 21508 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2495 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0xD8 /*primary()*/));
    emit_rm(cbuf, 0x3, (0x0 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1) );
  
#line 21517 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2562 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    store_to_stackslot( cbuf, 0xD9, 0x03, opnd_array(0)->disp(ra_,this,0) );
  
#line 21525 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void addF_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 2577 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );           // FLD    ST(i-1)
    emit_d8( cbuf, 0xC0-1+opnd_array(2)->reg(ra_,this,idx2) );
  
#line 21541 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xDE /*primary()*/));
  
#line 21549 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1746 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x0 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1) );
  
#line 21557 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void addX_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xF3));
  
#line 21572 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0F));
  
#line 21580 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x58));
  
#line 21588 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2095 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1), opnd_array(2)->reg(ra_,this,idx2));
  
#line 21596 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void addX_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {
    MacroAssembler _masm(&cbuf);

#line 11238 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ addss(opnd_array(1)->as_XMMRegister(ra_,this,idx1), InternalAddress(__ code()->consts()->start() + constant_offset()));
  
#line 21612 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void addX_immNode::eval_constant(Compile* C) {
  {

#line 11239 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
    _constant = C->constant_table().add(opnd_array(2));
#line 21620 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void addX_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xF3));
  
#line 21635 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0F));
  
#line 21643 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x58));
  
#line 21651 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(1)->reg(ra_,this,idx1);
    int base  = opnd_array(2)->base(ra_,this,idx2);
    int index = opnd_array(2)->index(ra_,this,idx2);
    int scale = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2);
    bool disp_is_oop = opnd_array(2)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 21665 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void addX_mem_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xF3));
  
#line 21680 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0F));
  
#line 21688 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x58));
  
#line 21696 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(2)->reg(ra_,this,idx2);
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 21710 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void subX_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xF3));
  
#line 21725 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0F));
  
#line 21733 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x5C));
  
#line 21741 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2095 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1), opnd_array(2)->reg(ra_,this,idx2));
  
#line 21749 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void subX_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {
    MacroAssembler _masm(&cbuf);

#line 11265 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ subss(opnd_array(1)->as_XMMRegister(ra_,this,idx1), InternalAddress(__ code()->consts()->start() + constant_offset()));
  
#line 21765 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void subX_immNode::eval_constant(Compile* C) {
  {

#line 11266 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
    _constant = C->constant_table().add(opnd_array(2));
#line 21773 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void subX_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xF3));
  
#line 21788 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0F));
  
#line 21796 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x5C));
  
#line 21804 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(1)->reg(ra_,this,idx1);
    int base  = opnd_array(2)->base(ra_,this,idx2);
    int index = opnd_array(2)->index(ra_,this,idx2);
    int scale = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2);
    bool disp_is_oop = opnd_array(2)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 21818 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void mulX_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xF3));
  
#line 21833 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0F));
  
#line 21841 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x59));
  
#line 21849 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2095 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1), opnd_array(2)->reg(ra_,this,idx2));
  
#line 21857 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void mulX_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {
    MacroAssembler _masm(&cbuf);

#line 11292 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ mulss(opnd_array(1)->as_XMMRegister(ra_,this,idx1), InternalAddress(__ code()->consts()->start() + constant_offset()));
  
#line 21873 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void mulX_immNode::eval_constant(Compile* C) {
  {

#line 11293 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
    _constant = C->constant_table().add(opnd_array(2));
#line 21881 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void mulX_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xF3));
  
#line 21896 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0F));
  
#line 21904 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x59));
  
#line 21912 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(1)->reg(ra_,this,idx1);
    int base  = opnd_array(2)->base(ra_,this,idx2);
    int index = opnd_array(2)->index(ra_,this,idx2);
    int scale = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2);
    bool disp_is_oop = opnd_array(2)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 21926 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void mulX_mem_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xF3));
  
#line 21941 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0F));
  
#line 21949 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x59));
  
#line 21957 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(2)->reg(ra_,this,idx2);
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 21971 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void divX_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xF3));
  
#line 21986 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0F));
  
#line 21994 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x5E));
  
#line 22002 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2095 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1), opnd_array(2)->reg(ra_,this,idx2));
  
#line 22010 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void divX_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {
    MacroAssembler _masm(&cbuf);

#line 11319 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ divss(opnd_array(1)->as_XMMRegister(ra_,this,idx1), InternalAddress(__ code()->consts()->start() + constant_offset()));
  
#line 22026 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void divX_immNode::eval_constant(Compile* C) {
  {

#line 11320 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
    _constant = C->constant_table().add(opnd_array(2));
#line 22034 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void divX_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xF3));
  
#line 22049 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0F));
  
#line 22057 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x5E));
  
#line 22065 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(1)->reg(ra_,this,idx1);
    int base  = opnd_array(2)->base(ra_,this,idx2);
    int index = opnd_array(2)->index(ra_,this,idx2);
    int scale = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2);
    bool disp_is_oop = opnd_array(2)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 22079 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void sqrtX_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xF3));
  
#line 22093 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0F));
  
#line 22101 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x51));
  
#line 22109 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2095 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(0)->reg(ra_,this), opnd_array(1)->reg(ra_,this,idx1));
  
#line 22117 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void sqrtX_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xF3));
  
#line 22131 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0F));
  
#line 22139 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x51));
  
#line 22147 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(0)->reg(ra_,this);
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 22161 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void sqrtXD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xF2));
  
#line 22175 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0F));
  
#line 22183 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x51));
  
#line 22191 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2095 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(0)->reg(ra_,this), opnd_array(1)->reg(ra_,this,idx1));
  
#line 22199 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void sqrtXD_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xF2));
  
#line 22213 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0F));
  
#line 22221 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x51));
  
#line 22229 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(0)->reg(ra_,this);
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 22243 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void absF_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 1586 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9 /*secondary()*/));
  
#line 22257 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xE1 /*primary()*/));
  
#line 22265 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void absX_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 4081 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    address signmask_address=(address)float_signmask_pool;
    // andpd:\tANDPS  $dst,[signconst]
    emit_opcode(cbuf, 0x0F);
    emit_opcode(cbuf, 0x54);
    emit_rm(cbuf, 0x0, opnd_array(1)->reg(ra_,this,idx1), 0x5);
    emit_d32(cbuf, (int)signmask_address);
  
#line 22284 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void negF_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 1586 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9 /*secondary()*/));
  
#line 22298 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xE0 /*primary()*/));
  
#line 22306 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void negX_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 4100 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    address signmask_address=(address)float_signflip_pool;
    // andpd:\tXORPS  $dst,[signconst]
    emit_opcode(cbuf, 0x0F);
    emit_opcode(cbuf, 0x57);
    emit_rm(cbuf, 0x0, opnd_array(1)->reg(ra_,this,idx1), 0x5);
    emit_d32(cbuf, (int)signmask_address);
  
#line 22325 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void addF24_reg_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9 /*tertiary()*/));
  
#line 22340 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2302 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(2)->base(ra_,this,idx2);
    int index    = opnd_array(2)->index(ra_,this,idx2);
    int scale    = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2);
    bool disp_is_oop = opnd_array(2)->disp_is_oop(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_is_oop);
  
#line 22354 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2495 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0xD8 /*primary()*/));
    emit_rm(cbuf, 0x3, (0x0 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1) );
  
#line 22363 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2562 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    store_to_stackslot( cbuf, 0xD9, 0x03, opnd_array(0)->disp(ra_,this,0) );
  
#line 22371 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void addF24_reg_mem_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9 /*tertiary()*/));
  
#line 22386 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2302 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_is_oop);
  
#line 22400 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2495 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0xD8 /*primary()*/));
    emit_rm(cbuf, 0x3, (0x0 /*secondary()*/), opnd_array(2)->reg(ra_,this,idx2) );
  
#line 22409 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2562 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    store_to_stackslot( cbuf, 0xD9, 0x03, opnd_array(0)->disp(ra_,this,0) );
  
#line 22417 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void addF_reg_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9 /*tertiary()*/));
  
#line 22432 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2302 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(2)->base(ra_,this,idx2);
    int index    = opnd_array(2)->index(ra_,this,idx2);
    int scale    = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2);
    bool disp_is_oop = opnd_array(2)->disp_is_oop(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_is_oop);
  
#line 22446 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xDE /*primary()*/));
  
#line 22454 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1746 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x0 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1) );
  
#line 22462 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void addF_reg_mem_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9 /*tertiary()*/));
  
#line 22477 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2302 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_is_oop);
  
#line 22491 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xDE /*primary()*/));
  
#line 22499 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1746 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x0 /*secondary()*/), opnd_array(2)->reg(ra_,this,idx2) );
  
#line 22507 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void addF24_mem_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9 /*tertiary()*/));
  
#line 22522 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2302 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_is_oop);
  
#line 22536 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2495 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0xD8 /*primary()*/));
    emit_rm(cbuf, 0x3, (0x0 /*secondary()*/), opnd_array(2)->reg(ra_,this,idx2) );
  
#line 22545 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2562 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    store_to_stackslot( cbuf, 0xD9, 0x03, opnd_array(0)->disp(ra_,this,0) );
  
#line 22553 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void addF24_mem_ciscNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9 /*tertiary()*/));
  
#line 22568 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2302 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(2)->base(ra_,this,idx2);
    int index    = opnd_array(2)->index(ra_,this,idx2);
    int scale    = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2);
    bool disp_is_oop = opnd_array(2)->disp_is_oop(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_is_oop);
  
#line 22582 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2208 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    cbuf.set_insts_mark();            // Mark start of opcode for reloc info in mem operand
  
#line 22590 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD8 /*primary()*/));
  
#line 22598 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2302 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x0 /*secondary()*/);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_is_oop);
  
#line 22612 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2562 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    store_to_stackslot( cbuf, 0xD9, 0x03, opnd_array(0)->disp(ra_,this,0) );
  
#line 22620 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void addF24_mem_cisc_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9 /*tertiary()*/));
  
#line 22635 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2302 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_is_oop);
  
#line 22649 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2208 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    cbuf.set_insts_mark();            // Mark start of opcode for reloc info in mem operand
  
#line 22657 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD8 /*primary()*/));
  
#line 22665 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2302 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x0 /*secondary()*/);
    int base     = opnd_array(2)->base(ra_,this,idx2);
    int index    = opnd_array(2)->index(ra_,this,idx2);
    int scale    = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2);
    bool disp_is_oop = opnd_array(2)->disp_is_oop(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_is_oop);
  
#line 22679 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2562 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    store_to_stackslot( cbuf, 0xD9, 0x03, opnd_array(0)->disp(ra_,this,0) );
  
#line 22687 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void addF24_mem_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9 /*tertiary()*/));
  
#line 22702 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2302 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(2)->base(ra_,this,idx2);
    int index    = opnd_array(2)->index(ra_,this,idx2);
    int scale    = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2);
    bool disp_is_oop = opnd_array(2)->disp_is_oop(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_is_oop);
  
#line 22716 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2208 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    cbuf.set_insts_mark();            // Mark start of opcode for reloc info in mem operand
  
#line 22724 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD8 /*primary()*/));
  
#line 22732 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2302 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x0 /*secondary()*/);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_is_oop);
  
#line 22746 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2562 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    store_to_stackslot( cbuf, 0xD9, 0x03, opnd_array(0)->disp(ra_,this,0) );
  
#line 22754 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void addF24_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {
    MacroAssembler _masm(&cbuf);

#line 11483 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ fld_s(opnd_array(1)->reg(ra_,this,idx1)- 1);  // FLD ST(i-1)
    __ fadd_s(InternalAddress(__ code()->consts()->start() + constant_offset()));
    __ fstp_s(Address(rsp, opnd_array(0)->disp(ra_,this,0)));
  
#line 22772 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void addF24_reg_immNode::eval_constant(Compile* C) {
  {

#line 11485 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
    _constant = C->constant_table().add(opnd_array(2));
#line 22780 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void addF_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {
    MacroAssembler _masm(&cbuf);

#line 11498 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ fld_s(opnd_array(1)->reg(ra_,this,idx1)- 1);  // FLD ST(i-1)
    __ fadd_s(InternalAddress(__ code()->consts()->start() + constant_offset()));
    __ fstp_d(opnd_array(0)->reg(ra_,this));
  
#line 22798 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void addF_reg_immNode::eval_constant(Compile* C) {
  {

#line 11500 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
    _constant = C->constant_table().add(opnd_array(2));
#line 22806 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void mulF24_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 2577 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );           // FLD    ST(i-1)
    emit_d8( cbuf, 0xC0-1+opnd_array(1)->reg(ra_,this,idx1) );
  
#line 22822 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2495 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0xD8 /*primary()*/));
    emit_rm(cbuf, 0x3, (0x1 /*secondary()*/), opnd_array(2)->reg(ra_,this,idx2) );
  
#line 22831 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2562 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    store_to_stackslot( cbuf, 0xD9, 0x03, opnd_array(0)->disp(ra_,this,0) );
  
#line 22839 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void mulF_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 2577 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );           // FLD    ST(i-1)
    emit_d8( cbuf, 0xC0-1+opnd_array(2)->reg(ra_,this,idx2) );
  
#line 22855 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2495 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0xD8 /*primary()*/));
    emit_rm(cbuf, 0x3, (0x1 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1) );
  
#line 22864 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2572 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xDD );           // FSTP   ST(i)
    emit_d8( cbuf, 0xD8+opnd_array(0)->reg(ra_,this) );
  
#line 22873 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void mulF24_reg_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9 /*tertiary()*/));
  
#line 22888 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2302 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(2)->base(ra_,this,idx2);
    int index    = opnd_array(2)->index(ra_,this,idx2);
    int scale    = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2);
    bool disp_is_oop = opnd_array(2)->disp_is_oop(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_is_oop);
  
#line 22902 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2495 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0xD8 /*primary()*/));
    emit_rm(cbuf, 0x3, (0x1 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1) );
  
#line 22911 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2562 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    store_to_stackslot( cbuf, 0xD9, 0x03, opnd_array(0)->disp(ra_,this,0) );
  
#line 22919 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void mulF24_reg_mem_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9 /*tertiary()*/));
  
#line 22934 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2302 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_is_oop);
  
#line 22948 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2495 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0xD8 /*primary()*/));
    emit_rm(cbuf, 0x3, (0x1 /*secondary()*/), opnd_array(2)->reg(ra_,this,idx2) );
  
#line 22957 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2562 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    store_to_stackslot( cbuf, 0xD9, 0x03, opnd_array(0)->disp(ra_,this,0) );
  
#line 22965 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void mulF_reg_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9 /*tertiary()*/));
  
#line 22980 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2302 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(2)->base(ra_,this,idx2);
    int index    = opnd_array(2)->index(ra_,this,idx2);
    int scale    = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2);
    bool disp_is_oop = opnd_array(2)->disp_is_oop(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_is_oop);
  
#line 22994 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2495 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0xD8 /*primary()*/));
    emit_rm(cbuf, 0x3, (0x1 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1) );
  
#line 23003 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2572 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xDD );           // FSTP   ST(i)
    emit_d8( cbuf, 0xD8+opnd_array(0)->reg(ra_,this) );
  
#line 23012 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void mulF_reg_mem_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9 /*tertiary()*/));
  
#line 23027 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2302 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_is_oop);
  
#line 23041 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2495 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0xD8 /*primary()*/));
    emit_rm(cbuf, 0x3, (0x1 /*secondary()*/), opnd_array(2)->reg(ra_,this,idx2) );
  
#line 23050 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2572 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xDD );           // FSTP   ST(i)
    emit_d8( cbuf, 0xD8+opnd_array(0)->reg(ra_,this) );
  
#line 23059 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void mulF24_mem_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9 /*tertiary()*/));
  
#line 23074 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2302 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(2)->base(ra_,this,idx2);
    int index    = opnd_array(2)->index(ra_,this,idx2);
    int scale    = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2);
    bool disp_is_oop = opnd_array(2)->disp_is_oop(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_is_oop);
  
#line 23088 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2208 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    cbuf.set_insts_mark();            // Mark start of opcode for reloc info in mem operand
  
#line 23096 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD8 /*primary()*/));
  
#line 23104 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2302 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x1 /*secondary()*/);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_is_oop);
  
#line 23118 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2562 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    store_to_stackslot( cbuf, 0xD9, 0x03, opnd_array(0)->disp(ra_,this,0) );
  
#line 23126 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void mulF24_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {
    MacroAssembler _masm(&cbuf);

#line 11589 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ fld_s(opnd_array(1)->reg(ra_,this,idx1)- 1);  // FLD ST(i-1)
    __ fmul_s(InternalAddress(__ code()->consts()->start() + constant_offset()));
    __ fstp_s(Address(rsp, opnd_array(0)->disp(ra_,this,0)));
  
#line 23144 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void mulF24_reg_immNode::eval_constant(Compile* C) {
  {

#line 11591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
    _constant = C->constant_table().add(opnd_array(2));
#line 23152 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void mulF_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {
    MacroAssembler _masm(&cbuf);

#line 11605 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ fld_s(opnd_array(1)->reg(ra_,this,idx1)- 1);  // FLD ST(i-1)
    __ fmul_s(InternalAddress(__ code()->consts()->start() + constant_offset()));
    __ fstp_d(opnd_array(0)->reg(ra_,this));
  
#line 23170 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void mulF_reg_immNode::eval_constant(Compile* C) {
  {

#line 11607 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
    _constant = C->constant_table().add(opnd_array(2));
#line 23178 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void mulF_reg_load1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9 /*tertiary()*/));
  
#line 23193 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2302 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_is_oop);
  
#line 23207 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2495 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0xD8 /*primary()*/));
    emit_rm(cbuf, 0x3, (0x1 /*secondary()*/), opnd_array(2)->reg(ra_,this,idx2) );
  
#line 23216 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2572 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xDD );           // FSTP   ST(i)
    emit_d8( cbuf, 0xD8+opnd_array(0)->reg(ra_,this) );
  
#line 23225 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void mulF_reg_load1_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9 /*tertiary()*/));
  
#line 23240 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2302 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(2)->base(ra_,this,idx2);
    int index    = opnd_array(2)->index(ra_,this,idx2);
    int scale    = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2);
    bool disp_is_oop = opnd_array(2)->disp_is_oop(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_is_oop);
  
#line 23254 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2495 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0xD8 /*primary()*/));
    emit_rm(cbuf, 0x3, (0x1 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1) );
  
#line 23263 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2572 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xDD );           // FSTP   ST(i)
    emit_d8( cbuf, 0xD8+opnd_array(0)->reg(ra_,this) );
  
#line 23272 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void addF_mulF_reg_load1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9 /*primary()*/));
  
#line 23288 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2302 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_is_oop);
  
#line 23302 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 4119 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Operand was loaded from memory into fp ST (stack top)
    // FMUL   ST,$src  /* D8 C8+i */
    emit_opcode(cbuf, 0xD8);
    emit_opcode(cbuf, 0xC8 + opnd_array(2)->reg(ra_,this,idx2));
  
#line 23313 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 4126 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // FADDP  ST,src2  /* D8 C0+i */
    emit_opcode(cbuf, 0xD8);
    emit_opcode(cbuf, 0xC0 + opnd_array(3)->reg(ra_,this,idx3));
    //could use FADDP  src2,fpST  /* DE C0+i */
  
#line 23324 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2572 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xDD );           // FSTP   ST(i)
    emit_d8( cbuf, 0xD8+opnd_array(0)->reg(ra_,this) );
  
#line 23333 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void addF_mulF_reg_load1_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9 /*primary()*/));
  
#line 23349 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2302 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(2)->base(ra_,this,idx2);
    int index    = opnd_array(2)->index(ra_,this,idx2);
    int scale    = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2);
    bool disp_is_oop = opnd_array(2)->disp_is_oop(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_is_oop);
  
#line 23363 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 4119 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Operand was loaded from memory into fp ST (stack top)
    // FMUL   ST,$src  /* D8 C8+i */
    emit_opcode(cbuf, 0xD8);
    emit_opcode(cbuf, 0xC8 + opnd_array(3)->reg(ra_,this,idx3));
  
#line 23374 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 4126 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // FADDP  ST,src2  /* D8 C0+i */
    emit_opcode(cbuf, 0xD8);
    emit_opcode(cbuf, 0xC0 + opnd_array(1)->reg(ra_,this,idx1));
    //could use FADDP  src2,fpST  /* DE C0+i */
  
#line 23385 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2572 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xDD );           // FSTP   ST(i)
    emit_d8( cbuf, 0xD8+opnd_array(0)->reg(ra_,this) );
  
#line 23394 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void addF_mulF_reg_load1_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9 /*primary()*/));
  
#line 23410 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2302 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(2)->base(ra_,this,idx2);
    int index    = opnd_array(2)->index(ra_,this,idx2);
    int scale    = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2);
    bool disp_is_oop = opnd_array(2)->disp_is_oop(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_is_oop);
  
#line 23424 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 4119 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Operand was loaded from memory into fp ST (stack top)
    // FMUL   ST,$src  /* D8 C8+i */
    emit_opcode(cbuf, 0xD8);
    emit_opcode(cbuf, 0xC8 + opnd_array(1)->reg(ra_,this,idx1));
  
#line 23435 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 4126 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // FADDP  ST,src2  /* D8 C0+i */
    emit_opcode(cbuf, 0xD8);
    emit_opcode(cbuf, 0xC0 + opnd_array(3)->reg(ra_,this,idx3));
    //could use FADDP  src2,fpST  /* DE C0+i */
  
#line 23446 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2572 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xDD );           // FSTP   ST(i)
    emit_d8( cbuf, 0xD8+opnd_array(0)->reg(ra_,this) );
  
#line 23455 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void addF_mulF_reg_load1_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9 /*primary()*/));
  
#line 23471 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2302 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(3)->base(ra_,this,idx3);
    int index    = opnd_array(3)->index(ra_,this,idx3);
    int scale    = opnd_array(3)->scale();
    int displace = opnd_array(3)->disp(ra_,this,idx3);
    bool disp_is_oop = opnd_array(3)->disp_is_oop(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_is_oop);
  
#line 23485 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 4119 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Operand was loaded from memory into fp ST (stack top)
    // FMUL   ST,$src  /* D8 C8+i */
    emit_opcode(cbuf, 0xD8);
    emit_opcode(cbuf, 0xC8 + opnd_array(2)->reg(ra_,this,idx2));
  
#line 23496 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 4126 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // FADDP  ST,src2  /* D8 C0+i */
    emit_opcode(cbuf, 0xD8);
    emit_opcode(cbuf, 0xC0 + opnd_array(1)->reg(ra_,this,idx1));
    //could use FADDP  src2,fpST  /* DE C0+i */
  
#line 23507 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2572 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xDD );           // FSTP   ST(i)
    emit_d8( cbuf, 0xD8+opnd_array(0)->reg(ra_,this) );
  
#line 23516 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void addF_mulF_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
  {

#line 2577 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );           // FLD    ST(i-1)
    emit_d8( cbuf, 0xC0-1+opnd_array(1)->reg(ra_,this,idx1) );
  
#line 23533 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 4119 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Operand was loaded from memory into fp ST (stack top)
    // FMUL   ST,$src  /* D8 C8+i */
    emit_opcode(cbuf, 0xD8);
    emit_opcode(cbuf, 0xC8 + opnd_array(2)->reg(ra_,this,idx2));
  
#line 23544 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 4133 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // FADDP  src2,ST  /* DE C0+i */
    emit_opcode(cbuf, 0xDE);
    emit_opcode(cbuf, 0xC0 + opnd_array(3)->reg(ra_,this,idx3));
  
#line 23554 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void addF_mulF_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
  {

#line 2577 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );           // FLD    ST(i-1)
    emit_d8( cbuf, 0xC0-1+opnd_array(2)->reg(ra_,this,idx2) );
  
#line 23571 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 4119 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Operand was loaded from memory into fp ST (stack top)
    // FMUL   ST,$src  /* D8 C8+i */
    emit_opcode(cbuf, 0xD8);
    emit_opcode(cbuf, 0xC8 + opnd_array(3)->reg(ra_,this,idx3));
  
#line 23582 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 4133 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // FADDP  src2,ST  /* DE C0+i */
    emit_opcode(cbuf, 0xDE);
    emit_opcode(cbuf, 0xC0 + opnd_array(1)->reg(ra_,this,idx1));
  
#line 23592 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void subF_divF_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
  {

#line 2577 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );           // FLD    ST(i-1)
    emit_d8( cbuf, 0xC0-1+opnd_array(1)->reg(ra_,this,idx1) );
  
#line 23609 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 4139 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Operand has been loaded into fp ST (stack top)
      // FSUB   ST,$src1
      emit_opcode(cbuf, 0xD8);
      emit_opcode(cbuf, 0xE0 + opnd_array(2)->reg(ra_,this,idx2));

      // FDIV
      emit_opcode(cbuf, 0xD8);
      emit_opcode(cbuf, 0xF0 + opnd_array(3)->reg(ra_,this,idx3));
  
#line 23624 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2572 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xDD );           // FSTP   ST(i)
    emit_d8( cbuf, 0xD8+opnd_array(0)->reg(ra_,this) );
  
#line 23633 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void divF24_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 2577 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );           // FLD    ST(i-1)
    emit_d8( cbuf, 0xC0-1+opnd_array(1)->reg(ra_,this,idx1) );
  
#line 23649 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2495 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0xD8 /*primary()*/));
    emit_rm(cbuf, 0x3, (0x6 /*secondary()*/), opnd_array(2)->reg(ra_,this,idx2) );
  
#line 23658 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2562 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    store_to_stackslot( cbuf, 0xD9, 0x03, opnd_array(0)->disp(ra_,this,0) );
  
#line 23666 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void divF_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 2577 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );           // FLD    ST(i-1)
    emit_d8( cbuf, 0xC0-1+opnd_array(2)->reg(ra_,this,idx2) );
  
#line 23682 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xDE /*primary()*/));
  
#line 23690 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1746 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x7 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1) );
  
#line 23698 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void modF24_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 2626 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // load dst in FPR0
    emit_opcode( cbuf, 0xD9 );
    emit_d8( cbuf, 0xC0-1+opnd_array(1)->reg(ra_,this,idx1) );
    if (opnd_array(2)->reg(ra_,this,idx2) != FPR1L_enc) {
      // fincstp
      emit_opcode (cbuf, 0xD9);
      emit_opcode (cbuf, 0xF7);
      // swap src with FPR1:
      // FXCH FPR1 with src
      emit_opcode(cbuf, 0xD9);
      emit_d8(cbuf, 0xC8-1+opnd_array(2)->reg(ra_,this,idx2) );
      // fdecstp
      emit_opcode (cbuf, 0xD9);
      emit_opcode (cbuf, 0xF6);
    }
  
#line 23727 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2827 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // fprem must be iterative
    // :: loop
    // fprem
    emit_opcode( cbuf, 0xD9 );
    emit_opcode( cbuf, 0xF8 );
    // wait
    emit_opcode( cbuf, 0x9b );
    // fnstsw ax
    emit_opcode( cbuf, 0xDF );
    emit_opcode( cbuf, 0xE0 );
    // sahf
    emit_opcode( cbuf, 0x9E );
    // jp  ::loop
    emit_opcode( cbuf, 0x0F );
    emit_opcode( cbuf, 0x8A );
    emit_opcode( cbuf, 0xF4 );
    emit_opcode( cbuf, 0xFF );
    emit_opcode( cbuf, 0xFF );
    emit_opcode( cbuf, 0xFF );
  
#line 23753 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2798 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    if (opnd_array(2)->reg(ra_,this,idx2) != FPR1L_enc) {
      // fincstp
      emit_opcode (cbuf, 0xD9);
      emit_opcode (cbuf, 0xF7);
      // FXCH FPR1 with src
      emit_opcode(cbuf, 0xD9);
      emit_d8(cbuf, 0xC8-1+opnd_array(2)->reg(ra_,this,idx2) );
      // fdecstp
      emit_opcode (cbuf, 0xD9);
      emit_opcode (cbuf, 0xF6);
    }
    // // following asm replaced with Pop_Reg_F or Pop_Mem_F
    // // FSTP   FPR$dst$$reg
    // emit_opcode( cbuf, 0xDD );
    // emit_d8( cbuf, 0xD8+$dst$$reg );
  
#line 23775 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2562 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    store_to_stackslot( cbuf, 0xD9, 0x03, opnd_array(0)->disp(ra_,this,0) );
  
#line 23783 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void modF_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 2626 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // load dst in FPR0
    emit_opcode( cbuf, 0xD9 );
    emit_d8( cbuf, 0xC0-1+opnd_array(1)->reg(ra_,this,idx1) );
    if (opnd_array(2)->reg(ra_,this,idx2) != FPR1L_enc) {
      // fincstp
      emit_opcode (cbuf, 0xD9);
      emit_opcode (cbuf, 0xF7);
      // swap src with FPR1:
      // FXCH FPR1 with src
      emit_opcode(cbuf, 0xD9);
      emit_d8(cbuf, 0xC8-1+opnd_array(2)->reg(ra_,this,idx2) );
      // fdecstp
      emit_opcode (cbuf, 0xD9);
      emit_opcode (cbuf, 0xF6);
    }
  
#line 23812 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2827 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // fprem must be iterative
    // :: loop
    // fprem
    emit_opcode( cbuf, 0xD9 );
    emit_opcode( cbuf, 0xF8 );
    // wait
    emit_opcode( cbuf, 0x9b );
    // fnstsw ax
    emit_opcode( cbuf, 0xDF );
    emit_opcode( cbuf, 0xE0 );
    // sahf
    emit_opcode( cbuf, 0x9E );
    // jp  ::loop
    emit_opcode( cbuf, 0x0F );
    emit_opcode( cbuf, 0x8A );
    emit_opcode( cbuf, 0xF4 );
    emit_opcode( cbuf, 0xFF );
    emit_opcode( cbuf, 0xFF );
    emit_opcode( cbuf, 0xFF );
  
#line 23838 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2798 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    if (opnd_array(2)->reg(ra_,this,idx2) != FPR1L_enc) {
      // fincstp
      emit_opcode (cbuf, 0xD9);
      emit_opcode (cbuf, 0xF7);
      // FXCH FPR1 with src
      emit_opcode(cbuf, 0xD9);
      emit_d8(cbuf, 0xC8-1+opnd_array(2)->reg(ra_,this,idx2) );
      // fdecstp
      emit_opcode (cbuf, 0xD9);
      emit_opcode (cbuf, 0xF6);
    }
    // // following asm replaced with Pop_Reg_F or Pop_Mem_F
    // // FSTP   FPR$dst$$reg
    // emit_opcode( cbuf, 0xDD );
    // emit_d8( cbuf, 0xD8+$dst$$reg );
  
#line 23860 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2572 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xDD );           // FSTP   ST(i)
    emit_d8( cbuf, 0xD8+opnd_array(1)->reg(ra_,this,idx1) );
  
#line 23869 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void modX_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 2668 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Allocate a word
    emit_opcode(cbuf,0x83);            // SUB ESP,4
    emit_opcode(cbuf,0xEC);
    emit_d8(cbuf,0x04);

    emit_opcode  (cbuf, 0xF3 );     // MOVSS [ESP], src1
    emit_opcode  (cbuf, 0x0F );
    emit_opcode  (cbuf, 0x11 );
    encode_RegMem(cbuf, opnd_array(2)->reg(ra_,this,idx2), ESP_enc, 0x4, 0, 0, false);

    emit_opcode(cbuf,0xD9 );      // FLD [ESP]
    encode_RegMem(cbuf, 0x0, ESP_enc, 0x4, 0, 0, false);

    emit_opcode  (cbuf, 0xF3 );     // MOVSS [ESP], src0
    emit_opcode  (cbuf, 0x0F );
    emit_opcode  (cbuf, 0x11 );
    encode_RegMem(cbuf, opnd_array(1)->reg(ra_,this,idx1), ESP_enc, 0x4, 0, 0, false);

    emit_opcode(cbuf,0xD9 );      // FLD [ESP]
    encode_RegMem(cbuf, 0x0, ESP_enc, 0x4, 0, 0, false);

  
#line 23904 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2827 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // fprem must be iterative
    // :: loop
    // fprem
    emit_opcode( cbuf, 0xD9 );
    emit_opcode( cbuf, 0xF8 );
    // wait
    emit_opcode( cbuf, 0x9b );
    // fnstsw ax
    emit_opcode( cbuf, 0xDF );
    emit_opcode( cbuf, 0xE0 );
    // sahf
    emit_opcode( cbuf, 0x9E );
    // jp  ::loop
    emit_opcode( cbuf, 0x0F );
    emit_opcode( cbuf, 0x8A );
    emit_opcode( cbuf, 0xF4 );
    emit_opcode( cbuf, 0xFF );
    emit_opcode( cbuf, 0xFF );
    emit_opcode( cbuf, 0xFF );
  
#line 23930 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2706 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    store_to_stackslot( cbuf, 0xD9, 0x03, 0 ); //FSTP_S [ESP]

    emit_opcode  (cbuf, 0xF3 );     // MOVSS dst(xmm), [ESP]
    emit_opcode  (cbuf, 0x0F );
    emit_opcode  (cbuf, 0x10 );
    encode_RegMem(cbuf, opnd_array(0)->reg(ra_,this), ESP_enc, 0x4, 0, 0, false);

    emit_opcode(cbuf,0x83);    // ADD ESP,d8 (4 or 8)
    emit_opcode(cbuf,0xC4);
    emit_d8(cbuf,(0x4));
  
#line 23947 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2501 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xDD );
    emit_d8( cbuf, 0xD8 );
  
#line 23956 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void roundFloat_mem_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 2583 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int pop = 0x02;
    if (opnd_array(1)->reg(ra_,this,idx1) != FPR1L_enc) {
      emit_opcode( cbuf, 0xD9 );         // FLD    ST(i-1)
      emit_d8( cbuf, 0xC0-1+opnd_array(1)->reg(ra_,this,idx1) );
      pop = 0x03;
    }
    store_to_stackslot( cbuf, 0xD9, pop, opnd_array(0)->disp(ra_,this,0) ); // FST<P>_S  [ESP+dst]
  
#line 23976 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void roundDouble_mem_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 2594 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int pop = 0x02;
    if (opnd_array(1)->reg(ra_,this,idx1) != FPR1L_enc) {
      emit_opcode( cbuf, 0xD9 );         // FLD    ST(i-1)
      emit_d8( cbuf, 0xC0-1+opnd_array(1)->reg(ra_,this,idx1) );
      pop = 0x03;
    }
    store_to_stackslot( cbuf, 0xDD, pop, opnd_array(0)->disp(ra_,this,0) ); // FST<P>_D  [ESP+dst]
  
#line 23996 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void convD2X_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 3999 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Allocate a word
    emit_opcode(cbuf,0x83);            // SUB ESP,4
    emit_opcode(cbuf,0xEC);
    emit_d8(cbuf,0x04);
    int pop = 0x02;
    if (opnd_array(1)->reg(ra_,this,idx1) != FPR1L_enc) {
      emit_opcode( cbuf, 0xD9 );       // FLD    ST(i-1)
      emit_d8( cbuf, 0xC0-1+opnd_array(1)->reg(ra_,this,idx1) );
      pop = 0x03;
    }
    store_to_stackslot( cbuf, 0xD9, pop, 0 ); // FST<P>_S  [ESP]

    emit_opcode  (cbuf, 0xF3 );        // MOVSS dst(xmm), [ESP]
    emit_opcode  (cbuf, 0x0F );
    emit_opcode  (cbuf, 0x10 );
    encode_RegMem(cbuf, opnd_array(0)->reg(ra_,this), ESP_enc, 0x4, 0, 0, false);

    emit_opcode(cbuf,0x83);            // ADD ESP,4
    emit_opcode(cbuf,0xC4);
    emit_d8(cbuf,0x04);
    // Carry on here...
  
#line 24030 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void convXD2X_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xF2 /*primary()*/));
  
#line 24044 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1586 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0F /*secondary()*/));
  
#line 24052 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x5A /*tertiary()*/));
  
#line 24060 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2095 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(0)->reg(ra_,this), opnd_array(1)->reg(ra_,this,idx1));
  
#line 24068 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void convF2D_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 2605 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int pop = 0xD0 - 1; // -1 since we skip FLD
    if (opnd_array(1)->reg(ra_,this,idx1) != FPR1L_enc) {
      emit_opcode( cbuf, 0xD9 );         // FLD    ST(src-1)
      emit_d8( cbuf, 0xC0-1+opnd_array(1)->reg(ra_,this,idx1) );
      pop = 0xD8;
    }
    emit_opcode( cbuf, 0xDD );
    emit_d8( cbuf, pop+opnd_array(0)->reg(ra_,this) );      // FST<P> ST(i)
  
#line 24089 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void convX2D_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 4060 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Allocate a word
    emit_opcode(cbuf,0x83);     // SUB ESP,4
    emit_opcode(cbuf,0xEC);
    emit_d8(cbuf,0x04);

    emit_opcode  (cbuf, 0xF3 ); // MOVSS [ESP], xmm
    emit_opcode  (cbuf, 0x0F );
    emit_opcode  (cbuf, 0x11 );
    encode_RegMem(cbuf, opnd_array(1)->reg(ra_,this,idx1), ESP_enc, 0x4, 0, 0, false);

    emit_opcode(cbuf,0xD9 );    // FLD_S [ESP]
    encode_RegMem(cbuf, 0x0, ESP_enc, 0x4, 0, 0, false);

    emit_opcode(cbuf,0x83);     // ADD ESP,4
    emit_opcode(cbuf,0xC4);
    emit_d8(cbuf,0x04);

    // Carry on here...
  
#line 24120 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2507 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xDD );           // FSTP   ST(i)
    emit_d8( cbuf, 0xD8+opnd_array(0)->reg(ra_,this) );
  
#line 24129 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void convX2XD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xF3 /*primary()*/));
  
#line 24143 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1586 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0F /*secondary()*/));
  
#line 24151 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x5A /*tertiary()*/));
  
#line 24159 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2095 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(0)->reg(ra_,this), opnd_array(1)->reg(ra_,this,idx1));
  
#line 24167 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void convD2I_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 2512 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );
    emit_d8( cbuf, 0xC0-1+opnd_array(1)->reg(ra_,this,idx1) );   // FLD ST(i-1)
  
#line 24182 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 3767 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Flip to round-to-zero mode.  We attempted to allow invalid-op
    // exceptions here, so that a NAN or other corner-case value will
    // thrown an exception (but normal values get converted at full speed).
    // However, I2C adapters and other float-stack manglers leave pending
    // invalid-op exceptions hanging.  We would have to clear them before
    // enabling them and that is more expensive than just testing for the
    // invalid value Intel stores down in the corner cases.
    emit_opcode(cbuf,0xD9);            // FLDCW  trunc
    emit_opcode(cbuf,0x2D);
    emit_d32(cbuf,(int)StubRoutines::addr_fpu_cntrl_wrd_trunc());
    // Allocate a word
    emit_opcode(cbuf,0x83);            // SUB ESP,4
    emit_opcode(cbuf,0xEC);
    emit_d8(cbuf,0x04);
    // Encoding assumes a double has been pushed into FPR0.
    // Store down the double as an int, popping the FPU stack
    emit_opcode(cbuf,0xDB);            // FISTP [ESP]
    emit_opcode(cbuf,0x1C);
    emit_d8(cbuf,0x24);
    // Restore the rounding mode; mask the exception
    emit_opcode(cbuf,0xD9);            // FLDCW   std/24-bit mode
    emit_opcode(cbuf,0x2D);
    emit_d32( cbuf, Compile::current()->in_24_bit_fp_mode()
        ? (int)StubRoutines::addr_fpu_cntrl_wrd_24()
        : (int)StubRoutines::addr_fpu_cntrl_wrd_std());

    // Load the converted int; adjust CPU stack
    emit_opcode(cbuf,0x58);       // POP EAX
    emit_opcode(cbuf,0x3D);       // CMP EAX,imm
    emit_d32   (cbuf,0x80000000); //         0x80000000
    emit_opcode(cbuf,0x75);       // JNE around_slow_call
    emit_d8    (cbuf,0x07);       // Size of slow_call
    // Push src onto stack slow-path
    emit_opcode(cbuf,0xD9 );      // FLD     ST(i)
    emit_d8    (cbuf,0xC0-1+opnd_array(1)->reg(ra_,this,idx1) );
    // CALL directly to the runtime
    cbuf.set_insts_mark();
    emit_opcode(cbuf,0xE8);       // Call into runtime
    emit_d32_reloc(cbuf, (StubRoutines::d2i_wrapper() - cbuf.insts_end()) - 4, runtime_call_Relocation::spec(), RELOC_IMM32 );
    // Carry on here...
  
#line 24229 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void convXD2I_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xF2));
  
#line 24243 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0F));
  
#line 24251 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x2C));
  
#line 24259 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 4023 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(0)->reg(ra_,this), opnd_array(1)->reg(ra_,this,idx1));

    // Compare the result to see if we need to go to the slow path
    emit_opcode(cbuf,0x81);       // CMP dst,imm
    emit_rm    (cbuf,0x3,0x7,opnd_array(0)->reg(ra_,this));
    emit_d32   (cbuf,0x80000000); //         0x80000000

    emit_opcode(cbuf,0x75);       // JNE around_slow_call
    emit_d8    (cbuf,0x13);       // Size of slow_call
    // Store xmm to a temp memory
    // location and push it onto stack.

    emit_opcode(cbuf,0x83);  // SUB ESP,4
    emit_opcode(cbuf,0xEC);
    emit_d8(cbuf, (0x1 /*primary()*/) ? 0x8 : 0x4);

    emit_opcode  (cbuf, (0x1 /*primary()*/) ? 0xF2 : 0xF3 );   // MOVSS [ESP], xmm
    emit_opcode  (cbuf, 0x0F );
    emit_opcode  (cbuf, 0x11 );
    encode_RegMem(cbuf, opnd_array(1)->reg(ra_,this,idx1), ESP_enc, 0x4, 0, 0, false);

    emit_opcode(cbuf, (0x1 /*primary()*/) ? 0xDD : 0xD9 );      // FLD [ESP]
    encode_RegMem(cbuf, 0x0, ESP_enc, 0x4, 0, 0, false);

    emit_opcode(cbuf,0x83);    // ADD ESP,4
    emit_opcode(cbuf,0xC4);
    emit_d8(cbuf, (0x1 /*primary()*/) ? 0x8 : 0x4);

    // CALL directly to the runtime
    cbuf.set_insts_mark();
    emit_opcode(cbuf,0xE8);       // Call into runtime
    emit_d32_reloc(cbuf, (StubRoutines::d2i_wrapper() - cbuf.insts_end()) - 4, runtime_call_Relocation::spec(), RELOC_IMM32 );

    // Carry on here...
  
#line 24300 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void convD2L_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 2512 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );
    emit_d8( cbuf, 0xC0-1+opnd_array(1)->reg(ra_,this,idx1) );   // FLD ST(i-1)
  
#line 24315 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 3810 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf,0xD9);            // FLDCW  trunc
    emit_opcode(cbuf,0x2D);
    emit_d32(cbuf,(int)StubRoutines::addr_fpu_cntrl_wrd_trunc());
    // Allocate a word
    emit_opcode(cbuf,0x83);            // SUB ESP,8
    emit_opcode(cbuf,0xEC);
    emit_d8(cbuf,0x08);
    // Encoding assumes a double has been pushed into FPR0.
    // Store down the double as a long, popping the FPU stack
    emit_opcode(cbuf,0xDF);            // FISTP [ESP]
    emit_opcode(cbuf,0x3C);
    emit_d8(cbuf,0x24);
    // Restore the rounding mode; mask the exception
    emit_opcode(cbuf,0xD9);            // FLDCW   std/24-bit mode
    emit_opcode(cbuf,0x2D);
    emit_d32( cbuf, Compile::current()->in_24_bit_fp_mode()
        ? (int)StubRoutines::addr_fpu_cntrl_wrd_24()
        : (int)StubRoutines::addr_fpu_cntrl_wrd_std());

    // Load the converted int; adjust CPU stack
    emit_opcode(cbuf,0x58);       // POP EAX
    emit_opcode(cbuf,0x5A);       // POP EDX
    emit_opcode(cbuf,0x81);       // CMP EDX,imm
    emit_d8    (cbuf,0xFA);       // rdx
    emit_d32   (cbuf,0x80000000); //         0x80000000
    emit_opcode(cbuf,0x75);       // JNE around_slow_call
    emit_d8    (cbuf,0x07+4);     // Size of slow_call
    emit_opcode(cbuf,0x85);       // TEST EAX,EAX
    emit_opcode(cbuf,0xC0);       // 2/rax,/rax,
    emit_opcode(cbuf,0x75);       // JNE around_slow_call
    emit_d8    (cbuf,0x07);       // Size of slow_call
    // Push src onto stack slow-path
    emit_opcode(cbuf,0xD9 );      // FLD     ST(i)
    emit_d8    (cbuf,0xC0-1+opnd_array(1)->reg(ra_,this,idx1) );
    // CALL directly to the runtime
    cbuf.set_insts_mark();
    emit_opcode(cbuf,0xE8);       // Call into runtime
    emit_d32_reloc(cbuf, (StubRoutines::d2l_wrapper() - cbuf.insts_end()) - 4, runtime_call_Relocation::spec(), RELOC_IMM32 );
    // Carry on here...
  
#line 24361 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void convXD2L_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 3925 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Allocate a word
    emit_opcode(cbuf,0x83);      // SUB ESP,8
    emit_opcode(cbuf,0xEC);
    emit_d8(cbuf,0x08);

    emit_opcode  (cbuf, 0xF2 );  // MOVSD [ESP], src
    emit_opcode  (cbuf, 0x0F );
    emit_opcode  (cbuf, 0x11 );
    encode_RegMem(cbuf, opnd_array(1)->reg(ra_,this,idx1), ESP_enc, 0x4, 0, 0, false);

    emit_opcode(cbuf,0xDD );     // FLD_D [ESP]
    encode_RegMem(cbuf, 0x0, ESP_enc, 0x4, 0, 0, false);

    emit_opcode(cbuf,0xD9);      // FLDCW  trunc
    emit_opcode(cbuf,0x2D);
    emit_d32(cbuf,(int)StubRoutines::addr_fpu_cntrl_wrd_trunc());

    // Encoding assumes a double has been pushed into FPR0.
    // Store down the double as a long, popping the FPU stack
    emit_opcode(cbuf,0xDF);      // FISTP [ESP]
    emit_opcode(cbuf,0x3C);
    emit_d8(cbuf,0x24);

    // Restore the rounding mode; mask the exception
    emit_opcode(cbuf,0xD9);      // FLDCW   std/24-bit mode
    emit_opcode(cbuf,0x2D);
    emit_d32( cbuf, Compile::current()->in_24_bit_fp_mode()
      ? (int)StubRoutines::addr_fpu_cntrl_wrd_24()
      : (int)StubRoutines::addr_fpu_cntrl_wrd_std());

    // Load the converted int; adjust CPU stack
    emit_opcode(cbuf,0x58);      // POP EAX

    emit_opcode(cbuf,0x5A);      // POP EDX

    emit_opcode(cbuf,0x81);      // CMP EDX,imm
    emit_d8    (cbuf,0xFA);      // rdx
    emit_d32   (cbuf,0x80000000); //         0x80000000

    emit_opcode(cbuf,0x75);      // JNE around_slow_call
    emit_d8    (cbuf,0x13+4);    // Size of slow_call

    emit_opcode(cbuf,0x85);      // TEST EAX,EAX
    emit_opcode(cbuf,0xC0);      // 2/rax,/rax,

    emit_opcode(cbuf,0x75);      // JNE around_slow_call
    emit_d8    (cbuf,0x13);      // Size of slow_call

    // Push src onto stack slow-path
    // Allocate a word
    emit_opcode(cbuf,0x83);      // SUB ESP,8
    emit_opcode(cbuf,0xEC);
    emit_d8(cbuf,0x08);

    emit_opcode  (cbuf, 0xF2 );  // MOVSD [ESP], src
    emit_opcode  (cbuf, 0x0F );
    emit_opcode  (cbuf, 0x11 );
    encode_RegMem(cbuf, opnd_array(1)->reg(ra_,this,idx1), ESP_enc, 0x4, 0, 0, false);

    emit_opcode(cbuf,0xDD );     // FLD_D [ESP]
    encode_RegMem(cbuf, 0x0, ESP_enc, 0x4, 0, 0, false);

    emit_opcode(cbuf,0x83);      // ADD ESP,8
    emit_opcode(cbuf,0xC4);
    emit_d8(cbuf,0x08);

    // CALL directly to the runtime
    cbuf.set_insts_mark();
    emit_opcode(cbuf,0xE8);      // Call into runtime
    emit_d32_reloc(cbuf, (StubRoutines::d2l_wrapper() - cbuf.insts_end()) - 4, runtime_call_Relocation::spec(), RELOC_IMM32 );
    // Carry on here...
  
#line 24445 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void convF2I_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 2577 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );           // FLD    ST(i-1)
    emit_d8( cbuf, 0xC0-1+opnd_array(1)->reg(ra_,this,idx1) );
  
#line 24460 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 3767 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Flip to round-to-zero mode.  We attempted to allow invalid-op
    // exceptions here, so that a NAN or other corner-case value will
    // thrown an exception (but normal values get converted at full speed).
    // However, I2C adapters and other float-stack manglers leave pending
    // invalid-op exceptions hanging.  We would have to clear them before
    // enabling them and that is more expensive than just testing for the
    // invalid value Intel stores down in the corner cases.
    emit_opcode(cbuf,0xD9);            // FLDCW  trunc
    emit_opcode(cbuf,0x2D);
    emit_d32(cbuf,(int)StubRoutines::addr_fpu_cntrl_wrd_trunc());
    // Allocate a word
    emit_opcode(cbuf,0x83);            // SUB ESP,4
    emit_opcode(cbuf,0xEC);
    emit_d8(cbuf,0x04);
    // Encoding assumes a double has been pushed into FPR0.
    // Store down the double as an int, popping the FPU stack
    emit_opcode(cbuf,0xDB);            // FISTP [ESP]
    emit_opcode(cbuf,0x1C);
    emit_d8(cbuf,0x24);
    // Restore the rounding mode; mask the exception
    emit_opcode(cbuf,0xD9);            // FLDCW   std/24-bit mode
    emit_opcode(cbuf,0x2D);
    emit_d32( cbuf, Compile::current()->in_24_bit_fp_mode()
        ? (int)StubRoutines::addr_fpu_cntrl_wrd_24()
        : (int)StubRoutines::addr_fpu_cntrl_wrd_std());

    // Load the converted int; adjust CPU stack
    emit_opcode(cbuf,0x58);       // POP EAX
    emit_opcode(cbuf,0x3D);       // CMP EAX,imm
    emit_d32   (cbuf,0x80000000); //         0x80000000
    emit_opcode(cbuf,0x75);       // JNE around_slow_call
    emit_d8    (cbuf,0x07);       // Size of slow_call
    // Push src onto stack slow-path
    emit_opcode(cbuf,0xD9 );      // FLD     ST(i)
    emit_d8    (cbuf,0xC0-1+opnd_array(1)->reg(ra_,this,idx1) );
    // CALL directly to the runtime
    cbuf.set_insts_mark();
    emit_opcode(cbuf,0xE8);       // Call into runtime
    emit_d32_reloc(cbuf, (StubRoutines::d2i_wrapper() - cbuf.insts_end()) - 4, runtime_call_Relocation::spec(), RELOC_IMM32 );
    // Carry on here...
  
#line 24507 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void convX2I_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xF3));
  
#line 24521 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0F));
  
#line 24529 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x2C));
  
#line 24537 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 4023 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(0)->reg(ra_,this), opnd_array(1)->reg(ra_,this,idx1));

    // Compare the result to see if we need to go to the slow path
    emit_opcode(cbuf,0x81);       // CMP dst,imm
    emit_rm    (cbuf,0x3,0x7,opnd_array(0)->reg(ra_,this));
    emit_d32   (cbuf,0x80000000); //         0x80000000

    emit_opcode(cbuf,0x75);       // JNE around_slow_call
    emit_d8    (cbuf,0x13);       // Size of slow_call
    // Store xmm to a temp memory
    // location and push it onto stack.

    emit_opcode(cbuf,0x83);  // SUB ESP,4
    emit_opcode(cbuf,0xEC);
    emit_d8(cbuf, (0x0 /*primary()*/) ? 0x8 : 0x4);

    emit_opcode  (cbuf, (0x0 /*primary()*/) ? 0xF2 : 0xF3 );   // MOVSS [ESP], xmm
    emit_opcode  (cbuf, 0x0F );
    emit_opcode  (cbuf, 0x11 );
    encode_RegMem(cbuf, opnd_array(1)->reg(ra_,this,idx1), ESP_enc, 0x4, 0, 0, false);

    emit_opcode(cbuf, (0x0 /*primary()*/) ? 0xDD : 0xD9 );      // FLD [ESP]
    encode_RegMem(cbuf, 0x0, ESP_enc, 0x4, 0, 0, false);

    emit_opcode(cbuf,0x83);    // ADD ESP,4
    emit_opcode(cbuf,0xC4);
    emit_d8(cbuf, (0x0 /*primary()*/) ? 0x8 : 0x4);

    // CALL directly to the runtime
    cbuf.set_insts_mark();
    emit_opcode(cbuf,0xE8);       // Call into runtime
    emit_d32_reloc(cbuf, (StubRoutines::d2i_wrapper() - cbuf.insts_end()) - 4, runtime_call_Relocation::spec(), RELOC_IMM32 );

    // Carry on here...
  
#line 24578 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void convF2L_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 2577 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xD9 );           // FLD    ST(i-1)
    emit_d8( cbuf, 0xC0-1+opnd_array(1)->reg(ra_,this,idx1) );
  
#line 24593 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 3810 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf,0xD9);            // FLDCW  trunc
    emit_opcode(cbuf,0x2D);
    emit_d32(cbuf,(int)StubRoutines::addr_fpu_cntrl_wrd_trunc());
    // Allocate a word
    emit_opcode(cbuf,0x83);            // SUB ESP,8
    emit_opcode(cbuf,0xEC);
    emit_d8(cbuf,0x08);
    // Encoding assumes a double has been pushed into FPR0.
    // Store down the double as a long, popping the FPU stack
    emit_opcode(cbuf,0xDF);            // FISTP [ESP]
    emit_opcode(cbuf,0x3C);
    emit_d8(cbuf,0x24);
    // Restore the rounding mode; mask the exception
    emit_opcode(cbuf,0xD9);            // FLDCW   std/24-bit mode
    emit_opcode(cbuf,0x2D);
    emit_d32( cbuf, Compile::current()->in_24_bit_fp_mode()
        ? (int)StubRoutines::addr_fpu_cntrl_wrd_24()
        : (int)StubRoutines::addr_fpu_cntrl_wrd_std());

    // Load the converted int; adjust CPU stack
    emit_opcode(cbuf,0x58);       // POP EAX
    emit_opcode(cbuf,0x5A);       // POP EDX
    emit_opcode(cbuf,0x81);       // CMP EDX,imm
    emit_d8    (cbuf,0xFA);       // rdx
    emit_d32   (cbuf,0x80000000); //         0x80000000
    emit_opcode(cbuf,0x75);       // JNE around_slow_call
    emit_d8    (cbuf,0x07+4);     // Size of slow_call
    emit_opcode(cbuf,0x85);       // TEST EAX,EAX
    emit_opcode(cbuf,0xC0);       // 2/rax,/rax,
    emit_opcode(cbuf,0x75);       // JNE around_slow_call
    emit_d8    (cbuf,0x07);       // Size of slow_call
    // Push src onto stack slow-path
    emit_opcode(cbuf,0xD9 );      // FLD     ST(i)
    emit_d8    (cbuf,0xC0-1+opnd_array(1)->reg(ra_,this,idx1) );
    // CALL directly to the runtime
    cbuf.set_insts_mark();
    emit_opcode(cbuf,0xE8);       // Call into runtime
    emit_d32_reloc(cbuf, (StubRoutines::d2l_wrapper() - cbuf.insts_end()) - 4, runtime_call_Relocation::spec(), RELOC_IMM32 );
    // Carry on here...
  
#line 24639 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void convX2L_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 3852 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Allocate a word
    emit_opcode(cbuf,0x83);      // SUB ESP,8
    emit_opcode(cbuf,0xEC);
    emit_d8(cbuf,0x08);

    emit_opcode  (cbuf, 0xF3 );  // MOVSS [ESP], src
    emit_opcode  (cbuf, 0x0F );
    emit_opcode  (cbuf, 0x11 );
    encode_RegMem(cbuf, opnd_array(1)->reg(ra_,this,idx1), ESP_enc, 0x4, 0, 0, false);

    emit_opcode(cbuf,0xD9 );     // FLD_S [ESP]
    encode_RegMem(cbuf, 0x0, ESP_enc, 0x4, 0, 0, false);

    emit_opcode(cbuf,0xD9);      // FLDCW  trunc
    emit_opcode(cbuf,0x2D);
    emit_d32(cbuf,(int)StubRoutines::addr_fpu_cntrl_wrd_trunc());

    // Encoding assumes a double has been pushed into FPR0.
    // Store down the double as a long, popping the FPU stack
    emit_opcode(cbuf,0xDF);      // FISTP [ESP]
    emit_opcode(cbuf,0x3C);
    emit_d8(cbuf,0x24);

    // Restore the rounding mode; mask the exception
    emit_opcode(cbuf,0xD9);      // FLDCW   std/24-bit mode
    emit_opcode(cbuf,0x2D);
    emit_d32( cbuf, Compile::current()->in_24_bit_fp_mode()
      ? (int)StubRoutines::addr_fpu_cntrl_wrd_24()
      : (int)StubRoutines::addr_fpu_cntrl_wrd_std());

    // Load the converted int; adjust CPU stack
    emit_opcode(cbuf,0x58);      // POP EAX

    emit_opcode(cbuf,0x5A);      // POP EDX

    emit_opcode(cbuf,0x81);      // CMP EDX,imm
    emit_d8    (cbuf,0xFA);      // rdx
    emit_d32   (cbuf,0x80000000);//         0x80000000

    emit_opcode(cbuf,0x75);      // JNE around_slow_call
    emit_d8    (cbuf,0x13+4);    // Size of slow_call

    emit_opcode(cbuf,0x85);      // TEST EAX,EAX
    emit_opcode(cbuf,0xC0);      // 2/rax,/rax,

    emit_opcode(cbuf,0x75);      // JNE around_slow_call
    emit_d8    (cbuf,0x13);      // Size of slow_call

    // Allocate a word
    emit_opcode(cbuf,0x83);      // SUB ESP,4
    emit_opcode(cbuf,0xEC);
    emit_d8(cbuf,0x04);

    emit_opcode  (cbuf, 0xF3 );  // MOVSS [ESP], src
    emit_opcode  (cbuf, 0x0F );
    emit_opcode  (cbuf, 0x11 );
    encode_RegMem(cbuf, opnd_array(1)->reg(ra_,this,idx1), ESP_enc, 0x4, 0, 0, false);

    emit_opcode(cbuf,0xD9 );     // FLD_S [ESP]
    encode_RegMem(cbuf, 0x0, ESP_enc, 0x4, 0, 0, false);

    emit_opcode(cbuf,0x83);      // ADD ESP,4
    emit_opcode(cbuf,0xC4);
    emit_d8(cbuf,0x04);

    // CALL directly to the runtime
    cbuf.set_insts_mark();
    emit_opcode(cbuf,0xE8);       // Call into runtime
    emit_d32_reloc(cbuf, (StubRoutines::d2l_wrapper() - cbuf.insts_end()) - 4, runtime_call_Relocation::spec(), RELOC_IMM32 );
    // Carry on here...
  
#line 24722 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void convI2D_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 2547 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    store_to_stackslot( cbuf, (0xDB /*primary()*/), (0x0 /*secondary()*/), opnd_array(1)->disp(ra_,this,idx1) );
  
#line 24736 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2507 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xDD );           // FSTP   ST(i)
    emit_d8( cbuf, 0xD8+opnd_array(0)->reg(ra_,this) );
  
#line 24745 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void convI2XD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xF2 /*primary()*/));
  
#line 24759 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1586 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0F /*secondary()*/));
  
#line 24767 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x2A /*tertiary()*/));
  
#line 24775 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2095 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(0)->reg(ra_,this), opnd_array(1)->reg(ra_,this,idx1));
  
#line 24783 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void convI2XD_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xF2 /*primary()*/));
  
#line 24797 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1586 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0F /*secondary()*/));
  
#line 24805 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x2A /*tertiary()*/));
  
#line 24813 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(0)->reg(ra_,this);
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 24827 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void convXI2XD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {
    MacroAssembler _masm(&cbuf);

#line 12075 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ movdl(opnd_array(0)->as_XMMRegister(ra_,this), opnd_array(1)->as_Register(ra_,this,idx1));
    __ cvtdq2pd(opnd_array(0)->as_XMMRegister(ra_,this), opnd_array(0)->as_XMMRegister(ra_,this));
  
#line 24843 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void convI2D_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xDB /*primary()*/));
  
#line 24857 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2302 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_is_oop);
  
#line 24871 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2507 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xDD );           // FSTP   ST(i)
    emit_d8( cbuf, 0xD8+opnd_array(0)->reg(ra_,this) );
  
#line 24880 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void conv24I2F_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 2547 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    store_to_stackslot( cbuf, (0xDB /*primary()*/), (0x0 /*secondary()*/), opnd_array(1)->disp(ra_,this,idx1) );
  
#line 24894 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2572 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xDD );           // FSTP   ST(i)
    emit_d8( cbuf, 0xD8+opnd_array(0)->reg(ra_,this) );
  
#line 24903 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void convI2F_SSFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 2547 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    store_to_stackslot( cbuf, (0xDB /*primary()*/), (0x0 /*secondary()*/), opnd_array(1)->disp(ra_,this,idx1) );
  
#line 24917 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2562 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    store_to_stackslot( cbuf, 0xD9, 0x03, opnd_array(0)->disp(ra_,this,0) );
  
#line 24925 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void convI2F_SSF_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xDB /*primary()*/));
  
#line 24939 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2302 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_is_oop);
  
#line 24953 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2562 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    store_to_stackslot( cbuf, 0xD9, 0x03, opnd_array(0)->disp(ra_,this,0) );
  
#line 24961 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void convI2F_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 2547 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    store_to_stackslot( cbuf, (0xDB /*primary()*/), (0x0 /*secondary()*/), opnd_array(1)->disp(ra_,this,idx1) );
  
#line 24975 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2572 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xDD );           // FSTP   ST(i)
    emit_d8( cbuf, 0xD8+opnd_array(0)->reg(ra_,this) );
  
#line 24984 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void convI2F_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xDB /*primary()*/));
  
#line 24998 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2302 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_is_oop);
  
#line 25012 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2572 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xDD );           // FSTP   ST(i)
    emit_d8( cbuf, 0xD8+opnd_array(0)->reg(ra_,this) );
  
#line 25021 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void convI2X_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xF3 /*primary()*/));
  
#line 25035 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1586 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0F /*secondary()*/));
  
#line 25043 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x2A /*tertiary()*/));
  
#line 25051 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2095 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(0)->reg(ra_,this), opnd_array(1)->reg(ra_,this,idx1));
  
#line 25059 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void convXI2X_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {
    MacroAssembler _masm(&cbuf);

#line 12173 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ movdl(opnd_array(0)->as_XMMRegister(ra_,this), opnd_array(1)->as_Register(ra_,this,idx1));
    __ cvtdq2ps(opnd_array(0)->as_XMMRegister(ra_,this), opnd_array(0)->as_XMMRegister(ra_,this));
  
#line 25075 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void convI2L_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 2965 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // mov $dst.lo,$src
    int dst_encoding = opnd_array(0)->reg(ra_,this);
    int src_encoding = opnd_array(1)->reg(ra_,this,idx1);
    encode_Copy( cbuf, dst_encoding  , src_encoding );
    // mov $dst.hi,$src
    encode_Copy( cbuf, HIGH_FROM_LOW(dst_encoding), src_encoding );
    // sar $dst.hi,31
    emit_opcode( cbuf, 0xC1 );
    emit_rm(cbuf, 0x3, 7, HIGH_FROM_LOW(dst_encoding) );
    emit_d8(cbuf, 0x1F );
  
#line 25098 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void convI2L_reg_zexNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 2082 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    encode_Copy( cbuf, opnd_array(0)->reg(ra_,this), opnd_array(1)->reg(ra_,this,idx1) );
  
#line 25113 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x33 /*primary()*/));
  
#line 25121 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2113 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, HIGH_FROM_LOW(opnd_array(0)->reg(ra_,this)), HIGH_FROM_LOW(opnd_array(0)->reg(ra_,this)));
  
#line 25129 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void zerox_longNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 2082 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    encode_Copy( cbuf, opnd_array(0)->reg(ra_,this), opnd_array(1)->reg(ra_,this,idx1) );
  
#line 25144 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x33 /*primary()*/));
  
#line 25152 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2113 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, HIGH_FROM_LOW(opnd_array(0)->reg(ra_,this)), HIGH_FROM_LOW(opnd_array(0)->reg(ra_,this)));
  
#line 25160 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void convL2D_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 2978 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // push $src.hi
    emit_opcode(cbuf, 0x50+HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)));
    // push $src.lo
    emit_opcode(cbuf, 0x50+opnd_array(1)->reg(ra_,this,idx1)  );
    // fild 64-bits at [SP]
    emit_opcode(cbuf,0xdf);
    emit_d8(cbuf, 0x6C);
    emit_d8(cbuf, 0x24);
    emit_d8(cbuf, 0x00);
    // pop stack
    emit_opcode(cbuf, 0x83); // add  SP, #8
    emit_rm(cbuf, 0x3, 0x00, ESP_enc);
    emit_d8(cbuf, 0x8);
  
#line 25186 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2568 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    store_to_stackslot( cbuf, 0xDD, 0x03, opnd_array(0)->disp(ra_,this,0) );
  
#line 25194 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void convL2XD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 3008 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // push $src.hi
    emit_opcode(cbuf, 0x50+HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)));
    // push $src.lo
    emit_opcode(cbuf, 0x50+opnd_array(1)->reg(ra_,this,idx1)  );
    // fild 64-bits at [SP]
    emit_opcode(cbuf,0xdf);
    emit_d8(cbuf, 0x6C);
    emit_d8(cbuf, 0x24);
    emit_d8(cbuf, 0x00);
  
#line 25216 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2692 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    store_to_stackslot( cbuf, 0xDD, 0x03, 0 ); //FSTP [ESP]

    // UseXmmLoadAndClearUpper ? movsd dst,[esp] : movlpd dst,[esp]
    emit_opcode  (cbuf, UseXmmLoadAndClearUpper ? 0xF2 : 0x66);
    emit_opcode  (cbuf, 0x0F );
    emit_opcode  (cbuf, UseXmmLoadAndClearUpper ? 0x10 : 0x12);
    encode_RegMem(cbuf, opnd_array(0)->reg(ra_,this), ESP_enc, 0x4, 0, 0, false);

    emit_opcode(cbuf,0x83);    // ADD ESP,8
    emit_opcode(cbuf,0xC4);
    emit_d8(cbuf,0x08);
  
#line 25234 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void convL2X_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 3008 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // push $src.hi
    emit_opcode(cbuf, 0x50+HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)));
    // push $src.lo
    emit_opcode(cbuf, 0x50+opnd_array(1)->reg(ra_,this,idx1)  );
    // fild 64-bits at [SP]
    emit_opcode(cbuf,0xdf);
    emit_d8(cbuf, 0x6C);
    emit_d8(cbuf, 0x24);
    emit_d8(cbuf, 0x00);
  
#line 25256 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2706 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    store_to_stackslot( cbuf, 0xD9, 0x03, 0 ); //FSTP_S [ESP]

    emit_opcode  (cbuf, 0xF3 );     // MOVSS dst(xmm), [ESP]
    emit_opcode  (cbuf, 0x0F );
    emit_opcode  (cbuf, 0x10 );
    encode_RegMem(cbuf, opnd_array(0)->reg(ra_,this), ESP_enc, 0x4, 0, 0, false);

    emit_opcode(cbuf,0x83);    // ADD ESP,d8 (4 or 8)
    emit_opcode(cbuf,0xC4);
    emit_d8(cbuf,(0x8));
  
#line 25273 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void convL2F_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 2978 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // push $src.hi
    emit_opcode(cbuf, 0x50+HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)));
    // push $src.lo
    emit_opcode(cbuf, 0x50+opnd_array(1)->reg(ra_,this,idx1)  );
    // fild 64-bits at [SP]
    emit_opcode(cbuf,0xdf);
    emit_d8(cbuf, 0x6C);
    emit_d8(cbuf, 0x24);
    emit_d8(cbuf, 0x00);
    // pop stack
    emit_opcode(cbuf, 0x83); // add  SP, #8
    emit_rm(cbuf, 0x3, 0x00, ESP_enc);
    emit_d8(cbuf, 0x8);
  
#line 25299 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2562 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    store_to_stackslot( cbuf, 0xD9, 0x03, opnd_array(0)->disp(ra_,this,0) );
  
#line 25307 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void convL2I_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 2086 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    encode_Copy( cbuf, opnd_array(0)->reg(ra_,this), opnd_array(1)->reg(ra_,this,idx1) );
  
#line 25321 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void MoveF2I_stack_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x8B /*primary()*/));
  
#line 25335 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(0)->reg(ra_,this);
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 25349 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void MoveF2I_reg_stackNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 2583 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int pop = 0x02;
    if (opnd_array(1)->reg(ra_,this,idx1) != FPR1L_enc) {
      emit_opcode( cbuf, 0xD9 );         // FLD    ST(i-1)
      emit_d8( cbuf, 0xC0-1+opnd_array(1)->reg(ra_,this,idx1) );
      pop = 0x03;
    }
    store_to_stackslot( cbuf, 0xD9, pop, opnd_array(0)->disp(ra_,this,0) ); // FST<P>_S  [ESP+dst]
  
#line 25369 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void MoveF2I_reg_stack_sseNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xF3));
  
#line 25383 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0F));
  
#line 25391 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x11));
  
#line 25399 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(1)->reg(ra_,this,idx1);
    int base  = opnd_array(0)->base(ra_,this,idx0);
    int index = opnd_array(0)->index(ra_,this,idx0);
    int scale = opnd_array(0)->scale();
    int displace = opnd_array(0)->disp(ra_,this,0);
    bool disp_is_oop = opnd_array(0)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 25413 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void MoveF2I_reg_reg_sseNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 2030 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, 0x66 );     // MOVD dst,src
    emit_opcode(cbuf, 0x0F );
    emit_opcode(cbuf, 0x7E );
    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1), opnd_array(0)->reg(ra_,this));
  
#line 25430 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void MoveI2F_reg_stackNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 2534 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    store_to_stackslot( cbuf, (0x89 /*primary()*/), opnd_array(1)->reg(ra_,this,idx1), opnd_array(0)->disp(ra_,this,0) );
  
#line 25444 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void MoveI2F_stack_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD9 /*primary()*/));
  
#line 25458 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2292 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    assert( !opnd_array(1)->disp_is_oop(), "No oops here because no relo info allowed" );
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, false);
  
#line 25472 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2572 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xDD );           // FSTP   ST(i)
    emit_d8( cbuf, 0xD8+opnd_array(0)->reg(ra_,this) );
  
#line 25481 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void MoveI2F_stack_reg_sseNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xF3));
  
#line 25495 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0F));
  
#line 25503 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x10));
  
#line 25511 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(0)->reg(ra_,this);
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 25525 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void MoveI2F_reg_reg_sseNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 2023 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, 0x66 );     // MOVD dst,src
    emit_opcode(cbuf, 0x0F );
    emit_opcode(cbuf, 0x6E );
    emit_rm(cbuf, 0x3, opnd_array(0)->reg(ra_,this), opnd_array(1)->reg(ra_,this,idx1));
  
#line 25542 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void MoveD2L_stack_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x8B /*primary()*/));
  
#line 25556 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(0)->reg(ra_,this);
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 25570 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1586 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x8B /*secondary()*/));
  
#line 25578 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2222 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = HIGH_FROM_LOW(opnd_array(0)->reg(ra_,this));  // Hi register of pair, computed from lo
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1) + 4;      // Offset is 4 further in memory
    assert( !opnd_array(1)->disp_is_oop(), "Cannot add 4 to oop" );
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, false/*disp_is_oop*/);
  
#line 25592 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void MoveD2L_reg_stackNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 2594 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int pop = 0x02;
    if (opnd_array(1)->reg(ra_,this,idx1) != FPR1L_enc) {
      emit_opcode( cbuf, 0xD9 );         // FLD    ST(i-1)
      emit_d8( cbuf, 0xC0-1+opnd_array(1)->reg(ra_,this,idx1) );
      pop = 0x03;
    }
    store_to_stackslot( cbuf, 0xDD, pop, opnd_array(0)->disp(ra_,this,0) ); // FST<P>_D  [ESP+dst]
  
#line 25612 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void MoveD2L_reg_stack_sseNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xF2));
  
#line 25626 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0F));
  
#line 25634 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x11));
  
#line 25642 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(1)->reg(ra_,this,idx1);
    int base  = opnd_array(0)->base(ra_,this,idx0);
    int index = opnd_array(0)->index(ra_,this,idx0);
    int scale = opnd_array(0)->scale();
    int displace = opnd_array(0)->disp(ra_,this,0);
    bool disp_is_oop = opnd_array(0)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 25656 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void MoveD2L_reg_reg_sseNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 2058 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    { // MOVD $dst.lo,$src
      emit_opcode(cbuf,0x66);
      emit_opcode(cbuf,0x0F);
      emit_opcode(cbuf,0x7E);
      emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1), opnd_array(0)->reg(ra_,this));
    }
    { // PSHUFLW $tmp,$src,0x4E  (01001110b)
      emit_opcode(cbuf,0xF2);
      emit_opcode(cbuf,0x0F);
      emit_opcode(cbuf,0x70);
      emit_rm(cbuf, 0x3, opnd_array(2)->reg(ra_,this,idx2), opnd_array(1)->reg(ra_,this,idx1));
      emit_d8(cbuf, 0x4E);
    }
    { // MOVD $dst.hi,$tmp
      emit_opcode(cbuf,0x66);
      emit_opcode(cbuf,0x0F);
      emit_opcode(cbuf,0x7E);
      emit_rm(cbuf, 0x3, opnd_array(2)->reg(ra_,this,idx2), HIGH_FROM_LOW(opnd_array(0)->reg(ra_,this)));
    }
  
#line 25689 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void MoveL2D_reg_stackNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x89 /*primary()*/));
  
#line 25703 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(1)->reg(ra_,this,idx1);
    int base  = opnd_array(0)->base(ra_,this,idx0);
    int index = opnd_array(0)->index(ra_,this,idx0);
    int scale = opnd_array(0)->scale();
    int displace = opnd_array(0)->disp(ra_,this,0);
    bool disp_is_oop = opnd_array(0)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 25717 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1586 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x89 /*secondary()*/));
  
#line 25725 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2222 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1));  // Hi register of pair, computed from lo
    int base  = opnd_array(0)->base(ra_,this,idx0);
    int index = opnd_array(0)->index(ra_,this,idx0);
    int scale = opnd_array(0)->scale();
    int displace = opnd_array(0)->disp(ra_,this,0) + 4;      // Offset is 4 further in memory
    assert( !opnd_array(0)->disp_is_oop(), "Cannot add 4 to oop" );
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, false/*disp_is_oop*/);
  
#line 25739 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void MoveL2D_stack_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xDD /*primary()*/));
  
#line 25753 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2292 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    assert( !opnd_array(1)->disp_is_oop(), "No oops here because no relo info allowed" );
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, false);
  
#line 25767 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2507 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode( cbuf, 0xDD );           // FSTP   ST(i)
    emit_d8( cbuf, 0xD8+opnd_array(0)->reg(ra_,this) );
  
#line 25776 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void MoveL2D_stack_reg_sseNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xF2));
  
#line 25790 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0F));
  
#line 25798 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x10));
  
#line 25806 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(0)->reg(ra_,this);
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 25820 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void MoveL2D_stack_reg_sse_partialNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x66));
  
#line 25834 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x0F));
  
#line 25842 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x12));
  
#line 25850 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(0)->reg(ra_,this);
    int base  = opnd_array(1)->base(ra_,this,idx1);
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 25864 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void MoveL2D_reg_reg_sseNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
  {

#line 2037 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    { // MOVD $dst,$src.lo
      emit_opcode(cbuf,0x66);
      emit_opcode(cbuf,0x0F);
      emit_opcode(cbuf,0x6E);
      emit_rm(cbuf, 0x3, opnd_array(2)->reg(ra_,this,idx2), opnd_array(1)->reg(ra_,this,idx1));
    }
    { // MOVD $tmp,$src.hi
      emit_opcode(cbuf,0x66);
      emit_opcode(cbuf,0x0F);
      emit_opcode(cbuf,0x6E);
      emit_rm(cbuf, 0x3, opnd_array(3)->reg(ra_,this,idx3), HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)));
    }
    { // PUNPCKLDQ $dst,$tmp
      emit_opcode(cbuf,0x66);
      emit_opcode(cbuf,0x0F);
      emit_opcode(cbuf,0x62);
      emit_rm(cbuf, 0x3, opnd_array(2)->reg(ra_,this,idx2), opnd_array(3)->reg(ra_,this,idx3));
     }
  
#line 25897 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void Repl8B_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 3182 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    MacroAssembler _masm(&cbuf);

    encode_CopyXD(cbuf, opnd_array(0)->reg(ra_,this), opnd_array(1)->reg(ra_,this,idx1));
    __ punpcklbw(as_XMMRegister(opnd_array(0)->reg(ra_,this)), as_XMMRegister(opnd_array(0)->reg(ra_,this)));
    __ pshuflw(as_XMMRegister(opnd_array(0)->reg(ra_,this)), as_XMMRegister(opnd_array(0)->reg(ra_,this)), 0x00);
  
#line 25915 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void Repl8B_eRegINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 3208 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    MacroAssembler _masm(&cbuf);

    __ movdl(as_XMMRegister(opnd_array(0)->reg(ra_,this)), as_Register(opnd_array(1)->reg(ra_,this,idx1)));
  
#line 25931 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 3182 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    MacroAssembler _masm(&cbuf);

    encode_CopyXD(cbuf, opnd_array(0)->reg(ra_,this), opnd_array(0)->reg(ra_,this));
    __ punpcklbw(as_XMMRegister(opnd_array(0)->reg(ra_,this)), as_XMMRegister(opnd_array(0)->reg(ra_,this)));
    __ pshuflw(as_XMMRegister(opnd_array(0)->reg(ra_,this)), as_XMMRegister(opnd_array(0)->reg(ra_,this)), 0x00);
  
#line 25943 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void Repl8B_immI0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 3202 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    MacroAssembler _masm(&cbuf);

    __ pxor(as_XMMRegister(opnd_array(0)->reg(ra_,this)), as_XMMRegister(opnd_array(0)->reg(ra_,this)));
  
#line 25959 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void Repl4S_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 3190 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    MacroAssembler _masm(&cbuf);

    __ pshuflw(as_XMMRegister(opnd_array(0)->reg(ra_,this)), as_XMMRegister(opnd_array(1)->reg(ra_,this,idx1)), 0x00);
  
#line 25975 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void Repl4S_eRegINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 3208 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    MacroAssembler _masm(&cbuf);

    __ movdl(as_XMMRegister(opnd_array(0)->reg(ra_,this)), as_Register(opnd_array(1)->reg(ra_,this,idx1)));
  
#line 25991 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 3190 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    MacroAssembler _masm(&cbuf);

    __ pshuflw(as_XMMRegister(opnd_array(0)->reg(ra_,this)), as_XMMRegister(opnd_array(0)->reg(ra_,this)), 0x00);
  
#line 26001 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void Repl4S_immI0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 3202 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    MacroAssembler _masm(&cbuf);

    __ pxor(as_XMMRegister(opnd_array(0)->reg(ra_,this)), as_XMMRegister(opnd_array(0)->reg(ra_,this)));
  
#line 26017 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void Repl4C_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 3190 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    MacroAssembler _masm(&cbuf);

    __ pshuflw(as_XMMRegister(opnd_array(0)->reg(ra_,this)), as_XMMRegister(opnd_array(1)->reg(ra_,this,idx1)), 0x00);
  
#line 26033 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void Repl4C_eRegINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 3208 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    MacroAssembler _masm(&cbuf);

    __ movdl(as_XMMRegister(opnd_array(0)->reg(ra_,this)), as_Register(opnd_array(1)->reg(ra_,this,idx1)));
  
#line 26049 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 3190 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    MacroAssembler _masm(&cbuf);

    __ pshuflw(as_XMMRegister(opnd_array(0)->reg(ra_,this)), as_XMMRegister(opnd_array(0)->reg(ra_,this)), 0x00);
  
#line 26059 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void Repl4C_immI0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 3202 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    MacroAssembler _masm(&cbuf);

    __ pxor(as_XMMRegister(opnd_array(0)->reg(ra_,this)), as_XMMRegister(opnd_array(0)->reg(ra_,this)));
  
#line 26075 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void Repl2I_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 3196 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    MacroAssembler _masm(&cbuf);

    __ pshufd(as_XMMRegister(opnd_array(0)->reg(ra_,this)), as_XMMRegister(opnd_array(1)->reg(ra_,this,idx1)), (0x00));
  
#line 26091 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void Repl2I_eRegINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 3208 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    MacroAssembler _masm(&cbuf);

    __ movdl(as_XMMRegister(opnd_array(0)->reg(ra_,this)), as_Register(opnd_array(1)->reg(ra_,this,idx1)));
  
#line 26107 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 3196 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    MacroAssembler _masm(&cbuf);

    __ pshufd(as_XMMRegister(opnd_array(0)->reg(ra_,this)), as_XMMRegister(opnd_array(0)->reg(ra_,this)), (0x00));
  
#line 26117 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void Repl2I_immI0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 3202 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    MacroAssembler _masm(&cbuf);

    __ pxor(as_XMMRegister(opnd_array(0)->reg(ra_,this)), as_XMMRegister(opnd_array(0)->reg(ra_,this)));
  
#line 26133 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void Repl2F_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 3196 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    MacroAssembler _masm(&cbuf);

    __ pshufd(as_XMMRegister(opnd_array(0)->reg(ra_,this)), as_XMMRegister(opnd_array(1)->reg(ra_,this,idx1)), (0xe0));
  
#line 26149 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void Repl2F_regXNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 3196 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    MacroAssembler _masm(&cbuf);

    __ pshufd(as_XMMRegister(opnd_array(0)->reg(ra_,this)), as_XMMRegister(opnd_array(1)->reg(ra_,this,idx1)), (0xe0));
  
#line 26165 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void Repl2F_immXF0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 3202 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    MacroAssembler _masm(&cbuf);

    __ pxor(as_XMMRegister(opnd_array(0)->reg(ra_,this)), as_XMMRegister(opnd_array(0)->reg(ra_,this)));
  
#line 26181 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void rep_stosNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xD1));
  
#line 26196 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1746 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x4 /*secondary()*/), (ECX_enc) );
  
#line 26204 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1603 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf,(0x33));
    emit_rm(cbuf, 0x3, (EAX_enc), (EAX_enc));
  
#line 26213 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xF3));
  
#line 26221 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1591 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xAB));
  
#line 26229 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void string_compareNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
    unsigned idx4 = idx3 + opnd_array(3)->num_edges();
    unsigned idx5 = idx4 + opnd_array(4)->num_edges();
  {
    MacroAssembler _masm(&cbuf);

#line 12642 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ string_compare(opnd_array(1)->as_Register(ra_,this,idx1), opnd_array(3)->as_Register(ra_,this,idx3),
                      opnd_array(2)->as_Register(ra_,this,idx2), opnd_array(4)->as_Register(ra_,this,idx4), opnd_array(0)->as_Register(ra_,this),
                      opnd_array(5)->as_XMMRegister(ra_,this,idx5));
  
#line 26250 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void string_equalsNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
    unsigned idx4 = idx3 + opnd_array(3)->num_edges();
    unsigned idx5 = idx4 + opnd_array(4)->num_edges();
  {
    MacroAssembler _masm(&cbuf);

#line 12657 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ char_arrays_equals(false, opnd_array(1)->as_Register(ra_,this,idx1), opnd_array(2)->as_Register(ra_,this,idx2),
                          opnd_array(3)->as_Register(ra_,this,idx3), opnd_array(0)->as_Register(ra_,this), as_Register(EBX_enc),
                          opnd_array(4)->as_XMMRegister(ra_,this,idx4), opnd_array(5)->as_XMMRegister(ra_,this,idx5));
  
#line 26271 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void string_indexof_conNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
    unsigned idx4 = idx3 + opnd_array(3)->num_edges();
    unsigned idx5 = idx4 + opnd_array(4)->num_edges();
  {
    MacroAssembler _masm(&cbuf);

#line 12673 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int icnt2 = (int)opnd_array(4)->constant();
    if (icnt2 >= 8) {
      // IndexOf for constant substrings with size >= 8 elements
      // which don't need to be loaded through stack.
      __ string_indexofC8(opnd_array(1)->as_Register(ra_,this,idx1), opnd_array(3)->as_Register(ra_,this,idx3),
                          opnd_array(2)->as_Register(ra_,this,idx2), as_Register(EAX_enc),
                          icnt2, opnd_array(0)->as_Register(ra_,this),
                          opnd_array(5)->as_XMMRegister(ra_,this,idx5), as_Register(ECX_enc));
    } else {
      // Small strings are loaded through stack if they cross page boundary.
      __ string_indexof(opnd_array(1)->as_Register(ra_,this,idx1), opnd_array(3)->as_Register(ra_,this,idx3),
                        opnd_array(2)->as_Register(ra_,this,idx2), as_Register(EAX_enc),
                        icnt2, opnd_array(0)->as_Register(ra_,this),
                        opnd_array(5)->as_XMMRegister(ra_,this,idx5), as_Register(ECX_enc));
    }
  
#line 26304 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void string_indexofNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
    unsigned idx4 = idx3 + opnd_array(3)->num_edges();
    unsigned idx5 = idx4 + opnd_array(4)->num_edges();
  {
    MacroAssembler _masm(&cbuf);

#line 12700 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ string_indexof(opnd_array(1)->as_Register(ra_,this,idx1), opnd_array(3)->as_Register(ra_,this,idx3),
                      opnd_array(2)->as_Register(ra_,this,idx2), opnd_array(4)->as_Register(ra_,this,idx4),
                      (-1), opnd_array(0)->as_Register(ra_,this),
                      opnd_array(5)->as_XMMRegister(ra_,this,idx5), as_Register(ECX_enc));
  
#line 26326 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void array_equalsNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
    unsigned idx4 = idx3 + opnd_array(3)->num_edges();
  {
    MacroAssembler _masm(&cbuf);

#line 12718 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    __ char_arrays_equals(true, opnd_array(1)->as_Register(ra_,this,idx1), opnd_array(2)->as_Register(ra_,this,idx2),
                          as_Register(ECX_enc), opnd_array(0)->as_Register(ra_,this), as_Register(EBX_enc),
                          opnd_array(3)->as_XMMRegister(ra_,this,idx3), opnd_array(4)->as_XMMRegister(ra_,this,idx4));
  
#line 26346 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void compI_eRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x3B /*primary()*/));
  
#line 26361 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2095 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1), opnd_array(2)->reg(ra_,this,idx2));
  
#line 26369 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void compI_eReg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1671 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Emit primary opcode and set sign-extend bit
    // Check for 8-bit immediate, and set sign extend bit in opcode
    if ((opnd_array(2)->constant() >= -128) && (opnd_array(2)->constant() <= 127)) {
      emit_opcode(cbuf, (0x81 /*primary()*/) | 0x02);    }
    else {                          // If 32-bit immediate
      emit_opcode(cbuf, (0x81 /*primary()*/));
    }
    // Emit r/m byte with secondary opcode, after primary opcode.
    emit_rm(cbuf, 0x3, (0x07 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1));
  
#line 26392 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1683 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Check for 8-bit immediate, and set sign extend bit in opcode
    if ((opnd_array(2)->constant() >= -128) && (opnd_array(2)->constant() <= 127)) {
      emit_d8(cbuf, opnd_array(2)->constant());
    }
    else {                          // If 32-bit immediate
      // Output immediate
      emit_d32(cbuf, opnd_array(2)->constant());
    }
  
#line 26407 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void compI_eReg_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x3B /*primary()*/));
  
#line 26422 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(1)->reg(ra_,this,idx1);
    int base  = opnd_array(2)->base(ra_,this,idx2);
    int index = opnd_array(2)->index(ra_,this,idx2);
    int scale = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2);
    bool disp_is_oop = opnd_array(2)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 26436 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void testI_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x85 /*primary()*/));
  
#line 26451 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2095 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1), opnd_array(1)->reg(ra_,this,idx1));
  
#line 26459 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void testI_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xF7 /*primary()*/));
  
#line 26475 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1746 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x00 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1) );
  
#line 26483 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2121 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Output immediate
    emit_d32(cbuf, opnd_array(2)->constant());
  
#line 26492 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void testI_reg_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x85 /*primary()*/));
  
#line 26508 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(1)->reg(ra_,this,idx1);
    int base  = opnd_array(2)->base(ra_,this,idx2);
    int index = opnd_array(2)->index(ra_,this,idx2);
    int scale = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2);
    bool disp_is_oop = opnd_array(2)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 26522 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void compU_eRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x3B /*primary()*/));
  
#line 26537 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2095 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1), opnd_array(2)->reg(ra_,this,idx2));
  
#line 26545 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void compU_eReg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1671 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Emit primary opcode and set sign-extend bit
    // Check for 8-bit immediate, and set sign extend bit in opcode
    if ((opnd_array(2)->constant() >= -128) && (opnd_array(2)->constant() <= 127)) {
      emit_opcode(cbuf, (0x81 /*primary()*/) | 0x02);    }
    else {                          // If 32-bit immediate
      emit_opcode(cbuf, (0x81 /*primary()*/));
    }
    // Emit r/m byte with secondary opcode, after primary opcode.
    emit_rm(cbuf, 0x3, (0x07 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1));
  
#line 26568 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1683 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Check for 8-bit immediate, and set sign extend bit in opcode
    if ((opnd_array(2)->constant() >= -128) && (opnd_array(2)->constant() <= 127)) {
      emit_d8(cbuf, opnd_array(2)->constant());
    }
    else {                          // If 32-bit immediate
      // Output immediate
      emit_d32(cbuf, opnd_array(2)->constant());
    }
  
#line 26583 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void compU_eReg_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x3B /*primary()*/));
  
#line 26598 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(1)->reg(ra_,this,idx1);
    int base  = opnd_array(2)->base(ra_,this,idx2);
    int index = opnd_array(2)->index(ra_,this,idx2);
    int scale = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2);
    bool disp_is_oop = opnd_array(2)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 26612 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void testU_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x85 /*primary()*/));
  
#line 26627 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2095 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1), opnd_array(1)->reg(ra_,this,idx1));
  
#line 26635 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void compP_eRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x3B /*primary()*/));
  
#line 26650 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2095 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1), opnd_array(2)->reg(ra_,this,idx2));
  
#line 26658 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void compP_eReg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1671 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Emit primary opcode and set sign-extend bit
    // Check for 8-bit immediate, and set sign extend bit in opcode
    if ((opnd_array(2)->constant() >= -128) && (opnd_array(2)->constant() <= 127)) {
      emit_opcode(cbuf, (0x81 /*primary()*/) | 0x02);    }
    else {                          // If 32-bit immediate
      emit_opcode(cbuf, (0x81 /*primary()*/));
    }
    // Emit r/m byte with secondary opcode, after primary opcode.
    emit_rm(cbuf, 0x3, (0x07 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1));
  
#line 26681 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1683 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Check for 8-bit immediate, and set sign extend bit in opcode
    if ((opnd_array(2)->constant() >= -128) && (opnd_array(2)->constant() <= 127)) {
      emit_d8(cbuf, opnd_array(2)->constant());
    }
    else {                          // If 32-bit immediate
      // Output immediate
      
if ( opnd_array(2)->constant_is_oop() ) {
  emit_d32_reloc(cbuf, opnd_array(2)->constant(), relocInfo::oop_type, 0);
} else {
  emit_d32(cbuf, opnd_array(2)->constant());
};
    }
  
#line 26701 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void compP_eReg_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x3B /*primary()*/));
  
#line 26716 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(1)->reg(ra_,this,idx1);
    int base  = opnd_array(2)->base(ra_,this,idx2);
    int index = opnd_array(2)->index(ra_,this,idx2);
    int scale = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2);
    bool disp_is_oop = opnd_array(2)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 26730 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void compP_mem_eRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x3B /*primary()*/));
  
#line 26745 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(1)->reg(ra_,this,idx1);
    int base  = opnd_array(2)->base(ra_,this,idx2);
    int index = opnd_array(2)->index(ra_,this,idx2);
    int scale = opnd_array(2)->scale();
    int displace = opnd_array(2)->disp(ra_,this,idx2);
    bool disp_is_oop = opnd_array(2)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 26759 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void testP_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x85 /*primary()*/));
  
#line 26774 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2095 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1), opnd_array(1)->reg(ra_,this,idx1));
  
#line 26782 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void testP_Reg_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xF7 /*primary()*/));
  
#line 26797 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2302 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int rm_byte_opcode = (0x00);
    int base     = opnd_array(1)->base(ra_,this,idx1);
    int index    = opnd_array(1)->index(ra_,this,idx1);
    int scale    = opnd_array(1)->scale();
    int displace = opnd_array(1)->disp(ra_,this,idx1);
    bool disp_is_oop = opnd_array(1)->disp_is_oop(); // disp-as-oop when working with static globals
    encode_RegMem(cbuf, rm_byte_opcode, base, index, scale, displace, disp_is_oop);
  
#line 26811 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2145 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d32(cbuf,(0xFFFFFFFF));
  
#line 26819 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void minI_eRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 2322 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Compare dst,src
    emit_opcode(cbuf,0x3B);
    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1), opnd_array(2)->reg(ra_,this,idx2));
    // jmp dst < src around move
    emit_opcode(cbuf,0x7C);
    emit_d8(cbuf,2);
    // move dst,src
    emit_opcode(cbuf,0x8B);
    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1), opnd_array(2)->reg(ra_,this,idx2));
  
#line 26842 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void maxI_eRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 2334 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Compare dst,src
    emit_opcode(cbuf,0x3B);
    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1), opnd_array(2)->reg(ra_,this,idx2));
    // jmp dst > src around move
    emit_opcode(cbuf,0x7F);
    emit_d8(cbuf,2);
    // move dst,src
    emit_opcode(cbuf,0x8B);
    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1), opnd_array(2)->reg(ra_,this,idx2));
  
#line 26865 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void loopLimit_eRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
    unsigned idx4 = idx3 + opnd_array(3)->num_edges();
    unsigned idx5 = idx4 + opnd_array(4)->num_edges();
  {
    MacroAssembler _masm(&cbuf);

#line 13001 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int strd = (int)opnd_array(3)->constant();
    assert(strd != 1 && strd != -1, "sanity");
    int m1 = (strd > 0) ? 1 : -1;
    // Convert limit to long (EAX:EDX)
    __ cdql();
    // Convert init to long (init:tmp)
    __ movl(opnd_array(5)->as_Register(ra_,this,idx5), opnd_array(1)->as_Register(ra_,this,idx1));
    __ sarl(opnd_array(5)->as_Register(ra_,this,idx5), 31);
    // $limit - $init
    __ subl(opnd_array(2)->as_Register(ra_,this,idx2), opnd_array(1)->as_Register(ra_,this,idx1));
    __ sbbl(opnd_array(4)->as_Register(ra_,this,idx4), opnd_array(5)->as_Register(ra_,this,idx5));
    // + ($stride - 1)
    if (strd > 0) {
      __ addl(opnd_array(2)->as_Register(ra_,this,idx2), (strd - 1));
      __ adcl(opnd_array(4)->as_Register(ra_,this,idx4), 0);
      __ movl(opnd_array(5)->as_Register(ra_,this,idx5), strd);
    } else {
      __ addl(opnd_array(2)->as_Register(ra_,this,idx2), (strd + 1));
      __ adcl(opnd_array(4)->as_Register(ra_,this,idx4), -1);
      __ lneg(opnd_array(4)->as_Register(ra_,this,idx4), opnd_array(2)->as_Register(ra_,this,idx2));
      __ movl(opnd_array(5)->as_Register(ra_,this,idx5), -strd);
    }
    // signed devision: (EAX:EDX) / pos_stride
    __ idivl(opnd_array(5)->as_Register(ra_,this,idx5));
    if (strd < 0) {
      // restore sign
      __ negl(opnd_array(5)->as_Register(ra_,this,idx5));
    }
    // (EAX) * stride
    __ mull(opnd_array(5)->as_Register(ra_,this,idx5));
    // + init (ignore upper bits)
    __ addl(opnd_array(2)->as_Register(ra_,this,idx2), opnd_array(1)->as_Register(ra_,this,idx1));
  
#line 26915 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void jumpXtndNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  ra_->C->constant_table().fill_jump_table(cbuf, (MachConstantNode*) this, _index2label);
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {
    MacroAssembler _masm(&cbuf);

#line 13045 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // Jump to Address(table_base + switch_reg)
    Address index(noreg, opnd_array(1)->as_Register(ra_,this,idx1), Address::times_1);
    __ jump(ArrayAddress(InternalAddress(__ code()->consts()->start() + constant_offset()), index));
  
#line 26933 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void jumpXtndNode::eval_constant(Compile* C) {
  _constant = C->constant_table().allocate_jump_table(this);
  // User did not define an encode section.
}
void jmpDirNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xE9 /*primary()*/));
  
#line 26951 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1716 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    Label *l = opnd_array(1)->label();
    emit_d32(cbuf, l ? (l->loc_pos() - (cbuf.insts_size()+4)) : 0);
  
#line 26960 "../generated/adfiles/ad_x86_32.cpp"
  }
}
uint  jmpDirNode::size(PhaseRegAlloc *ra_) const {
 assert(VerifyOops || MachNode::size(ra_) <= 5, "bad fixed size");
 return (VerifyOops ? MachNode::size(ra_) : 5);
}
void jmpConNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
  {

#line 1750 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    Label *l = opnd_array(3)->label();
    emit_d8(cbuf, (0x0F /*primary()*/));
    emit_cc(cbuf, (0x80 /*secondary()*/), opnd_array(1)->ccode());
    emit_d32(cbuf, l ? (l->loc_pos() - (cbuf.insts_size()+4)) : 0);
  
#line 26983 "../generated/adfiles/ad_x86_32.cpp"
  }
}
uint  jmpConNode::size(PhaseRegAlloc *ra_) const {
 assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
 return (VerifyOops ? MachNode::size(ra_) : 6);
}
void jmpLoopEndNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
  {

#line 1750 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    Label *l = opnd_array(3)->label();
    emit_d8(cbuf, (0x0F /*primary()*/));
    emit_cc(cbuf, (0x80 /*secondary()*/), opnd_array(1)->ccode());
    emit_d32(cbuf, l ? (l->loc_pos() - (cbuf.insts_size()+4)) : 0);
  
#line 27006 "../generated/adfiles/ad_x86_32.cpp"
  }
}
uint  jmpLoopEndNode::size(PhaseRegAlloc *ra_) const {
 assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
 return (VerifyOops ? MachNode::size(ra_) : 6);
}
void jmpLoopEndUNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
  {

#line 1750 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    Label *l = opnd_array(3)->label();
    emit_d8(cbuf, (0x0F /*primary()*/));
    emit_cc(cbuf, (0x80 /*secondary()*/), opnd_array(1)->ccode());
    emit_d32(cbuf, l ? (l->loc_pos() - (cbuf.insts_size()+4)) : 0);
  
#line 27029 "../generated/adfiles/ad_x86_32.cpp"
  }
}
uint  jmpLoopEndUNode::size(PhaseRegAlloc *ra_) const {
 assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
 return (VerifyOops ? MachNode::size(ra_) : 6);
}
void jmpLoopEndUCFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
  {

#line 1750 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    Label *l = opnd_array(3)->label();
    emit_d8(cbuf, (0x0F /*primary()*/));
    emit_cc(cbuf, (0x80 /*secondary()*/), opnd_array(1)->ccode());
    emit_d32(cbuf, l ? (l->loc_pos() - (cbuf.insts_size()+4)) : 0);
  
#line 27052 "../generated/adfiles/ad_x86_32.cpp"
  }
}
uint  jmpLoopEndUCFNode::size(PhaseRegAlloc *ra_) const {
 assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
 return (VerifyOops ? MachNode::size(ra_) : 6);
}
void jmpConUNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
  {

#line 1750 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    Label *l = opnd_array(3)->label();
    emit_d8(cbuf, (0x0F /*primary()*/));
    emit_cc(cbuf, (0x80 /*secondary()*/), opnd_array(1)->ccode());
    emit_d32(cbuf, l ? (l->loc_pos() - (cbuf.insts_size()+4)) : 0);
  
#line 27075 "../generated/adfiles/ad_x86_32.cpp"
  }
}
uint  jmpConUNode::size(PhaseRegAlloc *ra_) const {
 assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
 return (VerifyOops ? MachNode::size(ra_) : 6);
}
void jmpConUCFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
  {

#line 1750 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    Label *l = opnd_array(3)->label();
    emit_d8(cbuf, (0x0F /*primary()*/));
    emit_cc(cbuf, (0x80 /*secondary()*/), opnd_array(1)->ccode());
    emit_d32(cbuf, l ? (l->loc_pos() - (cbuf.insts_size()+4)) : 0);
  
#line 27098 "../generated/adfiles/ad_x86_32.cpp"
  }
}
uint  jmpConUCFNode::size(PhaseRegAlloc *ra_) const {
 assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
 return (VerifyOops ? MachNode::size(ra_) : 6);
}
void jmpConUCF2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
  {
    MacroAssembler _masm(&cbuf);

#line 13167 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    Label* l = opnd_array(3)->label();
    emit_d8(cbuf, (0x0F /*primary()*/));
    emit_cc(cbuf, (0x80 /*secondary()*/), Assembler::parity);
    int parity_disp = -1;
    bool ok = false;
    if (opnd_array(1)->ccode()== Assembler::notEqual) {
       // the two jumps 6 bytes apart so the jump distances are too
       parity_disp = l ? (l->loc_pos() - (cbuf.insts_size() + 4)) : 0;
    } else if (opnd_array(1)->ccode()== Assembler::equal) {
       parity_disp = 6;
       ok = true;
    } else {
       ShouldNotReachHere();
    }
    emit_d32(cbuf, parity_disp);
    emit_d8(cbuf, (0x0F /*primary()*/));
    emit_cc(cbuf, (0x80 /*secondary()*/), opnd_array(1)->ccode());
    int disp = l ? (l->loc_pos() - (cbuf.insts_size() + 4)) : 0;
    emit_d32(cbuf, disp);
  
#line 27137 "../generated/adfiles/ad_x86_32.cpp"
  }
}
uint  jmpConUCF2Node::size(PhaseRegAlloc *ra_) const {
 assert(VerifyOops || MachNode::size(ra_) <= 12, "bad fixed size");
 return (VerifyOops ? MachNode::size(ra_) : 12);
}
void partialSubtypeCheckNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1783 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    Register Redi = as_Register(EDI_enc); // result register
    Register Reax = as_Register(EAX_enc); // super class
    Register Recx = as_Register(ECX_enc); // killed
    Register Resi = as_Register(ESI_enc); // sub class
    Label miss;

    MacroAssembler _masm(&cbuf);
    __ check_klass_subtype_slow_path(Resi, Reax, Recx, Redi,
                                     NULL, &miss,
                                     /*set_cond_codes:*/ true);
    if ((0x1 /*primary()*/)) {
      __ xorptr(Redi, Redi);
    }
    __ bind(miss);
  
#line 27169 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void partialSubtypeCheck_vs_ZeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
  {

#line 1783 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    Register Redi = as_Register(EDI_enc); // result register
    Register Reax = as_Register(EAX_enc); // super class
    Register Recx = as_Register(ECX_enc); // killed
    Register Resi = as_Register(ESI_enc); // sub class
    Label miss;

    MacroAssembler _masm(&cbuf);
    __ check_klass_subtype_slow_path(Resi, Reax, Recx, Redi,
                                     NULL, &miss,
                                     /*set_cond_codes:*/ true);
    if ((0x0 /*primary()*/)) {
      __ xorptr(Redi, Redi);
    }
    __ bind(miss);
  
#line 27198 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void jmpDir_shortNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xEB /*primary()*/));
  
#line 27212 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1721 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    Label *l = opnd_array(1)->label();
    int disp = l ? (l->loc_pos() - (cbuf.insts_size()+1)) : 0;
    assert(-128 <= disp && disp <= 127, "Displacement too large for short jmp");
    emit_d8(cbuf, disp);
  
#line 27223 "../generated/adfiles/ad_x86_32.cpp"
  }
}
uint  jmpDir_shortNode::size(PhaseRegAlloc *ra_) const {
 assert(VerifyOops || MachNode::size(ra_) <= 2, "bad fixed size");
 return (VerifyOops ? MachNode::size(ra_) : 2);
}
void jmpCon_shortNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
  {

#line 1757 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    Label *l = opnd_array(3)->label();
    emit_cc(cbuf, (0x70 /*primary()*/), opnd_array(1)->ccode());
    int disp = l ? (l->loc_pos() - (cbuf.insts_size()+1)) : 0;
    assert(-128 <= disp && disp <= 127, "Displacement too large for short jmp");
    emit_d8(cbuf, disp);
  
#line 27247 "../generated/adfiles/ad_x86_32.cpp"
  }
}
uint  jmpCon_shortNode::size(PhaseRegAlloc *ra_) const {
 assert(VerifyOops || MachNode::size(ra_) <= 2, "bad fixed size");
 return (VerifyOops ? MachNode::size(ra_) : 2);
}
void jmpLoopEnd_shortNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
  {

#line 1757 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    Label *l = opnd_array(3)->label();
    emit_cc(cbuf, (0x70 /*primary()*/), opnd_array(1)->ccode());
    int disp = l ? (l->loc_pos() - (cbuf.insts_size()+1)) : 0;
    assert(-128 <= disp && disp <= 127, "Displacement too large for short jmp");
    emit_d8(cbuf, disp);
  
#line 27271 "../generated/adfiles/ad_x86_32.cpp"
  }
}
uint  jmpLoopEnd_shortNode::size(PhaseRegAlloc *ra_) const {
 assert(VerifyOops || MachNode::size(ra_) <= 2, "bad fixed size");
 return (VerifyOops ? MachNode::size(ra_) : 2);
}
void jmpLoopEndU_shortNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
  {

#line 1757 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    Label *l = opnd_array(3)->label();
    emit_cc(cbuf, (0x70 /*primary()*/), opnd_array(1)->ccode());
    int disp = l ? (l->loc_pos() - (cbuf.insts_size()+1)) : 0;
    assert(-128 <= disp && disp <= 127, "Displacement too large for short jmp");
    emit_d8(cbuf, disp);
  
#line 27295 "../generated/adfiles/ad_x86_32.cpp"
  }
}
uint  jmpLoopEndU_shortNode::size(PhaseRegAlloc *ra_) const {
 assert(VerifyOops || MachNode::size(ra_) <= 2, "bad fixed size");
 return (VerifyOops ? MachNode::size(ra_) : 2);
}
void jmpLoopEndUCF_shortNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
  {

#line 1757 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    Label *l = opnd_array(3)->label();
    emit_cc(cbuf, (0x70 /*primary()*/), opnd_array(1)->ccode());
    int disp = l ? (l->loc_pos() - (cbuf.insts_size()+1)) : 0;
    assert(-128 <= disp && disp <= 127, "Displacement too large for short jmp");
    emit_d8(cbuf, disp);
  
#line 27319 "../generated/adfiles/ad_x86_32.cpp"
  }
}
uint  jmpLoopEndUCF_shortNode::size(PhaseRegAlloc *ra_) const {
 assert(VerifyOops || MachNode::size(ra_) <= 2, "bad fixed size");
 return (VerifyOops ? MachNode::size(ra_) : 2);
}
void jmpConU_shortNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
  {

#line 1757 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    Label *l = opnd_array(3)->label();
    emit_cc(cbuf, (0x70 /*primary()*/), opnd_array(1)->ccode());
    int disp = l ? (l->loc_pos() - (cbuf.insts_size()+1)) : 0;
    assert(-128 <= disp && disp <= 127, "Displacement too large for short jmp");
    emit_d8(cbuf, disp);
  
#line 27343 "../generated/adfiles/ad_x86_32.cpp"
  }
}
uint  jmpConU_shortNode::size(PhaseRegAlloc *ra_) const {
 assert(VerifyOops || MachNode::size(ra_) <= 2, "bad fixed size");
 return (VerifyOops ? MachNode::size(ra_) : 2);
}
void jmpConUCF_shortNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
  {

#line 1757 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    Label *l = opnd_array(3)->label();
    emit_cc(cbuf, (0x70 /*primary()*/), opnd_array(1)->ccode());
    int disp = l ? (l->loc_pos() - (cbuf.insts_size()+1)) : 0;
    assert(-128 <= disp && disp <= 127, "Displacement too large for short jmp");
    emit_d8(cbuf, disp);
  
#line 27367 "../generated/adfiles/ad_x86_32.cpp"
  }
}
uint  jmpConUCF_shortNode::size(PhaseRegAlloc *ra_) const {
 assert(VerifyOops || MachNode::size(ra_) <= 2, "bad fixed size");
 return (VerifyOops ? MachNode::size(ra_) : 2);
}
void jmpConUCF2_shortNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
  {
    MacroAssembler _masm(&cbuf);

#line 13366 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    Label* l = opnd_array(3)->label();
    emit_cc(cbuf, (0x70 /*primary()*/), Assembler::parity);
    int parity_disp = -1;
    if (opnd_array(1)->ccode()== Assembler::notEqual) {
      parity_disp = l ? (l->loc_pos() - (cbuf.insts_size() + 1)) : 0;
    } else if (opnd_array(1)->ccode()== Assembler::equal) {
      parity_disp = 2;
    } else {
      ShouldNotReachHere();
    }
    emit_d8(cbuf, parity_disp);
    emit_cc(cbuf, (0x70 /*primary()*/), opnd_array(1)->ccode());
    int disp = l ? (l->loc_pos() - (cbuf.insts_size() + 1)) : 0;
    emit_d8(cbuf, disp);
    assert(-128 <= disp && disp <= 127, "Displacement too large for short jmp");
    assert(-128 <= parity_disp && parity_disp <= 127, "Displacement too large for short jmp");
  
#line 27403 "../generated/adfiles/ad_x86_32.cpp"
  }
}
uint  jmpConUCF2_shortNode::size(PhaseRegAlloc *ra_) const {
 assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
 return (VerifyOops ? MachNode::size(ra_) : 4);
}
void cmpL3_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {
    MacroAssembler _masm(&cbuf);

#line 13427 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    Label p_one, m_one, done;
    __ xorptr(opnd_array(0)->as_Register(ra_,this), opnd_array(0)->as_Register(ra_,this));
    __ cmpl(HIGH_FROM_LOW(opnd_array(1)->as_Register(ra_,this,idx1)), HIGH_FROM_LOW(opnd_array(2)->as_Register(ra_,this,idx2)));
    __ jccb(Assembler::less,    m_one);
    __ jccb(Assembler::greater, p_one);
    __ cmpl(opnd_array(1)->as_Register(ra_,this,idx1), opnd_array(2)->as_Register(ra_,this,idx2));
    __ jccb(Assembler::below,   m_one);
    __ jccb(Assembler::equal,   done);
    __ bind(p_one);
    __ incrementl(opnd_array(0)->as_Register(ra_,this));
    __ jmpb(done);
    __ bind(m_one);
    __ decrementl(opnd_array(0)->as_Register(ra_,this));
    __ bind(done);
  
#line 27436 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void cmpL_zero_flags_LTGENode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0x85 /*primary()*/));
  
#line 27451 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2113 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)), HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)));
  
#line 27459 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void cmpL_reg_flags_LTGENode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
  {

#line 3137 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // CMP    $src1.lo,$src2.lo\t! Long compare; set flags for low bits
    emit_opcode( cbuf, 0x3B );
    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1), opnd_array(2)->reg(ra_,this,idx2) );
    // MOV    $tmp,$src1.hi
    emit_opcode( cbuf, 0x8B );
    emit_rm(cbuf, 0x3, opnd_array(3)->reg(ra_,this,idx3), HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)) );
    // SBB   $tmp,$src2.hi\t! Compute flags for long compare
    emit_opcode( cbuf, 0x1B );
    emit_rm(cbuf, 0x3, opnd_array(3)->reg(ra_,this,idx3), HIGH_FROM_LOW(opnd_array(2)->reg(ra_,this,idx2)) );
  
#line 27483 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void cmovLL_reg_LTGENode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
    unsigned idx4 = idx3 + opnd_array(3)->num_edges();
  {

#line 1765 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x0F /*primary()*/));
    emit_cc(cbuf, (0x40 /*secondary()*/), opnd_array(1)->ccode());
  
#line 27501 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2109 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(3)->reg(ra_,this,idx3), opnd_array(4)->reg(ra_,this,idx4));
  
#line 27509 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1765 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x0F /*primary()*/));
    emit_cc(cbuf, (0x40 /*secondary()*/), opnd_array(1)->ccode());
  
#line 27518 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2113 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, HIGH_FROM_LOW(opnd_array(3)->reg(ra_,this,idx3)), HIGH_FROM_LOW(opnd_array(4)->reg(ra_,this,idx4)));
  
#line 27526 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void cmovLL_mem_LTGENode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
    unsigned idx4 = idx3 + opnd_array(3)->num_edges();
  {

#line 1765 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x0F /*primary()*/));
    emit_cc(cbuf, (0x40 /*secondary()*/), opnd_array(1)->ccode());
  
#line 27544 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(3)->reg(ra_,this,idx3);
    int base  = opnd_array(4)->base(ra_,this,idx4);
    int index = opnd_array(4)->index(ra_,this,idx4);
    int scale = opnd_array(4)->scale();
    int displace = opnd_array(4)->disp(ra_,this,idx4);
    bool disp_is_oop = opnd_array(4)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 27558 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1765 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x0F /*primary()*/));
    emit_cc(cbuf, (0x40 /*secondary()*/), opnd_array(1)->ccode());
  
#line 27567 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2222 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = HIGH_FROM_LOW(opnd_array(3)->reg(ra_,this,idx3));  // Hi register of pair, computed from lo
    int base  = opnd_array(4)->base(ra_,this,idx4);
    int index = opnd_array(4)->index(ra_,this,idx4);
    int scale = opnd_array(4)->scale();
    int displace = opnd_array(4)->disp(ra_,this,idx4) + 4;      // Offset is 4 further in memory
    assert( !opnd_array(4)->disp_is_oop(), "Cannot add 4 to oop" );
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, false/*disp_is_oop*/);
  
#line 27581 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void cmovII_reg_LTGENode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
    unsigned idx4 = idx3 + opnd_array(3)->num_edges();
  {

#line 1765 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x0F /*primary()*/));
    emit_cc(cbuf, (0x40 /*secondary()*/), opnd_array(1)->ccode());
  
#line 27599 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2095 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(3)->reg(ra_,this,idx3), opnd_array(4)->reg(ra_,this,idx4));
  
#line 27607 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void cmovII_mem_LTGENode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
    unsigned idx4 = idx3 + opnd_array(3)->num_edges();
  {

#line 1765 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x0F /*primary()*/));
    emit_cc(cbuf, (0x40 /*secondary()*/), opnd_array(1)->ccode());
  
#line 27625 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(3)->reg(ra_,this,idx3);
    int base  = opnd_array(4)->base(ra_,this,idx4);
    int index = opnd_array(4)->index(ra_,this,idx4);
    int scale = opnd_array(4)->scale();
    int displace = opnd_array(4)->disp(ra_,this,idx4);
    bool disp_is_oop = opnd_array(4)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 27639 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void cmovPP_reg_LTGENode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
    unsigned idx4 = idx3 + opnd_array(3)->num_edges();
  {

#line 1765 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x0F /*primary()*/));
    emit_cc(cbuf, (0x40 /*secondary()*/), opnd_array(1)->ccode());
  
#line 27657 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2095 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(3)->reg(ra_,this,idx3), opnd_array(4)->reg(ra_,this,idx4));
  
#line 27665 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void cmpL_zero_flags_EQNENode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
  {

#line 3116 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // MOV   $tmp,$src.lo
    emit_opcode(cbuf, 0x8B);
    emit_rm(cbuf, 0x3, opnd_array(3)->reg(ra_,this,idx3), opnd_array(1)->reg(ra_,this,idx1));
    // OR    $tmp,$src.hi
    emit_opcode(cbuf, 0x0B);
    emit_rm(cbuf, 0x3, opnd_array(3)->reg(ra_,this,idx3), HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)));
  
#line 27686 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void cmpL_reg_flags_EQNENode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 3125 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // CMP    $src1.lo,$src2.lo
    emit_opcode( cbuf, 0x3B );
    emit_rm(cbuf, 0x3, opnd_array(1)->reg(ra_,this,idx1), opnd_array(2)->reg(ra_,this,idx2) );
    // JNE,s  skip
    emit_cc(cbuf, 0x70, 0x5);
    emit_d8(cbuf,2);
    // CMP    $src1.hi,$src2.hi
    emit_opcode( cbuf, 0x3B );
    emit_rm(cbuf, 0x3, HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)), HIGH_FROM_LOW(opnd_array(2)->reg(ra_,this,idx2)) );
  
#line 27709 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void cmovLL_reg_EQNENode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
    unsigned idx4 = idx3 + opnd_array(3)->num_edges();
  {

#line 1765 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x0F /*primary()*/));
    emit_cc(cbuf, (0x40 /*secondary()*/), opnd_array(1)->ccode());
  
#line 27727 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2109 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(3)->reg(ra_,this,idx3), opnd_array(4)->reg(ra_,this,idx4));
  
#line 27735 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1765 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x0F /*primary()*/));
    emit_cc(cbuf, (0x40 /*secondary()*/), opnd_array(1)->ccode());
  
#line 27744 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2113 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, HIGH_FROM_LOW(opnd_array(3)->reg(ra_,this,idx3)), HIGH_FROM_LOW(opnd_array(4)->reg(ra_,this,idx4)));
  
#line 27752 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void cmovLL_mem_EQNENode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
    unsigned idx4 = idx3 + opnd_array(3)->num_edges();
  {

#line 1765 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x0F /*primary()*/));
    emit_cc(cbuf, (0x40 /*secondary()*/), opnd_array(1)->ccode());
  
#line 27770 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(3)->reg(ra_,this,idx3);
    int base  = opnd_array(4)->base(ra_,this,idx4);
    int index = opnd_array(4)->index(ra_,this,idx4);
    int scale = opnd_array(4)->scale();
    int displace = opnd_array(4)->disp(ra_,this,idx4);
    bool disp_is_oop = opnd_array(4)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 27784 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1765 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x0F /*primary()*/));
    emit_cc(cbuf, (0x40 /*secondary()*/), opnd_array(1)->ccode());
  
#line 27793 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2222 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = HIGH_FROM_LOW(opnd_array(3)->reg(ra_,this,idx3));  // Hi register of pair, computed from lo
    int base  = opnd_array(4)->base(ra_,this,idx4);
    int index = opnd_array(4)->index(ra_,this,idx4);
    int scale = opnd_array(4)->scale();
    int displace = opnd_array(4)->disp(ra_,this,idx4) + 4;      // Offset is 4 further in memory
    assert( !opnd_array(4)->disp_is_oop(), "Cannot add 4 to oop" );
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, false/*disp_is_oop*/);
  
#line 27807 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void cmovII_reg_EQNENode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
    unsigned idx4 = idx3 + opnd_array(3)->num_edges();
  {

#line 1765 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x0F /*primary()*/));
    emit_cc(cbuf, (0x40 /*secondary()*/), opnd_array(1)->ccode());
  
#line 27825 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2095 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(3)->reg(ra_,this,idx3), opnd_array(4)->reg(ra_,this,idx4));
  
#line 27833 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void cmovII_mem_EQNENode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
    unsigned idx4 = idx3 + opnd_array(3)->num_edges();
  {

#line 1765 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x0F /*primary()*/));
    emit_cc(cbuf, (0x40 /*secondary()*/), opnd_array(1)->ccode());
  
#line 27851 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(3)->reg(ra_,this,idx3);
    int base  = opnd_array(4)->base(ra_,this,idx4);
    int index = opnd_array(4)->index(ra_,this,idx4);
    int scale = opnd_array(4)->scale();
    int displace = opnd_array(4)->disp(ra_,this,idx4);
    bool disp_is_oop = opnd_array(4)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 27865 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void cmovPP_reg_EQNENode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
    unsigned idx4 = idx3 + opnd_array(3)->num_edges();
  {

#line 1765 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x0F /*primary()*/));
    emit_cc(cbuf, (0x40 /*secondary()*/), opnd_array(1)->ccode());
  
#line 27883 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2095 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(3)->reg(ra_,this,idx3), opnd_array(4)->reg(ra_,this,idx4));
  
#line 27891 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void cmpL_zero_flags_LEGTNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
  {

#line 3149 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // XOR    $tmp,$tmp
    emit_opcode(cbuf,0x33);  // XOR
    emit_rm(cbuf,0x3, opnd_array(3)->reg(ra_,this,idx3), opnd_array(3)->reg(ra_,this,idx3));
    // CMP    $tmp,$src.lo
    emit_opcode( cbuf, 0x3B );
    emit_rm(cbuf, 0x3, opnd_array(3)->reg(ra_,this,idx3), opnd_array(1)->reg(ra_,this,idx1) );
    // SBB    $tmp,$src.hi
    emit_opcode( cbuf, 0x1B );
    emit_rm(cbuf, 0x3, opnd_array(3)->reg(ra_,this,idx3), HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)) );
  
#line 27915 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void cmpL_reg_flags_LEGTNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
  {

#line 3137 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // CMP    $src1.lo,$src2.lo\t! Long compare; set flags for low bits
    emit_opcode( cbuf, 0x3B );
    emit_rm(cbuf, 0x3, opnd_array(2)->reg(ra_,this,idx2), opnd_array(1)->reg(ra_,this,idx1) );
    // MOV    $tmp,$src1.hi
    emit_opcode( cbuf, 0x8B );
    emit_rm(cbuf, 0x3, opnd_array(3)->reg(ra_,this,idx3), HIGH_FROM_LOW(opnd_array(2)->reg(ra_,this,idx2)) );
    // SBB   $tmp,$src2.hi\t! Compute flags for long compare
    emit_opcode( cbuf, 0x1B );
    emit_rm(cbuf, 0x3, opnd_array(3)->reg(ra_,this,idx3), HIGH_FROM_LOW(opnd_array(1)->reg(ra_,this,idx1)) );
  
#line 27939 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void cmovLL_reg_LEGTNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
    unsigned idx4 = idx3 + opnd_array(3)->num_edges();
  {

#line 1765 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x0F /*primary()*/));
    emit_cc(cbuf, (0x40 /*secondary()*/), opnd_array(1)->ccode());
  
#line 27957 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2109 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(3)->reg(ra_,this,idx3), opnd_array(4)->reg(ra_,this,idx4));
  
#line 27965 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1765 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x0F /*primary()*/));
    emit_cc(cbuf, (0x40 /*secondary()*/), opnd_array(1)->ccode());
  
#line 27974 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2113 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, HIGH_FROM_LOW(opnd_array(3)->reg(ra_,this,idx3)), HIGH_FROM_LOW(opnd_array(4)->reg(ra_,this,idx4)));
  
#line 27982 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void cmovLL_mem_LEGTNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
    unsigned idx4 = idx3 + opnd_array(3)->num_edges();
  {

#line 1765 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x0F /*primary()*/));
    emit_cc(cbuf, (0x40 /*secondary()*/), opnd_array(1)->ccode());
  
#line 28000 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(3)->reg(ra_,this,idx3);
    int base  = opnd_array(4)->base(ra_,this,idx4);
    int index = opnd_array(4)->index(ra_,this,idx4);
    int scale = opnd_array(4)->scale();
    int displace = opnd_array(4)->disp(ra_,this,idx4);
    bool disp_is_oop = opnd_array(4)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 28014 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1765 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x0F /*primary()*/));
    emit_cc(cbuf, (0x40 /*secondary()*/), opnd_array(1)->ccode());
  
#line 28023 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2222 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = HIGH_FROM_LOW(opnd_array(3)->reg(ra_,this,idx3));  // Hi register of pair, computed from lo
    int base  = opnd_array(4)->base(ra_,this,idx4);
    int index = opnd_array(4)->index(ra_,this,idx4);
    int scale = opnd_array(4)->scale();
    int displace = opnd_array(4)->disp(ra_,this,idx4) + 4;      // Offset is 4 further in memory
    assert( !opnd_array(4)->disp_is_oop(), "Cannot add 4 to oop" );
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, false/*disp_is_oop*/);
  
#line 28037 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void cmovII_reg_LEGTNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
    unsigned idx4 = idx3 + opnd_array(3)->num_edges();
  {

#line 1765 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x0F /*primary()*/));
    emit_cc(cbuf, (0x40 /*secondary()*/), opnd_array(1)->ccode());
  
#line 28055 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2095 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(3)->reg(ra_,this,idx3), opnd_array(4)->reg(ra_,this,idx4));
  
#line 28063 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void cmovII_mem_LEGTNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 2;
    unsigned idx1 = 2;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
    unsigned idx4 = idx3 + opnd_array(3)->num_edges();
  {

#line 1765 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x0F /*primary()*/));
    emit_cc(cbuf, (0x40 /*secondary()*/), opnd_array(1)->ccode());
  
#line 28081 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2212 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    int reg_encoding = opnd_array(3)->reg(ra_,this,idx3);
    int base  = opnd_array(4)->base(ra_,this,idx4);
    int index = opnd_array(4)->index(ra_,this,idx4);
    int scale = opnd_array(4)->scale();
    int displace = opnd_array(4)->disp(ra_,this,idx4);
    bool disp_is_oop = opnd_array(4)->disp_is_oop();
    encode_RegMem(cbuf, reg_encoding, base, index, scale, displace, disp_is_oop);
  
#line 28095 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void cmovPP_reg_LEGTNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
    unsigned idx4 = idx3 + opnd_array(3)->num_edges();
  {

#line 1765 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_d8(cbuf, (0x0F /*primary()*/));
    emit_cc(cbuf, (0x40 /*secondary()*/), opnd_array(1)->ccode());
  
#line 28113 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 2095 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, opnd_array(3)->reg(ra_,this,idx3), opnd_array(4)->reg(ra_,this,idx4));
  
#line 28121 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void CallStaticJavaDirectNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 1859 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // If method sets FPU control word restore it here
    debug_only(int off0 = cbuf.insts_size());
    if( Compile::current()->in_24_bit_fp_mode() ) {
      MacroAssembler masm(&cbuf);
      masm.fldcw(ExternalAddress(StubRoutines::addr_fpu_cntrl_wrd_std()));
    }
    debug_only(int off1 = cbuf.insts_size());
    assert(off1 - off0 == pre_call_FPU_size(), "correct size prediction");
  
#line 28142 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1893 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // CALL to fixup routine.  Fixup routine uses ScopeDesc info to determine
    // who we intended to call.
    cbuf.set_insts_mark();
    emit_d8(cbuf, (0xE8 /*primary()*/));
    if ( !_method ) {
      emit_d32_reloc(cbuf, (opnd_array(1)->method() - (int)(cbuf.insts_end()) - 4),
                     runtime_call_Relocation::spec(), RELOC_IMM32 );
    } else if(_optimized_virtual) {
      emit_d32_reloc(cbuf, (opnd_array(1)->method() - (int)(cbuf.insts_end()) - 4),
                     opt_virtual_call_Relocation::spec(), RELOC_IMM32 );
    } else {
      emit_d32_reloc(cbuf, (opnd_array(1)->method() - (int)(cbuf.insts_end()) - 4),
                     static_call_Relocation::spec(), RELOC_IMM32 );
    }
    if( _method ) {  // Emit stub for static call
      emit_java_to_interp(cbuf);
    }
  
#line 28166 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 67 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/os_cpu/linux_x86/vm/linux_x86_32.ad"

    if( VerifyStackAtCalls ) {
      // Check that stack depth is unchanged: find majik cookie on stack
      int framesize = ra_->reg2offset_unchecked(OptoReg::add(ra_->_matcher._old_SP,-3*VMRegImpl::slots_per_word));
      if(framesize >= 128) {
        emit_opcode(cbuf, 0x81); // cmp [esp+0],0xbadb1ood
        emit_d8(cbuf,0xBC);
        emit_d8(cbuf,0x24);
        emit_d32(cbuf,framesize); // Find majik cookie from ESP
        emit_d32(cbuf, 0xbadb100d);
      }
      else {
        emit_opcode(cbuf, 0x81); // cmp [esp+0],0xbadb1ood
        emit_d8(cbuf,0x7C);
        emit_d8(cbuf,0x24);
        emit_d8(cbuf,framesize); // Find majik cookie from ESP
        emit_d32(cbuf, 0xbadb100d);
      }
      // jmp EQ around INT3
      // QQQ TODO
      const int jump_around = 5; // size of call to breakpoint, 1 for CC
      emit_opcode(cbuf,0x74);
      emit_d8(cbuf, jump_around);
      // QQQ temporary
      emit_break(cbuf);
      // Die if stack mismatch
      // emit_opcode(cbuf,0xCC);
    }
  
#line 28200 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1870 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // If method sets FPU control word do it here also
    if( Compile::current()->in_24_bit_fp_mode() ) {
      MacroAssembler masm(&cbuf);
      masm.fldcw(ExternalAddress(StubRoutines::addr_fpu_cntrl_wrd_24()));
    }
  
#line 28212 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void CallStaticJavaHandleNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 1859 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // If method sets FPU control word restore it here
    debug_only(int off0 = cbuf.insts_size());
    if( Compile::current()->in_24_bit_fp_mode() ) {
      MacroAssembler masm(&cbuf);
      masm.fldcw(ExternalAddress(StubRoutines::addr_fpu_cntrl_wrd_std()));
    }
    debug_only(int off1 = cbuf.insts_size());
    assert(off1 - off0 == pre_call_FPU_size(), "correct size prediction");
  
#line 28233 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1878 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    debug_only(int off0 = cbuf.insts_size());
    MacroAssembler _masm(&cbuf);
    // RBP is preserved across all calls, even compiled calls.
    // Use it to preserve RSP in places where the callee might change the SP.
    __ movptr(rbp_mh_SP_save, rsp);
    debug_only(int off1 = cbuf.insts_size());
    assert(off1 - off0 == preserve_SP_size(), "correct size prediction");
  
#line 28247 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1893 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // CALL to fixup routine.  Fixup routine uses ScopeDesc info to determine
    // who we intended to call.
    cbuf.set_insts_mark();
    emit_d8(cbuf, (0xE8 /*primary()*/));
    if ( !_method ) {
      emit_d32_reloc(cbuf, (opnd_array(1)->method() - (int)(cbuf.insts_end()) - 4),
                     runtime_call_Relocation::spec(), RELOC_IMM32 );
    } else if(_optimized_virtual) {
      emit_d32_reloc(cbuf, (opnd_array(1)->method() - (int)(cbuf.insts_end()) - 4),
                     opt_virtual_call_Relocation::spec(), RELOC_IMM32 );
    } else {
      emit_d32_reloc(cbuf, (opnd_array(1)->method() - (int)(cbuf.insts_end()) - 4),
                     static_call_Relocation::spec(), RELOC_IMM32 );
    }
    if( _method ) {  // Emit stub for static call
      emit_java_to_interp(cbuf);
    }
  
#line 28271 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1888 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    MacroAssembler _masm(&cbuf);
    __ movptr(rsp, rbp_mh_SP_save);
  
#line 28280 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 67 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/os_cpu/linux_x86/vm/linux_x86_32.ad"

    if( VerifyStackAtCalls ) {
      // Check that stack depth is unchanged: find majik cookie on stack
      int framesize = ra_->reg2offset_unchecked(OptoReg::add(ra_->_matcher._old_SP,-3*VMRegImpl::slots_per_word));
      if(framesize >= 128) {
        emit_opcode(cbuf, 0x81); // cmp [esp+0],0xbadb1ood
        emit_d8(cbuf,0xBC);
        emit_d8(cbuf,0x24);
        emit_d32(cbuf,framesize); // Find majik cookie from ESP
        emit_d32(cbuf, 0xbadb100d);
      }
      else {
        emit_opcode(cbuf, 0x81); // cmp [esp+0],0xbadb1ood
        emit_d8(cbuf,0x7C);
        emit_d8(cbuf,0x24);
        emit_d8(cbuf,framesize); // Find majik cookie from ESP
        emit_d32(cbuf, 0xbadb100d);
      }
      // jmp EQ around INT3
      // QQQ TODO
      const int jump_around = 5; // size of call to breakpoint, 1 for CC
      emit_opcode(cbuf,0x74);
      emit_d8(cbuf, jump_around);
      // QQQ temporary
      emit_break(cbuf);
      // Die if stack mismatch
      // emit_opcode(cbuf,0xCC);
    }
  
#line 28314 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1870 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // If method sets FPU control word do it here also
    if( Compile::current()->in_24_bit_fp_mode() ) {
      MacroAssembler masm(&cbuf);
      masm.fldcw(ExternalAddress(StubRoutines::addr_fpu_cntrl_wrd_24()));
    }
  
#line 28326 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void CallDynamicJavaDirectNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 1859 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // If method sets FPU control word restore it here
    debug_only(int off0 = cbuf.insts_size());
    if( Compile::current()->in_24_bit_fp_mode() ) {
      MacroAssembler masm(&cbuf);
      masm.fldcw(ExternalAddress(StubRoutines::addr_fpu_cntrl_wrd_std()));
    }
    debug_only(int off1 = cbuf.insts_size());
    assert(off1 - off0 == pre_call_FPU_size(), "correct size prediction");
  
#line 28347 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1913 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // !!!!!
    // Generate  "Mov EAX,0x00", placeholder instruction to load oop-info
    // emit_call_dynamic_prologue( cbuf );
    cbuf.set_insts_mark();
    emit_opcode(cbuf, 0xB8 + EAX_enc);        // mov    EAX,-1
    emit_d32_reloc(cbuf, (int)Universe::non_oop_word(), oop_Relocation::spec_for_immediate(), RELOC_IMM32);
    address  virtual_call_oop_addr = cbuf.insts_mark();
    // CALL to fixup routine.  Fixup routine uses ScopeDesc info to determine
    // who we intended to call.
    cbuf.set_insts_mark();
    emit_d8(cbuf, (0xE8 /*primary()*/));
    emit_d32_reloc(cbuf, (opnd_array(1)->method() - (int)(cbuf.insts_end()) - 4),
                virtual_call_Relocation::spec(virtual_call_oop_addr), RELOC_IMM32 );
  
#line 28367 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 67 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/os_cpu/linux_x86/vm/linux_x86_32.ad"

    if( VerifyStackAtCalls ) {
      // Check that stack depth is unchanged: find majik cookie on stack
      int framesize = ra_->reg2offset_unchecked(OptoReg::add(ra_->_matcher._old_SP,-3*VMRegImpl::slots_per_word));
      if(framesize >= 128) {
        emit_opcode(cbuf, 0x81); // cmp [esp+0],0xbadb1ood
        emit_d8(cbuf,0xBC);
        emit_d8(cbuf,0x24);
        emit_d32(cbuf,framesize); // Find majik cookie from ESP
        emit_d32(cbuf, 0xbadb100d);
      }
      else {
        emit_opcode(cbuf, 0x81); // cmp [esp+0],0xbadb1ood
        emit_d8(cbuf,0x7C);
        emit_d8(cbuf,0x24);
        emit_d8(cbuf,framesize); // Find majik cookie from ESP
        emit_d32(cbuf, 0xbadb100d);
      }
      // jmp EQ around INT3
      // QQQ TODO
      const int jump_around = 5; // size of call to breakpoint, 1 for CC
      emit_opcode(cbuf,0x74);
      emit_d8(cbuf, jump_around);
      // QQQ temporary
      emit_break(cbuf);
      // Die if stack mismatch
      // emit_opcode(cbuf,0xCC);
    }
  
#line 28401 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1870 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // If method sets FPU control word do it here also
    if( Compile::current()->in_24_bit_fp_mode() ) {
      MacroAssembler masm(&cbuf);
      masm.fldcw(ExternalAddress(StubRoutines::addr_fpu_cntrl_wrd_24()));
    }
  
#line 28413 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void CallRuntimeDirectNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 1859 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // If method sets FPU control word restore it here
    debug_only(int off0 = cbuf.insts_size());
    if( Compile::current()->in_24_bit_fp_mode() ) {
      MacroAssembler masm(&cbuf);
      masm.fldcw(ExternalAddress(StubRoutines::addr_fpu_cntrl_wrd_std()));
    }
    debug_only(int off1 = cbuf.insts_size());
    assert(off1 - off0 == pre_call_FPU_size(), "correct size prediction");
  
#line 28434 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1800 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    MacroAssembler masm(&cbuf);
    int start = masm.offset();
    if (UseSSE >= 2) {
      if (VerifyFPU) {
        masm.verify_FPU(0, "must be empty in SSE2+ mode");
      }
    } else {
      // External c_calling_convention expects the FPU stack to be 'clean'.
      // Compiled code leaves it dirty.  Do cleanup now.
      masm.empty_FPU_stack();
    }
    if (sizeof_FFree_Float_Stack_All == -1) {
      sizeof_FFree_Float_Stack_All = masm.offset() - start;
    } else {
      assert(masm.offset() - start == sizeof_FFree_Float_Stack_All, "wrong size");
    }
  
#line 28457 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1826 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // This is the instruction starting address for relocation info.
    cbuf.set_insts_mark();
    emit_d8(cbuf, (0xE8 /*primary()*/));
    // CALL directly to the runtime
    emit_d32_reloc(cbuf, (opnd_array(1)->method() - (int)(cbuf.insts_end()) - 4),
                runtime_call_Relocation::spec(), RELOC_IMM32 );

    if (UseSSE >= 2) {
      MacroAssembler _masm(&cbuf);
      BasicType rt = tf()->return_type();

      if ((rt == T_FLOAT || rt == T_DOUBLE) && !return_value_is_used()) {
        // A C runtime call where the return value is unused.  In SSE2+
        // mode the result needs to be removed from the FPU stack.  It's
        // likely that this function call could be removed by the
        // optimizer if the C function is a pure function.
        __ ffree(0);
      } else if (rt == T_FLOAT) {
        __ lea(rsp, Address(rsp, -4));
        __ fstp_s(Address(rsp, 0));
        __ movflt(xmm0, Address(rsp, 0));
        __ lea(rsp, Address(rsp,  4));
      } else if (rt == T_DOUBLE) {
        __ lea(rsp, Address(rsp, -8));
        __ fstp_d(Address(rsp, 0));
        __ movdbl(xmm0, Address(rsp, 0));
        __ lea(rsp, Address(rsp,  8));
      }
    }
  
#line 28493 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1870 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // If method sets FPU control word do it here also
    if( Compile::current()->in_24_bit_fp_mode() ) {
      MacroAssembler masm(&cbuf);
      masm.fldcw(ExternalAddress(StubRoutines::addr_fpu_cntrl_wrd_24()));
    }
  
#line 28505 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void CallLeafDirectNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 1859 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // If method sets FPU control word restore it here
    debug_only(int off0 = cbuf.insts_size());
    if( Compile::current()->in_24_bit_fp_mode() ) {
      MacroAssembler masm(&cbuf);
      masm.fldcw(ExternalAddress(StubRoutines::addr_fpu_cntrl_wrd_std()));
    }
    debug_only(int off1 = cbuf.insts_size());
    assert(off1 - off0 == pre_call_FPU_size(), "correct size prediction");
  
#line 28526 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1800 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    MacroAssembler masm(&cbuf);
    int start = masm.offset();
    if (UseSSE >= 2) {
      if (VerifyFPU) {
        masm.verify_FPU(0, "must be empty in SSE2+ mode");
      }
    } else {
      // External c_calling_convention expects the FPU stack to be 'clean'.
      // Compiled code leaves it dirty.  Do cleanup now.
      masm.empty_FPU_stack();
    }
    if (sizeof_FFree_Float_Stack_All == -1) {
      sizeof_FFree_Float_Stack_All = masm.offset() - start;
    } else {
      assert(masm.offset() - start == sizeof_FFree_Float_Stack_All, "wrong size");
    }
  
#line 28549 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1826 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // This is the instruction starting address for relocation info.
    cbuf.set_insts_mark();
    emit_d8(cbuf, (0xE8 /*primary()*/));
    // CALL directly to the runtime
    emit_d32_reloc(cbuf, (opnd_array(1)->method() - (int)(cbuf.insts_end()) - 4),
                runtime_call_Relocation::spec(), RELOC_IMM32 );

    if (UseSSE >= 2) {
      MacroAssembler _masm(&cbuf);
      BasicType rt = tf()->return_type();

      if ((rt == T_FLOAT || rt == T_DOUBLE) && !return_value_is_used()) {
        // A C runtime call where the return value is unused.  In SSE2+
        // mode the result needs to be removed from the FPU stack.  It's
        // likely that this function call could be removed by the
        // optimizer if the C function is a pure function.
        __ ffree(0);
      } else if (rt == T_FLOAT) {
        __ lea(rsp, Address(rsp, -4));
        __ fstp_s(Address(rsp, 0));
        __ movflt(xmm0, Address(rsp, 0));
        __ lea(rsp, Address(rsp,  4));
      } else if (rt == T_DOUBLE) {
        __ lea(rsp, Address(rsp, -8));
        __ fstp_d(Address(rsp, 0));
        __ movdbl(xmm0, Address(rsp, 0));
        __ lea(rsp, Address(rsp,  8));
      }
    }
  
#line 28585 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1819 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    if( VerifyFPU ) {
      MacroAssembler masm(&cbuf);
      masm.verify_FPU( -3, "Returning from Runtime Leaf call");
    }
  
#line 28596 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1870 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // If method sets FPU control word do it here also
    if( Compile::current()->in_24_bit_fp_mode() ) {
      MacroAssembler masm(&cbuf);
      masm.fldcw(ExternalAddress(StubRoutines::addr_fpu_cntrl_wrd_24()));
    }
  
#line 28608 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void CallLeafNoFPDirectNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 1826 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // This is the instruction starting address for relocation info.
    cbuf.set_insts_mark();
    emit_d8(cbuf, (0xE8 /*primary()*/));
    // CALL directly to the runtime
    emit_d32_reloc(cbuf, (opnd_array(1)->method() - (int)(cbuf.insts_end()) - 4),
                runtime_call_Relocation::spec(), RELOC_IMM32 );

    if (UseSSE >= 2) {
      MacroAssembler _masm(&cbuf);
      BasicType rt = tf()->return_type();

      if ((rt == T_FLOAT || rt == T_DOUBLE) && !return_value_is_used()) {
        // A C runtime call where the return value is unused.  In SSE2+
        // mode the result needs to be removed from the FPU stack.  It's
        // likely that this function call could be removed by the
        // optimizer if the C function is a pure function.
        __ ffree(0);
      } else if (rt == T_FLOAT) {
        __ lea(rsp, Address(rsp, -4));
        __ fstp_s(Address(rsp, 0));
        __ movflt(xmm0, Address(rsp, 0));
        __ lea(rsp, Address(rsp,  4));
      } else if (rt == T_DOUBLE) {
        __ lea(rsp, Address(rsp, -8));
        __ fstp_d(Address(rsp, 0));
        __ movdbl(xmm0, Address(rsp, 0));
        __ lea(rsp, Address(rsp,  8));
      }
    }
  
#line 28650 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void RetNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 5;
    unsigned idx1 = 5;
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xC3 /*primary()*/));
  
#line 28664 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void TailCalljmpIndNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 5;
    unsigned idx1 = 5;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xFF /*primary()*/));
  
#line 28679 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1746 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x4 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1) );
  
#line 28687 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void tailjmpIndNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 5;
    unsigned idx1 = 5;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
  {

#line 3750 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf,0x5A);
  
#line 28702 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1581 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_opcode(cbuf, (0xFF /*primary()*/));
  
#line 28710 "../generated/adfiles/ad_x86_32.cpp"
  }
  {

#line 1746 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    emit_rm(cbuf, 0x3, (0x4 /*secondary()*/), opnd_array(1)->reg(ra_,this,idx1) );
  
#line 28718 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void CreateExceptionNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  // User did not define which encode class to use.
}
uint  CreateExceptionNode::size(PhaseRegAlloc *ra_) const {
 assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
 return (VerifyOops ? MachNode::size(ra_) : 0);
}
void RethrowExceptionNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 5;
    unsigned idx1 = 5;
  {

#line 3754 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    cbuf.set_insts_mark();
    emit_opcode(cbuf, 0xE9);        // jmp    entry
    emit_d32_reloc(cbuf, (int)OptoRuntime::rethrow_stub() - ((int)cbuf.insts_end())-4,
                   runtime_call_Relocation::spec(), RELOC_IMM32 );
  
#line 28746 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void cmpFastLockNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
    unsigned idx4 = idx3 + opnd_array(3)->num_edges();
  {

#line 3289 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"


    Register objReg = as_Register(opnd_array(1)->reg(ra_,this,idx1));
    Register boxReg = as_Register(opnd_array(2)->reg(ra_,this,idx2));
    Register tmpReg = as_Register(opnd_array(3)->reg(ra_,this,idx3));
    Register scrReg = as_Register(opnd_array(4)->reg(ra_,this,idx4));

    // Ensure the register assignents are disjoint
    guarantee (objReg != boxReg, "") ;
    guarantee (objReg != tmpReg, "") ;
    guarantee (objReg != scrReg, "") ;
    guarantee (boxReg != tmpReg, "") ;
    guarantee (boxReg != scrReg, "") ;
    guarantee (tmpReg == as_Register(EAX_enc), "") ;

    MacroAssembler masm(&cbuf);

    if (_counters != NULL) {
      masm.atomic_incl(ExternalAddress((address) _counters->total_entry_count_addr()));
    }
    if (EmitSync & 1) {
        // set box->dhw = unused_mark (3)
        // Force all sync thru slow-path: slow_enter() and slow_exit() 
        masm.movptr (Address(boxReg, 0), int32_t(markOopDesc::unused_mark())) ;             
        masm.cmpptr (rsp, (int32_t)0) ;                        
    } else 
    if (EmitSync & 2) { 
        Label DONE_LABEL ;           
        if (UseBiasedLocking) {
           // Note: tmpReg maps to the swap_reg argument and scrReg to the tmp_reg argument.
           masm.biased_locking_enter(boxReg, objReg, tmpReg, scrReg, false, DONE_LABEL, NULL, _counters);
        }

        masm.movptr(tmpReg, Address(objReg, 0)) ;          // fetch markword 
        masm.orptr (tmpReg, 0x1);
        masm.movptr(Address(boxReg, 0), tmpReg);           // Anticipate successful CAS 
        if (os::is_MP()) { masm.lock();  }
        masm.cmpxchgptr(boxReg, Address(objReg, 0));          // Updates tmpReg
        masm.jcc(Assembler::equal, DONE_LABEL);
        // Recursive locking
        masm.subptr(tmpReg, rsp);
        masm.andptr(tmpReg, (int32_t) 0xFFFFF003 );
        masm.movptr(Address(boxReg, 0), tmpReg);
        masm.bind(DONE_LABEL) ; 
    } else {  
      // Possible cases that we'll encounter in fast_lock 
      // ------------------------------------------------
      // * Inflated
      //    -- unlocked
      //    -- Locked
      //       = by self
      //       = by other
      // * biased
      //    -- by Self
      //    -- by other
      // * neutral
      // * stack-locked
      //    -- by self
      //       = sp-proximity test hits
      //       = sp-proximity test generates false-negative
      //    -- by other
      //

      Label IsInflated, DONE_LABEL, PopDone ;

      // TODO: optimize away redundant LDs of obj->mark and improve the markword triage
      // order to reduce the number of conditional branches in the most common cases.
      // Beware -- there's a subtle invariant that fetch of the markword
      // at [FETCH], below, will never observe a biased encoding (*101b).
      // If this invariant is not held we risk exclusion (safety) failure.
      if (UseBiasedLocking && !UseOptoBiasInlining) {
        masm.biased_locking_enter(boxReg, objReg, tmpReg, scrReg, false, DONE_LABEL, NULL, _counters);
      }

      masm.movptr(tmpReg, Address(objReg, 0)) ;         // [FETCH]
      masm.testptr(tmpReg, 0x02) ;                      // Inflated v (Stack-locked or neutral)
      masm.jccb  (Assembler::notZero, IsInflated) ;

      // Attempt stack-locking ...
      masm.orptr (tmpReg, 0x1);
      masm.movptr(Address(boxReg, 0), tmpReg);          // Anticipate successful CAS
      if (os::is_MP()) { masm.lock();  }
      masm.cmpxchgptr(boxReg, Address(objReg, 0));           // Updates tmpReg
      if (_counters != NULL) {
        masm.cond_inc32(Assembler::equal,
                        ExternalAddress((address)_counters->fast_path_entry_count_addr()));
      }
      masm.jccb (Assembler::equal, DONE_LABEL);

      // Recursive locking
      masm.subptr(tmpReg, rsp);
      masm.andptr(tmpReg, 0xFFFFF003 );
      masm.movptr(Address(boxReg, 0), tmpReg);
      if (_counters != NULL) {
        masm.cond_inc32(Assembler::equal,
                        ExternalAddress((address)_counters->fast_path_entry_count_addr()));
      }
      masm.jmp  (DONE_LABEL) ;

      masm.bind (IsInflated) ;

      // The object is inflated.
      //
      // TODO-FIXME: eliminate the ugly use of manifest constants:
      //   Use markOopDesc::monitor_value instead of "2".
      //   use markOop::unused_mark() instead of "3".
      // The tmpReg value is an objectMonitor reference ORed with
      // markOopDesc::monitor_value (2).   We can either convert tmpReg to an
      // objectmonitor pointer by masking off the "2" bit or we can just
      // use tmpReg as an objectmonitor pointer but bias the objectmonitor
      // field offsets with "-2" to compensate for and annul the low-order tag bit.
      //
      // I use the latter as it avoids AGI stalls.
      // As such, we write "mov r, [tmpReg+OFFSETOF(Owner)-2]"
      // instead of "mov r, [tmpReg+OFFSETOF(Owner)]".
      //
      #define OFFSET_SKEWED(f) ((ObjectMonitor::f ## _offset_in_bytes())-2)

      // boxReg refers to the on-stack BasicLock in the current frame.
      // We'd like to write:
      //   set box->_displaced_header = markOop::unused_mark().  Any non-0 value suffices.
      // This is convenient but results a ST-before-CAS penalty.  The following CAS suffers
      // additional latency as we have another ST in the store buffer that must drain.

      if (EmitSync & 8192) { 
         masm.movptr(Address(boxReg, 0), 3) ;            // results in ST-before-CAS penalty
         masm.get_thread (scrReg) ; 
         masm.movptr(boxReg, tmpReg);                    // consider: LEA box, [tmp-2] 
         masm.movptr(tmpReg, NULL_WORD);                 // consider: xor vs mov
         if (os::is_MP()) { masm.lock(); } 
         masm.cmpxchgptr(scrReg, Address(boxReg, ObjectMonitor::owner_offset_in_bytes()-2)) ; 
      } else 
      if ((EmitSync & 128) == 0) {                      // avoid ST-before-CAS
         masm.movptr(scrReg, boxReg) ; 
         masm.movptr(boxReg, tmpReg);                   // consider: LEA box, [tmp-2] 

         // Using a prefetchw helps avoid later RTS->RTO upgrades and cache probes
         if ((EmitSync & 2048) && VM_Version::supports_3dnow_prefetch() && os::is_MP()) {
            // prefetchw [eax + Offset(_owner)-2]
            masm.prefetchw(Address(rax, ObjectMonitor::owner_offset_in_bytes()-2));
         }

         if ((EmitSync & 64) == 0) {
           // Optimistic form: consider XORL tmpReg,tmpReg
           masm.movptr(tmpReg, NULL_WORD) ; 
         } else { 
           // Can suffer RTS->RTO upgrades on shared or cold $ lines
           // Test-And-CAS instead of CAS
           masm.movptr(tmpReg, Address (tmpReg, ObjectMonitor::owner_offset_in_bytes()-2)) ;   // rax, = m->_owner
           masm.testptr(tmpReg, tmpReg) ;                   // Locked ? 
           masm.jccb  (Assembler::notZero, DONE_LABEL) ;                   
         }

         // Appears unlocked - try to swing _owner from null to non-null.
         // Ideally, I'd manifest "Self" with get_thread and then attempt
         // to CAS the register containing Self into m->Owner.
         // But we don't have enough registers, so instead we can either try to CAS
         // rsp or the address of the box (in scr) into &m->owner.  If the CAS succeeds
         // we later store "Self" into m->Owner.  Transiently storing a stack address
         // (rsp or the address of the box) into  m->owner is harmless.
         // Invariant: tmpReg == 0.  tmpReg is EAX which is the implicit cmpxchg comparand.
         if (os::is_MP()) { masm.lock();  }
         masm.cmpxchgptr(scrReg, Address(boxReg, ObjectMonitor::owner_offset_in_bytes()-2)) ; 
         masm.movptr(Address(scrReg, 0), 3) ;          // box->_displaced_header = 3
         masm.jccb  (Assembler::notZero, DONE_LABEL) ; 
         masm.get_thread (scrReg) ;                    // beware: clobbers ICCs
         masm.movptr(Address(boxReg, ObjectMonitor::owner_offset_in_bytes()-2), scrReg) ; 
         masm.xorptr(boxReg, boxReg) ;                 // set icc.ZFlag = 1 to indicate success
                       
         // If the CAS fails we can either retry or pass control to the slow-path.  
         // We use the latter tactic.  
         // Pass the CAS result in the icc.ZFlag into DONE_LABEL
         // If the CAS was successful ...
         //   Self has acquired the lock
         //   Invariant: m->_recursions should already be 0, so we don't need to explicitly set it.
         // Intentional fall-through into DONE_LABEL ...
      } else {
         masm.movptr(Address(boxReg, 0), 3) ;       // results in ST-before-CAS penalty
         masm.movptr(boxReg, tmpReg) ; 

         // Using a prefetchw helps avoid later RTS->RTO upgrades and cache probes
         if ((EmitSync & 2048) && VM_Version::supports_3dnow_prefetch() && os::is_MP()) {
            // prefetchw [eax + Offset(_owner)-2]
            masm.prefetchw(Address(rax, ObjectMonitor::owner_offset_in_bytes()-2));
         }

         if ((EmitSync & 64) == 0) {
           // Optimistic form
           masm.xorptr  (tmpReg, tmpReg) ; 
         } else { 
           // Can suffer RTS->RTO upgrades on shared or cold $ lines
           masm.movptr(tmpReg, Address (tmpReg, ObjectMonitor::owner_offset_in_bytes()-2)) ;   // rax, = m->_owner
           masm.testptr(tmpReg, tmpReg) ;                   // Locked ? 
           masm.jccb  (Assembler::notZero, DONE_LABEL) ;                   
         }

         // Appears unlocked - try to swing _owner from null to non-null.
         // Use either "Self" (in scr) or rsp as thread identity in _owner.
         // Invariant: tmpReg == 0.  tmpReg is EAX which is the implicit cmpxchg comparand.
         masm.get_thread (scrReg) ;
         if (os::is_MP()) { masm.lock(); }
         masm.cmpxchgptr(scrReg, Address(boxReg, ObjectMonitor::owner_offset_in_bytes()-2)) ;

         // If the CAS fails we can either retry or pass control to the slow-path.
         // We use the latter tactic.
         // Pass the CAS result in the icc.ZFlag into DONE_LABEL
         // If the CAS was successful ...
         //   Self has acquired the lock
         //   Invariant: m->_recursions should already be 0, so we don't need to explicitly set it.
         // Intentional fall-through into DONE_LABEL ...
      }

      // DONE_LABEL is a hot target - we'd really like to place it at the
      // start of cache line by padding with NOPs.
      // See the AMD and Intel software optimization manuals for the
      // most efficient "long" NOP encodings.
      // Unfortunately none of our alignment mechanisms suffice.
      masm.bind(DONE_LABEL);

      // Avoid branch-to-branch on AMD processors
      // This appears to be superstition.
      if (EmitSync & 32) masm.nop() ;


      // At DONE_LABEL the icc ZFlag is set as follows ...
      // Fast_Unlock uses the same protocol.
      // ZFlag == 1 -> Success
      // ZFlag == 0 -> Failure - force control through the slow-path
    }
  
#line 28990 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void cmpFastUnlockNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
    unsigned idx2 = idx1 + opnd_array(1)->num_edges();
    unsigned idx3 = idx2 + opnd_array(2)->num_edges();
  {

#line 3547 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"


    Register objReg = as_Register(opnd_array(1)->reg(ra_,this,idx1));
    Register boxReg = as_Register(opnd_array(2)->reg(ra_,this,idx2));
    Register tmpReg = as_Register(opnd_array(3)->reg(ra_,this,idx3));

    guarantee (objReg != boxReg, "") ;
    guarantee (objReg != tmpReg, "") ;
    guarantee (boxReg != tmpReg, "") ;
    guarantee (boxReg == as_Register(EAX_enc), "") ;
    MacroAssembler masm(&cbuf);

    if (EmitSync & 4) {
      // Disable - inhibit all inlining.  Force control through the slow-path
      masm.cmpptr (rsp, 0) ; 
    } else 
    if (EmitSync & 8) {
      Label DONE_LABEL ;
      if (UseBiasedLocking) {
         masm.biased_locking_exit(objReg, tmpReg, DONE_LABEL);
      }
      // classic stack-locking code ...
      masm.movptr(tmpReg, Address(boxReg, 0)) ;
      masm.testptr(tmpReg, tmpReg) ;
      masm.jcc   (Assembler::zero, DONE_LABEL) ;
      if (os::is_MP()) { masm.lock(); }
      masm.cmpxchgptr(tmpReg, Address(objReg, 0));          // Uses EAX which is box
      masm.bind(DONE_LABEL);
    } else {
      Label DONE_LABEL, Stacked, CheckSucc, Inflated ;

      // Critically, the biased locking test must have precedence over
      // and appear before the (box->dhw == 0) recursive stack-lock test.
      if (UseBiasedLocking && !UseOptoBiasInlining) {
         masm.biased_locking_exit(objReg, tmpReg, DONE_LABEL);
      }
      
      masm.cmpptr(Address(boxReg, 0), 0) ;            // Examine the displaced header
      masm.movptr(tmpReg, Address(objReg, 0)) ;       // Examine the object's markword
      masm.jccb  (Assembler::zero, DONE_LABEL) ;      // 0 indicates recursive stack-lock

      masm.testptr(tmpReg, 0x02) ;                     // Inflated? 
      masm.jccb  (Assembler::zero, Stacked) ;

      masm.bind  (Inflated) ;
      // It's inflated.
      // Despite our balanced locking property we still check that m->_owner == Self
      // as java routines or native JNI code called by this thread might
      // have released the lock.
      // Refer to the comments in synchronizer.cpp for how we might encode extra
      // state in _succ so we can avoid fetching EntryList|cxq.
      //
      // I'd like to add more cases in fast_lock() and fast_unlock() --
      // such as recursive enter and exit -- but we have to be wary of
      // I$ bloat, T$ effects and BP$ effects.
      //
      // If there's no contention try a 1-0 exit.  That is, exit without
      // a costly MEMBAR or CAS.  See synchronizer.cpp for details on how
      // we detect and recover from the race that the 1-0 exit admits.
      //
      // Conceptually Fast_Unlock() must execute a STST|LDST "release" barrier
      // before it STs null into _owner, releasing the lock.  Updates
      // to data protected by the critical section must be visible before
      // we drop the lock (and thus before any other thread could acquire
      // the lock and observe the fields protected by the lock).
      // IA32's memory-model is SPO, so STs are ordered with respect to
      // each other and there's no need for an explicit barrier (fence).
      // See also http://gee.cs.oswego.edu/dl/jmm/cookbook.html.

      masm.get_thread (boxReg) ;
      if ((EmitSync & 4096) && VM_Version::supports_3dnow_prefetch() && os::is_MP()) {
        // prefetchw [ebx + Offset(_owner)-2]
        masm.prefetchw(Address(rbx, ObjectMonitor::owner_offset_in_bytes()-2));
      }

      // Note that we could employ various encoding schemes to reduce
      // the number of loads below (currently 4) to just 2 or 3.
      // Refer to the comments in synchronizer.cpp.
      // In practice the chain of fetches doesn't seem to impact performance, however.
      if ((EmitSync & 65536) == 0 && (EmitSync & 256)) {
         // Attempt to reduce branch density - AMD's branch predictor.
         masm.xorptr(boxReg, Address (tmpReg, ObjectMonitor::owner_offset_in_bytes()-2)) ;  
         masm.orptr(boxReg, Address (tmpReg, ObjectMonitor::recursions_offset_in_bytes()-2)) ;
         masm.orptr(boxReg, Address (tmpReg, ObjectMonitor::EntryList_offset_in_bytes()-2)) ; 
         masm.orptr(boxReg, Address (tmpReg, ObjectMonitor::cxq_offset_in_bytes()-2)) ; 
         masm.jccb  (Assembler::notZero, DONE_LABEL) ; 
         masm.movptr(Address (tmpReg, ObjectMonitor::owner_offset_in_bytes()-2), NULL_WORD) ; 
         masm.jmpb  (DONE_LABEL) ; 
      } else { 
         masm.xorptr(boxReg, Address (tmpReg, ObjectMonitor::owner_offset_in_bytes()-2)) ;  
         masm.orptr(boxReg, Address (tmpReg, ObjectMonitor::recursions_offset_in_bytes()-2)) ;
         masm.jccb  (Assembler::notZero, DONE_LABEL) ; 
         masm.movptr(boxReg, Address (tmpReg, ObjectMonitor::EntryList_offset_in_bytes()-2)) ; 
         masm.orptr(boxReg, Address (tmpReg, ObjectMonitor::cxq_offset_in_bytes()-2)) ; 
         masm.jccb  (Assembler::notZero, CheckSucc) ; 
         masm.movptr(Address (tmpReg, ObjectMonitor::owner_offset_in_bytes()-2), NULL_WORD) ; 
         masm.jmpb  (DONE_LABEL) ; 
      }

      // The Following code fragment (EmitSync & 65536) improves the performance of
      // contended applications and contended synchronization microbenchmarks.
      // Unfortunately the emission of the code - even though not executed - causes regressions
      // in scimark and jetstream, evidently because of $ effects.  Replacing the code
      // with an equal number of never-executed NOPs results in the same regression.
      // We leave it off by default.

      if ((EmitSync & 65536) != 0) {
         Label LSuccess, LGoSlowPath ;

         masm.bind  (CheckSucc) ;

         // Optional pre-test ... it's safe to elide this
         if ((EmitSync & 16) == 0) { 
            masm.cmpptr(Address (tmpReg, ObjectMonitor::succ_offset_in_bytes()-2), 0) ; 
            masm.jccb  (Assembler::zero, LGoSlowPath) ; 
         }

         // We have a classic Dekker-style idiom:
         //    ST m->_owner = 0 ; MEMBAR; LD m->_succ
         // There are a number of ways to implement the barrier:
         // (1) lock:andl &m->_owner, 0
         //     is fast, but mask doesn't currently support the "ANDL M,IMM32" form.
         //     LOCK: ANDL [ebx+Offset(_Owner)-2], 0
         //     Encodes as 81 31 OFF32 IMM32 or 83 63 OFF8 IMM8
         // (2) If supported, an explicit MFENCE is appealing.
         //     In older IA32 processors MFENCE is slower than lock:add or xchg
         //     particularly if the write-buffer is full as might be the case if
         //     if stores closely precede the fence or fence-equivalent instruction.
         //     In more modern implementations MFENCE appears faster, however.
         // (3) In lieu of an explicit fence, use lock:addl to the top-of-stack
         //     The $lines underlying the top-of-stack should be in M-state.
         //     The locked add instruction is serializing, of course.
         // (4) Use xchg, which is serializing
         //     mov boxReg, 0; xchgl boxReg, [tmpReg + Offset(_owner)-2] also works
         // (5) ST m->_owner = 0 and then execute lock:orl &m->_succ, 0.
         //     The integer condition codes will tell us if succ was 0.
         //     Since _succ and _owner should reside in the same $line and
         //     we just stored into _owner, it's likely that the $line
         //     remains in M-state for the lock:orl.
         //
         // We currently use (3), although it's likely that switching to (2)
         // is correct for the future.
            
         masm.movptr(Address (tmpReg, ObjectMonitor::owner_offset_in_bytes()-2), NULL_WORD) ; 
         if (os::is_MP()) { 
            if (VM_Version::supports_sse2() && 1 == FenceInstruction) { 
              masm.mfence();
            } else { 
              masm.lock () ; masm.addptr(Address(rsp, 0), 0) ; 
            }
         }
         // Ratify _succ remains non-null
         masm.cmpptr(Address (tmpReg, ObjectMonitor::succ_offset_in_bytes()-2), 0) ; 
         masm.jccb  (Assembler::notZero, LSuccess) ; 

         masm.xorptr(boxReg, boxReg) ;                  // box is really EAX
         if (os::is_MP()) { masm.lock(); }
         masm.cmpxchgptr(rsp, Address(tmpReg, ObjectMonitor::owner_offset_in_bytes()-2));
         masm.jccb  (Assembler::notEqual, LSuccess) ;
         // Since we're low on registers we installed rsp as a placeholding in _owner.
         // Now install Self over rsp.  This is safe as we're transitioning from
         // non-null to non=null
         masm.get_thread (boxReg) ;
         masm.movptr(Address (tmpReg, ObjectMonitor::owner_offset_in_bytes()-2), boxReg) ;
         // Intentional fall-through into LGoSlowPath ...

         masm.bind  (LGoSlowPath) ; 
         masm.orptr(boxReg, 1) ;                      // set ICC.ZF=0 to indicate failure
         masm.jmpb  (DONE_LABEL) ; 

         masm.bind  (LSuccess) ; 
         masm.xorptr(boxReg, boxReg) ;                 // set ICC.ZF=1 to indicate success
         masm.jmpb  (DONE_LABEL) ; 
      }

      masm.bind (Stacked) ;
      // It's not inflated and it's not recursively stack-locked and it's not biased.
      // It must be stack-locked.
      // Try to reset the header to displaced header.
      // The "box" value on the stack is stable, so we can reload
      // and be assured we observe the same value as above.
      masm.movptr(tmpReg, Address(boxReg, 0)) ;
      if (os::is_MP()) {   masm.lock();    }
      masm.cmpxchgptr(tmpReg, Address(objReg, 0)); // Uses EAX which is box
      // Intention fall-thru into DONE_LABEL


      // DONE_LABEL is a hot target - we'd really like to place it at the
      // start of cache line by padding with NOPs.
      // See the AMD and Intel software optimization manuals for the
      // most efficient "long" NOP encodings.
      // Unfortunately none of our alignment mechanisms suffice.
      if ((EmitSync & 65536) == 0) {
         masm.bind (CheckSucc) ;
      }
      masm.bind(DONE_LABEL);

      // Avoid branch to branch on AMD processors
      if (EmitSync & 32768) { masm.nop() ; }
    }
  
#line 29204 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void safePoint_pollNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 5;
    unsigned idx1 = 5;
  {

#line 4329 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    cbuf.relocate(cbuf.insts_mark(), relocInfo::poll_type, 0);
    emit_opcode(cbuf,0x85);
    emit_rm (cbuf, 0x0, 0x7, 0x5);
    emit_d32(cbuf, (intptr_t)os::get_polling_page());
  
#line 29221 "../generated/adfiles/ad_x86_32.cpp"
  }
}
uint  safePoint_pollNode::size(PhaseRegAlloc *ra_) const {
 assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
 return (VerifyOops ? MachNode::size(ra_) : 6);
}
void tlsLoadPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 1;
    unsigned idx1 = 1;
  {

#line 56 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/os_cpu/linux_x86/vm/linux_x86_32.ad"

    Register dstReg = as_Register(opnd_array(0)->reg(ra_,this));
    MacroAssembler* masm = new MacroAssembler(&cbuf);
      masm->get_thread(dstReg);
  
#line 29241 "../generated/adfiles/ad_x86_32.cpp"
  }
}
void ShouldNotReachHereNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
    // Start at oper_input_base() and count operands
    unsigned idx0 = 5;
    unsigned idx1 = 5;
  {

#line 62 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/os_cpu/linux_x86/vm/linux_x86_32.ad"

    MacroAssembler* masm = new MacroAssembler(&cbuf);
    masm->call(RuntimeAddress(CAST_FROM_FN_PTR(address, os::breakpoint)));
  
#line 29256 "../generated/adfiles/ad_x86_32.cpp"
  }
}
const MachOper* popCountI_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* popCountL_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadBNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadB2LNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUBNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUB2LNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUB2L_immI8Node::memory_operand() const { return _opnds[1]; }
const MachOper* loadSNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadS2BNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadS2LNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUSNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUS2BNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUS2LNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUS2L_immI_255Node::memory_operand() const { return _opnds[1]; }
const MachOper* loadUS2L_immI16Node::memory_operand() const { return _opnds[1]; }
const MachOper* loadINode::memory_operand() const { return _opnds[1]; }
const MachOper* loadI2BNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadI2UBNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadI2SNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadI2USNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadI2LNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadI2L_immI_255Node::memory_operand() const { return _opnds[1]; }
const MachOper* loadI2L_immI_65535Node::memory_operand() const { return _opnds[1]; }
const MachOper* loadI2L_immINode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUI2LNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadLNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadL_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadLX_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadLX_reg_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadRangeNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadPNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadKlassNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadDNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadXDNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadXD_partialNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadXNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadFNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadA8BNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadA4SNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadA4CNode::memory_operand() const { return _opnds[1]; }
const MachOper* load2IUNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadA2FNode::memory_operand() const { return _opnds[1]; }
const MachOper* prefetchr0Node::memory_operand() const { return _opnds[1]; }
const MachOper* prefetchrNode::memory_operand() const { return _opnds[1]; }
const MachOper* prefetchrNTANode::memory_operand() const { return _opnds[1]; }
const MachOper* prefetchrT0Node::memory_operand() const { return _opnds[1]; }
const MachOper* prefetchrT2Node::memory_operand() const { return _opnds[1]; }
const MachOper* prefetchw0Node::memory_operand() const { return _opnds[1]; }
const MachOper* prefetchwNode::memory_operand() const { return _opnds[1]; }
const MachOper* prefetchwNTANode::memory_operand() const { return _opnds[1]; }
const MachOper* prefetchwT0Node::memory_operand() const { return _opnds[1]; }
const MachOper* prefetchwT2Node::memory_operand() const { return _opnds[1]; }
const MachOper* storeBNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeCNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeINode::memory_operand() const { return _opnds[1]; }
const MachOper* storeLNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeL2INode::memory_operand() const { return _opnds[1]; }
const MachOper* storeL_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeLX_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeLX_reg_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* storePNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeImmINode::memory_operand() const { return _opnds[1]; }
const MachOper* storeImmI16Node::memory_operand() const { return _opnds[1]; }
const MachOper* storeImmPNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeImmBNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeA8BNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeA4CNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeA2INode::memory_operand() const { return _opnds[1]; }
const MachOper* storeImmCMNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeDNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeD_roundedNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeXDNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeXNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeA2FNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeFNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeF_roundedNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeF_DroundedNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeF_immNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeX_immNode::memory_operand() const { return _opnds[1]; }
const TypePtr *membar_acquireNode::adr_type() const { return TypePtr::BOTTOM; }
const MachOper* membar_acquireNode::memory_operand() const { return (MachOper*)-1; }
const TypePtr *membar_acquire_lockNode::adr_type() const { return TypePtr::BOTTOM; }
const MachOper* membar_acquire_lockNode::memory_operand() const { return (MachOper*)-1; }
const TypePtr *membar_releaseNode::adr_type() const { return TypePtr::BOTTOM; }
const MachOper* membar_releaseNode::memory_operand() const { return (MachOper*)-1; }
const TypePtr *membar_release_lockNode::adr_type() const { return TypePtr::BOTTOM; }
const MachOper* membar_release_lockNode::memory_operand() const { return (MachOper*)-1; }
const MachOper* cmovI_memNode::memory_operand() const { return _opnds[4]; }
const MachOper* cmovI_memUNode::memory_operand() const { return _opnds[4]; }
const MachOper* cmovI_memUCFNode::memory_operand() const { return _opnds[4]; }
const MachOper* addI_eReg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* addI_eReg_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* addI_mem_eRegNode::memory_operand() const { return _opnds[1]; }
const MachOper* addI_mem_eReg_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* addI_mem_immNode::memory_operand() const { return _opnds[1]; }
const MachOper* incI_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* decI_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadPLockedNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadLLockedNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadLX_LockedNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadLX_reg_LockedNode::memory_operand() const { return _opnds[1]; }
const MachOper* storePConditionalNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeIConditionalNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeLConditionalNode::memory_operand() const { return _opnds[1]; }
const MachOper* subI_eReg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* subI_mem_eRegNode::memory_operand() const { return _opnds[1]; }
const MachOper* mulI_mem_immNode::memory_operand() const { return _opnds[1]; }
const MachOper* mulINode::memory_operand() const { return _opnds[2]; }
const MachOper* mulI_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* sarI_mem_1Node::memory_operand() const { return _opnds[1]; }
const MachOper* sarI_mem_immNode::memory_operand() const { return _opnds[1]; }
const MachOper* andI_eReg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* andI_eReg_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* andI_mem_eRegNode::memory_operand() const { return _opnds[1]; }
const MachOper* andI_mem_eReg_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* andI_mem_immNode::memory_operand() const { return _opnds[1]; }
const MachOper* orI_eReg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* orI_eReg_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* orI_mem_eRegNode::memory_operand() const { return _opnds[1]; }
const MachOper* orI_mem_eReg_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* orI_mem_immNode::memory_operand() const { return _opnds[1]; }
const MachOper* xorI_eReg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* xorI_eReg_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* xorI_mem_eRegNode::memory_operand() const { return _opnds[1]; }
const MachOper* xorI_mem_eReg_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* xorI_mem_immNode::memory_operand() const { return _opnds[1]; }
const MachOper* addL_eReg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* addL_eReg_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* subL_eReg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* andL_eReg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* andL_eReg_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* orl_eReg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* orl_eReg_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* xorl_eReg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* xorl_eReg_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* cmpXD_ccmemNode::memory_operand() const { return _opnds[2]; }
const MachOper* cmpXD_ccmemCFNode::memory_operand() const { return _opnds[2]; }
const MachOper* cmpXD_regmemNode::memory_operand() const { return _opnds[2]; }
const MachOper* subD_reg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* addD_reg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* addD_reg_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* addD_mem_regNode::memory_operand() const { return _opnds[1]; }
const MachOper* addD_mem_reg_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* addXD_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* addXD_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* subXD_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* mulXD_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* mulXD_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* divXD_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* mulD_reg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* mulD_reg_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* mulD_reg_mem_ciscNode::memory_operand() const { return _opnds[2]; }
const MachOper* mulD_reg_mem_cisc_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* cmpX_ccmemNode::memory_operand() const { return _opnds[2]; }
const MachOper* cmpX_ccmemCFNode::memory_operand() const { return _opnds[2]; }
const MachOper* cmpX_regmemNode::memory_operand() const { return _opnds[2]; }
const MachOper* addX_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* addX_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* subX_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* mulX_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* mulX_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* divX_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* sqrtX_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* sqrtXD_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* addF24_reg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* addF24_reg_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* addF_reg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* addF_reg_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* addF24_mem_regNode::memory_operand() const { return _opnds[1]; }
const TypePtr *addF24_mem_ciscNode::adr_type() const { return TypePtr::BOTTOM; }
const MachOper* addF24_mem_ciscNode::memory_operand() const { return (MachOper*)-1; }
const TypePtr *addF24_mem_cisc_0Node::adr_type() const { return TypePtr::BOTTOM; }
const MachOper* addF24_mem_cisc_0Node::memory_operand() const { return (MachOper*)-1; }
const TypePtr *addF24_mem_memNode::adr_type() const { return TypePtr::BOTTOM; }
const MachOper* addF24_mem_memNode::memory_operand() const { return (MachOper*)-1; }
const MachOper* mulF24_reg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* mulF24_reg_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* mulF_reg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* mulF_reg_mem_0Node::memory_operand() const { return _opnds[1]; }
const TypePtr *mulF24_mem_memNode::adr_type() const { return TypePtr::BOTTOM; }
const MachOper* mulF24_mem_memNode::memory_operand() const { return (MachOper*)-1; }
const MachOper* mulF_reg_load1Node::memory_operand() const { return _opnds[1]; }
const MachOper* mulF_reg_load1_0Node::memory_operand() const { return _opnds[2]; }
const MachOper* addF_mulF_reg_load1Node::memory_operand() const { return _opnds[1]; }
const MachOper* addF_mulF_reg_load1_1Node::memory_operand() const { return _opnds[2]; }
const MachOper* addF_mulF_reg_load1_0Node::memory_operand() const { return _opnds[2]; }
const MachOper* addF_mulF_reg_load1_2Node::memory_operand() const { return _opnds[3]; }
const MachOper* convI2XD_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* convI2D_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* convI2F_SSF_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* convI2F_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* compI_eReg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* testI_reg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* compU_eReg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* compP_eReg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* compP_mem_eRegNode::memory_operand() const { return _opnds[2]; }
const MachOper* testP_Reg_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* cmovLL_mem_LTGENode::memory_operand() const { return _opnds[4]; }
const MachOper* cmovII_mem_LTGENode::memory_operand() const { return _opnds[4]; }
const MachOper* cmovLL_mem_EQNENode::memory_operand() const { return _opnds[4]; }
const MachOper* cmovII_mem_EQNENode::memory_operand() const { return _opnds[4]; }
const MachOper* cmovLL_mem_LEGTNode::memory_operand() const { return _opnds[4]; }
const MachOper* cmovII_mem_LEGTNode::memory_operand() const { return _opnds[4]; }


const bool Matcher::has_match_rule(int opcode) {
  assert(_last_machine_leaf < opcode && opcode < _last_opcode, "opcode in range");
  return _hasMatchRule[opcode];
}

const bool Matcher::_hasMatchRule[_last_opcode] = {
    false,  // Node
    false,  // Set
    false,  // RegN
    false,  // RegI
    false,  // RegP
    false,  // RegF
    false,  // RegD
    false,  // RegL
    false,  // RegFlags
    false,  // _last_machine_leaf
    true ,  // AbsD
    true ,  // AbsF
    false,  // AbsI
    true ,  // AddD
    true ,  // AddF
    true ,  // AddI
    true ,  // AddL
    true ,  // AddP
    false,  // Allocate
    false,  // AllocateArray
    true ,  // AndI
    true ,  // AndL
    true ,  // AryEq
    true ,  // AtanD
    true ,  // Binary
    true ,  // Bool
    false,  // BoxLock
    true ,  // ReverseBytesI
    true ,  // ReverseBytesL
    true ,  // ReverseBytesUS
    true ,  // ReverseBytesS
    false,  // CProj
    true ,  // CallDynamicJava
    false,  // CallJava
    true ,  // CallLeaf
    true ,  // CallLeafNoFP
    true ,  // CallRuntime
    true ,  // CallStaticJava
    true ,  // CastII
    true ,  // CastX2P
    true ,  // CastP2X
    true ,  // CastPP
    false,  // Catch
    false,  // CatchProj
    true ,  // CheckCastPP
    true ,  // ClearArray
    false,  // ConstraintCast
    true ,  // CMoveD
    true ,  // CMoveF
    true ,  // CMoveI
    true ,  // CMoveL
    true ,  // CMoveP
    false,  // CMoveN
    false,  // CmpN
    true ,  // CmpD
    true ,  // CmpD3
    true ,  // CmpF
    true ,  // CmpF3
    true ,  // CmpI
    true ,  // CmpL
    true ,  // CmpL3
    true ,  // CmpLTMask
    true ,  // CmpP
    true ,  // CmpU
    true ,  // CompareAndSwapI
    true ,  // CompareAndSwapL
    true ,  // CompareAndSwapP
    false,  // CompareAndSwapN
    false,  // Con
    false,  // ConN
    true ,  // ConD
    true ,  // ConF
    true ,  // ConI
    true ,  // ConL
    true ,  // ConP
    true ,  // Conv2B
    true ,  // ConvD2F
    true ,  // ConvD2I
    true ,  // ConvD2L
    true ,  // ConvF2D
    true ,  // ConvF2I
    true ,  // ConvF2L
    true ,  // ConvI2D
    true ,  // ConvI2F
    true ,  // ConvI2L
    true ,  // ConvL2D
    true ,  // ConvL2F
    true ,  // ConvL2I
    true ,  // CosD
    false,  // CountedLoop
    true ,  // CountedLoopEnd
    true ,  // CountLeadingZerosI
    true ,  // CountLeadingZerosL
    true ,  // CountTrailingZerosI
    true ,  // CountTrailingZerosL
    true ,  // CreateEx
    false,  // DecodeN
    true ,  // DivD
    true ,  // DivF
    true ,  // DivI
    true ,  // DivL
    false,  // DivMod
    true ,  // DivModI
    false,  // DivModL
    false,  // EncodeP
    true ,  // ExpD
    true ,  // FastLock
    true ,  // FastUnlock
    true ,  // Goto
    true ,  // Halt
    true ,  // If
    false,  // IfFalse
    false,  // IfTrue
    false,  // Initialize
    false,  // JProj
    true ,  // Jump
    false,  // JumpProj
    true ,  // LShiftI
    true ,  // LShiftL
    true ,  // LoadB
    true ,  // LoadUB
    true ,  // LoadUS
    true ,  // LoadD
    false,  // LoadD_unaligned
    true ,  // LoadF
    true ,  // LoadI
    true ,  // LoadUI2L
    true ,  // LoadKlass
    false,  // LoadNKlass
    true ,  // LoadL
    false,  // LoadL_unaligned
    true ,  // LoadPLocked
    true ,  // LoadLLocked
    true ,  // LoadP
    false,  // LoadN
    true ,  // LoadRange
    true ,  // LoadS
    false,  // Lock
    true ,  // LogD
    true ,  // Log10D
    false,  // Loop
    true ,  // LoopLimit
    false,  // Mach
    false,  // MachProj
    true ,  // MaxI
    true ,  // MemBarAcquire
    false,  // MemBarCPUOrder
    true ,  // MemBarRelease
    true ,  // MemBarVolatile
    false,  // MergeMem
    true ,  // MinI
    true ,  // ModD
    true ,  // ModF
    true ,  // ModI
    true ,  // ModL
    true ,  // MoveI2F
    true ,  // MoveF2I
    true ,  // MoveL2D
    true ,  // MoveD2L
    true ,  // MulD
    true ,  // MulF
    false,  // MulHiL
    true ,  // MulI
    true ,  // MulL
    false,  // Multi
    true ,  // NegD
    true ,  // NegF
    false,  // NeverBranch
    false,  // Opaque1
    false,  // Opaque2
    true ,  // OrI
    true ,  // OrL
    false,  // PCTable
    false,  // Parm
    true ,  // PartialSubtypeCheck
    false,  // Phi
    true ,  // PopCountI
    true ,  // PopCountL
    true ,  // PowD
    true ,  // PrefetchRead
    true ,  // PrefetchWrite
    false,  // Proj
    true ,  // RShiftI
    true ,  // RShiftL
    false,  // Region
    true ,  // Rethrow
    true ,  // Return
    false,  // Root
    true ,  // RoundDouble
    true ,  // RoundFloat
    true ,  // SafePoint
    false,  // SafePointScalarObject
    false,  // SCMemProj
    true ,  // SinD
    true ,  // SqrtD
    false,  // Start
    false,  // StartOSR
    true ,  // StoreB
    true ,  // StoreC
    true ,  // StoreCM
    true ,  // StorePConditional
    true ,  // StoreIConditional
    true ,  // StoreLConditional
    true ,  // StoreD
    true ,  // StoreF
    true ,  // StoreI
    true ,  // StoreL
    true ,  // StoreP
    false,  // StoreN
    true ,  // StrComp
    true ,  // StrEquals
    true ,  // StrIndexOf
    true ,  // SubD
    true ,  // SubF
    true ,  // SubI
    true ,  // SubL
    true ,  // TailCall
    true ,  // TailJump
    true ,  // TanD
    true ,  // ThreadLocal
    false,  // Unlock
    true ,  // URShiftI
    true ,  // URShiftL
    true ,  // XorI
    true ,  // XorL
    false,  // Vector
    false,  // AddVB
    false,  // AddVC
    false,  // AddVS
    false,  // AddVI
    false,  // AddVL
    false,  // AddVF
    false,  // AddVD
    false,  // SubVB
    false,  // SubVC
    false,  // SubVS
    false,  // SubVI
    false,  // SubVL
    false,  // SubVF
    false,  // SubVD
    false,  // MulVF
    false,  // MulVD
    false,  // DivVF
    false,  // DivVD
    false,  // LShiftVB
    false,  // LShiftVC
    false,  // LShiftVS
    false,  // LShiftVI
    false,  // URShiftVB
    false,  // URShiftVC
    false,  // URShiftVS
    false,  // URShiftVI
    false,  // AndV
    false,  // OrV
    false,  // XorV
    false,  // VectorLoad
    false,  // Load16B
    true ,  // Load8B
    false,  // Load4B
    false,  // Load8C
    true ,  // Load4C
    false,  // Load2C
    false,  // Load8S
    true ,  // Load4S
    false,  // Load2S
    false,  // Load4I
    true ,  // Load2I
    false,  // Load2L
    false,  // Load4F
    true ,  // Load2F
    false,  // Load2D
    false,  // VectorStore
    false,  // Store16B
    true ,  // Store8B
    false,  // Store4B
    false,  // Store8C
    true ,  // Store4C
    false,  // Store2C
    false,  // Store4I
    true ,  // Store2I
    false,  // Store2L
    false,  // Store4F
    true ,  // Store2F
    false,  // Store2D
    false,  // Pack
    false,  // PackB
    false,  // PackS
    false,  // PackC
    false,  // PackI
    false,  // PackL
    false,  // PackF
    false,  // PackD
    false,  // Pack2x1B
    false,  // Pack2x2B
    false,  // Replicate16B
    true ,  // Replicate8B
    false,  // Replicate4B
    false,  // Replicate8S
    true ,  // Replicate4S
    false,  // Replicate2S
    false,  // Replicate8C
    true ,  // Replicate4C
    false,  // Replicate2C
    false,  // Replicate4I
    true ,  // Replicate2I
    false,  // Replicate2L
    false,  // Replicate4F
    true ,  // Replicate2F
    false,  // Replicate2D
    false,  // Extract
    false,  // ExtractB
    false,  // ExtractS
    false,  // ExtractC
    false,  // ExtractI
    false,  // ExtractL
    false,  // ExtractF
    false   // ExtractD
};


bool Matcher::stack_direction() const { return false; }

int Compile::sync_stack_slots() const { return 1; }

uint Matcher::stack_alignment_in_bytes() { return StackAlignmentInBytes; }

OptoReg::Name Matcher::return_addr() const { return OptoReg::stack2reg(- 1 +
              round_to(1+VerifyStackAtCalls+
              Compile::current()->fixed_slots(),
              (StackAlignmentInBytes/wordSize))); }

uint Compile::in_preserve_stack_slots() { return 2+VerifyStackAtCalls; }

uint Compile::out_preserve_stack_slots() { return SharedRuntime::out_preserve_stack_slots(); }

uint Compile::varargs_C_out_slots_killed() const { return 0; }

void Matcher::calling_convention(BasicType *sig_bt, VMRegPair *regs, uint length, bool is_outgoing) {

#line 4445 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // No difference between ingoing/outgoing just pass false
    SharedRuntime::java_calling_convention(sig_bt, regs, length, false);
  
#line 29814 "../generated/adfiles/ad_x86_32.cpp"

}

void Matcher::c_calling_convention(BasicType *sig_bt, VMRegPair *regs, uint length) {

#line 4457 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    // This is obviously always outgoing
    (void) SharedRuntime::c_calling_convention(sig_bt, regs, length);
  
#line 29825 "../generated/adfiles/ad_x86_32.cpp"

}

OptoRegPair Matcher::return_value(int ideal_reg, bool is_outgoing) {

#line 4479 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    assert( ideal_reg >= Op_RegI && ideal_reg <= Op_RegL, "only return normal values" );
    static int lo[Op_RegL+1] = { 0, 0, OptoReg::Bad, EAX_num,      EAX_num,      FPR1L_num,    FPR1L_num, EAX_num };
    static int hi[Op_RegL+1] = { 0, 0, OptoReg::Bad, OptoReg::Bad, OptoReg::Bad, OptoReg::Bad, FPR1H_num, EDX_num };
    if( ideal_reg == Op_RegD && UseSSE>=2 )
      return OptoRegPair(XMM0b_num,XMM0a_num);
    if( ideal_reg == Op_RegF && UseSSE>=1 )
      return OptoRegPair(OptoReg::Bad,XMM0a_num);
    return OptoRegPair(hi[ideal_reg],lo[ideal_reg]);
  
#line 29842 "../generated/adfiles/ad_x86_32.cpp"

}

OptoRegPair Matcher::c_return_value(int ideal_reg, bool is_outgoing) {

#line 4463 "/home/mandrake/rpm/BUILD/java-1.7.0-openjdk/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"

    assert( ideal_reg >= Op_RegI && ideal_reg <= Op_RegL, "only return normal values" );
    static int lo[Op_RegL+1] = { 0, 0, OptoReg::Bad, EAX_num,      EAX_num,      FPR1L_num,    FPR1L_num, EAX_num };
    static int hi[Op_RegL+1] = { 0, 0, OptoReg::Bad, OptoReg::Bad, OptoReg::Bad, OptoReg::Bad, FPR1H_num, EDX_num };

    // in SSE2+ mode we want to keep the FPU stack clean so pretend
    // that C functions return float and double results in XMM0.
    if( ideal_reg == Op_RegD && UseSSE>=2 )
      return OptoRegPair(XMM0b_num,XMM0a_num);
    if( ideal_reg == Op_RegF && UseSSE>=2 )
      return OptoRegPair(OptoReg::Bad,XMM0a_num);

    return OptoRegPair(hi[ideal_reg],lo[ideal_reg]);
  
#line 29863 "../generated/adfiles/ad_x86_32.cpp"

}

OptoReg::Name Matcher::inline_cache_reg() { return OptoReg::Name(EAX_num); }

const RegMask &Matcher::inline_cache_reg_mask() { return INLINE_CACHE_REG_mask; }

int Matcher::inline_cache_reg_encode() { return _regEncode[inline_cache_reg()]; }

OptoReg::Name Matcher::interpreter_method_oop_reg() { return OptoReg::Name(EBX_num); }

const RegMask &Matcher::interpreter_method_oop_reg_mask() { return INTERPRETER_METHOD_OOP_REG_mask; }

int Matcher::interpreter_method_oop_reg_encode() { return _regEncode[interpreter_method_oop_reg()]; }

OptoReg::Name Matcher::interpreter_frame_pointer_reg() { return OptoReg::Name(EBP_num); }

const RegMask &Matcher::interpreter_frame_pointer_reg_mask() { return INTERPRETER_FRAME_POINTER_REG_mask; }

OptoReg::Name Matcher::c_frame_pointer() const { return OptoReg::Name(ESP_num); }

// Number of callee-save + always-save registers
int  Matcher::number_of_saved_registers() {
  return 0;
};

// Check consistency of C++ compilation with ADLC options:
// Check adlc -DLINUX=1
#ifndef LINUX
#  error "LINUX must be defined"
#endif // LINUX
// Check adlc -D_GNU_SOURCE=1
#ifndef _GNU_SOURCE
#  error "_GNU_SOURCE must be defined"
#endif // _GNU_SOURCE
// Check adlc -DIA32=1
#ifndef IA32
#  error "IA32 must be defined"
#endif // IA32
// Check adlc -U_LP64
#ifdef _LP64
#  error "_LP64 must not be defined"
#endif // _LP64
